/*
 * Copyright 2009-2010 Yuichiro Moriguchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.morilib.lingua;

import net.morilib.lingua.numeral.RomanNumeral;
import net.morilib.lisp.test.TC;

/**
 *
 *
 * @author MORIGUCHI, Yuichiro 2012/05/09
 */
public class RomanNumeralTest extends TC {

	public void testToRoman() {
		nil(RomanNumeral.toRoman(0));
		eq(RomanNumeral.toRoman(1),"I");
		eq(RomanNumeral.toRoman(2),"II");
		eq(RomanNumeral.toRoman(3),"III");
		eq(RomanNumeral.toRoman(4),"IV");
		eq(RomanNumeral.toRoman(5),"V");
		eq(RomanNumeral.toRoman(6),"VI");
		eq(RomanNumeral.toRoman(7),"VII");
		eq(RomanNumeral.toRoman(8),"VIII");
		eq(RomanNumeral.toRoman(9),"IX");
		eq(RomanNumeral.toRoman(10),"X");
		eq(RomanNumeral.toRoman(11),"XI");
		eq(RomanNumeral.toRoman(12),"XII");
		eq(RomanNumeral.toRoman(13),"XIII");
		eq(RomanNumeral.toRoman(14),"XIV");
		eq(RomanNumeral.toRoman(15),"XV");
		eq(RomanNumeral.toRoman(16),"XVI");
		eq(RomanNumeral.toRoman(17),"XVII");
		eq(RomanNumeral.toRoman(18),"XVIII");
		eq(RomanNumeral.toRoman(19),"XIX");
		eq(RomanNumeral.toRoman(20),"XX");
		eq(RomanNumeral.toRoman(21),"XXI");
		eq(RomanNumeral.toRoman(22),"XXII");
		eq(RomanNumeral.toRoman(23),"XXIII");
		eq(RomanNumeral.toRoman(24),"XXIV");
		eq(RomanNumeral.toRoman(25),"XXV");
		eq(RomanNumeral.toRoman(26),"XXVI");
		eq(RomanNumeral.toRoman(27),"XXVII");
		eq(RomanNumeral.toRoman(28),"XXVIII");
		eq(RomanNumeral.toRoman(29),"XXIX");
		eq(RomanNumeral.toRoman(30),"XXX");
		eq(RomanNumeral.toRoman(31),"XXXI");
		eq(RomanNumeral.toRoman(32),"XXXII");
		eq(RomanNumeral.toRoman(33),"XXXIII");
		eq(RomanNumeral.toRoman(34),"XXXIV");
		eq(RomanNumeral.toRoman(35),"XXXV");
		eq(RomanNumeral.toRoman(36),"XXXVI");
		eq(RomanNumeral.toRoman(37),"XXXVII");
		eq(RomanNumeral.toRoman(38),"XXXVIII");
		eq(RomanNumeral.toRoman(39),"XXXIX");
		eq(RomanNumeral.toRoman(40),"XL");
		eq(RomanNumeral.toRoman(41),"XLI");
		eq(RomanNumeral.toRoman(42),"XLII");
		eq(RomanNumeral.toRoman(43),"XLIII");
		eq(RomanNumeral.toRoman(44),"XLIV");
		eq(RomanNumeral.toRoman(45),"XLV");
		eq(RomanNumeral.toRoman(46),"XLVI");
		eq(RomanNumeral.toRoman(47),"XLVII");
		eq(RomanNumeral.toRoman(48),"XLVIII");
		eq(RomanNumeral.toRoman(49),"XLIX");
		eq(RomanNumeral.toRoman(50),"L");
		eq(RomanNumeral.toRoman(51),"LI");
		eq(RomanNumeral.toRoman(52),"LII");
		eq(RomanNumeral.toRoman(53),"LIII");
		eq(RomanNumeral.toRoman(54),"LIV");
		eq(RomanNumeral.toRoman(55),"LV");
		eq(RomanNumeral.toRoman(56),"LVI");
		eq(RomanNumeral.toRoman(57),"LVII");
		eq(RomanNumeral.toRoman(58),"LVIII");
		eq(RomanNumeral.toRoman(59),"LIX");
		eq(RomanNumeral.toRoman(60),"LX");
		eq(RomanNumeral.toRoman(61),"LXI");
		eq(RomanNumeral.toRoman(62),"LXII");
		eq(RomanNumeral.toRoman(63),"LXIII");
		eq(RomanNumeral.toRoman(64),"LXIV");
		eq(RomanNumeral.toRoman(65),"LXV");
		eq(RomanNumeral.toRoman(66),"LXVI");
		eq(RomanNumeral.toRoman(67),"LXVII");
		eq(RomanNumeral.toRoman(68),"LXVIII");
		eq(RomanNumeral.toRoman(69),"LXIX");
		eq(RomanNumeral.toRoman(70),"LXX");
		eq(RomanNumeral.toRoman(71),"LXXI");
		eq(RomanNumeral.toRoman(72),"LXXII");
		eq(RomanNumeral.toRoman(73),"LXXIII");
		eq(RomanNumeral.toRoman(74),"LXXIV");
		eq(RomanNumeral.toRoman(75),"LXXV");
		eq(RomanNumeral.toRoman(76),"LXXVI");
		eq(RomanNumeral.toRoman(77),"LXXVII");
		eq(RomanNumeral.toRoman(78),"LXXVIII");
		eq(RomanNumeral.toRoman(79),"LXXIX");
		eq(RomanNumeral.toRoman(80),"LXXX");
		eq(RomanNumeral.toRoman(81),"LXXXI");
		eq(RomanNumeral.toRoman(82),"LXXXII");
		eq(RomanNumeral.toRoman(83),"LXXXIII");
		eq(RomanNumeral.toRoman(84),"LXXXIV");
		eq(RomanNumeral.toRoman(85),"LXXXV");
		eq(RomanNumeral.toRoman(86),"LXXXVI");
		eq(RomanNumeral.toRoman(87),"LXXXVII");
		eq(RomanNumeral.toRoman(88),"LXXXVIII");
		eq(RomanNumeral.toRoman(89),"LXXXIX");
		eq(RomanNumeral.toRoman(90),"XC");
		eq(RomanNumeral.toRoman(91),"XCI");
		eq(RomanNumeral.toRoman(92),"XCII");
		eq(RomanNumeral.toRoman(93),"XCIII");
		eq(RomanNumeral.toRoman(94),"XCIV");
		eq(RomanNumeral.toRoman(95),"XCV");
		eq(RomanNumeral.toRoman(96),"XCVI");
		eq(RomanNumeral.toRoman(97),"XCVII");
		eq(RomanNumeral.toRoman(98),"XCVIII");
		eq(RomanNumeral.toRoman(99),"XCIX");
		eq(RomanNumeral.toRoman(100),"C");
		eq(RomanNumeral.toRoman(101),"CI");
		eq(RomanNumeral.toRoman(102),"CII");
		eq(RomanNumeral.toRoman(103),"CIII");
		eq(RomanNumeral.toRoman(104),"CIV");
		eq(RomanNumeral.toRoman(105),"CV");
		eq(RomanNumeral.toRoman(106),"CVI");
		eq(RomanNumeral.toRoman(107),"CVII");
		eq(RomanNumeral.toRoman(108),"CVIII");
		eq(RomanNumeral.toRoman(109),"CIX");
		eq(RomanNumeral.toRoman(110),"CX");
		eq(RomanNumeral.toRoman(111),"CXI");
		eq(RomanNumeral.toRoman(112),"CXII");
		eq(RomanNumeral.toRoman(113),"CXIII");
		eq(RomanNumeral.toRoman(114),"CXIV");
		eq(RomanNumeral.toRoman(115),"CXV");
		eq(RomanNumeral.toRoman(116),"CXVI");
		eq(RomanNumeral.toRoman(117),"CXVII");
		eq(RomanNumeral.toRoman(118),"CXVIII");
		eq(RomanNumeral.toRoman(119),"CXIX");
		eq(RomanNumeral.toRoman(120),"CXX");
		eq(RomanNumeral.toRoman(121),"CXXI");
		eq(RomanNumeral.toRoman(122),"CXXII");
		eq(RomanNumeral.toRoman(123),"CXXIII");
		eq(RomanNumeral.toRoman(124),"CXXIV");
		eq(RomanNumeral.toRoman(125),"CXXV");
		eq(RomanNumeral.toRoman(126),"CXXVI");
		eq(RomanNumeral.toRoman(127),"CXXVII");
		eq(RomanNumeral.toRoman(128),"CXXVIII");
		eq(RomanNumeral.toRoman(129),"CXXIX");
		eq(RomanNumeral.toRoman(130),"CXXX");
		eq(RomanNumeral.toRoman(131),"CXXXI");
		eq(RomanNumeral.toRoman(132),"CXXXII");
		eq(RomanNumeral.toRoman(133),"CXXXIII");
		eq(RomanNumeral.toRoman(134),"CXXXIV");
		eq(RomanNumeral.toRoman(135),"CXXXV");
		eq(RomanNumeral.toRoman(136),"CXXXVI");
		eq(RomanNumeral.toRoman(137),"CXXXVII");
		eq(RomanNumeral.toRoman(138),"CXXXVIII");
		eq(RomanNumeral.toRoman(139),"CXXXIX");
		eq(RomanNumeral.toRoman(140),"CXL");
		eq(RomanNumeral.toRoman(141),"CXLI");
		eq(RomanNumeral.toRoman(142),"CXLII");
		eq(RomanNumeral.toRoman(143),"CXLIII");
		eq(RomanNumeral.toRoman(144),"CXLIV");
		eq(RomanNumeral.toRoman(145),"CXLV");
		eq(RomanNumeral.toRoman(146),"CXLVI");
		eq(RomanNumeral.toRoman(147),"CXLVII");
		eq(RomanNumeral.toRoman(148),"CXLVIII");
		eq(RomanNumeral.toRoman(149),"CXLIX");
		eq(RomanNumeral.toRoman(150),"CL");
		eq(RomanNumeral.toRoman(151),"CLI");
		eq(RomanNumeral.toRoman(152),"CLII");
		eq(RomanNumeral.toRoman(153),"CLIII");
		eq(RomanNumeral.toRoman(154),"CLIV");
		eq(RomanNumeral.toRoman(155),"CLV");
		eq(RomanNumeral.toRoman(156),"CLVI");
		eq(RomanNumeral.toRoman(157),"CLVII");
		eq(RomanNumeral.toRoman(158),"CLVIII");
		eq(RomanNumeral.toRoman(159),"CLIX");
		eq(RomanNumeral.toRoman(160),"CLX");
		eq(RomanNumeral.toRoman(161),"CLXI");
		eq(RomanNumeral.toRoman(162),"CLXII");
		eq(RomanNumeral.toRoman(163),"CLXIII");
		eq(RomanNumeral.toRoman(164),"CLXIV");
		eq(RomanNumeral.toRoman(165),"CLXV");
		eq(RomanNumeral.toRoman(166),"CLXVI");
		eq(RomanNumeral.toRoman(167),"CLXVII");
		eq(RomanNumeral.toRoman(168),"CLXVIII");
		eq(RomanNumeral.toRoman(169),"CLXIX");
		eq(RomanNumeral.toRoman(170),"CLXX");
		eq(RomanNumeral.toRoman(171),"CLXXI");
		eq(RomanNumeral.toRoman(172),"CLXXII");
		eq(RomanNumeral.toRoman(173),"CLXXIII");
		eq(RomanNumeral.toRoman(174),"CLXXIV");
		eq(RomanNumeral.toRoman(175),"CLXXV");
		eq(RomanNumeral.toRoman(176),"CLXXVI");
		eq(RomanNumeral.toRoman(177),"CLXXVII");
		eq(RomanNumeral.toRoman(178),"CLXXVIII");
		eq(RomanNumeral.toRoman(179),"CLXXIX");
		eq(RomanNumeral.toRoman(180),"CLXXX");
		eq(RomanNumeral.toRoman(181),"CLXXXI");
		eq(RomanNumeral.toRoman(182),"CLXXXII");
		eq(RomanNumeral.toRoman(183),"CLXXXIII");
		eq(RomanNumeral.toRoman(184),"CLXXXIV");
		eq(RomanNumeral.toRoman(185),"CLXXXV");
		eq(RomanNumeral.toRoman(186),"CLXXXVI");
		eq(RomanNumeral.toRoman(187),"CLXXXVII");
		eq(RomanNumeral.toRoman(188),"CLXXXVIII");
		eq(RomanNumeral.toRoman(189),"CLXXXIX");
		eq(RomanNumeral.toRoman(190),"CXC");
		eq(RomanNumeral.toRoman(191),"CXCI");
		eq(RomanNumeral.toRoman(192),"CXCII");
		eq(RomanNumeral.toRoman(193),"CXCIII");
		eq(RomanNumeral.toRoman(194),"CXCIV");
		eq(RomanNumeral.toRoman(195),"CXCV");
		eq(RomanNumeral.toRoman(196),"CXCVI");
		eq(RomanNumeral.toRoman(197),"CXCVII");
		eq(RomanNumeral.toRoman(198),"CXCVIII");
		eq(RomanNumeral.toRoman(199),"CXCIX");
		eq(RomanNumeral.toRoman(200),"CC");
		eq(RomanNumeral.toRoman(201),"CCI");
		eq(RomanNumeral.toRoman(202),"CCII");
		eq(RomanNumeral.toRoman(203),"CCIII");
		eq(RomanNumeral.toRoman(204),"CCIV");
		eq(RomanNumeral.toRoman(205),"CCV");
		eq(RomanNumeral.toRoman(206),"CCVI");
		eq(RomanNumeral.toRoman(207),"CCVII");
		eq(RomanNumeral.toRoman(208),"CCVIII");
		eq(RomanNumeral.toRoman(209),"CCIX");
		eq(RomanNumeral.toRoman(210),"CCX");
		eq(RomanNumeral.toRoman(211),"CCXI");
		eq(RomanNumeral.toRoman(212),"CCXII");
		eq(RomanNumeral.toRoman(213),"CCXIII");
		eq(RomanNumeral.toRoman(214),"CCXIV");
		eq(RomanNumeral.toRoman(215),"CCXV");
		eq(RomanNumeral.toRoman(216),"CCXVI");
		eq(RomanNumeral.toRoman(217),"CCXVII");
		eq(RomanNumeral.toRoman(218),"CCXVIII");
		eq(RomanNumeral.toRoman(219),"CCXIX");
		eq(RomanNumeral.toRoman(220),"CCXX");
		eq(RomanNumeral.toRoman(221),"CCXXI");
		eq(RomanNumeral.toRoman(222),"CCXXII");
		eq(RomanNumeral.toRoman(223),"CCXXIII");
		eq(RomanNumeral.toRoman(224),"CCXXIV");
		eq(RomanNumeral.toRoman(225),"CCXXV");
		eq(RomanNumeral.toRoman(226),"CCXXVI");
		eq(RomanNumeral.toRoman(227),"CCXXVII");
		eq(RomanNumeral.toRoman(228),"CCXXVIII");
		eq(RomanNumeral.toRoman(229),"CCXXIX");
		eq(RomanNumeral.toRoman(230),"CCXXX");
		eq(RomanNumeral.toRoman(231),"CCXXXI");
		eq(RomanNumeral.toRoman(232),"CCXXXII");
		eq(RomanNumeral.toRoman(233),"CCXXXIII");
		eq(RomanNumeral.toRoman(234),"CCXXXIV");
		eq(RomanNumeral.toRoman(235),"CCXXXV");
		eq(RomanNumeral.toRoman(236),"CCXXXVI");
		eq(RomanNumeral.toRoman(237),"CCXXXVII");
		eq(RomanNumeral.toRoman(238),"CCXXXVIII");
		eq(RomanNumeral.toRoman(239),"CCXXXIX");
		eq(RomanNumeral.toRoman(240),"CCXL");
		eq(RomanNumeral.toRoman(241),"CCXLI");
		eq(RomanNumeral.toRoman(242),"CCXLII");
		eq(RomanNumeral.toRoman(243),"CCXLIII");
		eq(RomanNumeral.toRoman(244),"CCXLIV");
		eq(RomanNumeral.toRoman(245),"CCXLV");
		eq(RomanNumeral.toRoman(246),"CCXLVI");
		eq(RomanNumeral.toRoman(247),"CCXLVII");
		eq(RomanNumeral.toRoman(248),"CCXLVIII");
		eq(RomanNumeral.toRoman(249),"CCXLIX");
		eq(RomanNumeral.toRoman(250),"CCL");
		eq(RomanNumeral.toRoman(251),"CCLI");
		eq(RomanNumeral.toRoman(252),"CCLII");
		eq(RomanNumeral.toRoman(253),"CCLIII");
		eq(RomanNumeral.toRoman(254),"CCLIV");
		eq(RomanNumeral.toRoman(255),"CCLV");
		eq(RomanNumeral.toRoman(256),"CCLVI");
		eq(RomanNumeral.toRoman(257),"CCLVII");
		eq(RomanNumeral.toRoman(258),"CCLVIII");
		eq(RomanNumeral.toRoman(259),"CCLIX");
		eq(RomanNumeral.toRoman(260),"CCLX");
		eq(RomanNumeral.toRoman(261),"CCLXI");
		eq(RomanNumeral.toRoman(262),"CCLXII");
		eq(RomanNumeral.toRoman(263),"CCLXIII");
		eq(RomanNumeral.toRoman(264),"CCLXIV");
		eq(RomanNumeral.toRoman(265),"CCLXV");
		eq(RomanNumeral.toRoman(266),"CCLXVI");
		eq(RomanNumeral.toRoman(267),"CCLXVII");
		eq(RomanNumeral.toRoman(268),"CCLXVIII");
		eq(RomanNumeral.toRoman(269),"CCLXIX");
		eq(RomanNumeral.toRoman(270),"CCLXX");
		eq(RomanNumeral.toRoman(271),"CCLXXI");
		eq(RomanNumeral.toRoman(272),"CCLXXII");
		eq(RomanNumeral.toRoman(273),"CCLXXIII");
		eq(RomanNumeral.toRoman(274),"CCLXXIV");
		eq(RomanNumeral.toRoman(275),"CCLXXV");
		eq(RomanNumeral.toRoman(276),"CCLXXVI");
		eq(RomanNumeral.toRoman(277),"CCLXXVII");
		eq(RomanNumeral.toRoman(278),"CCLXXVIII");
		eq(RomanNumeral.toRoman(279),"CCLXXIX");
		eq(RomanNumeral.toRoman(280),"CCLXXX");
		eq(RomanNumeral.toRoman(281),"CCLXXXI");
		eq(RomanNumeral.toRoman(282),"CCLXXXII");
		eq(RomanNumeral.toRoman(283),"CCLXXXIII");
		eq(RomanNumeral.toRoman(284),"CCLXXXIV");
		eq(RomanNumeral.toRoman(285),"CCLXXXV");
		eq(RomanNumeral.toRoman(286),"CCLXXXVI");
		eq(RomanNumeral.toRoman(287),"CCLXXXVII");
		eq(RomanNumeral.toRoman(288),"CCLXXXVIII");
		eq(RomanNumeral.toRoman(289),"CCLXXXIX");
		eq(RomanNumeral.toRoman(290),"CCXC");
		eq(RomanNumeral.toRoman(291),"CCXCI");
		eq(RomanNumeral.toRoman(292),"CCXCII");
		eq(RomanNumeral.toRoman(293),"CCXCIII");
		eq(RomanNumeral.toRoman(294),"CCXCIV");
		eq(RomanNumeral.toRoman(295),"CCXCV");
		eq(RomanNumeral.toRoman(296),"CCXCVI");
		eq(RomanNumeral.toRoman(297),"CCXCVII");
		eq(RomanNumeral.toRoman(298),"CCXCVIII");
		eq(RomanNumeral.toRoman(299),"CCXCIX");
		eq(RomanNumeral.toRoman(300),"CCC");
		eq(RomanNumeral.toRoman(301),"CCCI");
		eq(RomanNumeral.toRoman(302),"CCCII");
		eq(RomanNumeral.toRoman(303),"CCCIII");
		eq(RomanNumeral.toRoman(304),"CCCIV");
		eq(RomanNumeral.toRoman(305),"CCCV");
		eq(RomanNumeral.toRoman(306),"CCCVI");
		eq(RomanNumeral.toRoman(307),"CCCVII");
		eq(RomanNumeral.toRoman(308),"CCCVIII");
		eq(RomanNumeral.toRoman(309),"CCCIX");
		eq(RomanNumeral.toRoman(310),"CCCX");
		eq(RomanNumeral.toRoman(311),"CCCXI");
		eq(RomanNumeral.toRoman(312),"CCCXII");
		eq(RomanNumeral.toRoman(313),"CCCXIII");
		eq(RomanNumeral.toRoman(314),"CCCXIV");
		eq(RomanNumeral.toRoman(315),"CCCXV");
		eq(RomanNumeral.toRoman(316),"CCCXVI");
		eq(RomanNumeral.toRoman(317),"CCCXVII");
		eq(RomanNumeral.toRoman(318),"CCCXVIII");
		eq(RomanNumeral.toRoman(319),"CCCXIX");
		eq(RomanNumeral.toRoman(320),"CCCXX");
		eq(RomanNumeral.toRoman(321),"CCCXXI");
		eq(RomanNumeral.toRoman(322),"CCCXXII");
		eq(RomanNumeral.toRoman(323),"CCCXXIII");
		eq(RomanNumeral.toRoman(324),"CCCXXIV");
		eq(RomanNumeral.toRoman(325),"CCCXXV");
		eq(RomanNumeral.toRoman(326),"CCCXXVI");
		eq(RomanNumeral.toRoman(327),"CCCXXVII");
		eq(RomanNumeral.toRoman(328),"CCCXXVIII");
		eq(RomanNumeral.toRoman(329),"CCCXXIX");
		eq(RomanNumeral.toRoman(330),"CCCXXX");
		eq(RomanNumeral.toRoman(331),"CCCXXXI");
		eq(RomanNumeral.toRoman(332),"CCCXXXII");
		eq(RomanNumeral.toRoman(333),"CCCXXXIII");
		eq(RomanNumeral.toRoman(334),"CCCXXXIV");
		eq(RomanNumeral.toRoman(335),"CCCXXXV");
		eq(RomanNumeral.toRoman(336),"CCCXXXVI");
		eq(RomanNumeral.toRoman(337),"CCCXXXVII");
		eq(RomanNumeral.toRoman(338),"CCCXXXVIII");
		eq(RomanNumeral.toRoman(339),"CCCXXXIX");
		eq(RomanNumeral.toRoman(340),"CCCXL");
		eq(RomanNumeral.toRoman(341),"CCCXLI");
		eq(RomanNumeral.toRoman(342),"CCCXLII");
		eq(RomanNumeral.toRoman(343),"CCCXLIII");
		eq(RomanNumeral.toRoman(344),"CCCXLIV");
		eq(RomanNumeral.toRoman(345),"CCCXLV");
		eq(RomanNumeral.toRoman(346),"CCCXLVI");
		eq(RomanNumeral.toRoman(347),"CCCXLVII");
		eq(RomanNumeral.toRoman(348),"CCCXLVIII");
		eq(RomanNumeral.toRoman(349),"CCCXLIX");
		eq(RomanNumeral.toRoman(350),"CCCL");
		eq(RomanNumeral.toRoman(351),"CCCLI");
		eq(RomanNumeral.toRoman(352),"CCCLII");
		eq(RomanNumeral.toRoman(353),"CCCLIII");
		eq(RomanNumeral.toRoman(354),"CCCLIV");
		eq(RomanNumeral.toRoman(355),"CCCLV");
		eq(RomanNumeral.toRoman(356),"CCCLVI");
		eq(RomanNumeral.toRoman(357),"CCCLVII");
		eq(RomanNumeral.toRoman(358),"CCCLVIII");
		eq(RomanNumeral.toRoman(359),"CCCLIX");
		eq(RomanNumeral.toRoman(360),"CCCLX");
		eq(RomanNumeral.toRoman(361),"CCCLXI");
		eq(RomanNumeral.toRoman(362),"CCCLXII");
		eq(RomanNumeral.toRoman(363),"CCCLXIII");
		eq(RomanNumeral.toRoman(364),"CCCLXIV");
		eq(RomanNumeral.toRoman(365),"CCCLXV");
		eq(RomanNumeral.toRoman(366),"CCCLXVI");
		eq(RomanNumeral.toRoman(367),"CCCLXVII");
		eq(RomanNumeral.toRoman(368),"CCCLXVIII");
		eq(RomanNumeral.toRoman(369),"CCCLXIX");
		eq(RomanNumeral.toRoman(370),"CCCLXX");
		eq(RomanNumeral.toRoman(371),"CCCLXXI");
		eq(RomanNumeral.toRoman(372),"CCCLXXII");
		eq(RomanNumeral.toRoman(373),"CCCLXXIII");
		eq(RomanNumeral.toRoman(374),"CCCLXXIV");
		eq(RomanNumeral.toRoman(375),"CCCLXXV");
		eq(RomanNumeral.toRoman(376),"CCCLXXVI");
		eq(RomanNumeral.toRoman(377),"CCCLXXVII");
		eq(RomanNumeral.toRoman(378),"CCCLXXVIII");
		eq(RomanNumeral.toRoman(379),"CCCLXXIX");
		eq(RomanNumeral.toRoman(380),"CCCLXXX");
		eq(RomanNumeral.toRoman(381),"CCCLXXXI");
		eq(RomanNumeral.toRoman(382),"CCCLXXXII");
		eq(RomanNumeral.toRoman(383),"CCCLXXXIII");
		eq(RomanNumeral.toRoman(384),"CCCLXXXIV");
		eq(RomanNumeral.toRoman(385),"CCCLXXXV");
		eq(RomanNumeral.toRoman(386),"CCCLXXXVI");
		eq(RomanNumeral.toRoman(387),"CCCLXXXVII");
		eq(RomanNumeral.toRoman(388),"CCCLXXXVIII");
		eq(RomanNumeral.toRoman(389),"CCCLXXXIX");
		eq(RomanNumeral.toRoman(390),"CCCXC");
		eq(RomanNumeral.toRoman(391),"CCCXCI");
		eq(RomanNumeral.toRoman(392),"CCCXCII");
		eq(RomanNumeral.toRoman(393),"CCCXCIII");
		eq(RomanNumeral.toRoman(394),"CCCXCIV");
		eq(RomanNumeral.toRoman(395),"CCCXCV");
		eq(RomanNumeral.toRoman(396),"CCCXCVI");
		eq(RomanNumeral.toRoman(397),"CCCXCVII");
		eq(RomanNumeral.toRoman(398),"CCCXCVIII");
		eq(RomanNumeral.toRoman(399),"CCCXCIX");
		eq(RomanNumeral.toRoman(400),"CD");
		eq(RomanNumeral.toRoman(401),"CDI");
		eq(RomanNumeral.toRoman(402),"CDII");
		eq(RomanNumeral.toRoman(403),"CDIII");
		eq(RomanNumeral.toRoman(404),"CDIV");
		eq(RomanNumeral.toRoman(405),"CDV");
		eq(RomanNumeral.toRoman(406),"CDVI");
		eq(RomanNumeral.toRoman(407),"CDVII");
		eq(RomanNumeral.toRoman(408),"CDVIII");
		eq(RomanNumeral.toRoman(409),"CDIX");
		eq(RomanNumeral.toRoman(410),"CDX");
		eq(RomanNumeral.toRoman(411),"CDXI");
		eq(RomanNumeral.toRoman(412),"CDXII");
		eq(RomanNumeral.toRoman(413),"CDXIII");
		eq(RomanNumeral.toRoman(414),"CDXIV");
		eq(RomanNumeral.toRoman(415),"CDXV");
		eq(RomanNumeral.toRoman(416),"CDXVI");
		eq(RomanNumeral.toRoman(417),"CDXVII");
		eq(RomanNumeral.toRoman(418),"CDXVIII");
		eq(RomanNumeral.toRoman(419),"CDXIX");
		eq(RomanNumeral.toRoman(420),"CDXX");
		eq(RomanNumeral.toRoman(421),"CDXXI");
		eq(RomanNumeral.toRoman(422),"CDXXII");
		eq(RomanNumeral.toRoman(423),"CDXXIII");
		eq(RomanNumeral.toRoman(424),"CDXXIV");
		eq(RomanNumeral.toRoman(425),"CDXXV");
		eq(RomanNumeral.toRoman(426),"CDXXVI");
		eq(RomanNumeral.toRoman(427),"CDXXVII");
		eq(RomanNumeral.toRoman(428),"CDXXVIII");
		eq(RomanNumeral.toRoman(429),"CDXXIX");
		eq(RomanNumeral.toRoman(430),"CDXXX");
		eq(RomanNumeral.toRoman(431),"CDXXXI");
		eq(RomanNumeral.toRoman(432),"CDXXXII");
		eq(RomanNumeral.toRoman(433),"CDXXXIII");
		eq(RomanNumeral.toRoman(434),"CDXXXIV");
		eq(RomanNumeral.toRoman(435),"CDXXXV");
		eq(RomanNumeral.toRoman(436),"CDXXXVI");
		eq(RomanNumeral.toRoman(437),"CDXXXVII");
		eq(RomanNumeral.toRoman(438),"CDXXXVIII");
		eq(RomanNumeral.toRoman(439),"CDXXXIX");
		eq(RomanNumeral.toRoman(440),"CDXL");
		eq(RomanNumeral.toRoman(441),"CDXLI");
		eq(RomanNumeral.toRoman(442),"CDXLII");
		eq(RomanNumeral.toRoman(443),"CDXLIII");
		eq(RomanNumeral.toRoman(444),"CDXLIV");
		eq(RomanNumeral.toRoman(445),"CDXLV");
		eq(RomanNumeral.toRoman(446),"CDXLVI");
		eq(RomanNumeral.toRoman(447),"CDXLVII");
		eq(RomanNumeral.toRoman(448),"CDXLVIII");
		eq(RomanNumeral.toRoman(449),"CDXLIX");
		eq(RomanNumeral.toRoman(450),"CDL");
		eq(RomanNumeral.toRoman(451),"CDLI");
		eq(RomanNumeral.toRoman(452),"CDLII");
		eq(RomanNumeral.toRoman(453),"CDLIII");
		eq(RomanNumeral.toRoman(454),"CDLIV");
		eq(RomanNumeral.toRoman(455),"CDLV");
		eq(RomanNumeral.toRoman(456),"CDLVI");
		eq(RomanNumeral.toRoman(457),"CDLVII");
		eq(RomanNumeral.toRoman(458),"CDLVIII");
		eq(RomanNumeral.toRoman(459),"CDLIX");
		eq(RomanNumeral.toRoman(460),"CDLX");
		eq(RomanNumeral.toRoman(461),"CDLXI");
		eq(RomanNumeral.toRoman(462),"CDLXII");
		eq(RomanNumeral.toRoman(463),"CDLXIII");
		eq(RomanNumeral.toRoman(464),"CDLXIV");
		eq(RomanNumeral.toRoman(465),"CDLXV");
		eq(RomanNumeral.toRoman(466),"CDLXVI");
		eq(RomanNumeral.toRoman(467),"CDLXVII");
		eq(RomanNumeral.toRoman(468),"CDLXVIII");
		eq(RomanNumeral.toRoman(469),"CDLXIX");
		eq(RomanNumeral.toRoman(470),"CDLXX");
		eq(RomanNumeral.toRoman(471),"CDLXXI");
		eq(RomanNumeral.toRoman(472),"CDLXXII");
		eq(RomanNumeral.toRoman(473),"CDLXXIII");
		eq(RomanNumeral.toRoman(474),"CDLXXIV");
		eq(RomanNumeral.toRoman(475),"CDLXXV");
		eq(RomanNumeral.toRoman(476),"CDLXXVI");
		eq(RomanNumeral.toRoman(477),"CDLXXVII");
		eq(RomanNumeral.toRoman(478),"CDLXXVIII");
		eq(RomanNumeral.toRoman(479),"CDLXXIX");
		eq(RomanNumeral.toRoman(480),"CDLXXX");
		eq(RomanNumeral.toRoman(481),"CDLXXXI");
		eq(RomanNumeral.toRoman(482),"CDLXXXII");
		eq(RomanNumeral.toRoman(483),"CDLXXXIII");
		eq(RomanNumeral.toRoman(484),"CDLXXXIV");
		eq(RomanNumeral.toRoman(485),"CDLXXXV");
		eq(RomanNumeral.toRoman(486),"CDLXXXVI");
		eq(RomanNumeral.toRoman(487),"CDLXXXVII");
		eq(RomanNumeral.toRoman(488),"CDLXXXVIII");
		eq(RomanNumeral.toRoman(489),"CDLXXXIX");
		eq(RomanNumeral.toRoman(490),"CDXC");
		eq(RomanNumeral.toRoman(491),"CDXCI");
		eq(RomanNumeral.toRoman(492),"CDXCII");
		eq(RomanNumeral.toRoman(493),"CDXCIII");
		eq(RomanNumeral.toRoman(494),"CDXCIV");
		eq(RomanNumeral.toRoman(495),"CDXCV");
		eq(RomanNumeral.toRoman(496),"CDXCVI");
		eq(RomanNumeral.toRoman(497),"CDXCVII");
		eq(RomanNumeral.toRoman(498),"CDXCVIII");
		eq(RomanNumeral.toRoman(499),"CDXCIX");
		eq(RomanNumeral.toRoman(500),"D");
		eq(RomanNumeral.toRoman(501),"DI");
		eq(RomanNumeral.toRoman(502),"DII");
		eq(RomanNumeral.toRoman(503),"DIII");
		eq(RomanNumeral.toRoman(504),"DIV");
		eq(RomanNumeral.toRoman(505),"DV");
		eq(RomanNumeral.toRoman(506),"DVI");
		eq(RomanNumeral.toRoman(507),"DVII");
		eq(RomanNumeral.toRoman(508),"DVIII");
		eq(RomanNumeral.toRoman(509),"DIX");
		eq(RomanNumeral.toRoman(510),"DX");
		eq(RomanNumeral.toRoman(511),"DXI");
		eq(RomanNumeral.toRoman(512),"DXII");
		eq(RomanNumeral.toRoman(513),"DXIII");
		eq(RomanNumeral.toRoman(514),"DXIV");
		eq(RomanNumeral.toRoman(515),"DXV");
		eq(RomanNumeral.toRoman(516),"DXVI");
		eq(RomanNumeral.toRoman(517),"DXVII");
		eq(RomanNumeral.toRoman(518),"DXVIII");
		eq(RomanNumeral.toRoman(519),"DXIX");
		eq(RomanNumeral.toRoman(520),"DXX");
		eq(RomanNumeral.toRoman(521),"DXXI");
		eq(RomanNumeral.toRoman(522),"DXXII");
		eq(RomanNumeral.toRoman(523),"DXXIII");
		eq(RomanNumeral.toRoman(524),"DXXIV");
		eq(RomanNumeral.toRoman(525),"DXXV");
		eq(RomanNumeral.toRoman(526),"DXXVI");
		eq(RomanNumeral.toRoman(527),"DXXVII");
		eq(RomanNumeral.toRoman(528),"DXXVIII");
		eq(RomanNumeral.toRoman(529),"DXXIX");
		eq(RomanNumeral.toRoman(530),"DXXX");
		eq(RomanNumeral.toRoman(531),"DXXXI");
		eq(RomanNumeral.toRoman(532),"DXXXII");
		eq(RomanNumeral.toRoman(533),"DXXXIII");
		eq(RomanNumeral.toRoman(534),"DXXXIV");
		eq(RomanNumeral.toRoman(535),"DXXXV");
		eq(RomanNumeral.toRoman(536),"DXXXVI");
		eq(RomanNumeral.toRoman(537),"DXXXVII");
		eq(RomanNumeral.toRoman(538),"DXXXVIII");
		eq(RomanNumeral.toRoman(539),"DXXXIX");
		eq(RomanNumeral.toRoman(540),"DXL");
		eq(RomanNumeral.toRoman(541),"DXLI");
		eq(RomanNumeral.toRoman(542),"DXLII");
		eq(RomanNumeral.toRoman(543),"DXLIII");
		eq(RomanNumeral.toRoman(544),"DXLIV");
		eq(RomanNumeral.toRoman(545),"DXLV");
		eq(RomanNumeral.toRoman(546),"DXLVI");
		eq(RomanNumeral.toRoman(547),"DXLVII");
		eq(RomanNumeral.toRoman(548),"DXLVIII");
		eq(RomanNumeral.toRoman(549),"DXLIX");
		eq(RomanNumeral.toRoman(550),"DL");
		eq(RomanNumeral.toRoman(551),"DLI");
		eq(RomanNumeral.toRoman(552),"DLII");
		eq(RomanNumeral.toRoman(553),"DLIII");
		eq(RomanNumeral.toRoman(554),"DLIV");
		eq(RomanNumeral.toRoman(555),"DLV");
		eq(RomanNumeral.toRoman(556),"DLVI");
		eq(RomanNumeral.toRoman(557),"DLVII");
		eq(RomanNumeral.toRoman(558),"DLVIII");
		eq(RomanNumeral.toRoman(559),"DLIX");
		eq(RomanNumeral.toRoman(560),"DLX");
		eq(RomanNumeral.toRoman(561),"DLXI");
		eq(RomanNumeral.toRoman(562),"DLXII");
		eq(RomanNumeral.toRoman(563),"DLXIII");
		eq(RomanNumeral.toRoman(564),"DLXIV");
		eq(RomanNumeral.toRoman(565),"DLXV");
		eq(RomanNumeral.toRoman(566),"DLXVI");
		eq(RomanNumeral.toRoman(567),"DLXVII");
		eq(RomanNumeral.toRoman(568),"DLXVIII");
		eq(RomanNumeral.toRoman(569),"DLXIX");
		eq(RomanNumeral.toRoman(570),"DLXX");
		eq(RomanNumeral.toRoman(571),"DLXXI");
		eq(RomanNumeral.toRoman(572),"DLXXII");
		eq(RomanNumeral.toRoman(573),"DLXXIII");
		eq(RomanNumeral.toRoman(574),"DLXXIV");
		eq(RomanNumeral.toRoman(575),"DLXXV");
		eq(RomanNumeral.toRoman(576),"DLXXVI");
		eq(RomanNumeral.toRoman(577),"DLXXVII");
		eq(RomanNumeral.toRoman(578),"DLXXVIII");
		eq(RomanNumeral.toRoman(579),"DLXXIX");
		eq(RomanNumeral.toRoman(580),"DLXXX");
		eq(RomanNumeral.toRoman(581),"DLXXXI");
		eq(RomanNumeral.toRoman(582),"DLXXXII");
		eq(RomanNumeral.toRoman(583),"DLXXXIII");
		eq(RomanNumeral.toRoman(584),"DLXXXIV");
		eq(RomanNumeral.toRoman(585),"DLXXXV");
		eq(RomanNumeral.toRoman(586),"DLXXXVI");
		eq(RomanNumeral.toRoman(587),"DLXXXVII");
		eq(RomanNumeral.toRoman(588),"DLXXXVIII");
		eq(RomanNumeral.toRoman(589),"DLXXXIX");
		eq(RomanNumeral.toRoman(590),"DXC");
		eq(RomanNumeral.toRoman(591),"DXCI");
		eq(RomanNumeral.toRoman(592),"DXCII");
		eq(RomanNumeral.toRoman(593),"DXCIII");
		eq(RomanNumeral.toRoman(594),"DXCIV");
		eq(RomanNumeral.toRoman(595),"DXCV");
		eq(RomanNumeral.toRoman(596),"DXCVI");
		eq(RomanNumeral.toRoman(597),"DXCVII");
		eq(RomanNumeral.toRoman(598),"DXCVIII");
		eq(RomanNumeral.toRoman(599),"DXCIX");
		eq(RomanNumeral.toRoman(600),"DC");
		eq(RomanNumeral.toRoman(601),"DCI");
		eq(RomanNumeral.toRoman(602),"DCII");
		eq(RomanNumeral.toRoman(603),"DCIII");
		eq(RomanNumeral.toRoman(604),"DCIV");
		eq(RomanNumeral.toRoman(605),"DCV");
		eq(RomanNumeral.toRoman(606),"DCVI");
		eq(RomanNumeral.toRoman(607),"DCVII");
		eq(RomanNumeral.toRoman(608),"DCVIII");
		eq(RomanNumeral.toRoman(609),"DCIX");
		eq(RomanNumeral.toRoman(610),"DCX");
		eq(RomanNumeral.toRoman(611),"DCXI");
		eq(RomanNumeral.toRoman(612),"DCXII");
		eq(RomanNumeral.toRoman(613),"DCXIII");
		eq(RomanNumeral.toRoman(614),"DCXIV");
		eq(RomanNumeral.toRoman(615),"DCXV");
		eq(RomanNumeral.toRoman(616),"DCXVI");
		eq(RomanNumeral.toRoman(617),"DCXVII");
		eq(RomanNumeral.toRoman(618),"DCXVIII");
		eq(RomanNumeral.toRoman(619),"DCXIX");
		eq(RomanNumeral.toRoman(620),"DCXX");
		eq(RomanNumeral.toRoman(621),"DCXXI");
		eq(RomanNumeral.toRoman(622),"DCXXII");
		eq(RomanNumeral.toRoman(623),"DCXXIII");
		eq(RomanNumeral.toRoman(624),"DCXXIV");
		eq(RomanNumeral.toRoman(625),"DCXXV");
		eq(RomanNumeral.toRoman(626),"DCXXVI");
		eq(RomanNumeral.toRoman(627),"DCXXVII");
		eq(RomanNumeral.toRoman(628),"DCXXVIII");
		eq(RomanNumeral.toRoman(629),"DCXXIX");
		eq(RomanNumeral.toRoman(630),"DCXXX");
		eq(RomanNumeral.toRoman(631),"DCXXXI");
		eq(RomanNumeral.toRoman(632),"DCXXXII");
		eq(RomanNumeral.toRoman(633),"DCXXXIII");
		eq(RomanNumeral.toRoman(634),"DCXXXIV");
		eq(RomanNumeral.toRoman(635),"DCXXXV");
		eq(RomanNumeral.toRoman(636),"DCXXXVI");
		eq(RomanNumeral.toRoman(637),"DCXXXVII");
		eq(RomanNumeral.toRoman(638),"DCXXXVIII");
		eq(RomanNumeral.toRoman(639),"DCXXXIX");
		eq(RomanNumeral.toRoman(640),"DCXL");
		eq(RomanNumeral.toRoman(641),"DCXLI");
		eq(RomanNumeral.toRoman(642),"DCXLII");
		eq(RomanNumeral.toRoman(643),"DCXLIII");
		eq(RomanNumeral.toRoman(644),"DCXLIV");
		eq(RomanNumeral.toRoman(645),"DCXLV");
		eq(RomanNumeral.toRoman(646),"DCXLVI");
		eq(RomanNumeral.toRoman(647),"DCXLVII");
		eq(RomanNumeral.toRoman(648),"DCXLVIII");
		eq(RomanNumeral.toRoman(649),"DCXLIX");
		eq(RomanNumeral.toRoman(650),"DCL");
		eq(RomanNumeral.toRoman(651),"DCLI");
		eq(RomanNumeral.toRoman(652),"DCLII");
		eq(RomanNumeral.toRoman(653),"DCLIII");
		eq(RomanNumeral.toRoman(654),"DCLIV");
		eq(RomanNumeral.toRoman(655),"DCLV");
		eq(RomanNumeral.toRoman(656),"DCLVI");
		eq(RomanNumeral.toRoman(657),"DCLVII");
		eq(RomanNumeral.toRoman(658),"DCLVIII");
		eq(RomanNumeral.toRoman(659),"DCLIX");
		eq(RomanNumeral.toRoman(660),"DCLX");
		eq(RomanNumeral.toRoman(661),"DCLXI");
		eq(RomanNumeral.toRoman(662),"DCLXII");
		eq(RomanNumeral.toRoman(663),"DCLXIII");
		eq(RomanNumeral.toRoman(664),"DCLXIV");
		eq(RomanNumeral.toRoman(665),"DCLXV");
		eq(RomanNumeral.toRoman(666),"DCLXVI");
		eq(RomanNumeral.toRoman(667),"DCLXVII");
		eq(RomanNumeral.toRoman(668),"DCLXVIII");
		eq(RomanNumeral.toRoman(669),"DCLXIX");
		eq(RomanNumeral.toRoman(670),"DCLXX");
		eq(RomanNumeral.toRoman(671),"DCLXXI");
		eq(RomanNumeral.toRoman(672),"DCLXXII");
		eq(RomanNumeral.toRoman(673),"DCLXXIII");
		eq(RomanNumeral.toRoman(674),"DCLXXIV");
		eq(RomanNumeral.toRoman(675),"DCLXXV");
		eq(RomanNumeral.toRoman(676),"DCLXXVI");
		eq(RomanNumeral.toRoman(677),"DCLXXVII");
		eq(RomanNumeral.toRoman(678),"DCLXXVIII");
		eq(RomanNumeral.toRoman(679),"DCLXXIX");
		eq(RomanNumeral.toRoman(680),"DCLXXX");
		eq(RomanNumeral.toRoman(681),"DCLXXXI");
		eq(RomanNumeral.toRoman(682),"DCLXXXII");
		eq(RomanNumeral.toRoman(683),"DCLXXXIII");
		eq(RomanNumeral.toRoman(684),"DCLXXXIV");
		eq(RomanNumeral.toRoman(685),"DCLXXXV");
		eq(RomanNumeral.toRoman(686),"DCLXXXVI");
		eq(RomanNumeral.toRoman(687),"DCLXXXVII");
		eq(RomanNumeral.toRoman(688),"DCLXXXVIII");
		eq(RomanNumeral.toRoman(689),"DCLXXXIX");
		eq(RomanNumeral.toRoman(690),"DCXC");
		eq(RomanNumeral.toRoman(691),"DCXCI");
		eq(RomanNumeral.toRoman(692),"DCXCII");
		eq(RomanNumeral.toRoman(693),"DCXCIII");
		eq(RomanNumeral.toRoman(694),"DCXCIV");
		eq(RomanNumeral.toRoman(695),"DCXCV");
		eq(RomanNumeral.toRoman(696),"DCXCVI");
		eq(RomanNumeral.toRoman(697),"DCXCVII");
		eq(RomanNumeral.toRoman(698),"DCXCVIII");
		eq(RomanNumeral.toRoman(699),"DCXCIX");
		eq(RomanNumeral.toRoman(700),"DCC");
		eq(RomanNumeral.toRoman(701),"DCCI");
		eq(RomanNumeral.toRoman(702),"DCCII");
		eq(RomanNumeral.toRoman(703),"DCCIII");
		eq(RomanNumeral.toRoman(704),"DCCIV");
		eq(RomanNumeral.toRoman(705),"DCCV");
		eq(RomanNumeral.toRoman(706),"DCCVI");
		eq(RomanNumeral.toRoman(707),"DCCVII");
		eq(RomanNumeral.toRoman(708),"DCCVIII");
		eq(RomanNumeral.toRoman(709),"DCCIX");
		eq(RomanNumeral.toRoman(710),"DCCX");
		eq(RomanNumeral.toRoman(711),"DCCXI");
		eq(RomanNumeral.toRoman(712),"DCCXII");
		eq(RomanNumeral.toRoman(713),"DCCXIII");
		eq(RomanNumeral.toRoman(714),"DCCXIV");
		eq(RomanNumeral.toRoman(715),"DCCXV");
		eq(RomanNumeral.toRoman(716),"DCCXVI");
		eq(RomanNumeral.toRoman(717),"DCCXVII");
		eq(RomanNumeral.toRoman(718),"DCCXVIII");
		eq(RomanNumeral.toRoman(719),"DCCXIX");
		eq(RomanNumeral.toRoman(720),"DCCXX");
		eq(RomanNumeral.toRoman(721),"DCCXXI");
		eq(RomanNumeral.toRoman(722),"DCCXXII");
		eq(RomanNumeral.toRoman(723),"DCCXXIII");
		eq(RomanNumeral.toRoman(724),"DCCXXIV");
		eq(RomanNumeral.toRoman(725),"DCCXXV");
		eq(RomanNumeral.toRoman(726),"DCCXXVI");
		eq(RomanNumeral.toRoman(727),"DCCXXVII");
		eq(RomanNumeral.toRoman(728),"DCCXXVIII");
		eq(RomanNumeral.toRoman(729),"DCCXXIX");
		eq(RomanNumeral.toRoman(730),"DCCXXX");
		eq(RomanNumeral.toRoman(731),"DCCXXXI");
		eq(RomanNumeral.toRoman(732),"DCCXXXII");
		eq(RomanNumeral.toRoman(733),"DCCXXXIII");
		eq(RomanNumeral.toRoman(734),"DCCXXXIV");
		eq(RomanNumeral.toRoman(735),"DCCXXXV");
		eq(RomanNumeral.toRoman(736),"DCCXXXVI");
		eq(RomanNumeral.toRoman(737),"DCCXXXVII");
		eq(RomanNumeral.toRoman(738),"DCCXXXVIII");
		eq(RomanNumeral.toRoman(739),"DCCXXXIX");
		eq(RomanNumeral.toRoman(740),"DCCXL");
		eq(RomanNumeral.toRoman(741),"DCCXLI");
		eq(RomanNumeral.toRoman(742),"DCCXLII");
		eq(RomanNumeral.toRoman(743),"DCCXLIII");
		eq(RomanNumeral.toRoman(744),"DCCXLIV");
		eq(RomanNumeral.toRoman(745),"DCCXLV");
		eq(RomanNumeral.toRoman(746),"DCCXLVI");
		eq(RomanNumeral.toRoman(747),"DCCXLVII");
		eq(RomanNumeral.toRoman(748),"DCCXLVIII");
		eq(RomanNumeral.toRoman(749),"DCCXLIX");
		eq(RomanNumeral.toRoman(750),"DCCL");
		eq(RomanNumeral.toRoman(751),"DCCLI");
		eq(RomanNumeral.toRoman(752),"DCCLII");
		eq(RomanNumeral.toRoman(753),"DCCLIII");
		eq(RomanNumeral.toRoman(754),"DCCLIV");
		eq(RomanNumeral.toRoman(755),"DCCLV");
		eq(RomanNumeral.toRoman(756),"DCCLVI");
		eq(RomanNumeral.toRoman(757),"DCCLVII");
		eq(RomanNumeral.toRoman(758),"DCCLVIII");
		eq(RomanNumeral.toRoman(759),"DCCLIX");
		eq(RomanNumeral.toRoman(760),"DCCLX");
		eq(RomanNumeral.toRoman(761),"DCCLXI");
		eq(RomanNumeral.toRoman(762),"DCCLXII");
		eq(RomanNumeral.toRoman(763),"DCCLXIII");
		eq(RomanNumeral.toRoman(764),"DCCLXIV");
		eq(RomanNumeral.toRoman(765),"DCCLXV");
		eq(RomanNumeral.toRoman(766),"DCCLXVI");
		eq(RomanNumeral.toRoman(767),"DCCLXVII");
		eq(RomanNumeral.toRoman(768),"DCCLXVIII");
		eq(RomanNumeral.toRoman(769),"DCCLXIX");
		eq(RomanNumeral.toRoman(770),"DCCLXX");
		eq(RomanNumeral.toRoman(771),"DCCLXXI");
		eq(RomanNumeral.toRoman(772),"DCCLXXII");
		eq(RomanNumeral.toRoman(773),"DCCLXXIII");
		eq(RomanNumeral.toRoman(774),"DCCLXXIV");
		eq(RomanNumeral.toRoman(775),"DCCLXXV");
		eq(RomanNumeral.toRoman(776),"DCCLXXVI");
		eq(RomanNumeral.toRoman(777),"DCCLXXVII");
		eq(RomanNumeral.toRoman(778),"DCCLXXVIII");
		eq(RomanNumeral.toRoman(779),"DCCLXXIX");
		eq(RomanNumeral.toRoman(780),"DCCLXXX");
		eq(RomanNumeral.toRoman(781),"DCCLXXXI");
		eq(RomanNumeral.toRoman(782),"DCCLXXXII");
		eq(RomanNumeral.toRoman(783),"DCCLXXXIII");
		eq(RomanNumeral.toRoman(784),"DCCLXXXIV");
		eq(RomanNumeral.toRoman(785),"DCCLXXXV");
		eq(RomanNumeral.toRoman(786),"DCCLXXXVI");
		eq(RomanNumeral.toRoman(787),"DCCLXXXVII");
		eq(RomanNumeral.toRoman(788),"DCCLXXXVIII");
		eq(RomanNumeral.toRoman(789),"DCCLXXXIX");
		eq(RomanNumeral.toRoman(790),"DCCXC");
		eq(RomanNumeral.toRoman(791),"DCCXCI");
		eq(RomanNumeral.toRoman(792),"DCCXCII");
		eq(RomanNumeral.toRoman(793),"DCCXCIII");
		eq(RomanNumeral.toRoman(794),"DCCXCIV");
		eq(RomanNumeral.toRoman(795),"DCCXCV");
		eq(RomanNumeral.toRoman(796),"DCCXCVI");
		eq(RomanNumeral.toRoman(797),"DCCXCVII");
		eq(RomanNumeral.toRoman(798),"DCCXCVIII");
		eq(RomanNumeral.toRoman(799),"DCCXCIX");
		eq(RomanNumeral.toRoman(800),"DCCC");
		eq(RomanNumeral.toRoman(801),"DCCCI");
		eq(RomanNumeral.toRoman(802),"DCCCII");
		eq(RomanNumeral.toRoman(803),"DCCCIII");
		eq(RomanNumeral.toRoman(804),"DCCCIV");
		eq(RomanNumeral.toRoman(805),"DCCCV");
		eq(RomanNumeral.toRoman(806),"DCCCVI");
		eq(RomanNumeral.toRoman(807),"DCCCVII");
		eq(RomanNumeral.toRoman(808),"DCCCVIII");
		eq(RomanNumeral.toRoman(809),"DCCCIX");
		eq(RomanNumeral.toRoman(810),"DCCCX");
		eq(RomanNumeral.toRoman(811),"DCCCXI");
		eq(RomanNumeral.toRoman(812),"DCCCXII");
		eq(RomanNumeral.toRoman(813),"DCCCXIII");
		eq(RomanNumeral.toRoman(814),"DCCCXIV");
		eq(RomanNumeral.toRoman(815),"DCCCXV");
		eq(RomanNumeral.toRoman(816),"DCCCXVI");
		eq(RomanNumeral.toRoman(817),"DCCCXVII");
		eq(RomanNumeral.toRoman(818),"DCCCXVIII");
		eq(RomanNumeral.toRoman(819),"DCCCXIX");
		eq(RomanNumeral.toRoman(820),"DCCCXX");
		eq(RomanNumeral.toRoman(821),"DCCCXXI");
		eq(RomanNumeral.toRoman(822),"DCCCXXII");
		eq(RomanNumeral.toRoman(823),"DCCCXXIII");
		eq(RomanNumeral.toRoman(824),"DCCCXXIV");
		eq(RomanNumeral.toRoman(825),"DCCCXXV");
		eq(RomanNumeral.toRoman(826),"DCCCXXVI");
		eq(RomanNumeral.toRoman(827),"DCCCXXVII");
		eq(RomanNumeral.toRoman(828),"DCCCXXVIII");
		eq(RomanNumeral.toRoman(829),"DCCCXXIX");
		eq(RomanNumeral.toRoman(830),"DCCCXXX");
		eq(RomanNumeral.toRoman(831),"DCCCXXXI");
		eq(RomanNumeral.toRoman(832),"DCCCXXXII");
		eq(RomanNumeral.toRoman(833),"DCCCXXXIII");
		eq(RomanNumeral.toRoman(834),"DCCCXXXIV");
		eq(RomanNumeral.toRoman(835),"DCCCXXXV");
		eq(RomanNumeral.toRoman(836),"DCCCXXXVI");
		eq(RomanNumeral.toRoman(837),"DCCCXXXVII");
		eq(RomanNumeral.toRoman(838),"DCCCXXXVIII");
		eq(RomanNumeral.toRoman(839),"DCCCXXXIX");
		eq(RomanNumeral.toRoman(840),"DCCCXL");
		eq(RomanNumeral.toRoman(841),"DCCCXLI");
		eq(RomanNumeral.toRoman(842),"DCCCXLII");
		eq(RomanNumeral.toRoman(843),"DCCCXLIII");
		eq(RomanNumeral.toRoman(844),"DCCCXLIV");
		eq(RomanNumeral.toRoman(845),"DCCCXLV");
		eq(RomanNumeral.toRoman(846),"DCCCXLVI");
		eq(RomanNumeral.toRoman(847),"DCCCXLVII");
		eq(RomanNumeral.toRoman(848),"DCCCXLVIII");
		eq(RomanNumeral.toRoman(849),"DCCCXLIX");
		eq(RomanNumeral.toRoman(850),"DCCCL");
		eq(RomanNumeral.toRoman(851),"DCCCLI");
		eq(RomanNumeral.toRoman(852),"DCCCLII");
		eq(RomanNumeral.toRoman(853),"DCCCLIII");
		eq(RomanNumeral.toRoman(854),"DCCCLIV");
		eq(RomanNumeral.toRoman(855),"DCCCLV");
		eq(RomanNumeral.toRoman(856),"DCCCLVI");
		eq(RomanNumeral.toRoman(857),"DCCCLVII");
		eq(RomanNumeral.toRoman(858),"DCCCLVIII");
		eq(RomanNumeral.toRoman(859),"DCCCLIX");
		eq(RomanNumeral.toRoman(860),"DCCCLX");
		eq(RomanNumeral.toRoman(861),"DCCCLXI");
		eq(RomanNumeral.toRoman(862),"DCCCLXII");
		eq(RomanNumeral.toRoman(863),"DCCCLXIII");
		eq(RomanNumeral.toRoman(864),"DCCCLXIV");
		eq(RomanNumeral.toRoman(865),"DCCCLXV");
		eq(RomanNumeral.toRoman(866),"DCCCLXVI");
		eq(RomanNumeral.toRoman(867),"DCCCLXVII");
		eq(RomanNumeral.toRoman(868),"DCCCLXVIII");
		eq(RomanNumeral.toRoman(869),"DCCCLXIX");
		eq(RomanNumeral.toRoman(870),"DCCCLXX");
		eq(RomanNumeral.toRoman(871),"DCCCLXXI");
		eq(RomanNumeral.toRoman(872),"DCCCLXXII");
		eq(RomanNumeral.toRoman(873),"DCCCLXXIII");
		eq(RomanNumeral.toRoman(874),"DCCCLXXIV");
		eq(RomanNumeral.toRoman(875),"DCCCLXXV");
		eq(RomanNumeral.toRoman(876),"DCCCLXXVI");
		eq(RomanNumeral.toRoman(877),"DCCCLXXVII");
		eq(RomanNumeral.toRoman(878),"DCCCLXXVIII");
		eq(RomanNumeral.toRoman(879),"DCCCLXXIX");
		eq(RomanNumeral.toRoman(880),"DCCCLXXX");
		eq(RomanNumeral.toRoman(881),"DCCCLXXXI");
		eq(RomanNumeral.toRoman(882),"DCCCLXXXII");
		eq(RomanNumeral.toRoman(883),"DCCCLXXXIII");
		eq(RomanNumeral.toRoman(884),"DCCCLXXXIV");
		eq(RomanNumeral.toRoman(885),"DCCCLXXXV");
		eq(RomanNumeral.toRoman(886),"DCCCLXXXVI");
		eq(RomanNumeral.toRoman(887),"DCCCLXXXVII");
		eq(RomanNumeral.toRoman(888),"DCCCLXXXVIII");
		eq(RomanNumeral.toRoman(889),"DCCCLXXXIX");
		eq(RomanNumeral.toRoman(890),"DCCCXC");
		eq(RomanNumeral.toRoman(891),"DCCCXCI");
		eq(RomanNumeral.toRoman(892),"DCCCXCII");
		eq(RomanNumeral.toRoman(893),"DCCCXCIII");
		eq(RomanNumeral.toRoman(894),"DCCCXCIV");
		eq(RomanNumeral.toRoman(895),"DCCCXCV");
		eq(RomanNumeral.toRoman(896),"DCCCXCVI");
		eq(RomanNumeral.toRoman(897),"DCCCXCVII");
		eq(RomanNumeral.toRoman(898),"DCCCXCVIII");
		eq(RomanNumeral.toRoman(899),"DCCCXCIX");
		eq(RomanNumeral.toRoman(900),"CM");
		eq(RomanNumeral.toRoman(901),"CMI");
		eq(RomanNumeral.toRoman(902),"CMII");
		eq(RomanNumeral.toRoman(903),"CMIII");
		eq(RomanNumeral.toRoman(904),"CMIV");
		eq(RomanNumeral.toRoman(905),"CMV");
		eq(RomanNumeral.toRoman(906),"CMVI");
		eq(RomanNumeral.toRoman(907),"CMVII");
		eq(RomanNumeral.toRoman(908),"CMVIII");
		eq(RomanNumeral.toRoman(909),"CMIX");
		eq(RomanNumeral.toRoman(910),"CMX");
		eq(RomanNumeral.toRoman(911),"CMXI");
		eq(RomanNumeral.toRoman(912),"CMXII");
		eq(RomanNumeral.toRoman(913),"CMXIII");
		eq(RomanNumeral.toRoman(914),"CMXIV");
		eq(RomanNumeral.toRoman(915),"CMXV");
		eq(RomanNumeral.toRoman(916),"CMXVI");
		eq(RomanNumeral.toRoman(917),"CMXVII");
		eq(RomanNumeral.toRoman(918),"CMXVIII");
		eq(RomanNumeral.toRoman(919),"CMXIX");
		eq(RomanNumeral.toRoman(920),"CMXX");
		eq(RomanNumeral.toRoman(921),"CMXXI");
		eq(RomanNumeral.toRoman(922),"CMXXII");
		eq(RomanNumeral.toRoman(923),"CMXXIII");
		eq(RomanNumeral.toRoman(924),"CMXXIV");
		eq(RomanNumeral.toRoman(925),"CMXXV");
		eq(RomanNumeral.toRoman(926),"CMXXVI");
		eq(RomanNumeral.toRoman(927),"CMXXVII");
		eq(RomanNumeral.toRoman(928),"CMXXVIII");
		eq(RomanNumeral.toRoman(929),"CMXXIX");
		eq(RomanNumeral.toRoman(930),"CMXXX");
		eq(RomanNumeral.toRoman(931),"CMXXXI");
		eq(RomanNumeral.toRoman(932),"CMXXXII");
		eq(RomanNumeral.toRoman(933),"CMXXXIII");
		eq(RomanNumeral.toRoman(934),"CMXXXIV");
		eq(RomanNumeral.toRoman(935),"CMXXXV");
		eq(RomanNumeral.toRoman(936),"CMXXXVI");
		eq(RomanNumeral.toRoman(937),"CMXXXVII");
		eq(RomanNumeral.toRoman(938),"CMXXXVIII");
		eq(RomanNumeral.toRoman(939),"CMXXXIX");
		eq(RomanNumeral.toRoman(940),"CMXL");
		eq(RomanNumeral.toRoman(941),"CMXLI");
		eq(RomanNumeral.toRoman(942),"CMXLII");
		eq(RomanNumeral.toRoman(943),"CMXLIII");
		eq(RomanNumeral.toRoman(944),"CMXLIV");
		eq(RomanNumeral.toRoman(945),"CMXLV");
		eq(RomanNumeral.toRoman(946),"CMXLVI");
		eq(RomanNumeral.toRoman(947),"CMXLVII");
		eq(RomanNumeral.toRoman(948),"CMXLVIII");
		eq(RomanNumeral.toRoman(949),"CMXLIX");
		eq(RomanNumeral.toRoman(950),"CML");
		eq(RomanNumeral.toRoman(951),"CMLI");
		eq(RomanNumeral.toRoman(952),"CMLII");
		eq(RomanNumeral.toRoman(953),"CMLIII");
		eq(RomanNumeral.toRoman(954),"CMLIV");
		eq(RomanNumeral.toRoman(955),"CMLV");
		eq(RomanNumeral.toRoman(956),"CMLVI");
		eq(RomanNumeral.toRoman(957),"CMLVII");
		eq(RomanNumeral.toRoman(958),"CMLVIII");
		eq(RomanNumeral.toRoman(959),"CMLIX");
		eq(RomanNumeral.toRoman(960),"CMLX");
		eq(RomanNumeral.toRoman(961),"CMLXI");
		eq(RomanNumeral.toRoman(962),"CMLXII");
		eq(RomanNumeral.toRoman(963),"CMLXIII");
		eq(RomanNumeral.toRoman(964),"CMLXIV");
		eq(RomanNumeral.toRoman(965),"CMLXV");
		eq(RomanNumeral.toRoman(966),"CMLXVI");
		eq(RomanNumeral.toRoman(967),"CMLXVII");
		eq(RomanNumeral.toRoman(968),"CMLXVIII");
		eq(RomanNumeral.toRoman(969),"CMLXIX");
		eq(RomanNumeral.toRoman(970),"CMLXX");
		eq(RomanNumeral.toRoman(971),"CMLXXI");
		eq(RomanNumeral.toRoman(972),"CMLXXII");
		eq(RomanNumeral.toRoman(973),"CMLXXIII");
		eq(RomanNumeral.toRoman(974),"CMLXXIV");
		eq(RomanNumeral.toRoman(975),"CMLXXV");
		eq(RomanNumeral.toRoman(976),"CMLXXVI");
		eq(RomanNumeral.toRoman(977),"CMLXXVII");
		eq(RomanNumeral.toRoman(978),"CMLXXVIII");
		eq(RomanNumeral.toRoman(979),"CMLXXIX");
		eq(RomanNumeral.toRoman(980),"CMLXXX");
		eq(RomanNumeral.toRoman(981),"CMLXXXI");
		eq(RomanNumeral.toRoman(982),"CMLXXXII");
		eq(RomanNumeral.toRoman(983),"CMLXXXIII");
		eq(RomanNumeral.toRoman(984),"CMLXXXIV");
		eq(RomanNumeral.toRoman(985),"CMLXXXV");
		eq(RomanNumeral.toRoman(986),"CMLXXXVI");
		eq(RomanNumeral.toRoman(987),"CMLXXXVII");
		eq(RomanNumeral.toRoman(988),"CMLXXXVIII");
		eq(RomanNumeral.toRoman(989),"CMLXXXIX");
		eq(RomanNumeral.toRoman(990),"CMXC");
		eq(RomanNumeral.toRoman(991),"CMXCI");
		eq(RomanNumeral.toRoman(992),"CMXCII");
		eq(RomanNumeral.toRoman(993),"CMXCIII");
		eq(RomanNumeral.toRoman(994),"CMXCIV");
		eq(RomanNumeral.toRoman(995),"CMXCV");
		eq(RomanNumeral.toRoman(996),"CMXCVI");
		eq(RomanNumeral.toRoman(997),"CMXCVII");
		eq(RomanNumeral.toRoman(998),"CMXCVIII");
		eq(RomanNumeral.toRoman(999),"CMXCIX");
		eq(RomanNumeral.toRoman(1000),"M");
		eq(RomanNumeral.toRoman(1001),"MI");
		eq(RomanNumeral.toRoman(1002),"MII");
		eq(RomanNumeral.toRoman(1003),"MIII");
		eq(RomanNumeral.toRoman(1004),"MIV");
		eq(RomanNumeral.toRoman(1005),"MV");
		eq(RomanNumeral.toRoman(1006),"MVI");
		eq(RomanNumeral.toRoman(1007),"MVII");
		eq(RomanNumeral.toRoman(1008),"MVIII");
		eq(RomanNumeral.toRoman(1009),"MIX");
		eq(RomanNumeral.toRoman(1010),"MX");
		eq(RomanNumeral.toRoman(1011),"MXI");
		eq(RomanNumeral.toRoman(1012),"MXII");
		eq(RomanNumeral.toRoman(1013),"MXIII");
		eq(RomanNumeral.toRoman(1014),"MXIV");
		eq(RomanNumeral.toRoman(1015),"MXV");
		eq(RomanNumeral.toRoman(1016),"MXVI");
		eq(RomanNumeral.toRoman(1017),"MXVII");
		eq(RomanNumeral.toRoman(1018),"MXVIII");
		eq(RomanNumeral.toRoman(1019),"MXIX");
		eq(RomanNumeral.toRoman(1020),"MXX");
		eq(RomanNumeral.toRoman(1021),"MXXI");
		eq(RomanNumeral.toRoman(1022),"MXXII");
		eq(RomanNumeral.toRoman(1023),"MXXIII");
		eq(RomanNumeral.toRoman(1024),"MXXIV");
		eq(RomanNumeral.toRoman(1025),"MXXV");
		eq(RomanNumeral.toRoman(1026),"MXXVI");
		eq(RomanNumeral.toRoman(1027),"MXXVII");
		eq(RomanNumeral.toRoman(1028),"MXXVIII");
		eq(RomanNumeral.toRoman(1029),"MXXIX");
		eq(RomanNumeral.toRoman(1030),"MXXX");
		eq(RomanNumeral.toRoman(1031),"MXXXI");
		eq(RomanNumeral.toRoman(1032),"MXXXII");
		eq(RomanNumeral.toRoman(1033),"MXXXIII");
		eq(RomanNumeral.toRoman(1034),"MXXXIV");
		eq(RomanNumeral.toRoman(1035),"MXXXV");
		eq(RomanNumeral.toRoman(1036),"MXXXVI");
		eq(RomanNumeral.toRoman(1037),"MXXXVII");
		eq(RomanNumeral.toRoman(1038),"MXXXVIII");
		eq(RomanNumeral.toRoman(1039),"MXXXIX");
		eq(RomanNumeral.toRoman(1040),"MXL");
		eq(RomanNumeral.toRoman(1041),"MXLI");
		eq(RomanNumeral.toRoman(1042),"MXLII");
		eq(RomanNumeral.toRoman(1043),"MXLIII");
		eq(RomanNumeral.toRoman(1044),"MXLIV");
		eq(RomanNumeral.toRoman(1045),"MXLV");
		eq(RomanNumeral.toRoman(1046),"MXLVI");
		eq(RomanNumeral.toRoman(1047),"MXLVII");
		eq(RomanNumeral.toRoman(1048),"MXLVIII");
		eq(RomanNumeral.toRoman(1049),"MXLIX");
		eq(RomanNumeral.toRoman(1050),"ML");
		eq(RomanNumeral.toRoman(1051),"MLI");
		eq(RomanNumeral.toRoman(1052),"MLII");
		eq(RomanNumeral.toRoman(1053),"MLIII");
		eq(RomanNumeral.toRoman(1054),"MLIV");
		eq(RomanNumeral.toRoman(1055),"MLV");
		eq(RomanNumeral.toRoman(1056),"MLVI");
		eq(RomanNumeral.toRoman(1057),"MLVII");
		eq(RomanNumeral.toRoman(1058),"MLVIII");
		eq(RomanNumeral.toRoman(1059),"MLIX");
		eq(RomanNumeral.toRoman(1060),"MLX");
		eq(RomanNumeral.toRoman(1061),"MLXI");
		eq(RomanNumeral.toRoman(1062),"MLXII");
		eq(RomanNumeral.toRoman(1063),"MLXIII");
		eq(RomanNumeral.toRoman(1064),"MLXIV");
		eq(RomanNumeral.toRoman(1065),"MLXV");
		eq(RomanNumeral.toRoman(1066),"MLXVI");
		eq(RomanNumeral.toRoman(1067),"MLXVII");
		eq(RomanNumeral.toRoman(1068),"MLXVIII");
		eq(RomanNumeral.toRoman(1069),"MLXIX");
		eq(RomanNumeral.toRoman(1070),"MLXX");
		eq(RomanNumeral.toRoman(1071),"MLXXI");
		eq(RomanNumeral.toRoman(1072),"MLXXII");
		eq(RomanNumeral.toRoman(1073),"MLXXIII");
		eq(RomanNumeral.toRoman(1074),"MLXXIV");
		eq(RomanNumeral.toRoman(1075),"MLXXV");
		eq(RomanNumeral.toRoman(1076),"MLXXVI");
		eq(RomanNumeral.toRoman(1077),"MLXXVII");
		eq(RomanNumeral.toRoman(1078),"MLXXVIII");
		eq(RomanNumeral.toRoman(1079),"MLXXIX");
		eq(RomanNumeral.toRoman(1080),"MLXXX");
		eq(RomanNumeral.toRoman(1081),"MLXXXI");
		eq(RomanNumeral.toRoman(1082),"MLXXXII");
		eq(RomanNumeral.toRoman(1083),"MLXXXIII");
		eq(RomanNumeral.toRoman(1084),"MLXXXIV");
		eq(RomanNumeral.toRoman(1085),"MLXXXV");
		eq(RomanNumeral.toRoman(1086),"MLXXXVI");
		eq(RomanNumeral.toRoman(1087),"MLXXXVII");
		eq(RomanNumeral.toRoman(1088),"MLXXXVIII");
		eq(RomanNumeral.toRoman(1089),"MLXXXIX");
		eq(RomanNumeral.toRoman(1090),"MXC");
		eq(RomanNumeral.toRoman(1091),"MXCI");
		eq(RomanNumeral.toRoman(1092),"MXCII");
		eq(RomanNumeral.toRoman(1093),"MXCIII");
		eq(RomanNumeral.toRoman(1094),"MXCIV");
		eq(RomanNumeral.toRoman(1095),"MXCV");
		eq(RomanNumeral.toRoman(1096),"MXCVI");
		eq(RomanNumeral.toRoman(1097),"MXCVII");
		eq(RomanNumeral.toRoman(1098),"MXCVIII");
		eq(RomanNumeral.toRoman(1099),"MXCIX");
		eq(RomanNumeral.toRoman(1100),"MC");
		eq(RomanNumeral.toRoman(1101),"MCI");
		eq(RomanNumeral.toRoman(1102),"MCII");
		eq(RomanNumeral.toRoman(1103),"MCIII");
		eq(RomanNumeral.toRoman(1104),"MCIV");
		eq(RomanNumeral.toRoman(1105),"MCV");
		eq(RomanNumeral.toRoman(1106),"MCVI");
		eq(RomanNumeral.toRoman(1107),"MCVII");
		eq(RomanNumeral.toRoman(1108),"MCVIII");
		eq(RomanNumeral.toRoman(1109),"MCIX");
		eq(RomanNumeral.toRoman(1110),"MCX");
		eq(RomanNumeral.toRoman(1111),"MCXI");
		eq(RomanNumeral.toRoman(1112),"MCXII");
		eq(RomanNumeral.toRoman(1113),"MCXIII");
		eq(RomanNumeral.toRoman(1114),"MCXIV");
		eq(RomanNumeral.toRoman(1115),"MCXV");
		eq(RomanNumeral.toRoman(1116),"MCXVI");
		eq(RomanNumeral.toRoman(1117),"MCXVII");
		eq(RomanNumeral.toRoman(1118),"MCXVIII");
		eq(RomanNumeral.toRoman(1119),"MCXIX");
		eq(RomanNumeral.toRoman(1120),"MCXX");
		eq(RomanNumeral.toRoman(1121),"MCXXI");
		eq(RomanNumeral.toRoman(1122),"MCXXII");
		eq(RomanNumeral.toRoman(1123),"MCXXIII");
		eq(RomanNumeral.toRoman(1124),"MCXXIV");
		eq(RomanNumeral.toRoman(1125),"MCXXV");
		eq(RomanNumeral.toRoman(1126),"MCXXVI");
		eq(RomanNumeral.toRoman(1127),"MCXXVII");
		eq(RomanNumeral.toRoman(1128),"MCXXVIII");
		eq(RomanNumeral.toRoman(1129),"MCXXIX");
		eq(RomanNumeral.toRoman(1130),"MCXXX");
		eq(RomanNumeral.toRoman(1131),"MCXXXI");
		eq(RomanNumeral.toRoman(1132),"MCXXXII");
		eq(RomanNumeral.toRoman(1133),"MCXXXIII");
		eq(RomanNumeral.toRoman(1134),"MCXXXIV");
		eq(RomanNumeral.toRoman(1135),"MCXXXV");
		eq(RomanNumeral.toRoman(1136),"MCXXXVI");
		eq(RomanNumeral.toRoman(1137),"MCXXXVII");
		eq(RomanNumeral.toRoman(1138),"MCXXXVIII");
		eq(RomanNumeral.toRoman(1139),"MCXXXIX");
		eq(RomanNumeral.toRoman(1140),"MCXL");
		eq(RomanNumeral.toRoman(1141),"MCXLI");
		eq(RomanNumeral.toRoman(1142),"MCXLII");
		eq(RomanNumeral.toRoman(1143),"MCXLIII");
		eq(RomanNumeral.toRoman(1144),"MCXLIV");
		eq(RomanNumeral.toRoman(1145),"MCXLV");
		eq(RomanNumeral.toRoman(1146),"MCXLVI");
		eq(RomanNumeral.toRoman(1147),"MCXLVII");
		eq(RomanNumeral.toRoman(1148),"MCXLVIII");
		eq(RomanNumeral.toRoman(1149),"MCXLIX");
		eq(RomanNumeral.toRoman(1150),"MCL");
		eq(RomanNumeral.toRoman(1151),"MCLI");
		eq(RomanNumeral.toRoman(1152),"MCLII");
		eq(RomanNumeral.toRoman(1153),"MCLIII");
		eq(RomanNumeral.toRoman(1154),"MCLIV");
		eq(RomanNumeral.toRoman(1155),"MCLV");
		eq(RomanNumeral.toRoman(1156),"MCLVI");
		eq(RomanNumeral.toRoman(1157),"MCLVII");
		eq(RomanNumeral.toRoman(1158),"MCLVIII");
		eq(RomanNumeral.toRoman(1159),"MCLIX");
		eq(RomanNumeral.toRoman(1160),"MCLX");
		eq(RomanNumeral.toRoman(1161),"MCLXI");
		eq(RomanNumeral.toRoman(1162),"MCLXII");
		eq(RomanNumeral.toRoman(1163),"MCLXIII");
		eq(RomanNumeral.toRoman(1164),"MCLXIV");
		eq(RomanNumeral.toRoman(1165),"MCLXV");
		eq(RomanNumeral.toRoman(1166),"MCLXVI");
		eq(RomanNumeral.toRoman(1167),"MCLXVII");
		eq(RomanNumeral.toRoman(1168),"MCLXVIII");
		eq(RomanNumeral.toRoman(1169),"MCLXIX");
		eq(RomanNumeral.toRoman(1170),"MCLXX");
		eq(RomanNumeral.toRoman(1171),"MCLXXI");
		eq(RomanNumeral.toRoman(1172),"MCLXXII");
		eq(RomanNumeral.toRoman(1173),"MCLXXIII");
		eq(RomanNumeral.toRoman(1174),"MCLXXIV");
		eq(RomanNumeral.toRoman(1175),"MCLXXV");
		eq(RomanNumeral.toRoman(1176),"MCLXXVI");
		eq(RomanNumeral.toRoman(1177),"MCLXXVII");
		eq(RomanNumeral.toRoman(1178),"MCLXXVIII");
		eq(RomanNumeral.toRoman(1179),"MCLXXIX");
		eq(RomanNumeral.toRoman(1180),"MCLXXX");
		eq(RomanNumeral.toRoman(1181),"MCLXXXI");
		eq(RomanNumeral.toRoman(1182),"MCLXXXII");
		eq(RomanNumeral.toRoman(1183),"MCLXXXIII");
		eq(RomanNumeral.toRoman(1184),"MCLXXXIV");
		eq(RomanNumeral.toRoman(1185),"MCLXXXV");
		eq(RomanNumeral.toRoman(1186),"MCLXXXVI");
		eq(RomanNumeral.toRoman(1187),"MCLXXXVII");
		eq(RomanNumeral.toRoman(1188),"MCLXXXVIII");
		eq(RomanNumeral.toRoman(1189),"MCLXXXIX");
		eq(RomanNumeral.toRoman(1190),"MCXC");
		eq(RomanNumeral.toRoman(1191),"MCXCI");
		eq(RomanNumeral.toRoman(1192),"MCXCII");
		eq(RomanNumeral.toRoman(1193),"MCXCIII");
		eq(RomanNumeral.toRoman(1194),"MCXCIV");
		eq(RomanNumeral.toRoman(1195),"MCXCV");
		eq(RomanNumeral.toRoman(1196),"MCXCVI");
		eq(RomanNumeral.toRoman(1197),"MCXCVII");
		eq(RomanNumeral.toRoman(1198),"MCXCVIII");
		eq(RomanNumeral.toRoman(1199),"MCXCIX");
		eq(RomanNumeral.toRoman(1200),"MCC");
		eq(RomanNumeral.toRoman(1201),"MCCI");
		eq(RomanNumeral.toRoman(1202),"MCCII");
		eq(RomanNumeral.toRoman(1203),"MCCIII");
		eq(RomanNumeral.toRoman(1204),"MCCIV");
		eq(RomanNumeral.toRoman(1205),"MCCV");
		eq(RomanNumeral.toRoman(1206),"MCCVI");
		eq(RomanNumeral.toRoman(1207),"MCCVII");
		eq(RomanNumeral.toRoman(1208),"MCCVIII");
		eq(RomanNumeral.toRoman(1209),"MCCIX");
		eq(RomanNumeral.toRoman(1210),"MCCX");
		eq(RomanNumeral.toRoman(1211),"MCCXI");
		eq(RomanNumeral.toRoman(1212),"MCCXII");
		eq(RomanNumeral.toRoman(1213),"MCCXIII");
		eq(RomanNumeral.toRoman(1214),"MCCXIV");
		eq(RomanNumeral.toRoman(1215),"MCCXV");
		eq(RomanNumeral.toRoman(1216),"MCCXVI");
		eq(RomanNumeral.toRoman(1217),"MCCXVII");
		eq(RomanNumeral.toRoman(1218),"MCCXVIII");
		eq(RomanNumeral.toRoman(1219),"MCCXIX");
		eq(RomanNumeral.toRoman(1220),"MCCXX");
		eq(RomanNumeral.toRoman(1221),"MCCXXI");
		eq(RomanNumeral.toRoman(1222),"MCCXXII");
		eq(RomanNumeral.toRoman(1223),"MCCXXIII");
		eq(RomanNumeral.toRoman(1224),"MCCXXIV");
		eq(RomanNumeral.toRoman(1225),"MCCXXV");
		eq(RomanNumeral.toRoman(1226),"MCCXXVI");
		eq(RomanNumeral.toRoman(1227),"MCCXXVII");
		eq(RomanNumeral.toRoman(1228),"MCCXXVIII");
		eq(RomanNumeral.toRoman(1229),"MCCXXIX");
		eq(RomanNumeral.toRoman(1230),"MCCXXX");
		eq(RomanNumeral.toRoman(1231),"MCCXXXI");
		eq(RomanNumeral.toRoman(1232),"MCCXXXII");
		eq(RomanNumeral.toRoman(1233),"MCCXXXIII");
		eq(RomanNumeral.toRoman(1234),"MCCXXXIV");
		eq(RomanNumeral.toRoman(1235),"MCCXXXV");
		eq(RomanNumeral.toRoman(1236),"MCCXXXVI");
		eq(RomanNumeral.toRoman(1237),"MCCXXXVII");
		eq(RomanNumeral.toRoman(1238),"MCCXXXVIII");
		eq(RomanNumeral.toRoman(1239),"MCCXXXIX");
		eq(RomanNumeral.toRoman(1240),"MCCXL");
		eq(RomanNumeral.toRoman(1241),"MCCXLI");
		eq(RomanNumeral.toRoman(1242),"MCCXLII");
		eq(RomanNumeral.toRoman(1243),"MCCXLIII");
		eq(RomanNumeral.toRoman(1244),"MCCXLIV");
		eq(RomanNumeral.toRoman(1245),"MCCXLV");
		eq(RomanNumeral.toRoman(1246),"MCCXLVI");
		eq(RomanNumeral.toRoman(1247),"MCCXLVII");
		eq(RomanNumeral.toRoman(1248),"MCCXLVIII");
		eq(RomanNumeral.toRoman(1249),"MCCXLIX");
		eq(RomanNumeral.toRoman(1250),"MCCL");
		eq(RomanNumeral.toRoman(1251),"MCCLI");
		eq(RomanNumeral.toRoman(1252),"MCCLII");
		eq(RomanNumeral.toRoman(1253),"MCCLIII");
		eq(RomanNumeral.toRoman(1254),"MCCLIV");
		eq(RomanNumeral.toRoman(1255),"MCCLV");
		eq(RomanNumeral.toRoman(1256),"MCCLVI");
		eq(RomanNumeral.toRoman(1257),"MCCLVII");
		eq(RomanNumeral.toRoman(1258),"MCCLVIII");
		eq(RomanNumeral.toRoman(1259),"MCCLIX");
		eq(RomanNumeral.toRoman(1260),"MCCLX");
		eq(RomanNumeral.toRoman(1261),"MCCLXI");
		eq(RomanNumeral.toRoman(1262),"MCCLXII");
		eq(RomanNumeral.toRoman(1263),"MCCLXIII");
		eq(RomanNumeral.toRoman(1264),"MCCLXIV");
		eq(RomanNumeral.toRoman(1265),"MCCLXV");
		eq(RomanNumeral.toRoman(1266),"MCCLXVI");
		eq(RomanNumeral.toRoman(1267),"MCCLXVII");
		eq(RomanNumeral.toRoman(1268),"MCCLXVIII");
		eq(RomanNumeral.toRoman(1269),"MCCLXIX");
		eq(RomanNumeral.toRoman(1270),"MCCLXX");
		eq(RomanNumeral.toRoman(1271),"MCCLXXI");
		eq(RomanNumeral.toRoman(1272),"MCCLXXII");
		eq(RomanNumeral.toRoman(1273),"MCCLXXIII");
		eq(RomanNumeral.toRoman(1274),"MCCLXXIV");
		eq(RomanNumeral.toRoman(1275),"MCCLXXV");
		eq(RomanNumeral.toRoman(1276),"MCCLXXVI");
		eq(RomanNumeral.toRoman(1277),"MCCLXXVII");
		eq(RomanNumeral.toRoman(1278),"MCCLXXVIII");
		eq(RomanNumeral.toRoman(1279),"MCCLXXIX");
		eq(RomanNumeral.toRoman(1280),"MCCLXXX");
		eq(RomanNumeral.toRoman(1281),"MCCLXXXI");
		eq(RomanNumeral.toRoman(1282),"MCCLXXXII");
		eq(RomanNumeral.toRoman(1283),"MCCLXXXIII");
		eq(RomanNumeral.toRoman(1284),"MCCLXXXIV");
		eq(RomanNumeral.toRoman(1285),"MCCLXXXV");
		eq(RomanNumeral.toRoman(1286),"MCCLXXXVI");
		eq(RomanNumeral.toRoman(1287),"MCCLXXXVII");
		eq(RomanNumeral.toRoman(1288),"MCCLXXXVIII");
		eq(RomanNumeral.toRoman(1289),"MCCLXXXIX");
		eq(RomanNumeral.toRoman(1290),"MCCXC");
		eq(RomanNumeral.toRoman(1291),"MCCXCI");
		eq(RomanNumeral.toRoman(1292),"MCCXCII");
		eq(RomanNumeral.toRoman(1293),"MCCXCIII");
		eq(RomanNumeral.toRoman(1294),"MCCXCIV");
		eq(RomanNumeral.toRoman(1295),"MCCXCV");
		eq(RomanNumeral.toRoman(1296),"MCCXCVI");
		eq(RomanNumeral.toRoman(1297),"MCCXCVII");
		eq(RomanNumeral.toRoman(1298),"MCCXCVIII");
		eq(RomanNumeral.toRoman(1299),"MCCXCIX");
		eq(RomanNumeral.toRoman(1300),"MCCC");
		eq(RomanNumeral.toRoman(1301),"MCCCI");
		eq(RomanNumeral.toRoman(1302),"MCCCII");
		eq(RomanNumeral.toRoman(1303),"MCCCIII");
		eq(RomanNumeral.toRoman(1304),"MCCCIV");
		eq(RomanNumeral.toRoman(1305),"MCCCV");
		eq(RomanNumeral.toRoman(1306),"MCCCVI");
		eq(RomanNumeral.toRoman(1307),"MCCCVII");
		eq(RomanNumeral.toRoman(1308),"MCCCVIII");
		eq(RomanNumeral.toRoman(1309),"MCCCIX");
		eq(RomanNumeral.toRoman(1310),"MCCCX");
		eq(RomanNumeral.toRoman(1311),"MCCCXI");
		eq(RomanNumeral.toRoman(1312),"MCCCXII");
		eq(RomanNumeral.toRoman(1313),"MCCCXIII");
		eq(RomanNumeral.toRoman(1314),"MCCCXIV");
		eq(RomanNumeral.toRoman(1315),"MCCCXV");
		eq(RomanNumeral.toRoman(1316),"MCCCXVI");
		eq(RomanNumeral.toRoman(1317),"MCCCXVII");
		eq(RomanNumeral.toRoman(1318),"MCCCXVIII");
		eq(RomanNumeral.toRoman(1319),"MCCCXIX");
		eq(RomanNumeral.toRoman(1320),"MCCCXX");
		eq(RomanNumeral.toRoman(1321),"MCCCXXI");
		eq(RomanNumeral.toRoman(1322),"MCCCXXII");
		eq(RomanNumeral.toRoman(1323),"MCCCXXIII");
		eq(RomanNumeral.toRoman(1324),"MCCCXXIV");
		eq(RomanNumeral.toRoman(1325),"MCCCXXV");
		eq(RomanNumeral.toRoman(1326),"MCCCXXVI");
		eq(RomanNumeral.toRoman(1327),"MCCCXXVII");
		eq(RomanNumeral.toRoman(1328),"MCCCXXVIII");
		eq(RomanNumeral.toRoman(1329),"MCCCXXIX");
		eq(RomanNumeral.toRoman(1330),"MCCCXXX");
		eq(RomanNumeral.toRoman(1331),"MCCCXXXI");
		eq(RomanNumeral.toRoman(1332),"MCCCXXXII");
		eq(RomanNumeral.toRoman(1333),"MCCCXXXIII");
		eq(RomanNumeral.toRoman(1334),"MCCCXXXIV");
		eq(RomanNumeral.toRoman(1335),"MCCCXXXV");
		eq(RomanNumeral.toRoman(1336),"MCCCXXXVI");
		eq(RomanNumeral.toRoman(1337),"MCCCXXXVII");
		eq(RomanNumeral.toRoman(1338),"MCCCXXXVIII");
		eq(RomanNumeral.toRoman(1339),"MCCCXXXIX");
		eq(RomanNumeral.toRoman(1340),"MCCCXL");
		eq(RomanNumeral.toRoman(1341),"MCCCXLI");
		eq(RomanNumeral.toRoman(1342),"MCCCXLII");
		eq(RomanNumeral.toRoman(1343),"MCCCXLIII");
		eq(RomanNumeral.toRoman(1344),"MCCCXLIV");
		eq(RomanNumeral.toRoman(1345),"MCCCXLV");
		eq(RomanNumeral.toRoman(1346),"MCCCXLVI");
		eq(RomanNumeral.toRoman(1347),"MCCCXLVII");
		eq(RomanNumeral.toRoman(1348),"MCCCXLVIII");
		eq(RomanNumeral.toRoman(1349),"MCCCXLIX");
		eq(RomanNumeral.toRoman(1350),"MCCCL");
		eq(RomanNumeral.toRoman(1351),"MCCCLI");
		eq(RomanNumeral.toRoman(1352),"MCCCLII");
		eq(RomanNumeral.toRoman(1353),"MCCCLIII");
		eq(RomanNumeral.toRoman(1354),"MCCCLIV");
		eq(RomanNumeral.toRoman(1355),"MCCCLV");
		eq(RomanNumeral.toRoman(1356),"MCCCLVI");
		eq(RomanNumeral.toRoman(1357),"MCCCLVII");
		eq(RomanNumeral.toRoman(1358),"MCCCLVIII");
		eq(RomanNumeral.toRoman(1359),"MCCCLIX");
		eq(RomanNumeral.toRoman(1360),"MCCCLX");
		eq(RomanNumeral.toRoman(1361),"MCCCLXI");
		eq(RomanNumeral.toRoman(1362),"MCCCLXII");
		eq(RomanNumeral.toRoman(1363),"MCCCLXIII");
		eq(RomanNumeral.toRoman(1364),"MCCCLXIV");
		eq(RomanNumeral.toRoman(1365),"MCCCLXV");
		eq(RomanNumeral.toRoman(1366),"MCCCLXVI");
		eq(RomanNumeral.toRoman(1367),"MCCCLXVII");
		eq(RomanNumeral.toRoman(1368),"MCCCLXVIII");
		eq(RomanNumeral.toRoman(1369),"MCCCLXIX");
		eq(RomanNumeral.toRoman(1370),"MCCCLXX");
		eq(RomanNumeral.toRoman(1371),"MCCCLXXI");
		eq(RomanNumeral.toRoman(1372),"MCCCLXXII");
		eq(RomanNumeral.toRoman(1373),"MCCCLXXIII");
		eq(RomanNumeral.toRoman(1374),"MCCCLXXIV");
		eq(RomanNumeral.toRoman(1375),"MCCCLXXV");
		eq(RomanNumeral.toRoman(1376),"MCCCLXXVI");
		eq(RomanNumeral.toRoman(1377),"MCCCLXXVII");
		eq(RomanNumeral.toRoman(1378),"MCCCLXXVIII");
		eq(RomanNumeral.toRoman(1379),"MCCCLXXIX");
		eq(RomanNumeral.toRoman(1380),"MCCCLXXX");
		eq(RomanNumeral.toRoman(1381),"MCCCLXXXI");
		eq(RomanNumeral.toRoman(1382),"MCCCLXXXII");
		eq(RomanNumeral.toRoman(1383),"MCCCLXXXIII");
		eq(RomanNumeral.toRoman(1384),"MCCCLXXXIV");
		eq(RomanNumeral.toRoman(1385),"MCCCLXXXV");
		eq(RomanNumeral.toRoman(1386),"MCCCLXXXVI");
		eq(RomanNumeral.toRoman(1387),"MCCCLXXXVII");
		eq(RomanNumeral.toRoman(1388),"MCCCLXXXVIII");
		eq(RomanNumeral.toRoman(1389),"MCCCLXXXIX");
		eq(RomanNumeral.toRoman(1390),"MCCCXC");
		eq(RomanNumeral.toRoman(1391),"MCCCXCI");
		eq(RomanNumeral.toRoman(1392),"MCCCXCII");
		eq(RomanNumeral.toRoman(1393),"MCCCXCIII");
		eq(RomanNumeral.toRoman(1394),"MCCCXCIV");
		eq(RomanNumeral.toRoman(1395),"MCCCXCV");
		eq(RomanNumeral.toRoman(1396),"MCCCXCVI");
		eq(RomanNumeral.toRoman(1397),"MCCCXCVII");
		eq(RomanNumeral.toRoman(1398),"MCCCXCVIII");
		eq(RomanNumeral.toRoman(1399),"MCCCXCIX");
		eq(RomanNumeral.toRoman(1400),"MCD");
		eq(RomanNumeral.toRoman(1401),"MCDI");
		eq(RomanNumeral.toRoman(1402),"MCDII");
		eq(RomanNumeral.toRoman(1403),"MCDIII");
		eq(RomanNumeral.toRoman(1404),"MCDIV");
		eq(RomanNumeral.toRoman(1405),"MCDV");
		eq(RomanNumeral.toRoman(1406),"MCDVI");
		eq(RomanNumeral.toRoman(1407),"MCDVII");
		eq(RomanNumeral.toRoman(1408),"MCDVIII");
		eq(RomanNumeral.toRoman(1409),"MCDIX");
		eq(RomanNumeral.toRoman(1410),"MCDX");
		eq(RomanNumeral.toRoman(1411),"MCDXI");
		eq(RomanNumeral.toRoman(1412),"MCDXII");
		eq(RomanNumeral.toRoman(1413),"MCDXIII");
		eq(RomanNumeral.toRoman(1414),"MCDXIV");
		eq(RomanNumeral.toRoman(1415),"MCDXV");
		eq(RomanNumeral.toRoman(1416),"MCDXVI");
		eq(RomanNumeral.toRoman(1417),"MCDXVII");
		eq(RomanNumeral.toRoman(1418),"MCDXVIII");
		eq(RomanNumeral.toRoman(1419),"MCDXIX");
		eq(RomanNumeral.toRoman(1420),"MCDXX");
		eq(RomanNumeral.toRoman(1421),"MCDXXI");
		eq(RomanNumeral.toRoman(1422),"MCDXXII");
		eq(RomanNumeral.toRoman(1423),"MCDXXIII");
		eq(RomanNumeral.toRoman(1424),"MCDXXIV");
		eq(RomanNumeral.toRoman(1425),"MCDXXV");
		eq(RomanNumeral.toRoman(1426),"MCDXXVI");
		eq(RomanNumeral.toRoman(1427),"MCDXXVII");
		eq(RomanNumeral.toRoman(1428),"MCDXXVIII");
		eq(RomanNumeral.toRoman(1429),"MCDXXIX");
		eq(RomanNumeral.toRoman(1430),"MCDXXX");
		eq(RomanNumeral.toRoman(1431),"MCDXXXI");
		eq(RomanNumeral.toRoman(1432),"MCDXXXII");
		eq(RomanNumeral.toRoman(1433),"MCDXXXIII");
		eq(RomanNumeral.toRoman(1434),"MCDXXXIV");
		eq(RomanNumeral.toRoman(1435),"MCDXXXV");
		eq(RomanNumeral.toRoman(1436),"MCDXXXVI");
		eq(RomanNumeral.toRoman(1437),"MCDXXXVII");
		eq(RomanNumeral.toRoman(1438),"MCDXXXVIII");
		eq(RomanNumeral.toRoman(1439),"MCDXXXIX");
		eq(RomanNumeral.toRoman(1440),"MCDXL");
		eq(RomanNumeral.toRoman(1441),"MCDXLI");
		eq(RomanNumeral.toRoman(1442),"MCDXLII");
		eq(RomanNumeral.toRoman(1443),"MCDXLIII");
		eq(RomanNumeral.toRoman(1444),"MCDXLIV");
		eq(RomanNumeral.toRoman(1445),"MCDXLV");
		eq(RomanNumeral.toRoman(1446),"MCDXLVI");
		eq(RomanNumeral.toRoman(1447),"MCDXLVII");
		eq(RomanNumeral.toRoman(1448),"MCDXLVIII");
		eq(RomanNumeral.toRoman(1449),"MCDXLIX");
		eq(RomanNumeral.toRoman(1450),"MCDL");
		eq(RomanNumeral.toRoman(1451),"MCDLI");
		eq(RomanNumeral.toRoman(1452),"MCDLII");
		eq(RomanNumeral.toRoman(1453),"MCDLIII");
		eq(RomanNumeral.toRoman(1454),"MCDLIV");
		eq(RomanNumeral.toRoman(1455),"MCDLV");
		eq(RomanNumeral.toRoman(1456),"MCDLVI");
		eq(RomanNumeral.toRoman(1457),"MCDLVII");
		eq(RomanNumeral.toRoman(1458),"MCDLVIII");
		eq(RomanNumeral.toRoman(1459),"MCDLIX");
		eq(RomanNumeral.toRoman(1460),"MCDLX");
		eq(RomanNumeral.toRoman(1461),"MCDLXI");
		eq(RomanNumeral.toRoman(1462),"MCDLXII");
		eq(RomanNumeral.toRoman(1463),"MCDLXIII");
		eq(RomanNumeral.toRoman(1464),"MCDLXIV");
		eq(RomanNumeral.toRoman(1465),"MCDLXV");
		eq(RomanNumeral.toRoman(1466),"MCDLXVI");
		eq(RomanNumeral.toRoman(1467),"MCDLXVII");
		eq(RomanNumeral.toRoman(1468),"MCDLXVIII");
		eq(RomanNumeral.toRoman(1469),"MCDLXIX");
		eq(RomanNumeral.toRoman(1470),"MCDLXX");
		eq(RomanNumeral.toRoman(1471),"MCDLXXI");
		eq(RomanNumeral.toRoman(1472),"MCDLXXII");
		eq(RomanNumeral.toRoman(1473),"MCDLXXIII");
		eq(RomanNumeral.toRoman(1474),"MCDLXXIV");
		eq(RomanNumeral.toRoman(1475),"MCDLXXV");
		eq(RomanNumeral.toRoman(1476),"MCDLXXVI");
		eq(RomanNumeral.toRoman(1477),"MCDLXXVII");
		eq(RomanNumeral.toRoman(1478),"MCDLXXVIII");
		eq(RomanNumeral.toRoman(1479),"MCDLXXIX");
		eq(RomanNumeral.toRoman(1480),"MCDLXXX");
		eq(RomanNumeral.toRoman(1481),"MCDLXXXI");
		eq(RomanNumeral.toRoman(1482),"MCDLXXXII");
		eq(RomanNumeral.toRoman(1483),"MCDLXXXIII");
		eq(RomanNumeral.toRoman(1484),"MCDLXXXIV");
		eq(RomanNumeral.toRoman(1485),"MCDLXXXV");
		eq(RomanNumeral.toRoman(1486),"MCDLXXXVI");
		eq(RomanNumeral.toRoman(1487),"MCDLXXXVII");
		eq(RomanNumeral.toRoman(1488),"MCDLXXXVIII");
		eq(RomanNumeral.toRoman(1489),"MCDLXXXIX");
		eq(RomanNumeral.toRoman(1490),"MCDXC");
		eq(RomanNumeral.toRoman(1491),"MCDXCI");
		eq(RomanNumeral.toRoman(1492),"MCDXCII");
		eq(RomanNumeral.toRoman(1493),"MCDXCIII");
		eq(RomanNumeral.toRoman(1494),"MCDXCIV");
		eq(RomanNumeral.toRoman(1495),"MCDXCV");
		eq(RomanNumeral.toRoman(1496),"MCDXCVI");
		eq(RomanNumeral.toRoman(1497),"MCDXCVII");
		eq(RomanNumeral.toRoman(1498),"MCDXCVIII");
		eq(RomanNumeral.toRoman(1499),"MCDXCIX");
		eq(RomanNumeral.toRoman(1500),"MD");
		eq(RomanNumeral.toRoman(1501),"MDI");
		eq(RomanNumeral.toRoman(1502),"MDII");
		eq(RomanNumeral.toRoman(1503),"MDIII");
		eq(RomanNumeral.toRoman(1504),"MDIV");
		eq(RomanNumeral.toRoman(1505),"MDV");
		eq(RomanNumeral.toRoman(1506),"MDVI");
		eq(RomanNumeral.toRoman(1507),"MDVII");
		eq(RomanNumeral.toRoman(1508),"MDVIII");
		eq(RomanNumeral.toRoman(1509),"MDIX");
		eq(RomanNumeral.toRoman(1510),"MDX");
		eq(RomanNumeral.toRoman(1511),"MDXI");
		eq(RomanNumeral.toRoman(1512),"MDXII");
		eq(RomanNumeral.toRoman(1513),"MDXIII");
		eq(RomanNumeral.toRoman(1514),"MDXIV");
		eq(RomanNumeral.toRoman(1515),"MDXV");
		eq(RomanNumeral.toRoman(1516),"MDXVI");
		eq(RomanNumeral.toRoman(1517),"MDXVII");
		eq(RomanNumeral.toRoman(1518),"MDXVIII");
		eq(RomanNumeral.toRoman(1519),"MDXIX");
		eq(RomanNumeral.toRoman(1520),"MDXX");
		eq(RomanNumeral.toRoman(1521),"MDXXI");
		eq(RomanNumeral.toRoman(1522),"MDXXII");
		eq(RomanNumeral.toRoman(1523),"MDXXIII");
		eq(RomanNumeral.toRoman(1524),"MDXXIV");
		eq(RomanNumeral.toRoman(1525),"MDXXV");
		eq(RomanNumeral.toRoman(1526),"MDXXVI");
		eq(RomanNumeral.toRoman(1527),"MDXXVII");
		eq(RomanNumeral.toRoman(1528),"MDXXVIII");
		eq(RomanNumeral.toRoman(1529),"MDXXIX");
		eq(RomanNumeral.toRoman(1530),"MDXXX");
		eq(RomanNumeral.toRoman(1531),"MDXXXI");
		eq(RomanNumeral.toRoman(1532),"MDXXXII");
		eq(RomanNumeral.toRoman(1533),"MDXXXIII");
		eq(RomanNumeral.toRoman(1534),"MDXXXIV");
		eq(RomanNumeral.toRoman(1535),"MDXXXV");
		eq(RomanNumeral.toRoman(1536),"MDXXXVI");
		eq(RomanNumeral.toRoman(1537),"MDXXXVII");
		eq(RomanNumeral.toRoman(1538),"MDXXXVIII");
		eq(RomanNumeral.toRoman(1539),"MDXXXIX");
		eq(RomanNumeral.toRoman(1540),"MDXL");
		eq(RomanNumeral.toRoman(1541),"MDXLI");
		eq(RomanNumeral.toRoman(1542),"MDXLII");
		eq(RomanNumeral.toRoman(1543),"MDXLIII");
		eq(RomanNumeral.toRoman(1544),"MDXLIV");
		eq(RomanNumeral.toRoman(1545),"MDXLV");
		eq(RomanNumeral.toRoman(1546),"MDXLVI");
		eq(RomanNumeral.toRoman(1547),"MDXLVII");
		eq(RomanNumeral.toRoman(1548),"MDXLVIII");
		eq(RomanNumeral.toRoman(1549),"MDXLIX");
		eq(RomanNumeral.toRoman(1550),"MDL");
		eq(RomanNumeral.toRoman(1551),"MDLI");
		eq(RomanNumeral.toRoman(1552),"MDLII");
		eq(RomanNumeral.toRoman(1553),"MDLIII");
		eq(RomanNumeral.toRoman(1554),"MDLIV");
		eq(RomanNumeral.toRoman(1555),"MDLV");
		eq(RomanNumeral.toRoman(1556),"MDLVI");
		eq(RomanNumeral.toRoman(1557),"MDLVII");
		eq(RomanNumeral.toRoman(1558),"MDLVIII");
		eq(RomanNumeral.toRoman(1559),"MDLIX");
		eq(RomanNumeral.toRoman(1560),"MDLX");
		eq(RomanNumeral.toRoman(1561),"MDLXI");
		eq(RomanNumeral.toRoman(1562),"MDLXII");
		eq(RomanNumeral.toRoman(1563),"MDLXIII");
		eq(RomanNumeral.toRoman(1564),"MDLXIV");
		eq(RomanNumeral.toRoman(1565),"MDLXV");
		eq(RomanNumeral.toRoman(1566),"MDLXVI");
		eq(RomanNumeral.toRoman(1567),"MDLXVII");
		eq(RomanNumeral.toRoman(1568),"MDLXVIII");
		eq(RomanNumeral.toRoman(1569),"MDLXIX");
		eq(RomanNumeral.toRoman(1570),"MDLXX");
		eq(RomanNumeral.toRoman(1571),"MDLXXI");
		eq(RomanNumeral.toRoman(1572),"MDLXXII");
		eq(RomanNumeral.toRoman(1573),"MDLXXIII");
		eq(RomanNumeral.toRoman(1574),"MDLXXIV");
		eq(RomanNumeral.toRoman(1575),"MDLXXV");
		eq(RomanNumeral.toRoman(1576),"MDLXXVI");
		eq(RomanNumeral.toRoman(1577),"MDLXXVII");
		eq(RomanNumeral.toRoman(1578),"MDLXXVIII");
		eq(RomanNumeral.toRoman(1579),"MDLXXIX");
		eq(RomanNumeral.toRoman(1580),"MDLXXX");
		eq(RomanNumeral.toRoman(1581),"MDLXXXI");
		eq(RomanNumeral.toRoman(1582),"MDLXXXII");
		eq(RomanNumeral.toRoman(1583),"MDLXXXIII");
		eq(RomanNumeral.toRoman(1584),"MDLXXXIV");
		eq(RomanNumeral.toRoman(1585),"MDLXXXV");
		eq(RomanNumeral.toRoman(1586),"MDLXXXVI");
		eq(RomanNumeral.toRoman(1587),"MDLXXXVII");
		eq(RomanNumeral.toRoman(1588),"MDLXXXVIII");
		eq(RomanNumeral.toRoman(1589),"MDLXXXIX");
		eq(RomanNumeral.toRoman(1590),"MDXC");
		eq(RomanNumeral.toRoman(1591),"MDXCI");
		eq(RomanNumeral.toRoman(1592),"MDXCII");
		eq(RomanNumeral.toRoman(1593),"MDXCIII");
		eq(RomanNumeral.toRoman(1594),"MDXCIV");
		eq(RomanNumeral.toRoman(1595),"MDXCV");
		eq(RomanNumeral.toRoman(1596),"MDXCVI");
		eq(RomanNumeral.toRoman(1597),"MDXCVII");
		eq(RomanNumeral.toRoman(1598),"MDXCVIII");
		eq(RomanNumeral.toRoman(1599),"MDXCIX");
		eq(RomanNumeral.toRoman(1600),"MDC");
		eq(RomanNumeral.toRoman(1601),"MDCI");
		eq(RomanNumeral.toRoman(1602),"MDCII");
		eq(RomanNumeral.toRoman(1603),"MDCIII");
		eq(RomanNumeral.toRoman(1604),"MDCIV");
		eq(RomanNumeral.toRoman(1605),"MDCV");
		eq(RomanNumeral.toRoman(1606),"MDCVI");
		eq(RomanNumeral.toRoman(1607),"MDCVII");
		eq(RomanNumeral.toRoman(1608),"MDCVIII");
		eq(RomanNumeral.toRoman(1609),"MDCIX");
		eq(RomanNumeral.toRoman(1610),"MDCX");
		eq(RomanNumeral.toRoman(1611),"MDCXI");
		eq(RomanNumeral.toRoman(1612),"MDCXII");
		eq(RomanNumeral.toRoman(1613),"MDCXIII");
		eq(RomanNumeral.toRoman(1614),"MDCXIV");
		eq(RomanNumeral.toRoman(1615),"MDCXV");
		eq(RomanNumeral.toRoman(1616),"MDCXVI");
		eq(RomanNumeral.toRoman(1617),"MDCXVII");
		eq(RomanNumeral.toRoman(1618),"MDCXVIII");
		eq(RomanNumeral.toRoman(1619),"MDCXIX");
		eq(RomanNumeral.toRoman(1620),"MDCXX");
		eq(RomanNumeral.toRoman(1621),"MDCXXI");
		eq(RomanNumeral.toRoman(1622),"MDCXXII");
		eq(RomanNumeral.toRoman(1623),"MDCXXIII");
		eq(RomanNumeral.toRoman(1624),"MDCXXIV");
		eq(RomanNumeral.toRoman(1625),"MDCXXV");
		eq(RomanNumeral.toRoman(1626),"MDCXXVI");
		eq(RomanNumeral.toRoman(1627),"MDCXXVII");
		eq(RomanNumeral.toRoman(1628),"MDCXXVIII");
		eq(RomanNumeral.toRoman(1629),"MDCXXIX");
		eq(RomanNumeral.toRoman(1630),"MDCXXX");
		eq(RomanNumeral.toRoman(1631),"MDCXXXI");
		eq(RomanNumeral.toRoman(1632),"MDCXXXII");
		eq(RomanNumeral.toRoman(1633),"MDCXXXIII");
		eq(RomanNumeral.toRoman(1634),"MDCXXXIV");
		eq(RomanNumeral.toRoman(1635),"MDCXXXV");
		eq(RomanNumeral.toRoman(1636),"MDCXXXVI");
		eq(RomanNumeral.toRoman(1637),"MDCXXXVII");
		eq(RomanNumeral.toRoman(1638),"MDCXXXVIII");
		eq(RomanNumeral.toRoman(1639),"MDCXXXIX");
		eq(RomanNumeral.toRoman(1640),"MDCXL");
		eq(RomanNumeral.toRoman(1641),"MDCXLI");
		eq(RomanNumeral.toRoman(1642),"MDCXLII");
		eq(RomanNumeral.toRoman(1643),"MDCXLIII");
		eq(RomanNumeral.toRoman(1644),"MDCXLIV");
		eq(RomanNumeral.toRoman(1645),"MDCXLV");
		eq(RomanNumeral.toRoman(1646),"MDCXLVI");
		eq(RomanNumeral.toRoman(1647),"MDCXLVII");
		eq(RomanNumeral.toRoman(1648),"MDCXLVIII");
		eq(RomanNumeral.toRoman(1649),"MDCXLIX");
		eq(RomanNumeral.toRoman(1650),"MDCL");
		eq(RomanNumeral.toRoman(1651),"MDCLI");
		eq(RomanNumeral.toRoman(1652),"MDCLII");
		eq(RomanNumeral.toRoman(1653),"MDCLIII");
		eq(RomanNumeral.toRoman(1654),"MDCLIV");
		eq(RomanNumeral.toRoman(1655),"MDCLV");
		eq(RomanNumeral.toRoman(1656),"MDCLVI");
		eq(RomanNumeral.toRoman(1657),"MDCLVII");
		eq(RomanNumeral.toRoman(1658),"MDCLVIII");
		eq(RomanNumeral.toRoman(1659),"MDCLIX");
		eq(RomanNumeral.toRoman(1660),"MDCLX");
		eq(RomanNumeral.toRoman(1661),"MDCLXI");
		eq(RomanNumeral.toRoman(1662),"MDCLXII");
		eq(RomanNumeral.toRoman(1663),"MDCLXIII");
		eq(RomanNumeral.toRoman(1664),"MDCLXIV");
		eq(RomanNumeral.toRoman(1665),"MDCLXV");
		eq(RomanNumeral.toRoman(1666),"MDCLXVI");
		eq(RomanNumeral.toRoman(1667),"MDCLXVII");
		eq(RomanNumeral.toRoman(1668),"MDCLXVIII");
		eq(RomanNumeral.toRoman(1669),"MDCLXIX");
		eq(RomanNumeral.toRoman(1670),"MDCLXX");
		eq(RomanNumeral.toRoman(1671),"MDCLXXI");
		eq(RomanNumeral.toRoman(1672),"MDCLXXII");
		eq(RomanNumeral.toRoman(1673),"MDCLXXIII");
		eq(RomanNumeral.toRoman(1674),"MDCLXXIV");
		eq(RomanNumeral.toRoman(1675),"MDCLXXV");
		eq(RomanNumeral.toRoman(1676),"MDCLXXVI");
		eq(RomanNumeral.toRoman(1677),"MDCLXXVII");
		eq(RomanNumeral.toRoman(1678),"MDCLXXVIII");
		eq(RomanNumeral.toRoman(1679),"MDCLXXIX");
		eq(RomanNumeral.toRoman(1680),"MDCLXXX");
		eq(RomanNumeral.toRoman(1681),"MDCLXXXI");
		eq(RomanNumeral.toRoman(1682),"MDCLXXXII");
		eq(RomanNumeral.toRoman(1683),"MDCLXXXIII");
		eq(RomanNumeral.toRoman(1684),"MDCLXXXIV");
		eq(RomanNumeral.toRoman(1685),"MDCLXXXV");
		eq(RomanNumeral.toRoman(1686),"MDCLXXXVI");
		eq(RomanNumeral.toRoman(1687),"MDCLXXXVII");
		eq(RomanNumeral.toRoman(1688),"MDCLXXXVIII");
		eq(RomanNumeral.toRoman(1689),"MDCLXXXIX");
		eq(RomanNumeral.toRoman(1690),"MDCXC");
		eq(RomanNumeral.toRoman(1691),"MDCXCI");
		eq(RomanNumeral.toRoman(1692),"MDCXCII");
		eq(RomanNumeral.toRoman(1693),"MDCXCIII");
		eq(RomanNumeral.toRoman(1694),"MDCXCIV");
		eq(RomanNumeral.toRoman(1695),"MDCXCV");
		eq(RomanNumeral.toRoman(1696),"MDCXCVI");
		eq(RomanNumeral.toRoman(1697),"MDCXCVII");
		eq(RomanNumeral.toRoman(1698),"MDCXCVIII");
		eq(RomanNumeral.toRoman(1699),"MDCXCIX");
		eq(RomanNumeral.toRoman(1700),"MDCC");
		eq(RomanNumeral.toRoman(1701),"MDCCI");
		eq(RomanNumeral.toRoman(1702),"MDCCII");
		eq(RomanNumeral.toRoman(1703),"MDCCIII");
		eq(RomanNumeral.toRoman(1704),"MDCCIV");
		eq(RomanNumeral.toRoman(1705),"MDCCV");
		eq(RomanNumeral.toRoman(1706),"MDCCVI");
		eq(RomanNumeral.toRoman(1707),"MDCCVII");
		eq(RomanNumeral.toRoman(1708),"MDCCVIII");
		eq(RomanNumeral.toRoman(1709),"MDCCIX");
		eq(RomanNumeral.toRoman(1710),"MDCCX");
		eq(RomanNumeral.toRoman(1711),"MDCCXI");
		eq(RomanNumeral.toRoman(1712),"MDCCXII");
		eq(RomanNumeral.toRoman(1713),"MDCCXIII");
		eq(RomanNumeral.toRoman(1714),"MDCCXIV");
		eq(RomanNumeral.toRoman(1715),"MDCCXV");
		eq(RomanNumeral.toRoman(1716),"MDCCXVI");
		eq(RomanNumeral.toRoman(1717),"MDCCXVII");
		eq(RomanNumeral.toRoman(1718),"MDCCXVIII");
		eq(RomanNumeral.toRoman(1719),"MDCCXIX");
		eq(RomanNumeral.toRoman(1720),"MDCCXX");
		eq(RomanNumeral.toRoman(1721),"MDCCXXI");
		eq(RomanNumeral.toRoman(1722),"MDCCXXII");
		eq(RomanNumeral.toRoman(1723),"MDCCXXIII");
		eq(RomanNumeral.toRoman(1724),"MDCCXXIV");
		eq(RomanNumeral.toRoman(1725),"MDCCXXV");
		eq(RomanNumeral.toRoman(1726),"MDCCXXVI");
		eq(RomanNumeral.toRoman(1727),"MDCCXXVII");
		eq(RomanNumeral.toRoman(1728),"MDCCXXVIII");
		eq(RomanNumeral.toRoman(1729),"MDCCXXIX");
		eq(RomanNumeral.toRoman(1730),"MDCCXXX");
		eq(RomanNumeral.toRoman(1731),"MDCCXXXI");
		eq(RomanNumeral.toRoman(1732),"MDCCXXXII");
		eq(RomanNumeral.toRoman(1733),"MDCCXXXIII");
		eq(RomanNumeral.toRoman(1734),"MDCCXXXIV");
		eq(RomanNumeral.toRoman(1735),"MDCCXXXV");
		eq(RomanNumeral.toRoman(1736),"MDCCXXXVI");
		eq(RomanNumeral.toRoman(1737),"MDCCXXXVII");
		eq(RomanNumeral.toRoman(1738),"MDCCXXXVIII");
		eq(RomanNumeral.toRoman(1739),"MDCCXXXIX");
		eq(RomanNumeral.toRoman(1740),"MDCCXL");
		eq(RomanNumeral.toRoman(1741),"MDCCXLI");
		eq(RomanNumeral.toRoman(1742),"MDCCXLII");
		eq(RomanNumeral.toRoman(1743),"MDCCXLIII");
		eq(RomanNumeral.toRoman(1744),"MDCCXLIV");
		eq(RomanNumeral.toRoman(1745),"MDCCXLV");
		eq(RomanNumeral.toRoman(1746),"MDCCXLVI");
		eq(RomanNumeral.toRoman(1747),"MDCCXLVII");
		eq(RomanNumeral.toRoman(1748),"MDCCXLVIII");
		eq(RomanNumeral.toRoman(1749),"MDCCXLIX");
		eq(RomanNumeral.toRoman(1750),"MDCCL");
		eq(RomanNumeral.toRoman(1751),"MDCCLI");
		eq(RomanNumeral.toRoman(1752),"MDCCLII");
		eq(RomanNumeral.toRoman(1753),"MDCCLIII");
		eq(RomanNumeral.toRoman(1754),"MDCCLIV");
		eq(RomanNumeral.toRoman(1755),"MDCCLV");
		eq(RomanNumeral.toRoman(1756),"MDCCLVI");
		eq(RomanNumeral.toRoman(1757),"MDCCLVII");
		eq(RomanNumeral.toRoman(1758),"MDCCLVIII");
		eq(RomanNumeral.toRoman(1759),"MDCCLIX");
		eq(RomanNumeral.toRoman(1760),"MDCCLX");
		eq(RomanNumeral.toRoman(1761),"MDCCLXI");
		eq(RomanNumeral.toRoman(1762),"MDCCLXII");
		eq(RomanNumeral.toRoman(1763),"MDCCLXIII");
		eq(RomanNumeral.toRoman(1764),"MDCCLXIV");
		eq(RomanNumeral.toRoman(1765),"MDCCLXV");
		eq(RomanNumeral.toRoman(1766),"MDCCLXVI");
		eq(RomanNumeral.toRoman(1767),"MDCCLXVII");
		eq(RomanNumeral.toRoman(1768),"MDCCLXVIII");
		eq(RomanNumeral.toRoman(1769),"MDCCLXIX");
		eq(RomanNumeral.toRoman(1770),"MDCCLXX");
		eq(RomanNumeral.toRoman(1771),"MDCCLXXI");
		eq(RomanNumeral.toRoman(1772),"MDCCLXXII");
		eq(RomanNumeral.toRoman(1773),"MDCCLXXIII");
		eq(RomanNumeral.toRoman(1774),"MDCCLXXIV");
		eq(RomanNumeral.toRoman(1775),"MDCCLXXV");
		eq(RomanNumeral.toRoman(1776),"MDCCLXXVI");
		eq(RomanNumeral.toRoman(1777),"MDCCLXXVII");
		eq(RomanNumeral.toRoman(1778),"MDCCLXXVIII");
		eq(RomanNumeral.toRoman(1779),"MDCCLXXIX");
		eq(RomanNumeral.toRoman(1780),"MDCCLXXX");
		eq(RomanNumeral.toRoman(1781),"MDCCLXXXI");
		eq(RomanNumeral.toRoman(1782),"MDCCLXXXII");
		eq(RomanNumeral.toRoman(1783),"MDCCLXXXIII");
		eq(RomanNumeral.toRoman(1784),"MDCCLXXXIV");
		eq(RomanNumeral.toRoman(1785),"MDCCLXXXV");
		eq(RomanNumeral.toRoman(1786),"MDCCLXXXVI");
		eq(RomanNumeral.toRoman(1787),"MDCCLXXXVII");
		eq(RomanNumeral.toRoman(1788),"MDCCLXXXVIII");
		eq(RomanNumeral.toRoman(1789),"MDCCLXXXIX");
		eq(RomanNumeral.toRoman(1790),"MDCCXC");
		eq(RomanNumeral.toRoman(1791),"MDCCXCI");
		eq(RomanNumeral.toRoman(1792),"MDCCXCII");
		eq(RomanNumeral.toRoman(1793),"MDCCXCIII");
		eq(RomanNumeral.toRoman(1794),"MDCCXCIV");
		eq(RomanNumeral.toRoman(1795),"MDCCXCV");
		eq(RomanNumeral.toRoman(1796),"MDCCXCVI");
		eq(RomanNumeral.toRoman(1797),"MDCCXCVII");
		eq(RomanNumeral.toRoman(1798),"MDCCXCVIII");
		eq(RomanNumeral.toRoman(1799),"MDCCXCIX");
		eq(RomanNumeral.toRoman(1800),"MDCCC");
		eq(RomanNumeral.toRoman(1801),"MDCCCI");
		eq(RomanNumeral.toRoman(1802),"MDCCCII");
		eq(RomanNumeral.toRoman(1803),"MDCCCIII");
		eq(RomanNumeral.toRoman(1804),"MDCCCIV");
		eq(RomanNumeral.toRoman(1805),"MDCCCV");
		eq(RomanNumeral.toRoman(1806),"MDCCCVI");
		eq(RomanNumeral.toRoman(1807),"MDCCCVII");
		eq(RomanNumeral.toRoman(1808),"MDCCCVIII");
		eq(RomanNumeral.toRoman(1809),"MDCCCIX");
		eq(RomanNumeral.toRoman(1810),"MDCCCX");
		eq(RomanNumeral.toRoman(1811),"MDCCCXI");
		eq(RomanNumeral.toRoman(1812),"MDCCCXII");
		eq(RomanNumeral.toRoman(1813),"MDCCCXIII");
		eq(RomanNumeral.toRoman(1814),"MDCCCXIV");
		eq(RomanNumeral.toRoman(1815),"MDCCCXV");
		eq(RomanNumeral.toRoman(1816),"MDCCCXVI");
		eq(RomanNumeral.toRoman(1817),"MDCCCXVII");
		eq(RomanNumeral.toRoman(1818),"MDCCCXVIII");
		eq(RomanNumeral.toRoman(1819),"MDCCCXIX");
		eq(RomanNumeral.toRoman(1820),"MDCCCXX");
		eq(RomanNumeral.toRoman(1821),"MDCCCXXI");
		eq(RomanNumeral.toRoman(1822),"MDCCCXXII");
		eq(RomanNumeral.toRoman(1823),"MDCCCXXIII");
		eq(RomanNumeral.toRoman(1824),"MDCCCXXIV");
		eq(RomanNumeral.toRoman(1825),"MDCCCXXV");
		eq(RomanNumeral.toRoman(1826),"MDCCCXXVI");
		eq(RomanNumeral.toRoman(1827),"MDCCCXXVII");
		eq(RomanNumeral.toRoman(1828),"MDCCCXXVIII");
		eq(RomanNumeral.toRoman(1829),"MDCCCXXIX");
		eq(RomanNumeral.toRoman(1830),"MDCCCXXX");
		eq(RomanNumeral.toRoman(1831),"MDCCCXXXI");
		eq(RomanNumeral.toRoman(1832),"MDCCCXXXII");
		eq(RomanNumeral.toRoman(1833),"MDCCCXXXIII");
		eq(RomanNumeral.toRoman(1834),"MDCCCXXXIV");
		eq(RomanNumeral.toRoman(1835),"MDCCCXXXV");
		eq(RomanNumeral.toRoman(1836),"MDCCCXXXVI");
		eq(RomanNumeral.toRoman(1837),"MDCCCXXXVII");
		eq(RomanNumeral.toRoman(1838),"MDCCCXXXVIII");
		eq(RomanNumeral.toRoman(1839),"MDCCCXXXIX");
		eq(RomanNumeral.toRoman(1840),"MDCCCXL");
		eq(RomanNumeral.toRoman(1841),"MDCCCXLI");
		eq(RomanNumeral.toRoman(1842),"MDCCCXLII");
		eq(RomanNumeral.toRoman(1843),"MDCCCXLIII");
		eq(RomanNumeral.toRoman(1844),"MDCCCXLIV");
		eq(RomanNumeral.toRoman(1845),"MDCCCXLV");
		eq(RomanNumeral.toRoman(1846),"MDCCCXLVI");
		eq(RomanNumeral.toRoman(1847),"MDCCCXLVII");
		eq(RomanNumeral.toRoman(1848),"MDCCCXLVIII");
		eq(RomanNumeral.toRoman(1849),"MDCCCXLIX");
		eq(RomanNumeral.toRoman(1850),"MDCCCL");
		eq(RomanNumeral.toRoman(1851),"MDCCCLI");
		eq(RomanNumeral.toRoman(1852),"MDCCCLII");
		eq(RomanNumeral.toRoman(1853),"MDCCCLIII");
		eq(RomanNumeral.toRoman(1854),"MDCCCLIV");
		eq(RomanNumeral.toRoman(1855),"MDCCCLV");
		eq(RomanNumeral.toRoman(1856),"MDCCCLVI");
		eq(RomanNumeral.toRoman(1857),"MDCCCLVII");
		eq(RomanNumeral.toRoman(1858),"MDCCCLVIII");
		eq(RomanNumeral.toRoman(1859),"MDCCCLIX");
		eq(RomanNumeral.toRoman(1860),"MDCCCLX");
		eq(RomanNumeral.toRoman(1861),"MDCCCLXI");
		eq(RomanNumeral.toRoman(1862),"MDCCCLXII");
		eq(RomanNumeral.toRoman(1863),"MDCCCLXIII");
		eq(RomanNumeral.toRoman(1864),"MDCCCLXIV");
		eq(RomanNumeral.toRoman(1865),"MDCCCLXV");
		eq(RomanNumeral.toRoman(1866),"MDCCCLXVI");
		eq(RomanNumeral.toRoman(1867),"MDCCCLXVII");
		eq(RomanNumeral.toRoman(1868),"MDCCCLXVIII");
		eq(RomanNumeral.toRoman(1869),"MDCCCLXIX");
		eq(RomanNumeral.toRoman(1870),"MDCCCLXX");
		eq(RomanNumeral.toRoman(1871),"MDCCCLXXI");
		eq(RomanNumeral.toRoman(1872),"MDCCCLXXII");
		eq(RomanNumeral.toRoman(1873),"MDCCCLXXIII");
		eq(RomanNumeral.toRoman(1874),"MDCCCLXXIV");
		eq(RomanNumeral.toRoman(1875),"MDCCCLXXV");
		eq(RomanNumeral.toRoman(1876),"MDCCCLXXVI");
		eq(RomanNumeral.toRoman(1877),"MDCCCLXXVII");
		eq(RomanNumeral.toRoman(1878),"MDCCCLXXVIII");
		eq(RomanNumeral.toRoman(1879),"MDCCCLXXIX");
		eq(RomanNumeral.toRoman(1880),"MDCCCLXXX");
		eq(RomanNumeral.toRoman(1881),"MDCCCLXXXI");
		eq(RomanNumeral.toRoman(1882),"MDCCCLXXXII");
		eq(RomanNumeral.toRoman(1883),"MDCCCLXXXIII");
		eq(RomanNumeral.toRoman(1884),"MDCCCLXXXIV");
		eq(RomanNumeral.toRoman(1885),"MDCCCLXXXV");
		eq(RomanNumeral.toRoman(1886),"MDCCCLXXXVI");
		eq(RomanNumeral.toRoman(1887),"MDCCCLXXXVII");
		eq(RomanNumeral.toRoman(1888),"MDCCCLXXXVIII");
		eq(RomanNumeral.toRoman(1889),"MDCCCLXXXIX");
		eq(RomanNumeral.toRoman(1890),"MDCCCXC");
		eq(RomanNumeral.toRoman(1891),"MDCCCXCI");
		eq(RomanNumeral.toRoman(1892),"MDCCCXCII");
		eq(RomanNumeral.toRoman(1893),"MDCCCXCIII");
		eq(RomanNumeral.toRoman(1894),"MDCCCXCIV");
		eq(RomanNumeral.toRoman(1895),"MDCCCXCV");
		eq(RomanNumeral.toRoman(1896),"MDCCCXCVI");
		eq(RomanNumeral.toRoman(1897),"MDCCCXCVII");
		eq(RomanNumeral.toRoman(1898),"MDCCCXCVIII");
		eq(RomanNumeral.toRoman(1899),"MDCCCXCIX");
		eq(RomanNumeral.toRoman(1900),"MCM");
		eq(RomanNumeral.toRoman(1901),"MCMI");
		eq(RomanNumeral.toRoman(1902),"MCMII");
		eq(RomanNumeral.toRoman(1903),"MCMIII");
		eq(RomanNumeral.toRoman(1904),"MCMIV");
		eq(RomanNumeral.toRoman(1905),"MCMV");
		eq(RomanNumeral.toRoman(1906),"MCMVI");
		eq(RomanNumeral.toRoman(1907),"MCMVII");
		eq(RomanNumeral.toRoman(1908),"MCMVIII");
		eq(RomanNumeral.toRoman(1909),"MCMIX");
		eq(RomanNumeral.toRoman(1910),"MCMX");
		eq(RomanNumeral.toRoman(1911),"MCMXI");
		eq(RomanNumeral.toRoman(1912),"MCMXII");
		eq(RomanNumeral.toRoman(1913),"MCMXIII");
		eq(RomanNumeral.toRoman(1914),"MCMXIV");
		eq(RomanNumeral.toRoman(1915),"MCMXV");
		eq(RomanNumeral.toRoman(1916),"MCMXVI");
		eq(RomanNumeral.toRoman(1917),"MCMXVII");
		eq(RomanNumeral.toRoman(1918),"MCMXVIII");
		eq(RomanNumeral.toRoman(1919),"MCMXIX");
		eq(RomanNumeral.toRoman(1920),"MCMXX");
		eq(RomanNumeral.toRoman(1921),"MCMXXI");
		eq(RomanNumeral.toRoman(1922),"MCMXXII");
		eq(RomanNumeral.toRoman(1923),"MCMXXIII");
		eq(RomanNumeral.toRoman(1924),"MCMXXIV");
		eq(RomanNumeral.toRoman(1925),"MCMXXV");
		eq(RomanNumeral.toRoman(1926),"MCMXXVI");
		eq(RomanNumeral.toRoman(1927),"MCMXXVII");
		eq(RomanNumeral.toRoman(1928),"MCMXXVIII");
		eq(RomanNumeral.toRoman(1929),"MCMXXIX");
		eq(RomanNumeral.toRoman(1930),"MCMXXX");
		eq(RomanNumeral.toRoman(1931),"MCMXXXI");
		eq(RomanNumeral.toRoman(1932),"MCMXXXII");
		eq(RomanNumeral.toRoman(1933),"MCMXXXIII");
		eq(RomanNumeral.toRoman(1934),"MCMXXXIV");
		eq(RomanNumeral.toRoman(1935),"MCMXXXV");
		eq(RomanNumeral.toRoman(1936),"MCMXXXVI");
		eq(RomanNumeral.toRoman(1937),"MCMXXXVII");
		eq(RomanNumeral.toRoman(1938),"MCMXXXVIII");
		eq(RomanNumeral.toRoman(1939),"MCMXXXIX");
		eq(RomanNumeral.toRoman(1940),"MCMXL");
		eq(RomanNumeral.toRoman(1941),"MCMXLI");
		eq(RomanNumeral.toRoman(1942),"MCMXLII");
		eq(RomanNumeral.toRoman(1943),"MCMXLIII");
		eq(RomanNumeral.toRoman(1944),"MCMXLIV");
		eq(RomanNumeral.toRoman(1945),"MCMXLV");
		eq(RomanNumeral.toRoman(1946),"MCMXLVI");
		eq(RomanNumeral.toRoman(1947),"MCMXLVII");
		eq(RomanNumeral.toRoman(1948),"MCMXLVIII");
		eq(RomanNumeral.toRoman(1949),"MCMXLIX");
		eq(RomanNumeral.toRoman(1950),"MCML");
		eq(RomanNumeral.toRoman(1951),"MCMLI");
		eq(RomanNumeral.toRoman(1952),"MCMLII");
		eq(RomanNumeral.toRoman(1953),"MCMLIII");
		eq(RomanNumeral.toRoman(1954),"MCMLIV");
		eq(RomanNumeral.toRoman(1955),"MCMLV");
		eq(RomanNumeral.toRoman(1956),"MCMLVI");
		eq(RomanNumeral.toRoman(1957),"MCMLVII");
		eq(RomanNumeral.toRoman(1958),"MCMLVIII");
		eq(RomanNumeral.toRoman(1959),"MCMLIX");
		eq(RomanNumeral.toRoman(1960),"MCMLX");
		eq(RomanNumeral.toRoman(1961),"MCMLXI");
		eq(RomanNumeral.toRoman(1962),"MCMLXII");
		eq(RomanNumeral.toRoman(1963),"MCMLXIII");
		eq(RomanNumeral.toRoman(1964),"MCMLXIV");
		eq(RomanNumeral.toRoman(1965),"MCMLXV");
		eq(RomanNumeral.toRoman(1966),"MCMLXVI");
		eq(RomanNumeral.toRoman(1967),"MCMLXVII");
		eq(RomanNumeral.toRoman(1968),"MCMLXVIII");
		eq(RomanNumeral.toRoman(1969),"MCMLXIX");
		eq(RomanNumeral.toRoman(1970),"MCMLXX");
		eq(RomanNumeral.toRoman(1971),"MCMLXXI");
		eq(RomanNumeral.toRoman(1972),"MCMLXXII");
		eq(RomanNumeral.toRoman(1973),"MCMLXXIII");
		eq(RomanNumeral.toRoman(1974),"MCMLXXIV");
		eq(RomanNumeral.toRoman(1975),"MCMLXXV");
		eq(RomanNumeral.toRoman(1976),"MCMLXXVI");
		eq(RomanNumeral.toRoman(1977),"MCMLXXVII");
		eq(RomanNumeral.toRoman(1978),"MCMLXXVIII");
		eq(RomanNumeral.toRoman(1979),"MCMLXXIX");
		eq(RomanNumeral.toRoman(1980),"MCMLXXX");
		eq(RomanNumeral.toRoman(1981),"MCMLXXXI");
		eq(RomanNumeral.toRoman(1982),"MCMLXXXII");
		eq(RomanNumeral.toRoman(1983),"MCMLXXXIII");
		eq(RomanNumeral.toRoman(1984),"MCMLXXXIV");
		eq(RomanNumeral.toRoman(1985),"MCMLXXXV");
		eq(RomanNumeral.toRoman(1986),"MCMLXXXVI");
		eq(RomanNumeral.toRoman(1987),"MCMLXXXVII");
		eq(RomanNumeral.toRoman(1988),"MCMLXXXVIII");
		eq(RomanNumeral.toRoman(1989),"MCMLXXXIX");
		eq(RomanNumeral.toRoman(1990),"MCMXC");
		eq(RomanNumeral.toRoman(1991),"MCMXCI");
		eq(RomanNumeral.toRoman(1992),"MCMXCII");
		eq(RomanNumeral.toRoman(1993),"MCMXCIII");
		eq(RomanNumeral.toRoman(1994),"MCMXCIV");
		eq(RomanNumeral.toRoman(1995),"MCMXCV");
		eq(RomanNumeral.toRoman(1996),"MCMXCVI");
		eq(RomanNumeral.toRoman(1997),"MCMXCVII");
		eq(RomanNumeral.toRoman(1998),"MCMXCVIII");
		eq(RomanNumeral.toRoman(1999),"MCMXCIX");
		eq(RomanNumeral.toRoman(2000),"MM");
		eq(RomanNumeral.toRoman(2001),"MMI");
		eq(RomanNumeral.toRoman(2002),"MMII");
		eq(RomanNumeral.toRoman(2003),"MMIII");
		eq(RomanNumeral.toRoman(2004),"MMIV");
		eq(RomanNumeral.toRoman(2005),"MMV");
		eq(RomanNumeral.toRoman(2006),"MMVI");
		eq(RomanNumeral.toRoman(2007),"MMVII");
		eq(RomanNumeral.toRoman(2008),"MMVIII");
		eq(RomanNumeral.toRoman(2009),"MMIX");
		eq(RomanNumeral.toRoman(2010),"MMX");
		eq(RomanNumeral.toRoman(2011),"MMXI");
		eq(RomanNumeral.toRoman(2012),"MMXII");
		eq(RomanNumeral.toRoman(2013),"MMXIII");
		eq(RomanNumeral.toRoman(2014),"MMXIV");
		eq(RomanNumeral.toRoman(2015),"MMXV");
		eq(RomanNumeral.toRoman(2016),"MMXVI");
		eq(RomanNumeral.toRoman(2017),"MMXVII");
		eq(RomanNumeral.toRoman(2018),"MMXVIII");
		eq(RomanNumeral.toRoman(2019),"MMXIX");
		eq(RomanNumeral.toRoman(2020),"MMXX");
		eq(RomanNumeral.toRoman(2021),"MMXXI");
		eq(RomanNumeral.toRoman(2022),"MMXXII");
		eq(RomanNumeral.toRoman(2023),"MMXXIII");
		eq(RomanNumeral.toRoman(2024),"MMXXIV");
		eq(RomanNumeral.toRoman(2025),"MMXXV");
		eq(RomanNumeral.toRoman(2026),"MMXXVI");
		eq(RomanNumeral.toRoman(2027),"MMXXVII");
		eq(RomanNumeral.toRoman(2028),"MMXXVIII");
		eq(RomanNumeral.toRoman(2029),"MMXXIX");
		eq(RomanNumeral.toRoman(2030),"MMXXX");
		eq(RomanNumeral.toRoman(2031),"MMXXXI");
		eq(RomanNumeral.toRoman(2032),"MMXXXII");
		eq(RomanNumeral.toRoman(2033),"MMXXXIII");
		eq(RomanNumeral.toRoman(2034),"MMXXXIV");
		eq(RomanNumeral.toRoman(2035),"MMXXXV");
		eq(RomanNumeral.toRoman(2036),"MMXXXVI");
		eq(RomanNumeral.toRoman(2037),"MMXXXVII");
		eq(RomanNumeral.toRoman(2038),"MMXXXVIII");
		eq(RomanNumeral.toRoman(2039),"MMXXXIX");
		eq(RomanNumeral.toRoman(2040),"MMXL");
		eq(RomanNumeral.toRoman(2041),"MMXLI");
		eq(RomanNumeral.toRoman(2042),"MMXLII");
		eq(RomanNumeral.toRoman(2043),"MMXLIII");
		eq(RomanNumeral.toRoman(2044),"MMXLIV");
		eq(RomanNumeral.toRoman(2045),"MMXLV");
		eq(RomanNumeral.toRoman(2046),"MMXLVI");
		eq(RomanNumeral.toRoman(2047),"MMXLVII");
		eq(RomanNumeral.toRoman(2048),"MMXLVIII");
		eq(RomanNumeral.toRoman(2049),"MMXLIX");
		eq(RomanNumeral.toRoman(2050),"MML");
		eq(RomanNumeral.toRoman(2051),"MMLI");
		eq(RomanNumeral.toRoman(2052),"MMLII");
		eq(RomanNumeral.toRoman(2053),"MMLIII");
		eq(RomanNumeral.toRoman(2054),"MMLIV");
		eq(RomanNumeral.toRoman(2055),"MMLV");
		eq(RomanNumeral.toRoman(2056),"MMLVI");
		eq(RomanNumeral.toRoman(2057),"MMLVII");
		eq(RomanNumeral.toRoman(2058),"MMLVIII");
		eq(RomanNumeral.toRoman(2059),"MMLIX");
		eq(RomanNumeral.toRoman(2060),"MMLX");
		eq(RomanNumeral.toRoman(2061),"MMLXI");
		eq(RomanNumeral.toRoman(2062),"MMLXII");
		eq(RomanNumeral.toRoman(2063),"MMLXIII");
		eq(RomanNumeral.toRoman(2064),"MMLXIV");
		eq(RomanNumeral.toRoman(2065),"MMLXV");
		eq(RomanNumeral.toRoman(2066),"MMLXVI");
		eq(RomanNumeral.toRoman(2067),"MMLXVII");
		eq(RomanNumeral.toRoman(2068),"MMLXVIII");
		eq(RomanNumeral.toRoman(2069),"MMLXIX");
		eq(RomanNumeral.toRoman(2070),"MMLXX");
		eq(RomanNumeral.toRoman(2071),"MMLXXI");
		eq(RomanNumeral.toRoman(2072),"MMLXXII");
		eq(RomanNumeral.toRoman(2073),"MMLXXIII");
		eq(RomanNumeral.toRoman(2074),"MMLXXIV");
		eq(RomanNumeral.toRoman(2075),"MMLXXV");
		eq(RomanNumeral.toRoman(2076),"MMLXXVI");
		eq(RomanNumeral.toRoman(2077),"MMLXXVII");
		eq(RomanNumeral.toRoman(2078),"MMLXXVIII");
		eq(RomanNumeral.toRoman(2079),"MMLXXIX");
		eq(RomanNumeral.toRoman(2080),"MMLXXX");
		eq(RomanNumeral.toRoman(2081),"MMLXXXI");
		eq(RomanNumeral.toRoman(2082),"MMLXXXII");
		eq(RomanNumeral.toRoman(2083),"MMLXXXIII");
		eq(RomanNumeral.toRoman(2084),"MMLXXXIV");
		eq(RomanNumeral.toRoman(2085),"MMLXXXV");
		eq(RomanNumeral.toRoman(2086),"MMLXXXVI");
		eq(RomanNumeral.toRoman(2087),"MMLXXXVII");
		eq(RomanNumeral.toRoman(2088),"MMLXXXVIII");
		eq(RomanNumeral.toRoman(2089),"MMLXXXIX");
		eq(RomanNumeral.toRoman(2090),"MMXC");
		eq(RomanNumeral.toRoman(2091),"MMXCI");
		eq(RomanNumeral.toRoman(2092),"MMXCII");
		eq(RomanNumeral.toRoman(2093),"MMXCIII");
		eq(RomanNumeral.toRoman(2094),"MMXCIV");
		eq(RomanNumeral.toRoman(2095),"MMXCV");
		eq(RomanNumeral.toRoman(2096),"MMXCVI");
		eq(RomanNumeral.toRoman(2097),"MMXCVII");
		eq(RomanNumeral.toRoman(2098),"MMXCVIII");
		eq(RomanNumeral.toRoman(2099),"MMXCIX");
		eq(RomanNumeral.toRoman(2100),"MMC");
		eq(RomanNumeral.toRoman(2101),"MMCI");
		eq(RomanNumeral.toRoman(2102),"MMCII");
		eq(RomanNumeral.toRoman(2103),"MMCIII");
		eq(RomanNumeral.toRoman(2104),"MMCIV");
		eq(RomanNumeral.toRoman(2105),"MMCV");
		eq(RomanNumeral.toRoman(2106),"MMCVI");
		eq(RomanNumeral.toRoman(2107),"MMCVII");
		eq(RomanNumeral.toRoman(2108),"MMCVIII");
		eq(RomanNumeral.toRoman(2109),"MMCIX");
		eq(RomanNumeral.toRoman(2110),"MMCX");
		eq(RomanNumeral.toRoman(2111),"MMCXI");
		eq(RomanNumeral.toRoman(2112),"MMCXII");
		eq(RomanNumeral.toRoman(2113),"MMCXIII");
		eq(RomanNumeral.toRoman(2114),"MMCXIV");
		eq(RomanNumeral.toRoman(2115),"MMCXV");
		eq(RomanNumeral.toRoman(2116),"MMCXVI");
		eq(RomanNumeral.toRoman(2117),"MMCXVII");
		eq(RomanNumeral.toRoman(2118),"MMCXVIII");
		eq(RomanNumeral.toRoman(2119),"MMCXIX");
		eq(RomanNumeral.toRoman(2120),"MMCXX");
		eq(RomanNumeral.toRoman(2121),"MMCXXI");
		eq(RomanNumeral.toRoman(2122),"MMCXXII");
		eq(RomanNumeral.toRoman(2123),"MMCXXIII");
		eq(RomanNumeral.toRoman(2124),"MMCXXIV");
		eq(RomanNumeral.toRoman(2125),"MMCXXV");
		eq(RomanNumeral.toRoman(2126),"MMCXXVI");
		eq(RomanNumeral.toRoman(2127),"MMCXXVII");
		eq(RomanNumeral.toRoman(2128),"MMCXXVIII");
		eq(RomanNumeral.toRoman(2129),"MMCXXIX");
		eq(RomanNumeral.toRoman(2130),"MMCXXX");
		eq(RomanNumeral.toRoman(2131),"MMCXXXI");
		eq(RomanNumeral.toRoman(2132),"MMCXXXII");
		eq(RomanNumeral.toRoman(2133),"MMCXXXIII");
		eq(RomanNumeral.toRoman(2134),"MMCXXXIV");
		eq(RomanNumeral.toRoman(2135),"MMCXXXV");
		eq(RomanNumeral.toRoman(2136),"MMCXXXVI");
		eq(RomanNumeral.toRoman(2137),"MMCXXXVII");
		eq(RomanNumeral.toRoman(2138),"MMCXXXVIII");
		eq(RomanNumeral.toRoman(2139),"MMCXXXIX");
		eq(RomanNumeral.toRoman(2140),"MMCXL");
		eq(RomanNumeral.toRoman(2141),"MMCXLI");
		eq(RomanNumeral.toRoman(2142),"MMCXLII");
		eq(RomanNumeral.toRoman(2143),"MMCXLIII");
		eq(RomanNumeral.toRoman(2144),"MMCXLIV");
		eq(RomanNumeral.toRoman(2145),"MMCXLV");
		eq(RomanNumeral.toRoman(2146),"MMCXLVI");
		eq(RomanNumeral.toRoman(2147),"MMCXLVII");
		eq(RomanNumeral.toRoman(2148),"MMCXLVIII");
		eq(RomanNumeral.toRoman(2149),"MMCXLIX");
		eq(RomanNumeral.toRoman(2150),"MMCL");
		eq(RomanNumeral.toRoman(2151),"MMCLI");
		eq(RomanNumeral.toRoman(2152),"MMCLII");
		eq(RomanNumeral.toRoman(2153),"MMCLIII");
		eq(RomanNumeral.toRoman(2154),"MMCLIV");
		eq(RomanNumeral.toRoman(2155),"MMCLV");
		eq(RomanNumeral.toRoman(2156),"MMCLVI");
		eq(RomanNumeral.toRoman(2157),"MMCLVII");
		eq(RomanNumeral.toRoman(2158),"MMCLVIII");
		eq(RomanNumeral.toRoman(2159),"MMCLIX");
		eq(RomanNumeral.toRoman(2160),"MMCLX");
		eq(RomanNumeral.toRoman(2161),"MMCLXI");
		eq(RomanNumeral.toRoman(2162),"MMCLXII");
		eq(RomanNumeral.toRoman(2163),"MMCLXIII");
		eq(RomanNumeral.toRoman(2164),"MMCLXIV");
		eq(RomanNumeral.toRoman(2165),"MMCLXV");
		eq(RomanNumeral.toRoman(2166),"MMCLXVI");
		eq(RomanNumeral.toRoman(2167),"MMCLXVII");
		eq(RomanNumeral.toRoman(2168),"MMCLXVIII");
		eq(RomanNumeral.toRoman(2169),"MMCLXIX");
		eq(RomanNumeral.toRoman(2170),"MMCLXX");
		eq(RomanNumeral.toRoman(2171),"MMCLXXI");
		eq(RomanNumeral.toRoman(2172),"MMCLXXII");
		eq(RomanNumeral.toRoman(2173),"MMCLXXIII");
		eq(RomanNumeral.toRoman(2174),"MMCLXXIV");
		eq(RomanNumeral.toRoman(2175),"MMCLXXV");
		eq(RomanNumeral.toRoman(2176),"MMCLXXVI");
		eq(RomanNumeral.toRoman(2177),"MMCLXXVII");
		eq(RomanNumeral.toRoman(2178),"MMCLXXVIII");
		eq(RomanNumeral.toRoman(2179),"MMCLXXIX");
		eq(RomanNumeral.toRoman(2180),"MMCLXXX");
		eq(RomanNumeral.toRoman(2181),"MMCLXXXI");
		eq(RomanNumeral.toRoman(2182),"MMCLXXXII");
		eq(RomanNumeral.toRoman(2183),"MMCLXXXIII");
		eq(RomanNumeral.toRoman(2184),"MMCLXXXIV");
		eq(RomanNumeral.toRoman(2185),"MMCLXXXV");
		eq(RomanNumeral.toRoman(2186),"MMCLXXXVI");
		eq(RomanNumeral.toRoman(2187),"MMCLXXXVII");
		eq(RomanNumeral.toRoman(2188),"MMCLXXXVIII");
		eq(RomanNumeral.toRoman(2189),"MMCLXXXIX");
		eq(RomanNumeral.toRoman(2190),"MMCXC");
		eq(RomanNumeral.toRoman(2191),"MMCXCI");
		eq(RomanNumeral.toRoman(2192),"MMCXCII");
		eq(RomanNumeral.toRoman(2193),"MMCXCIII");
		eq(RomanNumeral.toRoman(2194),"MMCXCIV");
		eq(RomanNumeral.toRoman(2195),"MMCXCV");
		eq(RomanNumeral.toRoman(2196),"MMCXCVI");
		eq(RomanNumeral.toRoman(2197),"MMCXCVII");
		eq(RomanNumeral.toRoman(2198),"MMCXCVIII");
		eq(RomanNumeral.toRoman(2199),"MMCXCIX");
		eq(RomanNumeral.toRoman(2200),"MMCC");
		eq(RomanNumeral.toRoman(2201),"MMCCI");
		eq(RomanNumeral.toRoman(2202),"MMCCII");
		eq(RomanNumeral.toRoman(2203),"MMCCIII");
		eq(RomanNumeral.toRoman(2204),"MMCCIV");
		eq(RomanNumeral.toRoman(2205),"MMCCV");
		eq(RomanNumeral.toRoman(2206),"MMCCVI");
		eq(RomanNumeral.toRoman(2207),"MMCCVII");
		eq(RomanNumeral.toRoman(2208),"MMCCVIII");
		eq(RomanNumeral.toRoman(2209),"MMCCIX");
		eq(RomanNumeral.toRoman(2210),"MMCCX");
		eq(RomanNumeral.toRoman(2211),"MMCCXI");
		eq(RomanNumeral.toRoman(2212),"MMCCXII");
		eq(RomanNumeral.toRoman(2213),"MMCCXIII");
		eq(RomanNumeral.toRoman(2214),"MMCCXIV");
		eq(RomanNumeral.toRoman(2215),"MMCCXV");
		eq(RomanNumeral.toRoman(2216),"MMCCXVI");
		eq(RomanNumeral.toRoman(2217),"MMCCXVII");
		eq(RomanNumeral.toRoman(2218),"MMCCXVIII");
		eq(RomanNumeral.toRoman(2219),"MMCCXIX");
		eq(RomanNumeral.toRoman(2220),"MMCCXX");
		eq(RomanNumeral.toRoman(2221),"MMCCXXI");
		eq(RomanNumeral.toRoman(2222),"MMCCXXII");
		eq(RomanNumeral.toRoman(2223),"MMCCXXIII");
		eq(RomanNumeral.toRoman(2224),"MMCCXXIV");
		eq(RomanNumeral.toRoman(2225),"MMCCXXV");
		eq(RomanNumeral.toRoman(2226),"MMCCXXVI");
		eq(RomanNumeral.toRoman(2227),"MMCCXXVII");
		eq(RomanNumeral.toRoman(2228),"MMCCXXVIII");
		eq(RomanNumeral.toRoman(2229),"MMCCXXIX");
		eq(RomanNumeral.toRoman(2230),"MMCCXXX");
		eq(RomanNumeral.toRoman(2231),"MMCCXXXI");
		eq(RomanNumeral.toRoman(2232),"MMCCXXXII");
		eq(RomanNumeral.toRoman(2233),"MMCCXXXIII");
		eq(RomanNumeral.toRoman(2234),"MMCCXXXIV");
		eq(RomanNumeral.toRoman(2235),"MMCCXXXV");
		eq(RomanNumeral.toRoman(2236),"MMCCXXXVI");
		eq(RomanNumeral.toRoman(2237),"MMCCXXXVII");
		eq(RomanNumeral.toRoman(2238),"MMCCXXXVIII");
		eq(RomanNumeral.toRoman(2239),"MMCCXXXIX");
		eq(RomanNumeral.toRoman(2240),"MMCCXL");
		eq(RomanNumeral.toRoman(2241),"MMCCXLI");
		eq(RomanNumeral.toRoman(2242),"MMCCXLII");
		eq(RomanNumeral.toRoman(2243),"MMCCXLIII");
		eq(RomanNumeral.toRoman(2244),"MMCCXLIV");
		eq(RomanNumeral.toRoman(2245),"MMCCXLV");
		eq(RomanNumeral.toRoman(2246),"MMCCXLVI");
		eq(RomanNumeral.toRoman(2247),"MMCCXLVII");
		eq(RomanNumeral.toRoman(2248),"MMCCXLVIII");
		eq(RomanNumeral.toRoman(2249),"MMCCXLIX");
		eq(RomanNumeral.toRoman(2250),"MMCCL");
		eq(RomanNumeral.toRoman(2251),"MMCCLI");
		eq(RomanNumeral.toRoman(2252),"MMCCLII");
		eq(RomanNumeral.toRoman(2253),"MMCCLIII");
		eq(RomanNumeral.toRoman(2254),"MMCCLIV");
		eq(RomanNumeral.toRoman(2255),"MMCCLV");
		eq(RomanNumeral.toRoman(2256),"MMCCLVI");
		eq(RomanNumeral.toRoman(2257),"MMCCLVII");
		eq(RomanNumeral.toRoman(2258),"MMCCLVIII");
		eq(RomanNumeral.toRoman(2259),"MMCCLIX");
		eq(RomanNumeral.toRoman(2260),"MMCCLX");
		eq(RomanNumeral.toRoman(2261),"MMCCLXI");
		eq(RomanNumeral.toRoman(2262),"MMCCLXII");
		eq(RomanNumeral.toRoman(2263),"MMCCLXIII");
		eq(RomanNumeral.toRoman(2264),"MMCCLXIV");
		eq(RomanNumeral.toRoman(2265),"MMCCLXV");
		eq(RomanNumeral.toRoman(2266),"MMCCLXVI");
		eq(RomanNumeral.toRoman(2267),"MMCCLXVII");
		eq(RomanNumeral.toRoman(2268),"MMCCLXVIII");
		eq(RomanNumeral.toRoman(2269),"MMCCLXIX");
		eq(RomanNumeral.toRoman(2270),"MMCCLXX");
		eq(RomanNumeral.toRoman(2271),"MMCCLXXI");
		eq(RomanNumeral.toRoman(2272),"MMCCLXXII");
		eq(RomanNumeral.toRoman(2273),"MMCCLXXIII");
		eq(RomanNumeral.toRoman(2274),"MMCCLXXIV");
		eq(RomanNumeral.toRoman(2275),"MMCCLXXV");
		eq(RomanNumeral.toRoman(2276),"MMCCLXXVI");
		eq(RomanNumeral.toRoman(2277),"MMCCLXXVII");
		eq(RomanNumeral.toRoman(2278),"MMCCLXXVIII");
		eq(RomanNumeral.toRoman(2279),"MMCCLXXIX");
		eq(RomanNumeral.toRoman(2280),"MMCCLXXX");
		eq(RomanNumeral.toRoman(2281),"MMCCLXXXI");
		eq(RomanNumeral.toRoman(2282),"MMCCLXXXII");
		eq(RomanNumeral.toRoman(2283),"MMCCLXXXIII");
		eq(RomanNumeral.toRoman(2284),"MMCCLXXXIV");
		eq(RomanNumeral.toRoman(2285),"MMCCLXXXV");
		eq(RomanNumeral.toRoman(2286),"MMCCLXXXVI");
		eq(RomanNumeral.toRoman(2287),"MMCCLXXXVII");
		eq(RomanNumeral.toRoman(2288),"MMCCLXXXVIII");
		eq(RomanNumeral.toRoman(2289),"MMCCLXXXIX");
		eq(RomanNumeral.toRoman(2290),"MMCCXC");
		eq(RomanNumeral.toRoman(2291),"MMCCXCI");
		eq(RomanNumeral.toRoman(2292),"MMCCXCII");
		eq(RomanNumeral.toRoman(2293),"MMCCXCIII");
		eq(RomanNumeral.toRoman(2294),"MMCCXCIV");
		eq(RomanNumeral.toRoman(2295),"MMCCXCV");
		eq(RomanNumeral.toRoman(2296),"MMCCXCVI");
		eq(RomanNumeral.toRoman(2297),"MMCCXCVII");
		eq(RomanNumeral.toRoman(2298),"MMCCXCVIII");
		eq(RomanNumeral.toRoman(2299),"MMCCXCIX");
		eq(RomanNumeral.toRoman(2300),"MMCCC");
		eq(RomanNumeral.toRoman(2301),"MMCCCI");
		eq(RomanNumeral.toRoman(2302),"MMCCCII");
		eq(RomanNumeral.toRoman(2303),"MMCCCIII");
		eq(RomanNumeral.toRoman(2304),"MMCCCIV");
		eq(RomanNumeral.toRoman(2305),"MMCCCV");
		eq(RomanNumeral.toRoman(2306),"MMCCCVI");
		eq(RomanNumeral.toRoman(2307),"MMCCCVII");
		eq(RomanNumeral.toRoman(2308),"MMCCCVIII");
		eq(RomanNumeral.toRoman(2309),"MMCCCIX");
		eq(RomanNumeral.toRoman(2310),"MMCCCX");
		eq(RomanNumeral.toRoman(2311),"MMCCCXI");
		eq(RomanNumeral.toRoman(2312),"MMCCCXII");
		eq(RomanNumeral.toRoman(2313),"MMCCCXIII");
		eq(RomanNumeral.toRoman(2314),"MMCCCXIV");
		eq(RomanNumeral.toRoman(2315),"MMCCCXV");
		eq(RomanNumeral.toRoman(2316),"MMCCCXVI");
		eq(RomanNumeral.toRoman(2317),"MMCCCXVII");
		eq(RomanNumeral.toRoman(2318),"MMCCCXVIII");
		eq(RomanNumeral.toRoman(2319),"MMCCCXIX");
		eq(RomanNumeral.toRoman(2320),"MMCCCXX");
		eq(RomanNumeral.toRoman(2321),"MMCCCXXI");
		eq(RomanNumeral.toRoman(2322),"MMCCCXXII");
		eq(RomanNumeral.toRoman(2323),"MMCCCXXIII");
		eq(RomanNumeral.toRoman(2324),"MMCCCXXIV");
		eq(RomanNumeral.toRoman(2325),"MMCCCXXV");
		eq(RomanNumeral.toRoman(2326),"MMCCCXXVI");
		eq(RomanNumeral.toRoman(2327),"MMCCCXXVII");
		eq(RomanNumeral.toRoman(2328),"MMCCCXXVIII");
		eq(RomanNumeral.toRoman(2329),"MMCCCXXIX");
		eq(RomanNumeral.toRoman(2330),"MMCCCXXX");
		eq(RomanNumeral.toRoman(2331),"MMCCCXXXI");
		eq(RomanNumeral.toRoman(2332),"MMCCCXXXII");
		eq(RomanNumeral.toRoman(2333),"MMCCCXXXIII");
		eq(RomanNumeral.toRoman(2334),"MMCCCXXXIV");
		eq(RomanNumeral.toRoman(2335),"MMCCCXXXV");
		eq(RomanNumeral.toRoman(2336),"MMCCCXXXVI");
		eq(RomanNumeral.toRoman(2337),"MMCCCXXXVII");
		eq(RomanNumeral.toRoman(2338),"MMCCCXXXVIII");
		eq(RomanNumeral.toRoman(2339),"MMCCCXXXIX");
		eq(RomanNumeral.toRoman(2340),"MMCCCXL");
		eq(RomanNumeral.toRoman(2341),"MMCCCXLI");
		eq(RomanNumeral.toRoman(2342),"MMCCCXLII");
		eq(RomanNumeral.toRoman(2343),"MMCCCXLIII");
		eq(RomanNumeral.toRoman(2344),"MMCCCXLIV");
		eq(RomanNumeral.toRoman(2345),"MMCCCXLV");
		eq(RomanNumeral.toRoman(2346),"MMCCCXLVI");
		eq(RomanNumeral.toRoman(2347),"MMCCCXLVII");
		eq(RomanNumeral.toRoman(2348),"MMCCCXLVIII");
		eq(RomanNumeral.toRoman(2349),"MMCCCXLIX");
		eq(RomanNumeral.toRoman(2350),"MMCCCL");
		eq(RomanNumeral.toRoman(2351),"MMCCCLI");
		eq(RomanNumeral.toRoman(2352),"MMCCCLII");
		eq(RomanNumeral.toRoman(2353),"MMCCCLIII");
		eq(RomanNumeral.toRoman(2354),"MMCCCLIV");
		eq(RomanNumeral.toRoman(2355),"MMCCCLV");
		eq(RomanNumeral.toRoman(2356),"MMCCCLVI");
		eq(RomanNumeral.toRoman(2357),"MMCCCLVII");
		eq(RomanNumeral.toRoman(2358),"MMCCCLVIII");
		eq(RomanNumeral.toRoman(2359),"MMCCCLIX");
		eq(RomanNumeral.toRoman(2360),"MMCCCLX");
		eq(RomanNumeral.toRoman(2361),"MMCCCLXI");
		eq(RomanNumeral.toRoman(2362),"MMCCCLXII");
		eq(RomanNumeral.toRoman(2363),"MMCCCLXIII");
		eq(RomanNumeral.toRoman(2364),"MMCCCLXIV");
		eq(RomanNumeral.toRoman(2365),"MMCCCLXV");
		eq(RomanNumeral.toRoman(2366),"MMCCCLXVI");
		eq(RomanNumeral.toRoman(2367),"MMCCCLXVII");
		eq(RomanNumeral.toRoman(2368),"MMCCCLXVIII");
		eq(RomanNumeral.toRoman(2369),"MMCCCLXIX");
		eq(RomanNumeral.toRoman(2370),"MMCCCLXX");
		eq(RomanNumeral.toRoman(2371),"MMCCCLXXI");
		eq(RomanNumeral.toRoman(2372),"MMCCCLXXII");
		eq(RomanNumeral.toRoman(2373),"MMCCCLXXIII");
		eq(RomanNumeral.toRoman(2374),"MMCCCLXXIV");
		eq(RomanNumeral.toRoman(2375),"MMCCCLXXV");
		eq(RomanNumeral.toRoman(2376),"MMCCCLXXVI");
		eq(RomanNumeral.toRoman(2377),"MMCCCLXXVII");
		eq(RomanNumeral.toRoman(2378),"MMCCCLXXVIII");
		eq(RomanNumeral.toRoman(2379),"MMCCCLXXIX");
		eq(RomanNumeral.toRoman(2380),"MMCCCLXXX");
		eq(RomanNumeral.toRoman(2381),"MMCCCLXXXI");
		eq(RomanNumeral.toRoman(2382),"MMCCCLXXXII");
		eq(RomanNumeral.toRoman(2383),"MMCCCLXXXIII");
		eq(RomanNumeral.toRoman(2384),"MMCCCLXXXIV");
		eq(RomanNumeral.toRoman(2385),"MMCCCLXXXV");
		eq(RomanNumeral.toRoman(2386),"MMCCCLXXXVI");
		eq(RomanNumeral.toRoman(2387),"MMCCCLXXXVII");
		eq(RomanNumeral.toRoman(2388),"MMCCCLXXXVIII");
		eq(RomanNumeral.toRoman(2389),"MMCCCLXXXIX");
		eq(RomanNumeral.toRoman(2390),"MMCCCXC");
		eq(RomanNumeral.toRoman(2391),"MMCCCXCI");
		eq(RomanNumeral.toRoman(2392),"MMCCCXCII");
		eq(RomanNumeral.toRoman(2393),"MMCCCXCIII");
		eq(RomanNumeral.toRoman(2394),"MMCCCXCIV");
		eq(RomanNumeral.toRoman(2395),"MMCCCXCV");
		eq(RomanNumeral.toRoman(2396),"MMCCCXCVI");
		eq(RomanNumeral.toRoman(2397),"MMCCCXCVII");
		eq(RomanNumeral.toRoman(2398),"MMCCCXCVIII");
		eq(RomanNumeral.toRoman(2399),"MMCCCXCIX");
		eq(RomanNumeral.toRoman(2400),"MMCD");
		eq(RomanNumeral.toRoman(2401),"MMCDI");
		eq(RomanNumeral.toRoman(2402),"MMCDII");
		eq(RomanNumeral.toRoman(2403),"MMCDIII");
		eq(RomanNumeral.toRoman(2404),"MMCDIV");
		eq(RomanNumeral.toRoman(2405),"MMCDV");
		eq(RomanNumeral.toRoman(2406),"MMCDVI");
		eq(RomanNumeral.toRoman(2407),"MMCDVII");
		eq(RomanNumeral.toRoman(2408),"MMCDVIII");
		eq(RomanNumeral.toRoman(2409),"MMCDIX");
		eq(RomanNumeral.toRoman(2410),"MMCDX");
		eq(RomanNumeral.toRoman(2411),"MMCDXI");
		eq(RomanNumeral.toRoman(2412),"MMCDXII");
		eq(RomanNumeral.toRoman(2413),"MMCDXIII");
		eq(RomanNumeral.toRoman(2414),"MMCDXIV");
		eq(RomanNumeral.toRoman(2415),"MMCDXV");
		eq(RomanNumeral.toRoman(2416),"MMCDXVI");
		eq(RomanNumeral.toRoman(2417),"MMCDXVII");
		eq(RomanNumeral.toRoman(2418),"MMCDXVIII");
		eq(RomanNumeral.toRoman(2419),"MMCDXIX");
		eq(RomanNumeral.toRoman(2420),"MMCDXX");
		eq(RomanNumeral.toRoman(2421),"MMCDXXI");
		eq(RomanNumeral.toRoman(2422),"MMCDXXII");
		eq(RomanNumeral.toRoman(2423),"MMCDXXIII");
		eq(RomanNumeral.toRoman(2424),"MMCDXXIV");
		eq(RomanNumeral.toRoman(2425),"MMCDXXV");
		eq(RomanNumeral.toRoman(2426),"MMCDXXVI");
		eq(RomanNumeral.toRoman(2427),"MMCDXXVII");
		eq(RomanNumeral.toRoman(2428),"MMCDXXVIII");
		eq(RomanNumeral.toRoman(2429),"MMCDXXIX");
		eq(RomanNumeral.toRoman(2430),"MMCDXXX");
		eq(RomanNumeral.toRoman(2431),"MMCDXXXI");
		eq(RomanNumeral.toRoman(2432),"MMCDXXXII");
		eq(RomanNumeral.toRoman(2433),"MMCDXXXIII");
		eq(RomanNumeral.toRoman(2434),"MMCDXXXIV");
		eq(RomanNumeral.toRoman(2435),"MMCDXXXV");
		eq(RomanNumeral.toRoman(2436),"MMCDXXXVI");
		eq(RomanNumeral.toRoman(2437),"MMCDXXXVII");
		eq(RomanNumeral.toRoman(2438),"MMCDXXXVIII");
		eq(RomanNumeral.toRoman(2439),"MMCDXXXIX");
		eq(RomanNumeral.toRoman(2440),"MMCDXL");
		eq(RomanNumeral.toRoman(2441),"MMCDXLI");
		eq(RomanNumeral.toRoman(2442),"MMCDXLII");
		eq(RomanNumeral.toRoman(2443),"MMCDXLIII");
		eq(RomanNumeral.toRoman(2444),"MMCDXLIV");
		eq(RomanNumeral.toRoman(2445),"MMCDXLV");
		eq(RomanNumeral.toRoman(2446),"MMCDXLVI");
		eq(RomanNumeral.toRoman(2447),"MMCDXLVII");
		eq(RomanNumeral.toRoman(2448),"MMCDXLVIII");
		eq(RomanNumeral.toRoman(2449),"MMCDXLIX");
		eq(RomanNumeral.toRoman(2450),"MMCDL");
		eq(RomanNumeral.toRoman(2451),"MMCDLI");
		eq(RomanNumeral.toRoman(2452),"MMCDLII");
		eq(RomanNumeral.toRoman(2453),"MMCDLIII");
		eq(RomanNumeral.toRoman(2454),"MMCDLIV");
		eq(RomanNumeral.toRoman(2455),"MMCDLV");
		eq(RomanNumeral.toRoman(2456),"MMCDLVI");
		eq(RomanNumeral.toRoman(2457),"MMCDLVII");
		eq(RomanNumeral.toRoman(2458),"MMCDLVIII");
		eq(RomanNumeral.toRoman(2459),"MMCDLIX");
		eq(RomanNumeral.toRoman(2460),"MMCDLX");
		eq(RomanNumeral.toRoman(2461),"MMCDLXI");
		eq(RomanNumeral.toRoman(2462),"MMCDLXII");
		eq(RomanNumeral.toRoman(2463),"MMCDLXIII");
		eq(RomanNumeral.toRoman(2464),"MMCDLXIV");
		eq(RomanNumeral.toRoman(2465),"MMCDLXV");
		eq(RomanNumeral.toRoman(2466),"MMCDLXVI");
		eq(RomanNumeral.toRoman(2467),"MMCDLXVII");
		eq(RomanNumeral.toRoman(2468),"MMCDLXVIII");
		eq(RomanNumeral.toRoman(2469),"MMCDLXIX");
		eq(RomanNumeral.toRoman(2470),"MMCDLXX");
		eq(RomanNumeral.toRoman(2471),"MMCDLXXI");
		eq(RomanNumeral.toRoman(2472),"MMCDLXXII");
		eq(RomanNumeral.toRoman(2473),"MMCDLXXIII");
		eq(RomanNumeral.toRoman(2474),"MMCDLXXIV");
		eq(RomanNumeral.toRoman(2475),"MMCDLXXV");
		eq(RomanNumeral.toRoman(2476),"MMCDLXXVI");
		eq(RomanNumeral.toRoman(2477),"MMCDLXXVII");
		eq(RomanNumeral.toRoman(2478),"MMCDLXXVIII");
		eq(RomanNumeral.toRoman(2479),"MMCDLXXIX");
		eq(RomanNumeral.toRoman(2480),"MMCDLXXX");
		eq(RomanNumeral.toRoman(2481),"MMCDLXXXI");
		eq(RomanNumeral.toRoman(2482),"MMCDLXXXII");
		eq(RomanNumeral.toRoman(2483),"MMCDLXXXIII");
		eq(RomanNumeral.toRoman(2484),"MMCDLXXXIV");
		eq(RomanNumeral.toRoman(2485),"MMCDLXXXV");
		eq(RomanNumeral.toRoman(2486),"MMCDLXXXVI");
		eq(RomanNumeral.toRoman(2487),"MMCDLXXXVII");
		eq(RomanNumeral.toRoman(2488),"MMCDLXXXVIII");
		eq(RomanNumeral.toRoman(2489),"MMCDLXXXIX");
		eq(RomanNumeral.toRoman(2490),"MMCDXC");
		eq(RomanNumeral.toRoman(2491),"MMCDXCI");
		eq(RomanNumeral.toRoman(2492),"MMCDXCII");
		eq(RomanNumeral.toRoman(2493),"MMCDXCIII");
		eq(RomanNumeral.toRoman(2494),"MMCDXCIV");
		eq(RomanNumeral.toRoman(2495),"MMCDXCV");
		eq(RomanNumeral.toRoman(2496),"MMCDXCVI");
		eq(RomanNumeral.toRoman(2497),"MMCDXCVII");
		eq(RomanNumeral.toRoman(2498),"MMCDXCVIII");
		eq(RomanNumeral.toRoman(2499),"MMCDXCIX");
		eq(RomanNumeral.toRoman(2500),"MMD");
		eq(RomanNumeral.toRoman(2501),"MMDI");
		eq(RomanNumeral.toRoman(2502),"MMDII");
		eq(RomanNumeral.toRoman(2503),"MMDIII");
		eq(RomanNumeral.toRoman(2504),"MMDIV");
		eq(RomanNumeral.toRoman(2505),"MMDV");
		eq(RomanNumeral.toRoman(2506),"MMDVI");
		eq(RomanNumeral.toRoman(2507),"MMDVII");
		eq(RomanNumeral.toRoman(2508),"MMDVIII");
		eq(RomanNumeral.toRoman(2509),"MMDIX");
		eq(RomanNumeral.toRoman(2510),"MMDX");
		eq(RomanNumeral.toRoman(2511),"MMDXI");
		eq(RomanNumeral.toRoman(2512),"MMDXII");
		eq(RomanNumeral.toRoman(2513),"MMDXIII");
		eq(RomanNumeral.toRoman(2514),"MMDXIV");
		eq(RomanNumeral.toRoman(2515),"MMDXV");
		eq(RomanNumeral.toRoman(2516),"MMDXVI");
		eq(RomanNumeral.toRoman(2517),"MMDXVII");
		eq(RomanNumeral.toRoman(2518),"MMDXVIII");
		eq(RomanNumeral.toRoman(2519),"MMDXIX");
		eq(RomanNumeral.toRoman(2520),"MMDXX");
		eq(RomanNumeral.toRoman(2521),"MMDXXI");
		eq(RomanNumeral.toRoman(2522),"MMDXXII");
		eq(RomanNumeral.toRoman(2523),"MMDXXIII");
		eq(RomanNumeral.toRoman(2524),"MMDXXIV");
		eq(RomanNumeral.toRoman(2525),"MMDXXV");
		eq(RomanNumeral.toRoman(2526),"MMDXXVI");
		eq(RomanNumeral.toRoman(2527),"MMDXXVII");
		eq(RomanNumeral.toRoman(2528),"MMDXXVIII");
		eq(RomanNumeral.toRoman(2529),"MMDXXIX");
		eq(RomanNumeral.toRoman(2530),"MMDXXX");
		eq(RomanNumeral.toRoman(2531),"MMDXXXI");
		eq(RomanNumeral.toRoman(2532),"MMDXXXII");
		eq(RomanNumeral.toRoman(2533),"MMDXXXIII");
		eq(RomanNumeral.toRoman(2534),"MMDXXXIV");
		eq(RomanNumeral.toRoman(2535),"MMDXXXV");
		eq(RomanNumeral.toRoman(2536),"MMDXXXVI");
		eq(RomanNumeral.toRoman(2537),"MMDXXXVII");
		eq(RomanNumeral.toRoman(2538),"MMDXXXVIII");
		eq(RomanNumeral.toRoman(2539),"MMDXXXIX");
		eq(RomanNumeral.toRoman(2540),"MMDXL");
		eq(RomanNumeral.toRoman(2541),"MMDXLI");
		eq(RomanNumeral.toRoman(2542),"MMDXLII");
		eq(RomanNumeral.toRoman(2543),"MMDXLIII");
		eq(RomanNumeral.toRoman(2544),"MMDXLIV");
		eq(RomanNumeral.toRoman(2545),"MMDXLV");
		eq(RomanNumeral.toRoman(2546),"MMDXLVI");
		eq(RomanNumeral.toRoman(2547),"MMDXLVII");
		eq(RomanNumeral.toRoman(2548),"MMDXLVIII");
		eq(RomanNumeral.toRoman(2549),"MMDXLIX");
		eq(RomanNumeral.toRoman(2550),"MMDL");
		eq(RomanNumeral.toRoman(2551),"MMDLI");
		eq(RomanNumeral.toRoman(2552),"MMDLII");
		eq(RomanNumeral.toRoman(2553),"MMDLIII");
		eq(RomanNumeral.toRoman(2554),"MMDLIV");
		eq(RomanNumeral.toRoman(2555),"MMDLV");
		eq(RomanNumeral.toRoman(2556),"MMDLVI");
		eq(RomanNumeral.toRoman(2557),"MMDLVII");
		eq(RomanNumeral.toRoman(2558),"MMDLVIII");
		eq(RomanNumeral.toRoman(2559),"MMDLIX");
		eq(RomanNumeral.toRoman(2560),"MMDLX");
		eq(RomanNumeral.toRoman(2561),"MMDLXI");
		eq(RomanNumeral.toRoman(2562),"MMDLXII");
		eq(RomanNumeral.toRoman(2563),"MMDLXIII");
		eq(RomanNumeral.toRoman(2564),"MMDLXIV");
		eq(RomanNumeral.toRoman(2565),"MMDLXV");
		eq(RomanNumeral.toRoman(2566),"MMDLXVI");
		eq(RomanNumeral.toRoman(2567),"MMDLXVII");
		eq(RomanNumeral.toRoman(2568),"MMDLXVIII");
		eq(RomanNumeral.toRoman(2569),"MMDLXIX");
		eq(RomanNumeral.toRoman(2570),"MMDLXX");
		eq(RomanNumeral.toRoman(2571),"MMDLXXI");
		eq(RomanNumeral.toRoman(2572),"MMDLXXII");
		eq(RomanNumeral.toRoman(2573),"MMDLXXIII");
		eq(RomanNumeral.toRoman(2574),"MMDLXXIV");
		eq(RomanNumeral.toRoman(2575),"MMDLXXV");
		eq(RomanNumeral.toRoman(2576),"MMDLXXVI");
		eq(RomanNumeral.toRoman(2577),"MMDLXXVII");
		eq(RomanNumeral.toRoman(2578),"MMDLXXVIII");
		eq(RomanNumeral.toRoman(2579),"MMDLXXIX");
		eq(RomanNumeral.toRoman(2580),"MMDLXXX");
		eq(RomanNumeral.toRoman(2581),"MMDLXXXI");
		eq(RomanNumeral.toRoman(2582),"MMDLXXXII");
		eq(RomanNumeral.toRoman(2583),"MMDLXXXIII");
		eq(RomanNumeral.toRoman(2584),"MMDLXXXIV");
		eq(RomanNumeral.toRoman(2585),"MMDLXXXV");
		eq(RomanNumeral.toRoman(2586),"MMDLXXXVI");
		eq(RomanNumeral.toRoman(2587),"MMDLXXXVII");
		eq(RomanNumeral.toRoman(2588),"MMDLXXXVIII");
		eq(RomanNumeral.toRoman(2589),"MMDLXXXIX");
		eq(RomanNumeral.toRoman(2590),"MMDXC");
		eq(RomanNumeral.toRoman(2591),"MMDXCI");
		eq(RomanNumeral.toRoman(2592),"MMDXCII");
		eq(RomanNumeral.toRoman(2593),"MMDXCIII");
		eq(RomanNumeral.toRoman(2594),"MMDXCIV");
		eq(RomanNumeral.toRoman(2595),"MMDXCV");
		eq(RomanNumeral.toRoman(2596),"MMDXCVI");
		eq(RomanNumeral.toRoman(2597),"MMDXCVII");
		eq(RomanNumeral.toRoman(2598),"MMDXCVIII");
		eq(RomanNumeral.toRoman(2599),"MMDXCIX");
		eq(RomanNumeral.toRoman(2600),"MMDC");
		eq(RomanNumeral.toRoman(2601),"MMDCI");
		eq(RomanNumeral.toRoman(2602),"MMDCII");
		eq(RomanNumeral.toRoman(2603),"MMDCIII");
		eq(RomanNumeral.toRoman(2604),"MMDCIV");
		eq(RomanNumeral.toRoman(2605),"MMDCV");
		eq(RomanNumeral.toRoman(2606),"MMDCVI");
		eq(RomanNumeral.toRoman(2607),"MMDCVII");
		eq(RomanNumeral.toRoman(2608),"MMDCVIII");
		eq(RomanNumeral.toRoman(2609),"MMDCIX");
		eq(RomanNumeral.toRoman(2610),"MMDCX");
		eq(RomanNumeral.toRoman(2611),"MMDCXI");
		eq(RomanNumeral.toRoman(2612),"MMDCXII");
		eq(RomanNumeral.toRoman(2613),"MMDCXIII");
		eq(RomanNumeral.toRoman(2614),"MMDCXIV");
		eq(RomanNumeral.toRoman(2615),"MMDCXV");
		eq(RomanNumeral.toRoman(2616),"MMDCXVI");
		eq(RomanNumeral.toRoman(2617),"MMDCXVII");
		eq(RomanNumeral.toRoman(2618),"MMDCXVIII");
		eq(RomanNumeral.toRoman(2619),"MMDCXIX");
		eq(RomanNumeral.toRoman(2620),"MMDCXX");
		eq(RomanNumeral.toRoman(2621),"MMDCXXI");
		eq(RomanNumeral.toRoman(2622),"MMDCXXII");
		eq(RomanNumeral.toRoman(2623),"MMDCXXIII");
		eq(RomanNumeral.toRoman(2624),"MMDCXXIV");
		eq(RomanNumeral.toRoman(2625),"MMDCXXV");
		eq(RomanNumeral.toRoman(2626),"MMDCXXVI");
		eq(RomanNumeral.toRoman(2627),"MMDCXXVII");
		eq(RomanNumeral.toRoman(2628),"MMDCXXVIII");
		eq(RomanNumeral.toRoman(2629),"MMDCXXIX");
		eq(RomanNumeral.toRoman(2630),"MMDCXXX");
		eq(RomanNumeral.toRoman(2631),"MMDCXXXI");
		eq(RomanNumeral.toRoman(2632),"MMDCXXXII");
		eq(RomanNumeral.toRoman(2633),"MMDCXXXIII");
		eq(RomanNumeral.toRoman(2634),"MMDCXXXIV");
		eq(RomanNumeral.toRoman(2635),"MMDCXXXV");
		eq(RomanNumeral.toRoman(2636),"MMDCXXXVI");
		eq(RomanNumeral.toRoman(2637),"MMDCXXXVII");
		eq(RomanNumeral.toRoman(2638),"MMDCXXXVIII");
		eq(RomanNumeral.toRoman(2639),"MMDCXXXIX");
		eq(RomanNumeral.toRoman(2640),"MMDCXL");
		eq(RomanNumeral.toRoman(2641),"MMDCXLI");
		eq(RomanNumeral.toRoman(2642),"MMDCXLII");
		eq(RomanNumeral.toRoman(2643),"MMDCXLIII");
		eq(RomanNumeral.toRoman(2644),"MMDCXLIV");
		eq(RomanNumeral.toRoman(2645),"MMDCXLV");
		eq(RomanNumeral.toRoman(2646),"MMDCXLVI");
		eq(RomanNumeral.toRoman(2647),"MMDCXLVII");
		eq(RomanNumeral.toRoman(2648),"MMDCXLVIII");
		eq(RomanNumeral.toRoman(2649),"MMDCXLIX");
		eq(RomanNumeral.toRoman(2650),"MMDCL");
		eq(RomanNumeral.toRoman(2651),"MMDCLI");
		eq(RomanNumeral.toRoman(2652),"MMDCLII");
		eq(RomanNumeral.toRoman(2653),"MMDCLIII");
		eq(RomanNumeral.toRoman(2654),"MMDCLIV");
		eq(RomanNumeral.toRoman(2655),"MMDCLV");
		eq(RomanNumeral.toRoman(2656),"MMDCLVI");
		eq(RomanNumeral.toRoman(2657),"MMDCLVII");
		eq(RomanNumeral.toRoman(2658),"MMDCLVIII");
		eq(RomanNumeral.toRoman(2659),"MMDCLIX");
		eq(RomanNumeral.toRoman(2660),"MMDCLX");
		eq(RomanNumeral.toRoman(2661),"MMDCLXI");
		eq(RomanNumeral.toRoman(2662),"MMDCLXII");
		eq(RomanNumeral.toRoman(2663),"MMDCLXIII");
		eq(RomanNumeral.toRoman(2664),"MMDCLXIV");
		eq(RomanNumeral.toRoman(2665),"MMDCLXV");
		eq(RomanNumeral.toRoman(2666),"MMDCLXVI");
		eq(RomanNumeral.toRoman(2667),"MMDCLXVII");
		eq(RomanNumeral.toRoman(2668),"MMDCLXVIII");
		eq(RomanNumeral.toRoman(2669),"MMDCLXIX");
		eq(RomanNumeral.toRoman(2670),"MMDCLXX");
		eq(RomanNumeral.toRoman(2671),"MMDCLXXI");
		eq(RomanNumeral.toRoman(2672),"MMDCLXXII");
		eq(RomanNumeral.toRoman(2673),"MMDCLXXIII");
		eq(RomanNumeral.toRoman(2674),"MMDCLXXIV");
		eq(RomanNumeral.toRoman(2675),"MMDCLXXV");
		eq(RomanNumeral.toRoman(2676),"MMDCLXXVI");
		eq(RomanNumeral.toRoman(2677),"MMDCLXXVII");
		eq(RomanNumeral.toRoman(2678),"MMDCLXXVIII");
		eq(RomanNumeral.toRoman(2679),"MMDCLXXIX");
		eq(RomanNumeral.toRoman(2680),"MMDCLXXX");
		eq(RomanNumeral.toRoman(2681),"MMDCLXXXI");
		eq(RomanNumeral.toRoman(2682),"MMDCLXXXII");
		eq(RomanNumeral.toRoman(2683),"MMDCLXXXIII");
		eq(RomanNumeral.toRoman(2684),"MMDCLXXXIV");
		eq(RomanNumeral.toRoman(2685),"MMDCLXXXV");
		eq(RomanNumeral.toRoman(2686),"MMDCLXXXVI");
		eq(RomanNumeral.toRoman(2687),"MMDCLXXXVII");
		eq(RomanNumeral.toRoman(2688),"MMDCLXXXVIII");
		eq(RomanNumeral.toRoman(2689),"MMDCLXXXIX");
		eq(RomanNumeral.toRoman(2690),"MMDCXC");
		eq(RomanNumeral.toRoman(2691),"MMDCXCI");
		eq(RomanNumeral.toRoman(2692),"MMDCXCII");
		eq(RomanNumeral.toRoman(2693),"MMDCXCIII");
		eq(RomanNumeral.toRoman(2694),"MMDCXCIV");
		eq(RomanNumeral.toRoman(2695),"MMDCXCV");
		eq(RomanNumeral.toRoman(2696),"MMDCXCVI");
		eq(RomanNumeral.toRoman(2697),"MMDCXCVII");
		eq(RomanNumeral.toRoman(2698),"MMDCXCVIII");
		eq(RomanNumeral.toRoman(2699),"MMDCXCIX");
		eq(RomanNumeral.toRoman(2700),"MMDCC");
		eq(RomanNumeral.toRoman(2701),"MMDCCI");
		eq(RomanNumeral.toRoman(2702),"MMDCCII");
		eq(RomanNumeral.toRoman(2703),"MMDCCIII");
		eq(RomanNumeral.toRoman(2704),"MMDCCIV");
		eq(RomanNumeral.toRoman(2705),"MMDCCV");
		eq(RomanNumeral.toRoman(2706),"MMDCCVI");
		eq(RomanNumeral.toRoman(2707),"MMDCCVII");
		eq(RomanNumeral.toRoman(2708),"MMDCCVIII");
		eq(RomanNumeral.toRoman(2709),"MMDCCIX");
		eq(RomanNumeral.toRoman(2710),"MMDCCX");
		eq(RomanNumeral.toRoman(2711),"MMDCCXI");
		eq(RomanNumeral.toRoman(2712),"MMDCCXII");
		eq(RomanNumeral.toRoman(2713),"MMDCCXIII");
		eq(RomanNumeral.toRoman(2714),"MMDCCXIV");
		eq(RomanNumeral.toRoman(2715),"MMDCCXV");
		eq(RomanNumeral.toRoman(2716),"MMDCCXVI");
		eq(RomanNumeral.toRoman(2717),"MMDCCXVII");
		eq(RomanNumeral.toRoman(2718),"MMDCCXVIII");
		eq(RomanNumeral.toRoman(2719),"MMDCCXIX");
		eq(RomanNumeral.toRoman(2720),"MMDCCXX");
		eq(RomanNumeral.toRoman(2721),"MMDCCXXI");
		eq(RomanNumeral.toRoman(2722),"MMDCCXXII");
		eq(RomanNumeral.toRoman(2723),"MMDCCXXIII");
		eq(RomanNumeral.toRoman(2724),"MMDCCXXIV");
		eq(RomanNumeral.toRoman(2725),"MMDCCXXV");
		eq(RomanNumeral.toRoman(2726),"MMDCCXXVI");
		eq(RomanNumeral.toRoman(2727),"MMDCCXXVII");
		eq(RomanNumeral.toRoman(2728),"MMDCCXXVIII");
		eq(RomanNumeral.toRoman(2729),"MMDCCXXIX");
		eq(RomanNumeral.toRoman(2730),"MMDCCXXX");
		eq(RomanNumeral.toRoman(2731),"MMDCCXXXI");
		eq(RomanNumeral.toRoman(2732),"MMDCCXXXII");
		eq(RomanNumeral.toRoman(2733),"MMDCCXXXIII");
		eq(RomanNumeral.toRoman(2734),"MMDCCXXXIV");
		eq(RomanNumeral.toRoman(2735),"MMDCCXXXV");
		eq(RomanNumeral.toRoman(2736),"MMDCCXXXVI");
		eq(RomanNumeral.toRoman(2737),"MMDCCXXXVII");
		eq(RomanNumeral.toRoman(2738),"MMDCCXXXVIII");
		eq(RomanNumeral.toRoman(2739),"MMDCCXXXIX");
		eq(RomanNumeral.toRoman(2740),"MMDCCXL");
		eq(RomanNumeral.toRoman(2741),"MMDCCXLI");
		eq(RomanNumeral.toRoman(2742),"MMDCCXLII");
		eq(RomanNumeral.toRoman(2743),"MMDCCXLIII");
		eq(RomanNumeral.toRoman(2744),"MMDCCXLIV");
		eq(RomanNumeral.toRoman(2745),"MMDCCXLV");
		eq(RomanNumeral.toRoman(2746),"MMDCCXLVI");
		eq(RomanNumeral.toRoman(2747),"MMDCCXLVII");
		eq(RomanNumeral.toRoman(2748),"MMDCCXLVIII");
		eq(RomanNumeral.toRoman(2749),"MMDCCXLIX");
		eq(RomanNumeral.toRoman(2750),"MMDCCL");
		eq(RomanNumeral.toRoman(2751),"MMDCCLI");
		eq(RomanNumeral.toRoman(2752),"MMDCCLII");
		eq(RomanNumeral.toRoman(2753),"MMDCCLIII");
		eq(RomanNumeral.toRoman(2754),"MMDCCLIV");
		eq(RomanNumeral.toRoman(2755),"MMDCCLV");
		eq(RomanNumeral.toRoman(2756),"MMDCCLVI");
		eq(RomanNumeral.toRoman(2757),"MMDCCLVII");
		eq(RomanNumeral.toRoman(2758),"MMDCCLVIII");
		eq(RomanNumeral.toRoman(2759),"MMDCCLIX");
		eq(RomanNumeral.toRoman(2760),"MMDCCLX");
		eq(RomanNumeral.toRoman(2761),"MMDCCLXI");
		eq(RomanNumeral.toRoman(2762),"MMDCCLXII");
		eq(RomanNumeral.toRoman(2763),"MMDCCLXIII");
		eq(RomanNumeral.toRoman(2764),"MMDCCLXIV");
		eq(RomanNumeral.toRoman(2765),"MMDCCLXV");
		eq(RomanNumeral.toRoman(2766),"MMDCCLXVI");
		eq(RomanNumeral.toRoman(2767),"MMDCCLXVII");
		eq(RomanNumeral.toRoman(2768),"MMDCCLXVIII");
		eq(RomanNumeral.toRoman(2769),"MMDCCLXIX");
		eq(RomanNumeral.toRoman(2770),"MMDCCLXX");
		eq(RomanNumeral.toRoman(2771),"MMDCCLXXI");
		eq(RomanNumeral.toRoman(2772),"MMDCCLXXII");
		eq(RomanNumeral.toRoman(2773),"MMDCCLXXIII");
		eq(RomanNumeral.toRoman(2774),"MMDCCLXXIV");
		eq(RomanNumeral.toRoman(2775),"MMDCCLXXV");
		eq(RomanNumeral.toRoman(2776),"MMDCCLXXVI");
		eq(RomanNumeral.toRoman(2777),"MMDCCLXXVII");
		eq(RomanNumeral.toRoman(2778),"MMDCCLXXVIII");
		eq(RomanNumeral.toRoman(2779),"MMDCCLXXIX");
		eq(RomanNumeral.toRoman(2780),"MMDCCLXXX");
		eq(RomanNumeral.toRoman(2781),"MMDCCLXXXI");
		eq(RomanNumeral.toRoman(2782),"MMDCCLXXXII");
		eq(RomanNumeral.toRoman(2783),"MMDCCLXXXIII");
		eq(RomanNumeral.toRoman(2784),"MMDCCLXXXIV");
		eq(RomanNumeral.toRoman(2785),"MMDCCLXXXV");
		eq(RomanNumeral.toRoman(2786),"MMDCCLXXXVI");
		eq(RomanNumeral.toRoman(2787),"MMDCCLXXXVII");
		eq(RomanNumeral.toRoman(2788),"MMDCCLXXXVIII");
		eq(RomanNumeral.toRoman(2789),"MMDCCLXXXIX");
		eq(RomanNumeral.toRoman(2790),"MMDCCXC");
		eq(RomanNumeral.toRoman(2791),"MMDCCXCI");
		eq(RomanNumeral.toRoman(2792),"MMDCCXCII");
		eq(RomanNumeral.toRoman(2793),"MMDCCXCIII");
		eq(RomanNumeral.toRoman(2794),"MMDCCXCIV");
		eq(RomanNumeral.toRoman(2795),"MMDCCXCV");
		eq(RomanNumeral.toRoman(2796),"MMDCCXCVI");
		eq(RomanNumeral.toRoman(2797),"MMDCCXCVII");
		eq(RomanNumeral.toRoman(2798),"MMDCCXCVIII");
		eq(RomanNumeral.toRoman(2799),"MMDCCXCIX");
		eq(RomanNumeral.toRoman(2800),"MMDCCC");
		eq(RomanNumeral.toRoman(2801),"MMDCCCI");
		eq(RomanNumeral.toRoman(2802),"MMDCCCII");
		eq(RomanNumeral.toRoman(2803),"MMDCCCIII");
		eq(RomanNumeral.toRoman(2804),"MMDCCCIV");
		eq(RomanNumeral.toRoman(2805),"MMDCCCV");
		eq(RomanNumeral.toRoman(2806),"MMDCCCVI");
		eq(RomanNumeral.toRoman(2807),"MMDCCCVII");
		eq(RomanNumeral.toRoman(2808),"MMDCCCVIII");
		eq(RomanNumeral.toRoman(2809),"MMDCCCIX");
		eq(RomanNumeral.toRoman(2810),"MMDCCCX");
		eq(RomanNumeral.toRoman(2811),"MMDCCCXI");
		eq(RomanNumeral.toRoman(2812),"MMDCCCXII");
		eq(RomanNumeral.toRoman(2813),"MMDCCCXIII");
		eq(RomanNumeral.toRoman(2814),"MMDCCCXIV");
		eq(RomanNumeral.toRoman(2815),"MMDCCCXV");
		eq(RomanNumeral.toRoman(2816),"MMDCCCXVI");
		eq(RomanNumeral.toRoman(2817),"MMDCCCXVII");
		eq(RomanNumeral.toRoman(2818),"MMDCCCXVIII");
		eq(RomanNumeral.toRoman(2819),"MMDCCCXIX");
		eq(RomanNumeral.toRoman(2820),"MMDCCCXX");
		eq(RomanNumeral.toRoman(2821),"MMDCCCXXI");
		eq(RomanNumeral.toRoman(2822),"MMDCCCXXII");
		eq(RomanNumeral.toRoman(2823),"MMDCCCXXIII");
		eq(RomanNumeral.toRoman(2824),"MMDCCCXXIV");
		eq(RomanNumeral.toRoman(2825),"MMDCCCXXV");
		eq(RomanNumeral.toRoman(2826),"MMDCCCXXVI");
		eq(RomanNumeral.toRoman(2827),"MMDCCCXXVII");
		eq(RomanNumeral.toRoman(2828),"MMDCCCXXVIII");
		eq(RomanNumeral.toRoman(2829),"MMDCCCXXIX");
		eq(RomanNumeral.toRoman(2830),"MMDCCCXXX");
		eq(RomanNumeral.toRoman(2831),"MMDCCCXXXI");
		eq(RomanNumeral.toRoman(2832),"MMDCCCXXXII");
		eq(RomanNumeral.toRoman(2833),"MMDCCCXXXIII");
		eq(RomanNumeral.toRoman(2834),"MMDCCCXXXIV");
		eq(RomanNumeral.toRoman(2835),"MMDCCCXXXV");
		eq(RomanNumeral.toRoman(2836),"MMDCCCXXXVI");
		eq(RomanNumeral.toRoman(2837),"MMDCCCXXXVII");
		eq(RomanNumeral.toRoman(2838),"MMDCCCXXXVIII");
		eq(RomanNumeral.toRoman(2839),"MMDCCCXXXIX");
		eq(RomanNumeral.toRoman(2840),"MMDCCCXL");
		eq(RomanNumeral.toRoman(2841),"MMDCCCXLI");
		eq(RomanNumeral.toRoman(2842),"MMDCCCXLII");
		eq(RomanNumeral.toRoman(2843),"MMDCCCXLIII");
		eq(RomanNumeral.toRoman(2844),"MMDCCCXLIV");
		eq(RomanNumeral.toRoman(2845),"MMDCCCXLV");
		eq(RomanNumeral.toRoman(2846),"MMDCCCXLVI");
		eq(RomanNumeral.toRoman(2847),"MMDCCCXLVII");
		eq(RomanNumeral.toRoman(2848),"MMDCCCXLVIII");
		eq(RomanNumeral.toRoman(2849),"MMDCCCXLIX");
		eq(RomanNumeral.toRoman(2850),"MMDCCCL");
		eq(RomanNumeral.toRoman(2851),"MMDCCCLI");
		eq(RomanNumeral.toRoman(2852),"MMDCCCLII");
		eq(RomanNumeral.toRoman(2853),"MMDCCCLIII");
		eq(RomanNumeral.toRoman(2854),"MMDCCCLIV");
		eq(RomanNumeral.toRoman(2855),"MMDCCCLV");
		eq(RomanNumeral.toRoman(2856),"MMDCCCLVI");
		eq(RomanNumeral.toRoman(2857),"MMDCCCLVII");
		eq(RomanNumeral.toRoman(2858),"MMDCCCLVIII");
		eq(RomanNumeral.toRoman(2859),"MMDCCCLIX");
		eq(RomanNumeral.toRoman(2860),"MMDCCCLX");
		eq(RomanNumeral.toRoman(2861),"MMDCCCLXI");
		eq(RomanNumeral.toRoman(2862),"MMDCCCLXII");
		eq(RomanNumeral.toRoman(2863),"MMDCCCLXIII");
		eq(RomanNumeral.toRoman(2864),"MMDCCCLXIV");
		eq(RomanNumeral.toRoman(2865),"MMDCCCLXV");
		eq(RomanNumeral.toRoman(2866),"MMDCCCLXVI");
		eq(RomanNumeral.toRoman(2867),"MMDCCCLXVII");
		eq(RomanNumeral.toRoman(2868),"MMDCCCLXVIII");
		eq(RomanNumeral.toRoman(2869),"MMDCCCLXIX");
		eq(RomanNumeral.toRoman(2870),"MMDCCCLXX");
		eq(RomanNumeral.toRoman(2871),"MMDCCCLXXI");
		eq(RomanNumeral.toRoman(2872),"MMDCCCLXXII");
		eq(RomanNumeral.toRoman(2873),"MMDCCCLXXIII");
		eq(RomanNumeral.toRoman(2874),"MMDCCCLXXIV");
		eq(RomanNumeral.toRoman(2875),"MMDCCCLXXV");
		eq(RomanNumeral.toRoman(2876),"MMDCCCLXXVI");
		eq(RomanNumeral.toRoman(2877),"MMDCCCLXXVII");
		eq(RomanNumeral.toRoman(2878),"MMDCCCLXXVIII");
		eq(RomanNumeral.toRoman(2879),"MMDCCCLXXIX");
		eq(RomanNumeral.toRoman(2880),"MMDCCCLXXX");
		eq(RomanNumeral.toRoman(2881),"MMDCCCLXXXI");
		eq(RomanNumeral.toRoman(2882),"MMDCCCLXXXII");
		eq(RomanNumeral.toRoman(2883),"MMDCCCLXXXIII");
		eq(RomanNumeral.toRoman(2884),"MMDCCCLXXXIV");
		eq(RomanNumeral.toRoman(2885),"MMDCCCLXXXV");
		eq(RomanNumeral.toRoman(2886),"MMDCCCLXXXVI");
		eq(RomanNumeral.toRoman(2887),"MMDCCCLXXXVII");
		eq(RomanNumeral.toRoman(2888),"MMDCCCLXXXVIII");
		eq(RomanNumeral.toRoman(2889),"MMDCCCLXXXIX");
		eq(RomanNumeral.toRoman(2890),"MMDCCCXC");
		eq(RomanNumeral.toRoman(2891),"MMDCCCXCI");
		eq(RomanNumeral.toRoman(2892),"MMDCCCXCII");
		eq(RomanNumeral.toRoman(2893),"MMDCCCXCIII");
		eq(RomanNumeral.toRoman(2894),"MMDCCCXCIV");
		eq(RomanNumeral.toRoman(2895),"MMDCCCXCV");
		eq(RomanNumeral.toRoman(2896),"MMDCCCXCVI");
		eq(RomanNumeral.toRoman(2897),"MMDCCCXCVII");
		eq(RomanNumeral.toRoman(2898),"MMDCCCXCVIII");
		eq(RomanNumeral.toRoman(2899),"MMDCCCXCIX");
		eq(RomanNumeral.toRoman(2900),"MMCM");
		eq(RomanNumeral.toRoman(2901),"MMCMI");
		eq(RomanNumeral.toRoman(2902),"MMCMII");
		eq(RomanNumeral.toRoman(2903),"MMCMIII");
		eq(RomanNumeral.toRoman(2904),"MMCMIV");
		eq(RomanNumeral.toRoman(2905),"MMCMV");
		eq(RomanNumeral.toRoman(2906),"MMCMVI");
		eq(RomanNumeral.toRoman(2907),"MMCMVII");
		eq(RomanNumeral.toRoman(2908),"MMCMVIII");
		eq(RomanNumeral.toRoman(2909),"MMCMIX");
		eq(RomanNumeral.toRoman(2910),"MMCMX");
		eq(RomanNumeral.toRoman(2911),"MMCMXI");
		eq(RomanNumeral.toRoman(2912),"MMCMXII");
		eq(RomanNumeral.toRoman(2913),"MMCMXIII");
		eq(RomanNumeral.toRoman(2914),"MMCMXIV");
		eq(RomanNumeral.toRoman(2915),"MMCMXV");
		eq(RomanNumeral.toRoman(2916),"MMCMXVI");
		eq(RomanNumeral.toRoman(2917),"MMCMXVII");
		eq(RomanNumeral.toRoman(2918),"MMCMXVIII");
		eq(RomanNumeral.toRoman(2919),"MMCMXIX");
		eq(RomanNumeral.toRoman(2920),"MMCMXX");
		eq(RomanNumeral.toRoman(2921),"MMCMXXI");
		eq(RomanNumeral.toRoman(2922),"MMCMXXII");
		eq(RomanNumeral.toRoman(2923),"MMCMXXIII");
		eq(RomanNumeral.toRoman(2924),"MMCMXXIV");
		eq(RomanNumeral.toRoman(2925),"MMCMXXV");
		eq(RomanNumeral.toRoman(2926),"MMCMXXVI");
		eq(RomanNumeral.toRoman(2927),"MMCMXXVII");
		eq(RomanNumeral.toRoman(2928),"MMCMXXVIII");
		eq(RomanNumeral.toRoman(2929),"MMCMXXIX");
		eq(RomanNumeral.toRoman(2930),"MMCMXXX");
		eq(RomanNumeral.toRoman(2931),"MMCMXXXI");
		eq(RomanNumeral.toRoman(2932),"MMCMXXXII");
		eq(RomanNumeral.toRoman(2933),"MMCMXXXIII");
		eq(RomanNumeral.toRoman(2934),"MMCMXXXIV");
		eq(RomanNumeral.toRoman(2935),"MMCMXXXV");
		eq(RomanNumeral.toRoman(2936),"MMCMXXXVI");
		eq(RomanNumeral.toRoman(2937),"MMCMXXXVII");
		eq(RomanNumeral.toRoman(2938),"MMCMXXXVIII");
		eq(RomanNumeral.toRoman(2939),"MMCMXXXIX");
		eq(RomanNumeral.toRoman(2940),"MMCMXL");
		eq(RomanNumeral.toRoman(2941),"MMCMXLI");
		eq(RomanNumeral.toRoman(2942),"MMCMXLII");
		eq(RomanNumeral.toRoman(2943),"MMCMXLIII");
		eq(RomanNumeral.toRoman(2944),"MMCMXLIV");
		eq(RomanNumeral.toRoman(2945),"MMCMXLV");
		eq(RomanNumeral.toRoman(2946),"MMCMXLVI");
		eq(RomanNumeral.toRoman(2947),"MMCMXLVII");
		eq(RomanNumeral.toRoman(2948),"MMCMXLVIII");
		eq(RomanNumeral.toRoman(2949),"MMCMXLIX");
		eq(RomanNumeral.toRoman(2950),"MMCML");
		eq(RomanNumeral.toRoman(2951),"MMCMLI");
		eq(RomanNumeral.toRoman(2952),"MMCMLII");
		eq(RomanNumeral.toRoman(2953),"MMCMLIII");
		eq(RomanNumeral.toRoman(2954),"MMCMLIV");
		eq(RomanNumeral.toRoman(2955),"MMCMLV");
		eq(RomanNumeral.toRoman(2956),"MMCMLVI");
		eq(RomanNumeral.toRoman(2957),"MMCMLVII");
		eq(RomanNumeral.toRoman(2958),"MMCMLVIII");
		eq(RomanNumeral.toRoman(2959),"MMCMLIX");
		eq(RomanNumeral.toRoman(2960),"MMCMLX");
		eq(RomanNumeral.toRoman(2961),"MMCMLXI");
		eq(RomanNumeral.toRoman(2962),"MMCMLXII");
		eq(RomanNumeral.toRoman(2963),"MMCMLXIII");
		eq(RomanNumeral.toRoman(2964),"MMCMLXIV");
		eq(RomanNumeral.toRoman(2965),"MMCMLXV");
		eq(RomanNumeral.toRoman(2966),"MMCMLXVI");
		eq(RomanNumeral.toRoman(2967),"MMCMLXVII");
		eq(RomanNumeral.toRoman(2968),"MMCMLXVIII");
		eq(RomanNumeral.toRoman(2969),"MMCMLXIX");
		eq(RomanNumeral.toRoman(2970),"MMCMLXX");
		eq(RomanNumeral.toRoman(2971),"MMCMLXXI");
		eq(RomanNumeral.toRoman(2972),"MMCMLXXII");
		eq(RomanNumeral.toRoman(2973),"MMCMLXXIII");
		eq(RomanNumeral.toRoman(2974),"MMCMLXXIV");
		eq(RomanNumeral.toRoman(2975),"MMCMLXXV");
		eq(RomanNumeral.toRoman(2976),"MMCMLXXVI");
		eq(RomanNumeral.toRoman(2977),"MMCMLXXVII");
		eq(RomanNumeral.toRoman(2978),"MMCMLXXVIII");
		eq(RomanNumeral.toRoman(2979),"MMCMLXXIX");
		eq(RomanNumeral.toRoman(2980),"MMCMLXXX");
		eq(RomanNumeral.toRoman(2981),"MMCMLXXXI");
		eq(RomanNumeral.toRoman(2982),"MMCMLXXXII");
		eq(RomanNumeral.toRoman(2983),"MMCMLXXXIII");
		eq(RomanNumeral.toRoman(2984),"MMCMLXXXIV");
		eq(RomanNumeral.toRoman(2985),"MMCMLXXXV");
		eq(RomanNumeral.toRoman(2986),"MMCMLXXXVI");
		eq(RomanNumeral.toRoman(2987),"MMCMLXXXVII");
		eq(RomanNumeral.toRoman(2988),"MMCMLXXXVIII");
		eq(RomanNumeral.toRoman(2989),"MMCMLXXXIX");
		eq(RomanNumeral.toRoman(2990),"MMCMXC");
		eq(RomanNumeral.toRoman(2991),"MMCMXCI");
		eq(RomanNumeral.toRoman(2992),"MMCMXCII");
		eq(RomanNumeral.toRoman(2993),"MMCMXCIII");
		eq(RomanNumeral.toRoman(2994),"MMCMXCIV");
		eq(RomanNumeral.toRoman(2995),"MMCMXCV");
		eq(RomanNumeral.toRoman(2996),"MMCMXCVI");
		eq(RomanNumeral.toRoman(2997),"MMCMXCVII");
		eq(RomanNumeral.toRoman(2998),"MMCMXCVIII");
		eq(RomanNumeral.toRoman(2999),"MMCMXCIX");
		eq(RomanNumeral.toRoman(3000),"MMM");
		eq(RomanNumeral.toRoman(3001),"MMMI");
		eq(RomanNumeral.toRoman(3002),"MMMII");
		eq(RomanNumeral.toRoman(3003),"MMMIII");
		eq(RomanNumeral.toRoman(3004),"MMMIV");
		eq(RomanNumeral.toRoman(3005),"MMMV");
		eq(RomanNumeral.toRoman(3006),"MMMVI");
		eq(RomanNumeral.toRoman(3007),"MMMVII");
		eq(RomanNumeral.toRoman(3008),"MMMVIII");
		eq(RomanNumeral.toRoman(3009),"MMMIX");
		eq(RomanNumeral.toRoman(3010),"MMMX");
		eq(RomanNumeral.toRoman(3011),"MMMXI");
		eq(RomanNumeral.toRoman(3012),"MMMXII");
		eq(RomanNumeral.toRoman(3013),"MMMXIII");
		eq(RomanNumeral.toRoman(3014),"MMMXIV");
		eq(RomanNumeral.toRoman(3015),"MMMXV");
		eq(RomanNumeral.toRoman(3016),"MMMXVI");
		eq(RomanNumeral.toRoman(3017),"MMMXVII");
		eq(RomanNumeral.toRoman(3018),"MMMXVIII");
		eq(RomanNumeral.toRoman(3019),"MMMXIX");
		eq(RomanNumeral.toRoman(3020),"MMMXX");
		eq(RomanNumeral.toRoman(3021),"MMMXXI");
		eq(RomanNumeral.toRoman(3022),"MMMXXII");
		eq(RomanNumeral.toRoman(3023),"MMMXXIII");
		eq(RomanNumeral.toRoman(3024),"MMMXXIV");
		eq(RomanNumeral.toRoman(3025),"MMMXXV");
		eq(RomanNumeral.toRoman(3026),"MMMXXVI");
		eq(RomanNumeral.toRoman(3027),"MMMXXVII");
		eq(RomanNumeral.toRoman(3028),"MMMXXVIII");
		eq(RomanNumeral.toRoman(3029),"MMMXXIX");
		eq(RomanNumeral.toRoman(3030),"MMMXXX");
		eq(RomanNumeral.toRoman(3031),"MMMXXXI");
		eq(RomanNumeral.toRoman(3032),"MMMXXXII");
		eq(RomanNumeral.toRoman(3033),"MMMXXXIII");
		eq(RomanNumeral.toRoman(3034),"MMMXXXIV");
		eq(RomanNumeral.toRoman(3035),"MMMXXXV");
		eq(RomanNumeral.toRoman(3036),"MMMXXXVI");
		eq(RomanNumeral.toRoman(3037),"MMMXXXVII");
		eq(RomanNumeral.toRoman(3038),"MMMXXXVIII");
		eq(RomanNumeral.toRoman(3039),"MMMXXXIX");
		eq(RomanNumeral.toRoman(3040),"MMMXL");
		eq(RomanNumeral.toRoman(3041),"MMMXLI");
		eq(RomanNumeral.toRoman(3042),"MMMXLII");
		eq(RomanNumeral.toRoman(3043),"MMMXLIII");
		eq(RomanNumeral.toRoman(3044),"MMMXLIV");
		eq(RomanNumeral.toRoman(3045),"MMMXLV");
		eq(RomanNumeral.toRoman(3046),"MMMXLVI");
		eq(RomanNumeral.toRoman(3047),"MMMXLVII");
		eq(RomanNumeral.toRoman(3048),"MMMXLVIII");
		eq(RomanNumeral.toRoman(3049),"MMMXLIX");
		eq(RomanNumeral.toRoman(3050),"MMML");
		eq(RomanNumeral.toRoman(3051),"MMMLI");
		eq(RomanNumeral.toRoman(3052),"MMMLII");
		eq(RomanNumeral.toRoman(3053),"MMMLIII");
		eq(RomanNumeral.toRoman(3054),"MMMLIV");
		eq(RomanNumeral.toRoman(3055),"MMMLV");
		eq(RomanNumeral.toRoman(3056),"MMMLVI");
		eq(RomanNumeral.toRoman(3057),"MMMLVII");
		eq(RomanNumeral.toRoman(3058),"MMMLVIII");
		eq(RomanNumeral.toRoman(3059),"MMMLIX");
		eq(RomanNumeral.toRoman(3060),"MMMLX");
		eq(RomanNumeral.toRoman(3061),"MMMLXI");
		eq(RomanNumeral.toRoman(3062),"MMMLXII");
		eq(RomanNumeral.toRoman(3063),"MMMLXIII");
		eq(RomanNumeral.toRoman(3064),"MMMLXIV");
		eq(RomanNumeral.toRoman(3065),"MMMLXV");
		eq(RomanNumeral.toRoman(3066),"MMMLXVI");
		eq(RomanNumeral.toRoman(3067),"MMMLXVII");
		eq(RomanNumeral.toRoman(3068),"MMMLXVIII");
		eq(RomanNumeral.toRoman(3069),"MMMLXIX");
		eq(RomanNumeral.toRoman(3070),"MMMLXX");
		eq(RomanNumeral.toRoman(3071),"MMMLXXI");
		eq(RomanNumeral.toRoman(3072),"MMMLXXII");
		eq(RomanNumeral.toRoman(3073),"MMMLXXIII");
		eq(RomanNumeral.toRoman(3074),"MMMLXXIV");
		eq(RomanNumeral.toRoman(3075),"MMMLXXV");
		eq(RomanNumeral.toRoman(3076),"MMMLXXVI");
		eq(RomanNumeral.toRoman(3077),"MMMLXXVII");
		eq(RomanNumeral.toRoman(3078),"MMMLXXVIII");
		eq(RomanNumeral.toRoman(3079),"MMMLXXIX");
		eq(RomanNumeral.toRoman(3080),"MMMLXXX");
		eq(RomanNumeral.toRoman(3081),"MMMLXXXI");
		eq(RomanNumeral.toRoman(3082),"MMMLXXXII");
		eq(RomanNumeral.toRoman(3083),"MMMLXXXIII");
		eq(RomanNumeral.toRoman(3084),"MMMLXXXIV");
		eq(RomanNumeral.toRoman(3085),"MMMLXXXV");
		eq(RomanNumeral.toRoman(3086),"MMMLXXXVI");
		eq(RomanNumeral.toRoman(3087),"MMMLXXXVII");
		eq(RomanNumeral.toRoman(3088),"MMMLXXXVIII");
		eq(RomanNumeral.toRoman(3089),"MMMLXXXIX");
		eq(RomanNumeral.toRoman(3090),"MMMXC");
		eq(RomanNumeral.toRoman(3091),"MMMXCI");
		eq(RomanNumeral.toRoman(3092),"MMMXCII");
		eq(RomanNumeral.toRoman(3093),"MMMXCIII");
		eq(RomanNumeral.toRoman(3094),"MMMXCIV");
		eq(RomanNumeral.toRoman(3095),"MMMXCV");
		eq(RomanNumeral.toRoman(3096),"MMMXCVI");
		eq(RomanNumeral.toRoman(3097),"MMMXCVII");
		eq(RomanNumeral.toRoman(3098),"MMMXCVIII");
		eq(RomanNumeral.toRoman(3099),"MMMXCIX");
		eq(RomanNumeral.toRoman(3100),"MMMC");
		eq(RomanNumeral.toRoman(3101),"MMMCI");
		eq(RomanNumeral.toRoman(3102),"MMMCII");
		eq(RomanNumeral.toRoman(3103),"MMMCIII");
		eq(RomanNumeral.toRoman(3104),"MMMCIV");
		eq(RomanNumeral.toRoman(3105),"MMMCV");
		eq(RomanNumeral.toRoman(3106),"MMMCVI");
		eq(RomanNumeral.toRoman(3107),"MMMCVII");
		eq(RomanNumeral.toRoman(3108),"MMMCVIII");
		eq(RomanNumeral.toRoman(3109),"MMMCIX");
		eq(RomanNumeral.toRoman(3110),"MMMCX");
		eq(RomanNumeral.toRoman(3111),"MMMCXI");
		eq(RomanNumeral.toRoman(3112),"MMMCXII");
		eq(RomanNumeral.toRoman(3113),"MMMCXIII");
		eq(RomanNumeral.toRoman(3114),"MMMCXIV");
		eq(RomanNumeral.toRoman(3115),"MMMCXV");
		eq(RomanNumeral.toRoman(3116),"MMMCXVI");
		eq(RomanNumeral.toRoman(3117),"MMMCXVII");
		eq(RomanNumeral.toRoman(3118),"MMMCXVIII");
		eq(RomanNumeral.toRoman(3119),"MMMCXIX");
		eq(RomanNumeral.toRoman(3120),"MMMCXX");
		eq(RomanNumeral.toRoman(3121),"MMMCXXI");
		eq(RomanNumeral.toRoman(3122),"MMMCXXII");
		eq(RomanNumeral.toRoman(3123),"MMMCXXIII");
		eq(RomanNumeral.toRoman(3124),"MMMCXXIV");
		eq(RomanNumeral.toRoman(3125),"MMMCXXV");
		eq(RomanNumeral.toRoman(3126),"MMMCXXVI");
		eq(RomanNumeral.toRoman(3127),"MMMCXXVII");
		eq(RomanNumeral.toRoman(3128),"MMMCXXVIII");
		eq(RomanNumeral.toRoman(3129),"MMMCXXIX");
		eq(RomanNumeral.toRoman(3130),"MMMCXXX");
		eq(RomanNumeral.toRoman(3131),"MMMCXXXI");
		eq(RomanNumeral.toRoman(3132),"MMMCXXXII");
		eq(RomanNumeral.toRoman(3133),"MMMCXXXIII");
		eq(RomanNumeral.toRoman(3134),"MMMCXXXIV");
		eq(RomanNumeral.toRoman(3135),"MMMCXXXV");
		eq(RomanNumeral.toRoman(3136),"MMMCXXXVI");
		eq(RomanNumeral.toRoman(3137),"MMMCXXXVII");
		eq(RomanNumeral.toRoman(3138),"MMMCXXXVIII");
		eq(RomanNumeral.toRoman(3139),"MMMCXXXIX");
		eq(RomanNumeral.toRoman(3140),"MMMCXL");
		eq(RomanNumeral.toRoman(3141),"MMMCXLI");
		eq(RomanNumeral.toRoman(3142),"MMMCXLII");
		eq(RomanNumeral.toRoman(3143),"MMMCXLIII");
		eq(RomanNumeral.toRoman(3144),"MMMCXLIV");
		eq(RomanNumeral.toRoman(3145),"MMMCXLV");
		eq(RomanNumeral.toRoman(3146),"MMMCXLVI");
		eq(RomanNumeral.toRoman(3147),"MMMCXLVII");
		eq(RomanNumeral.toRoman(3148),"MMMCXLVIII");
		eq(RomanNumeral.toRoman(3149),"MMMCXLIX");
		eq(RomanNumeral.toRoman(3150),"MMMCL");
		eq(RomanNumeral.toRoman(3151),"MMMCLI");
		eq(RomanNumeral.toRoman(3152),"MMMCLII");
		eq(RomanNumeral.toRoman(3153),"MMMCLIII");
		eq(RomanNumeral.toRoman(3154),"MMMCLIV");
		eq(RomanNumeral.toRoman(3155),"MMMCLV");
		eq(RomanNumeral.toRoman(3156),"MMMCLVI");
		eq(RomanNumeral.toRoman(3157),"MMMCLVII");
		eq(RomanNumeral.toRoman(3158),"MMMCLVIII");
		eq(RomanNumeral.toRoman(3159),"MMMCLIX");
		eq(RomanNumeral.toRoman(3160),"MMMCLX");
		eq(RomanNumeral.toRoman(3161),"MMMCLXI");
		eq(RomanNumeral.toRoman(3162),"MMMCLXII");
		eq(RomanNumeral.toRoman(3163),"MMMCLXIII");
		eq(RomanNumeral.toRoman(3164),"MMMCLXIV");
		eq(RomanNumeral.toRoman(3165),"MMMCLXV");
		eq(RomanNumeral.toRoman(3166),"MMMCLXVI");
		eq(RomanNumeral.toRoman(3167),"MMMCLXVII");
		eq(RomanNumeral.toRoman(3168),"MMMCLXVIII");
		eq(RomanNumeral.toRoman(3169),"MMMCLXIX");
		eq(RomanNumeral.toRoman(3170),"MMMCLXX");
		eq(RomanNumeral.toRoman(3171),"MMMCLXXI");
		eq(RomanNumeral.toRoman(3172),"MMMCLXXII");
		eq(RomanNumeral.toRoman(3173),"MMMCLXXIII");
		eq(RomanNumeral.toRoman(3174),"MMMCLXXIV");
		eq(RomanNumeral.toRoman(3175),"MMMCLXXV");
		eq(RomanNumeral.toRoman(3176),"MMMCLXXVI");
		eq(RomanNumeral.toRoman(3177),"MMMCLXXVII");
		eq(RomanNumeral.toRoman(3178),"MMMCLXXVIII");
		eq(RomanNumeral.toRoman(3179),"MMMCLXXIX");
		eq(RomanNumeral.toRoman(3180),"MMMCLXXX");
		eq(RomanNumeral.toRoman(3181),"MMMCLXXXI");
		eq(RomanNumeral.toRoman(3182),"MMMCLXXXII");
		eq(RomanNumeral.toRoman(3183),"MMMCLXXXIII");
		eq(RomanNumeral.toRoman(3184),"MMMCLXXXIV");
		eq(RomanNumeral.toRoman(3185),"MMMCLXXXV");
		eq(RomanNumeral.toRoman(3186),"MMMCLXXXVI");
		eq(RomanNumeral.toRoman(3187),"MMMCLXXXVII");
		eq(RomanNumeral.toRoman(3188),"MMMCLXXXVIII");
		eq(RomanNumeral.toRoman(3189),"MMMCLXXXIX");
		eq(RomanNumeral.toRoman(3190),"MMMCXC");
		eq(RomanNumeral.toRoman(3191),"MMMCXCI");
		eq(RomanNumeral.toRoman(3192),"MMMCXCII");
		eq(RomanNumeral.toRoman(3193),"MMMCXCIII");
		eq(RomanNumeral.toRoman(3194),"MMMCXCIV");
		eq(RomanNumeral.toRoman(3195),"MMMCXCV");
		eq(RomanNumeral.toRoman(3196),"MMMCXCVI");
		eq(RomanNumeral.toRoman(3197),"MMMCXCVII");
		eq(RomanNumeral.toRoman(3198),"MMMCXCVIII");
		eq(RomanNumeral.toRoman(3199),"MMMCXCIX");
		eq(RomanNumeral.toRoman(3200),"MMMCC");
		eq(RomanNumeral.toRoman(3201),"MMMCCI");
		eq(RomanNumeral.toRoman(3202),"MMMCCII");
		eq(RomanNumeral.toRoman(3203),"MMMCCIII");
		eq(RomanNumeral.toRoman(3204),"MMMCCIV");
		eq(RomanNumeral.toRoman(3205),"MMMCCV");
		eq(RomanNumeral.toRoman(3206),"MMMCCVI");
		eq(RomanNumeral.toRoman(3207),"MMMCCVII");
		eq(RomanNumeral.toRoman(3208),"MMMCCVIII");
		eq(RomanNumeral.toRoman(3209),"MMMCCIX");
		eq(RomanNumeral.toRoman(3210),"MMMCCX");
		eq(RomanNumeral.toRoman(3211),"MMMCCXI");
		eq(RomanNumeral.toRoman(3212),"MMMCCXII");
		eq(RomanNumeral.toRoman(3213),"MMMCCXIII");
		eq(RomanNumeral.toRoman(3214),"MMMCCXIV");
		eq(RomanNumeral.toRoman(3215),"MMMCCXV");
		eq(RomanNumeral.toRoman(3216),"MMMCCXVI");
		eq(RomanNumeral.toRoman(3217),"MMMCCXVII");
		eq(RomanNumeral.toRoman(3218),"MMMCCXVIII");
		eq(RomanNumeral.toRoman(3219),"MMMCCXIX");
		eq(RomanNumeral.toRoman(3220),"MMMCCXX");
		eq(RomanNumeral.toRoman(3221),"MMMCCXXI");
		eq(RomanNumeral.toRoman(3222),"MMMCCXXII");
		eq(RomanNumeral.toRoman(3223),"MMMCCXXIII");
		eq(RomanNumeral.toRoman(3224),"MMMCCXXIV");
		eq(RomanNumeral.toRoman(3225),"MMMCCXXV");
		eq(RomanNumeral.toRoman(3226),"MMMCCXXVI");
		eq(RomanNumeral.toRoman(3227),"MMMCCXXVII");
		eq(RomanNumeral.toRoman(3228),"MMMCCXXVIII");
		eq(RomanNumeral.toRoman(3229),"MMMCCXXIX");
		eq(RomanNumeral.toRoman(3230),"MMMCCXXX");
		eq(RomanNumeral.toRoman(3231),"MMMCCXXXI");
		eq(RomanNumeral.toRoman(3232),"MMMCCXXXII");
		eq(RomanNumeral.toRoman(3233),"MMMCCXXXIII");
		eq(RomanNumeral.toRoman(3234),"MMMCCXXXIV");
		eq(RomanNumeral.toRoman(3235),"MMMCCXXXV");
		eq(RomanNumeral.toRoman(3236),"MMMCCXXXVI");
		eq(RomanNumeral.toRoman(3237),"MMMCCXXXVII");
		eq(RomanNumeral.toRoman(3238),"MMMCCXXXVIII");
		eq(RomanNumeral.toRoman(3239),"MMMCCXXXIX");
		eq(RomanNumeral.toRoman(3240),"MMMCCXL");
		eq(RomanNumeral.toRoman(3241),"MMMCCXLI");
		eq(RomanNumeral.toRoman(3242),"MMMCCXLII");
		eq(RomanNumeral.toRoman(3243),"MMMCCXLIII");
		eq(RomanNumeral.toRoman(3244),"MMMCCXLIV");
		eq(RomanNumeral.toRoman(3245),"MMMCCXLV");
		eq(RomanNumeral.toRoman(3246),"MMMCCXLVI");
		eq(RomanNumeral.toRoman(3247),"MMMCCXLVII");
		eq(RomanNumeral.toRoman(3248),"MMMCCXLVIII");
		eq(RomanNumeral.toRoman(3249),"MMMCCXLIX");
		eq(RomanNumeral.toRoman(3250),"MMMCCL");
		eq(RomanNumeral.toRoman(3251),"MMMCCLI");
		eq(RomanNumeral.toRoman(3252),"MMMCCLII");
		eq(RomanNumeral.toRoman(3253),"MMMCCLIII");
		eq(RomanNumeral.toRoman(3254),"MMMCCLIV");
		eq(RomanNumeral.toRoman(3255),"MMMCCLV");
		eq(RomanNumeral.toRoman(3256),"MMMCCLVI");
		eq(RomanNumeral.toRoman(3257),"MMMCCLVII");
		eq(RomanNumeral.toRoman(3258),"MMMCCLVIII");
		eq(RomanNumeral.toRoman(3259),"MMMCCLIX");
		eq(RomanNumeral.toRoman(3260),"MMMCCLX");
		eq(RomanNumeral.toRoman(3261),"MMMCCLXI");
		eq(RomanNumeral.toRoman(3262),"MMMCCLXII");
		eq(RomanNumeral.toRoman(3263),"MMMCCLXIII");
		eq(RomanNumeral.toRoman(3264),"MMMCCLXIV");
		eq(RomanNumeral.toRoman(3265),"MMMCCLXV");
		eq(RomanNumeral.toRoman(3266),"MMMCCLXVI");
		eq(RomanNumeral.toRoman(3267),"MMMCCLXVII");
		eq(RomanNumeral.toRoman(3268),"MMMCCLXVIII");
		eq(RomanNumeral.toRoman(3269),"MMMCCLXIX");
		eq(RomanNumeral.toRoman(3270),"MMMCCLXX");
		eq(RomanNumeral.toRoman(3271),"MMMCCLXXI");
		eq(RomanNumeral.toRoman(3272),"MMMCCLXXII");
		eq(RomanNumeral.toRoman(3273),"MMMCCLXXIII");
		eq(RomanNumeral.toRoman(3274),"MMMCCLXXIV");
		eq(RomanNumeral.toRoman(3275),"MMMCCLXXV");
		eq(RomanNumeral.toRoman(3276),"MMMCCLXXVI");
		eq(RomanNumeral.toRoman(3277),"MMMCCLXXVII");
		eq(RomanNumeral.toRoman(3278),"MMMCCLXXVIII");
		eq(RomanNumeral.toRoman(3279),"MMMCCLXXIX");
		eq(RomanNumeral.toRoman(3280),"MMMCCLXXX");
		eq(RomanNumeral.toRoman(3281),"MMMCCLXXXI");
		eq(RomanNumeral.toRoman(3282),"MMMCCLXXXII");
		eq(RomanNumeral.toRoman(3283),"MMMCCLXXXIII");
		eq(RomanNumeral.toRoman(3284),"MMMCCLXXXIV");
		eq(RomanNumeral.toRoman(3285),"MMMCCLXXXV");
		eq(RomanNumeral.toRoman(3286),"MMMCCLXXXVI");
		eq(RomanNumeral.toRoman(3287),"MMMCCLXXXVII");
		eq(RomanNumeral.toRoman(3288),"MMMCCLXXXVIII");
		eq(RomanNumeral.toRoman(3289),"MMMCCLXXXIX");
		eq(RomanNumeral.toRoman(3290),"MMMCCXC");
		eq(RomanNumeral.toRoman(3291),"MMMCCXCI");
		eq(RomanNumeral.toRoman(3292),"MMMCCXCII");
		eq(RomanNumeral.toRoman(3293),"MMMCCXCIII");
		eq(RomanNumeral.toRoman(3294),"MMMCCXCIV");
		eq(RomanNumeral.toRoman(3295),"MMMCCXCV");
		eq(RomanNumeral.toRoman(3296),"MMMCCXCVI");
		eq(RomanNumeral.toRoman(3297),"MMMCCXCVII");
		eq(RomanNumeral.toRoman(3298),"MMMCCXCVIII");
		eq(RomanNumeral.toRoman(3299),"MMMCCXCIX");
		eq(RomanNumeral.toRoman(3300),"MMMCCC");
		eq(RomanNumeral.toRoman(3301),"MMMCCCI");
		eq(RomanNumeral.toRoman(3302),"MMMCCCII");
		eq(RomanNumeral.toRoman(3303),"MMMCCCIII");
		eq(RomanNumeral.toRoman(3304),"MMMCCCIV");
		eq(RomanNumeral.toRoman(3305),"MMMCCCV");
		eq(RomanNumeral.toRoman(3306),"MMMCCCVI");
		eq(RomanNumeral.toRoman(3307),"MMMCCCVII");
		eq(RomanNumeral.toRoman(3308),"MMMCCCVIII");
		eq(RomanNumeral.toRoman(3309),"MMMCCCIX");
		eq(RomanNumeral.toRoman(3310),"MMMCCCX");
		eq(RomanNumeral.toRoman(3311),"MMMCCCXI");
		eq(RomanNumeral.toRoman(3312),"MMMCCCXII");
		eq(RomanNumeral.toRoman(3313),"MMMCCCXIII");
		eq(RomanNumeral.toRoman(3314),"MMMCCCXIV");
		eq(RomanNumeral.toRoman(3315),"MMMCCCXV");
		eq(RomanNumeral.toRoman(3316),"MMMCCCXVI");
		eq(RomanNumeral.toRoman(3317),"MMMCCCXVII");
		eq(RomanNumeral.toRoman(3318),"MMMCCCXVIII");
		eq(RomanNumeral.toRoman(3319),"MMMCCCXIX");
		eq(RomanNumeral.toRoman(3320),"MMMCCCXX");
		eq(RomanNumeral.toRoman(3321),"MMMCCCXXI");
		eq(RomanNumeral.toRoman(3322),"MMMCCCXXII");
		eq(RomanNumeral.toRoman(3323),"MMMCCCXXIII");
		eq(RomanNumeral.toRoman(3324),"MMMCCCXXIV");
		eq(RomanNumeral.toRoman(3325),"MMMCCCXXV");
		eq(RomanNumeral.toRoman(3326),"MMMCCCXXVI");
		eq(RomanNumeral.toRoman(3327),"MMMCCCXXVII");
		eq(RomanNumeral.toRoman(3328),"MMMCCCXXVIII");
		eq(RomanNumeral.toRoman(3329),"MMMCCCXXIX");
		eq(RomanNumeral.toRoman(3330),"MMMCCCXXX");
		eq(RomanNumeral.toRoman(3331),"MMMCCCXXXI");
		eq(RomanNumeral.toRoman(3332),"MMMCCCXXXII");
		eq(RomanNumeral.toRoman(3333),"MMMCCCXXXIII");
		eq(RomanNumeral.toRoman(3334),"MMMCCCXXXIV");
		eq(RomanNumeral.toRoman(3335),"MMMCCCXXXV");
		eq(RomanNumeral.toRoman(3336),"MMMCCCXXXVI");
		eq(RomanNumeral.toRoman(3337),"MMMCCCXXXVII");
		eq(RomanNumeral.toRoman(3338),"MMMCCCXXXVIII");
		eq(RomanNumeral.toRoman(3339),"MMMCCCXXXIX");
		eq(RomanNumeral.toRoman(3340),"MMMCCCXL");
		eq(RomanNumeral.toRoman(3341),"MMMCCCXLI");
		eq(RomanNumeral.toRoman(3342),"MMMCCCXLII");
		eq(RomanNumeral.toRoman(3343),"MMMCCCXLIII");
		eq(RomanNumeral.toRoman(3344),"MMMCCCXLIV");
		eq(RomanNumeral.toRoman(3345),"MMMCCCXLV");
		eq(RomanNumeral.toRoman(3346),"MMMCCCXLVI");
		eq(RomanNumeral.toRoman(3347),"MMMCCCXLVII");
		eq(RomanNumeral.toRoman(3348),"MMMCCCXLVIII");
		eq(RomanNumeral.toRoman(3349),"MMMCCCXLIX");
		eq(RomanNumeral.toRoman(3350),"MMMCCCL");
		eq(RomanNumeral.toRoman(3351),"MMMCCCLI");
		eq(RomanNumeral.toRoman(3352),"MMMCCCLII");
		eq(RomanNumeral.toRoman(3353),"MMMCCCLIII");
		eq(RomanNumeral.toRoman(3354),"MMMCCCLIV");
		eq(RomanNumeral.toRoman(3355),"MMMCCCLV");
		eq(RomanNumeral.toRoman(3356),"MMMCCCLVI");
		eq(RomanNumeral.toRoman(3357),"MMMCCCLVII");
		eq(RomanNumeral.toRoman(3358),"MMMCCCLVIII");
		eq(RomanNumeral.toRoman(3359),"MMMCCCLIX");
		eq(RomanNumeral.toRoman(3360),"MMMCCCLX");
		eq(RomanNumeral.toRoman(3361),"MMMCCCLXI");
		eq(RomanNumeral.toRoman(3362),"MMMCCCLXII");
		eq(RomanNumeral.toRoman(3363),"MMMCCCLXIII");
		eq(RomanNumeral.toRoman(3364),"MMMCCCLXIV");
		eq(RomanNumeral.toRoman(3365),"MMMCCCLXV");
		eq(RomanNumeral.toRoman(3366),"MMMCCCLXVI");
		eq(RomanNumeral.toRoman(3367),"MMMCCCLXVII");
		eq(RomanNumeral.toRoman(3368),"MMMCCCLXVIII");
		eq(RomanNumeral.toRoman(3369),"MMMCCCLXIX");
		eq(RomanNumeral.toRoman(3370),"MMMCCCLXX");
		eq(RomanNumeral.toRoman(3371),"MMMCCCLXXI");
		eq(RomanNumeral.toRoman(3372),"MMMCCCLXXII");
		eq(RomanNumeral.toRoman(3373),"MMMCCCLXXIII");
		eq(RomanNumeral.toRoman(3374),"MMMCCCLXXIV");
		eq(RomanNumeral.toRoman(3375),"MMMCCCLXXV");
		eq(RomanNumeral.toRoman(3376),"MMMCCCLXXVI");
		eq(RomanNumeral.toRoman(3377),"MMMCCCLXXVII");
		eq(RomanNumeral.toRoman(3378),"MMMCCCLXXVIII");
		eq(RomanNumeral.toRoman(3379),"MMMCCCLXXIX");
		eq(RomanNumeral.toRoman(3380),"MMMCCCLXXX");
		eq(RomanNumeral.toRoman(3381),"MMMCCCLXXXI");
		eq(RomanNumeral.toRoman(3382),"MMMCCCLXXXII");
		eq(RomanNumeral.toRoman(3383),"MMMCCCLXXXIII");
		eq(RomanNumeral.toRoman(3384),"MMMCCCLXXXIV");
		eq(RomanNumeral.toRoman(3385),"MMMCCCLXXXV");
		eq(RomanNumeral.toRoman(3386),"MMMCCCLXXXVI");
		eq(RomanNumeral.toRoman(3387),"MMMCCCLXXXVII");
		eq(RomanNumeral.toRoman(3388),"MMMCCCLXXXVIII");
		eq(RomanNumeral.toRoman(3389),"MMMCCCLXXXIX");
		eq(RomanNumeral.toRoman(3390),"MMMCCCXC");
		eq(RomanNumeral.toRoman(3391),"MMMCCCXCI");
		eq(RomanNumeral.toRoman(3392),"MMMCCCXCII");
		eq(RomanNumeral.toRoman(3393),"MMMCCCXCIII");
		eq(RomanNumeral.toRoman(3394),"MMMCCCXCIV");
		eq(RomanNumeral.toRoman(3395),"MMMCCCXCV");
		eq(RomanNumeral.toRoman(3396),"MMMCCCXCVI");
		eq(RomanNumeral.toRoman(3397),"MMMCCCXCVII");
		eq(RomanNumeral.toRoman(3398),"MMMCCCXCVIII");
		eq(RomanNumeral.toRoman(3399),"MMMCCCXCIX");
		eq(RomanNumeral.toRoman(3400),"MMMCD");
		eq(RomanNumeral.toRoman(3401),"MMMCDI");
		eq(RomanNumeral.toRoman(3402),"MMMCDII");
		eq(RomanNumeral.toRoman(3403),"MMMCDIII");
		eq(RomanNumeral.toRoman(3404),"MMMCDIV");
		eq(RomanNumeral.toRoman(3405),"MMMCDV");
		eq(RomanNumeral.toRoman(3406),"MMMCDVI");
		eq(RomanNumeral.toRoman(3407),"MMMCDVII");
		eq(RomanNumeral.toRoman(3408),"MMMCDVIII");
		eq(RomanNumeral.toRoman(3409),"MMMCDIX");
		eq(RomanNumeral.toRoman(3410),"MMMCDX");
		eq(RomanNumeral.toRoman(3411),"MMMCDXI");
		eq(RomanNumeral.toRoman(3412),"MMMCDXII");
		eq(RomanNumeral.toRoman(3413),"MMMCDXIII");
		eq(RomanNumeral.toRoman(3414),"MMMCDXIV");
		eq(RomanNumeral.toRoman(3415),"MMMCDXV");
		eq(RomanNumeral.toRoman(3416),"MMMCDXVI");
		eq(RomanNumeral.toRoman(3417),"MMMCDXVII");
		eq(RomanNumeral.toRoman(3418),"MMMCDXVIII");
		eq(RomanNumeral.toRoman(3419),"MMMCDXIX");
		eq(RomanNumeral.toRoman(3420),"MMMCDXX");
		eq(RomanNumeral.toRoman(3421),"MMMCDXXI");
		eq(RomanNumeral.toRoman(3422),"MMMCDXXII");
		eq(RomanNumeral.toRoman(3423),"MMMCDXXIII");
		eq(RomanNumeral.toRoman(3424),"MMMCDXXIV");
		eq(RomanNumeral.toRoman(3425),"MMMCDXXV");
		eq(RomanNumeral.toRoman(3426),"MMMCDXXVI");
		eq(RomanNumeral.toRoman(3427),"MMMCDXXVII");
		eq(RomanNumeral.toRoman(3428),"MMMCDXXVIII");
		eq(RomanNumeral.toRoman(3429),"MMMCDXXIX");
		eq(RomanNumeral.toRoman(3430),"MMMCDXXX");
		eq(RomanNumeral.toRoman(3431),"MMMCDXXXI");
		eq(RomanNumeral.toRoman(3432),"MMMCDXXXII");
		eq(RomanNumeral.toRoman(3433),"MMMCDXXXIII");
		eq(RomanNumeral.toRoman(3434),"MMMCDXXXIV");
		eq(RomanNumeral.toRoman(3435),"MMMCDXXXV");
		eq(RomanNumeral.toRoman(3436),"MMMCDXXXVI");
		eq(RomanNumeral.toRoman(3437),"MMMCDXXXVII");
		eq(RomanNumeral.toRoman(3438),"MMMCDXXXVIII");
		eq(RomanNumeral.toRoman(3439),"MMMCDXXXIX");
		eq(RomanNumeral.toRoman(3440),"MMMCDXL");
		eq(RomanNumeral.toRoman(3441),"MMMCDXLI");
		eq(RomanNumeral.toRoman(3442),"MMMCDXLII");
		eq(RomanNumeral.toRoman(3443),"MMMCDXLIII");
		eq(RomanNumeral.toRoman(3444),"MMMCDXLIV");
		eq(RomanNumeral.toRoman(3445),"MMMCDXLV");
		eq(RomanNumeral.toRoman(3446),"MMMCDXLVI");
		eq(RomanNumeral.toRoman(3447),"MMMCDXLVII");
		eq(RomanNumeral.toRoman(3448),"MMMCDXLVIII");
		eq(RomanNumeral.toRoman(3449),"MMMCDXLIX");
		eq(RomanNumeral.toRoman(3450),"MMMCDL");
		eq(RomanNumeral.toRoman(3451),"MMMCDLI");
		eq(RomanNumeral.toRoman(3452),"MMMCDLII");
		eq(RomanNumeral.toRoman(3453),"MMMCDLIII");
		eq(RomanNumeral.toRoman(3454),"MMMCDLIV");
		eq(RomanNumeral.toRoman(3455),"MMMCDLV");
		eq(RomanNumeral.toRoman(3456),"MMMCDLVI");
		eq(RomanNumeral.toRoman(3457),"MMMCDLVII");
		eq(RomanNumeral.toRoman(3458),"MMMCDLVIII");
		eq(RomanNumeral.toRoman(3459),"MMMCDLIX");
		eq(RomanNumeral.toRoman(3460),"MMMCDLX");
		eq(RomanNumeral.toRoman(3461),"MMMCDLXI");
		eq(RomanNumeral.toRoman(3462),"MMMCDLXII");
		eq(RomanNumeral.toRoman(3463),"MMMCDLXIII");
		eq(RomanNumeral.toRoman(3464),"MMMCDLXIV");
		eq(RomanNumeral.toRoman(3465),"MMMCDLXV");
		eq(RomanNumeral.toRoman(3466),"MMMCDLXVI");
		eq(RomanNumeral.toRoman(3467),"MMMCDLXVII");
		eq(RomanNumeral.toRoman(3468),"MMMCDLXVIII");
		eq(RomanNumeral.toRoman(3469),"MMMCDLXIX");
		eq(RomanNumeral.toRoman(3470),"MMMCDLXX");
		eq(RomanNumeral.toRoman(3471),"MMMCDLXXI");
		eq(RomanNumeral.toRoman(3472),"MMMCDLXXII");
		eq(RomanNumeral.toRoman(3473),"MMMCDLXXIII");
		eq(RomanNumeral.toRoman(3474),"MMMCDLXXIV");
		eq(RomanNumeral.toRoman(3475),"MMMCDLXXV");
		eq(RomanNumeral.toRoman(3476),"MMMCDLXXVI");
		eq(RomanNumeral.toRoman(3477),"MMMCDLXXVII");
		eq(RomanNumeral.toRoman(3478),"MMMCDLXXVIII");
		eq(RomanNumeral.toRoman(3479),"MMMCDLXXIX");
		eq(RomanNumeral.toRoman(3480),"MMMCDLXXX");
		eq(RomanNumeral.toRoman(3481),"MMMCDLXXXI");
		eq(RomanNumeral.toRoman(3482),"MMMCDLXXXII");
		eq(RomanNumeral.toRoman(3483),"MMMCDLXXXIII");
		eq(RomanNumeral.toRoman(3484),"MMMCDLXXXIV");
		eq(RomanNumeral.toRoman(3485),"MMMCDLXXXV");
		eq(RomanNumeral.toRoman(3486),"MMMCDLXXXVI");
		eq(RomanNumeral.toRoman(3487),"MMMCDLXXXVII");
		eq(RomanNumeral.toRoman(3488),"MMMCDLXXXVIII");
		eq(RomanNumeral.toRoman(3489),"MMMCDLXXXIX");
		eq(RomanNumeral.toRoman(3490),"MMMCDXC");
		eq(RomanNumeral.toRoman(3491),"MMMCDXCI");
		eq(RomanNumeral.toRoman(3492),"MMMCDXCII");
		eq(RomanNumeral.toRoman(3493),"MMMCDXCIII");
		eq(RomanNumeral.toRoman(3494),"MMMCDXCIV");
		eq(RomanNumeral.toRoman(3495),"MMMCDXCV");
		eq(RomanNumeral.toRoman(3496),"MMMCDXCVI");
		eq(RomanNumeral.toRoman(3497),"MMMCDXCVII");
		eq(RomanNumeral.toRoman(3498),"MMMCDXCVIII");
		eq(RomanNumeral.toRoman(3499),"MMMCDXCIX");
		eq(RomanNumeral.toRoman(3500),"MMMD");
		eq(RomanNumeral.toRoman(3501),"MMMDI");
		eq(RomanNumeral.toRoman(3502),"MMMDII");
		eq(RomanNumeral.toRoman(3503),"MMMDIII");
		eq(RomanNumeral.toRoman(3504),"MMMDIV");
		eq(RomanNumeral.toRoman(3505),"MMMDV");
		eq(RomanNumeral.toRoman(3506),"MMMDVI");
		eq(RomanNumeral.toRoman(3507),"MMMDVII");
		eq(RomanNumeral.toRoman(3508),"MMMDVIII");
		eq(RomanNumeral.toRoman(3509),"MMMDIX");
		eq(RomanNumeral.toRoman(3510),"MMMDX");
		eq(RomanNumeral.toRoman(3511),"MMMDXI");
		eq(RomanNumeral.toRoman(3512),"MMMDXII");
		eq(RomanNumeral.toRoman(3513),"MMMDXIII");
		eq(RomanNumeral.toRoman(3514),"MMMDXIV");
		eq(RomanNumeral.toRoman(3515),"MMMDXV");
		eq(RomanNumeral.toRoman(3516),"MMMDXVI");
		eq(RomanNumeral.toRoman(3517),"MMMDXVII");
		eq(RomanNumeral.toRoman(3518),"MMMDXVIII");
		eq(RomanNumeral.toRoman(3519),"MMMDXIX");
		eq(RomanNumeral.toRoman(3520),"MMMDXX");
		eq(RomanNumeral.toRoman(3521),"MMMDXXI");
		eq(RomanNumeral.toRoman(3522),"MMMDXXII");
		eq(RomanNumeral.toRoman(3523),"MMMDXXIII");
		eq(RomanNumeral.toRoman(3524),"MMMDXXIV");
		eq(RomanNumeral.toRoman(3525),"MMMDXXV");
		eq(RomanNumeral.toRoman(3526),"MMMDXXVI");
		eq(RomanNumeral.toRoman(3527),"MMMDXXVII");
		eq(RomanNumeral.toRoman(3528),"MMMDXXVIII");
		eq(RomanNumeral.toRoman(3529),"MMMDXXIX");
		eq(RomanNumeral.toRoman(3530),"MMMDXXX");
		eq(RomanNumeral.toRoman(3531),"MMMDXXXI");
		eq(RomanNumeral.toRoman(3532),"MMMDXXXII");
		eq(RomanNumeral.toRoman(3533),"MMMDXXXIII");
		eq(RomanNumeral.toRoman(3534),"MMMDXXXIV");
		eq(RomanNumeral.toRoman(3535),"MMMDXXXV");
		eq(RomanNumeral.toRoman(3536),"MMMDXXXVI");
		eq(RomanNumeral.toRoman(3537),"MMMDXXXVII");
		eq(RomanNumeral.toRoman(3538),"MMMDXXXVIII");
		eq(RomanNumeral.toRoman(3539),"MMMDXXXIX");
		eq(RomanNumeral.toRoman(3540),"MMMDXL");
		eq(RomanNumeral.toRoman(3541),"MMMDXLI");
		eq(RomanNumeral.toRoman(3542),"MMMDXLII");
		eq(RomanNumeral.toRoman(3543),"MMMDXLIII");
		eq(RomanNumeral.toRoman(3544),"MMMDXLIV");
		eq(RomanNumeral.toRoman(3545),"MMMDXLV");
		eq(RomanNumeral.toRoman(3546),"MMMDXLVI");
		eq(RomanNumeral.toRoman(3547),"MMMDXLVII");
		eq(RomanNumeral.toRoman(3548),"MMMDXLVIII");
		eq(RomanNumeral.toRoman(3549),"MMMDXLIX");
		eq(RomanNumeral.toRoman(3550),"MMMDL");
		eq(RomanNumeral.toRoman(3551),"MMMDLI");
		eq(RomanNumeral.toRoman(3552),"MMMDLII");
		eq(RomanNumeral.toRoman(3553),"MMMDLIII");
		eq(RomanNumeral.toRoman(3554),"MMMDLIV");
		eq(RomanNumeral.toRoman(3555),"MMMDLV");
		eq(RomanNumeral.toRoman(3556),"MMMDLVI");
		eq(RomanNumeral.toRoman(3557),"MMMDLVII");
		eq(RomanNumeral.toRoman(3558),"MMMDLVIII");
		eq(RomanNumeral.toRoman(3559),"MMMDLIX");
		eq(RomanNumeral.toRoman(3560),"MMMDLX");
		eq(RomanNumeral.toRoman(3561),"MMMDLXI");
		eq(RomanNumeral.toRoman(3562),"MMMDLXII");
		eq(RomanNumeral.toRoman(3563),"MMMDLXIII");
		eq(RomanNumeral.toRoman(3564),"MMMDLXIV");
		eq(RomanNumeral.toRoman(3565),"MMMDLXV");
		eq(RomanNumeral.toRoman(3566),"MMMDLXVI");
		eq(RomanNumeral.toRoman(3567),"MMMDLXVII");
		eq(RomanNumeral.toRoman(3568),"MMMDLXVIII");
		eq(RomanNumeral.toRoman(3569),"MMMDLXIX");
		eq(RomanNumeral.toRoman(3570),"MMMDLXX");
		eq(RomanNumeral.toRoman(3571),"MMMDLXXI");
		eq(RomanNumeral.toRoman(3572),"MMMDLXXII");
		eq(RomanNumeral.toRoman(3573),"MMMDLXXIII");
		eq(RomanNumeral.toRoman(3574),"MMMDLXXIV");
		eq(RomanNumeral.toRoman(3575),"MMMDLXXV");
		eq(RomanNumeral.toRoman(3576),"MMMDLXXVI");
		eq(RomanNumeral.toRoman(3577),"MMMDLXXVII");
		eq(RomanNumeral.toRoman(3578),"MMMDLXXVIII");
		eq(RomanNumeral.toRoman(3579),"MMMDLXXIX");
		eq(RomanNumeral.toRoman(3580),"MMMDLXXX");
		eq(RomanNumeral.toRoman(3581),"MMMDLXXXI");
		eq(RomanNumeral.toRoman(3582),"MMMDLXXXII");
		eq(RomanNumeral.toRoman(3583),"MMMDLXXXIII");
		eq(RomanNumeral.toRoman(3584),"MMMDLXXXIV");
		eq(RomanNumeral.toRoman(3585),"MMMDLXXXV");
		eq(RomanNumeral.toRoman(3586),"MMMDLXXXVI");
		eq(RomanNumeral.toRoman(3587),"MMMDLXXXVII");
		eq(RomanNumeral.toRoman(3588),"MMMDLXXXVIII");
		eq(RomanNumeral.toRoman(3589),"MMMDLXXXIX");
		eq(RomanNumeral.toRoman(3590),"MMMDXC");
		eq(RomanNumeral.toRoman(3591),"MMMDXCI");
		eq(RomanNumeral.toRoman(3592),"MMMDXCII");
		eq(RomanNumeral.toRoman(3593),"MMMDXCIII");
		eq(RomanNumeral.toRoman(3594),"MMMDXCIV");
		eq(RomanNumeral.toRoman(3595),"MMMDXCV");
		eq(RomanNumeral.toRoman(3596),"MMMDXCVI");
		eq(RomanNumeral.toRoman(3597),"MMMDXCVII");
		eq(RomanNumeral.toRoman(3598),"MMMDXCVIII");
		eq(RomanNumeral.toRoman(3599),"MMMDXCIX");
		eq(RomanNumeral.toRoman(3600),"MMMDC");
		eq(RomanNumeral.toRoman(3601),"MMMDCI");
		eq(RomanNumeral.toRoman(3602),"MMMDCII");
		eq(RomanNumeral.toRoman(3603),"MMMDCIII");
		eq(RomanNumeral.toRoman(3604),"MMMDCIV");
		eq(RomanNumeral.toRoman(3605),"MMMDCV");
		eq(RomanNumeral.toRoman(3606),"MMMDCVI");
		eq(RomanNumeral.toRoman(3607),"MMMDCVII");
		eq(RomanNumeral.toRoman(3608),"MMMDCVIII");
		eq(RomanNumeral.toRoman(3609),"MMMDCIX");
		eq(RomanNumeral.toRoman(3610),"MMMDCX");
		eq(RomanNumeral.toRoman(3611),"MMMDCXI");
		eq(RomanNumeral.toRoman(3612),"MMMDCXII");
		eq(RomanNumeral.toRoman(3613),"MMMDCXIII");
		eq(RomanNumeral.toRoman(3614),"MMMDCXIV");
		eq(RomanNumeral.toRoman(3615),"MMMDCXV");
		eq(RomanNumeral.toRoman(3616),"MMMDCXVI");
		eq(RomanNumeral.toRoman(3617),"MMMDCXVII");
		eq(RomanNumeral.toRoman(3618),"MMMDCXVIII");
		eq(RomanNumeral.toRoman(3619),"MMMDCXIX");
		eq(RomanNumeral.toRoman(3620),"MMMDCXX");
		eq(RomanNumeral.toRoman(3621),"MMMDCXXI");
		eq(RomanNumeral.toRoman(3622),"MMMDCXXII");
		eq(RomanNumeral.toRoman(3623),"MMMDCXXIII");
		eq(RomanNumeral.toRoman(3624),"MMMDCXXIV");
		eq(RomanNumeral.toRoman(3625),"MMMDCXXV");
		eq(RomanNumeral.toRoman(3626),"MMMDCXXVI");
		eq(RomanNumeral.toRoman(3627),"MMMDCXXVII");
		eq(RomanNumeral.toRoman(3628),"MMMDCXXVIII");
		eq(RomanNumeral.toRoman(3629),"MMMDCXXIX");
		eq(RomanNumeral.toRoman(3630),"MMMDCXXX");
		eq(RomanNumeral.toRoman(3631),"MMMDCXXXI");
		eq(RomanNumeral.toRoman(3632),"MMMDCXXXII");
		eq(RomanNumeral.toRoman(3633),"MMMDCXXXIII");
		eq(RomanNumeral.toRoman(3634),"MMMDCXXXIV");
		eq(RomanNumeral.toRoman(3635),"MMMDCXXXV");
		eq(RomanNumeral.toRoman(3636),"MMMDCXXXVI");
		eq(RomanNumeral.toRoman(3637),"MMMDCXXXVII");
		eq(RomanNumeral.toRoman(3638),"MMMDCXXXVIII");
		eq(RomanNumeral.toRoman(3639),"MMMDCXXXIX");
		eq(RomanNumeral.toRoman(3640),"MMMDCXL");
		eq(RomanNumeral.toRoman(3641),"MMMDCXLI");
		eq(RomanNumeral.toRoman(3642),"MMMDCXLII");
		eq(RomanNumeral.toRoman(3643),"MMMDCXLIII");
		eq(RomanNumeral.toRoman(3644),"MMMDCXLIV");
		eq(RomanNumeral.toRoman(3645),"MMMDCXLV");
		eq(RomanNumeral.toRoman(3646),"MMMDCXLVI");
		eq(RomanNumeral.toRoman(3647),"MMMDCXLVII");
		eq(RomanNumeral.toRoman(3648),"MMMDCXLVIII");
		eq(RomanNumeral.toRoman(3649),"MMMDCXLIX");
		eq(RomanNumeral.toRoman(3650),"MMMDCL");
		eq(RomanNumeral.toRoman(3651),"MMMDCLI");
		eq(RomanNumeral.toRoman(3652),"MMMDCLII");
		eq(RomanNumeral.toRoman(3653),"MMMDCLIII");
		eq(RomanNumeral.toRoman(3654),"MMMDCLIV");
		eq(RomanNumeral.toRoman(3655),"MMMDCLV");
		eq(RomanNumeral.toRoman(3656),"MMMDCLVI");
		eq(RomanNumeral.toRoman(3657),"MMMDCLVII");
		eq(RomanNumeral.toRoman(3658),"MMMDCLVIII");
		eq(RomanNumeral.toRoman(3659),"MMMDCLIX");
		eq(RomanNumeral.toRoman(3660),"MMMDCLX");
		eq(RomanNumeral.toRoman(3661),"MMMDCLXI");
		eq(RomanNumeral.toRoman(3662),"MMMDCLXII");
		eq(RomanNumeral.toRoman(3663),"MMMDCLXIII");
		eq(RomanNumeral.toRoman(3664),"MMMDCLXIV");
		eq(RomanNumeral.toRoman(3665),"MMMDCLXV");
		eq(RomanNumeral.toRoman(3666),"MMMDCLXVI");
		eq(RomanNumeral.toRoman(3667),"MMMDCLXVII");
		eq(RomanNumeral.toRoman(3668),"MMMDCLXVIII");
		eq(RomanNumeral.toRoman(3669),"MMMDCLXIX");
		eq(RomanNumeral.toRoman(3670),"MMMDCLXX");
		eq(RomanNumeral.toRoman(3671),"MMMDCLXXI");
		eq(RomanNumeral.toRoman(3672),"MMMDCLXXII");
		eq(RomanNumeral.toRoman(3673),"MMMDCLXXIII");
		eq(RomanNumeral.toRoman(3674),"MMMDCLXXIV");
		eq(RomanNumeral.toRoman(3675),"MMMDCLXXV");
		eq(RomanNumeral.toRoman(3676),"MMMDCLXXVI");
		eq(RomanNumeral.toRoman(3677),"MMMDCLXXVII");
		eq(RomanNumeral.toRoman(3678),"MMMDCLXXVIII");
		eq(RomanNumeral.toRoman(3679),"MMMDCLXXIX");
		eq(RomanNumeral.toRoman(3680),"MMMDCLXXX");
		eq(RomanNumeral.toRoman(3681),"MMMDCLXXXI");
		eq(RomanNumeral.toRoman(3682),"MMMDCLXXXII");
		eq(RomanNumeral.toRoman(3683),"MMMDCLXXXIII");
		eq(RomanNumeral.toRoman(3684),"MMMDCLXXXIV");
		eq(RomanNumeral.toRoman(3685),"MMMDCLXXXV");
		eq(RomanNumeral.toRoman(3686),"MMMDCLXXXVI");
		eq(RomanNumeral.toRoman(3687),"MMMDCLXXXVII");
		eq(RomanNumeral.toRoman(3688),"MMMDCLXXXVIII");
		eq(RomanNumeral.toRoman(3689),"MMMDCLXXXIX");
		eq(RomanNumeral.toRoman(3690),"MMMDCXC");
		eq(RomanNumeral.toRoman(3691),"MMMDCXCI");
		eq(RomanNumeral.toRoman(3692),"MMMDCXCII");
		eq(RomanNumeral.toRoman(3693),"MMMDCXCIII");
		eq(RomanNumeral.toRoman(3694),"MMMDCXCIV");
		eq(RomanNumeral.toRoman(3695),"MMMDCXCV");
		eq(RomanNumeral.toRoman(3696),"MMMDCXCVI");
		eq(RomanNumeral.toRoman(3697),"MMMDCXCVII");
		eq(RomanNumeral.toRoman(3698),"MMMDCXCVIII");
		eq(RomanNumeral.toRoman(3699),"MMMDCXCIX");
		eq(RomanNumeral.toRoman(3700),"MMMDCC");
		eq(RomanNumeral.toRoman(3701),"MMMDCCI");
		eq(RomanNumeral.toRoman(3702),"MMMDCCII");
		eq(RomanNumeral.toRoman(3703),"MMMDCCIII");
		eq(RomanNumeral.toRoman(3704),"MMMDCCIV");
		eq(RomanNumeral.toRoman(3705),"MMMDCCV");
		eq(RomanNumeral.toRoman(3706),"MMMDCCVI");
		eq(RomanNumeral.toRoman(3707),"MMMDCCVII");
		eq(RomanNumeral.toRoman(3708),"MMMDCCVIII");
		eq(RomanNumeral.toRoman(3709),"MMMDCCIX");
		eq(RomanNumeral.toRoman(3710),"MMMDCCX");
		eq(RomanNumeral.toRoman(3711),"MMMDCCXI");
		eq(RomanNumeral.toRoman(3712),"MMMDCCXII");
		eq(RomanNumeral.toRoman(3713),"MMMDCCXIII");
		eq(RomanNumeral.toRoman(3714),"MMMDCCXIV");
		eq(RomanNumeral.toRoman(3715),"MMMDCCXV");
		eq(RomanNumeral.toRoman(3716),"MMMDCCXVI");
		eq(RomanNumeral.toRoman(3717),"MMMDCCXVII");
		eq(RomanNumeral.toRoman(3718),"MMMDCCXVIII");
		eq(RomanNumeral.toRoman(3719),"MMMDCCXIX");
		eq(RomanNumeral.toRoman(3720),"MMMDCCXX");
		eq(RomanNumeral.toRoman(3721),"MMMDCCXXI");
		eq(RomanNumeral.toRoman(3722),"MMMDCCXXII");
		eq(RomanNumeral.toRoman(3723),"MMMDCCXXIII");
		eq(RomanNumeral.toRoman(3724),"MMMDCCXXIV");
		eq(RomanNumeral.toRoman(3725),"MMMDCCXXV");
		eq(RomanNumeral.toRoman(3726),"MMMDCCXXVI");
		eq(RomanNumeral.toRoman(3727),"MMMDCCXXVII");
		eq(RomanNumeral.toRoman(3728),"MMMDCCXXVIII");
		eq(RomanNumeral.toRoman(3729),"MMMDCCXXIX");
		eq(RomanNumeral.toRoman(3730),"MMMDCCXXX");
		eq(RomanNumeral.toRoman(3731),"MMMDCCXXXI");
		eq(RomanNumeral.toRoman(3732),"MMMDCCXXXII");
		eq(RomanNumeral.toRoman(3733),"MMMDCCXXXIII");
		eq(RomanNumeral.toRoman(3734),"MMMDCCXXXIV");
		eq(RomanNumeral.toRoman(3735),"MMMDCCXXXV");
		eq(RomanNumeral.toRoman(3736),"MMMDCCXXXVI");
		eq(RomanNumeral.toRoman(3737),"MMMDCCXXXVII");
		eq(RomanNumeral.toRoman(3738),"MMMDCCXXXVIII");
		eq(RomanNumeral.toRoman(3739),"MMMDCCXXXIX");
		eq(RomanNumeral.toRoman(3740),"MMMDCCXL");
		eq(RomanNumeral.toRoman(3741),"MMMDCCXLI");
		eq(RomanNumeral.toRoman(3742),"MMMDCCXLII");
		eq(RomanNumeral.toRoman(3743),"MMMDCCXLIII");
		eq(RomanNumeral.toRoman(3744),"MMMDCCXLIV");
		eq(RomanNumeral.toRoman(3745),"MMMDCCXLV");
		eq(RomanNumeral.toRoman(3746),"MMMDCCXLVI");
		eq(RomanNumeral.toRoman(3747),"MMMDCCXLVII");
		eq(RomanNumeral.toRoman(3748),"MMMDCCXLVIII");
		eq(RomanNumeral.toRoman(3749),"MMMDCCXLIX");
		eq(RomanNumeral.toRoman(3750),"MMMDCCL");
		eq(RomanNumeral.toRoman(3751),"MMMDCCLI");
		eq(RomanNumeral.toRoman(3752),"MMMDCCLII");
		eq(RomanNumeral.toRoman(3753),"MMMDCCLIII");
		eq(RomanNumeral.toRoman(3754),"MMMDCCLIV");
		eq(RomanNumeral.toRoman(3755),"MMMDCCLV");
		eq(RomanNumeral.toRoman(3756),"MMMDCCLVI");
		eq(RomanNumeral.toRoman(3757),"MMMDCCLVII");
		eq(RomanNumeral.toRoman(3758),"MMMDCCLVIII");
		eq(RomanNumeral.toRoman(3759),"MMMDCCLIX");
		eq(RomanNumeral.toRoman(3760),"MMMDCCLX");
		eq(RomanNumeral.toRoman(3761),"MMMDCCLXI");
		eq(RomanNumeral.toRoman(3762),"MMMDCCLXII");
		eq(RomanNumeral.toRoman(3763),"MMMDCCLXIII");
		eq(RomanNumeral.toRoman(3764),"MMMDCCLXIV");
		eq(RomanNumeral.toRoman(3765),"MMMDCCLXV");
		eq(RomanNumeral.toRoman(3766),"MMMDCCLXVI");
		eq(RomanNumeral.toRoman(3767),"MMMDCCLXVII");
		eq(RomanNumeral.toRoman(3768),"MMMDCCLXVIII");
		eq(RomanNumeral.toRoman(3769),"MMMDCCLXIX");
		eq(RomanNumeral.toRoman(3770),"MMMDCCLXX");
		eq(RomanNumeral.toRoman(3771),"MMMDCCLXXI");
		eq(RomanNumeral.toRoman(3772),"MMMDCCLXXII");
		eq(RomanNumeral.toRoman(3773),"MMMDCCLXXIII");
		eq(RomanNumeral.toRoman(3774),"MMMDCCLXXIV");
		eq(RomanNumeral.toRoman(3775),"MMMDCCLXXV");
		eq(RomanNumeral.toRoman(3776),"MMMDCCLXXVI");
		eq(RomanNumeral.toRoman(3777),"MMMDCCLXXVII");
		eq(RomanNumeral.toRoman(3778),"MMMDCCLXXVIII");
		eq(RomanNumeral.toRoman(3779),"MMMDCCLXXIX");
		eq(RomanNumeral.toRoman(3780),"MMMDCCLXXX");
		eq(RomanNumeral.toRoman(3781),"MMMDCCLXXXI");
		eq(RomanNumeral.toRoman(3782),"MMMDCCLXXXII");
		eq(RomanNumeral.toRoman(3783),"MMMDCCLXXXIII");
		eq(RomanNumeral.toRoman(3784),"MMMDCCLXXXIV");
		eq(RomanNumeral.toRoman(3785),"MMMDCCLXXXV");
		eq(RomanNumeral.toRoman(3786),"MMMDCCLXXXVI");
		eq(RomanNumeral.toRoman(3787),"MMMDCCLXXXVII");
		eq(RomanNumeral.toRoman(3788),"MMMDCCLXXXVIII");
		eq(RomanNumeral.toRoman(3789),"MMMDCCLXXXIX");
		eq(RomanNumeral.toRoman(3790),"MMMDCCXC");
		eq(RomanNumeral.toRoman(3791),"MMMDCCXCI");
		eq(RomanNumeral.toRoman(3792),"MMMDCCXCII");
		eq(RomanNumeral.toRoman(3793),"MMMDCCXCIII");
		eq(RomanNumeral.toRoman(3794),"MMMDCCXCIV");
		eq(RomanNumeral.toRoman(3795),"MMMDCCXCV");
		eq(RomanNumeral.toRoman(3796),"MMMDCCXCVI");
		eq(RomanNumeral.toRoman(3797),"MMMDCCXCVII");
		eq(RomanNumeral.toRoman(3798),"MMMDCCXCVIII");
		eq(RomanNumeral.toRoman(3799),"MMMDCCXCIX");
		eq(RomanNumeral.toRoman(3800),"MMMDCCC");
		eq(RomanNumeral.toRoman(3801),"MMMDCCCI");
		eq(RomanNumeral.toRoman(3802),"MMMDCCCII");
		eq(RomanNumeral.toRoman(3803),"MMMDCCCIII");
		eq(RomanNumeral.toRoman(3804),"MMMDCCCIV");
		eq(RomanNumeral.toRoman(3805),"MMMDCCCV");
		eq(RomanNumeral.toRoman(3806),"MMMDCCCVI");
		eq(RomanNumeral.toRoman(3807),"MMMDCCCVII");
		eq(RomanNumeral.toRoman(3808),"MMMDCCCVIII");
		eq(RomanNumeral.toRoman(3809),"MMMDCCCIX");
		eq(RomanNumeral.toRoman(3810),"MMMDCCCX");
		eq(RomanNumeral.toRoman(3811),"MMMDCCCXI");
		eq(RomanNumeral.toRoman(3812),"MMMDCCCXII");
		eq(RomanNumeral.toRoman(3813),"MMMDCCCXIII");
		eq(RomanNumeral.toRoman(3814),"MMMDCCCXIV");
		eq(RomanNumeral.toRoman(3815),"MMMDCCCXV");
		eq(RomanNumeral.toRoman(3816),"MMMDCCCXVI");
		eq(RomanNumeral.toRoman(3817),"MMMDCCCXVII");
		eq(RomanNumeral.toRoman(3818),"MMMDCCCXVIII");
		eq(RomanNumeral.toRoman(3819),"MMMDCCCXIX");
		eq(RomanNumeral.toRoman(3820),"MMMDCCCXX");
		eq(RomanNumeral.toRoman(3821),"MMMDCCCXXI");
		eq(RomanNumeral.toRoman(3822),"MMMDCCCXXII");
		eq(RomanNumeral.toRoman(3823),"MMMDCCCXXIII");
		eq(RomanNumeral.toRoman(3824),"MMMDCCCXXIV");
		eq(RomanNumeral.toRoman(3825),"MMMDCCCXXV");
		eq(RomanNumeral.toRoman(3826),"MMMDCCCXXVI");
		eq(RomanNumeral.toRoman(3827),"MMMDCCCXXVII");
		eq(RomanNumeral.toRoman(3828),"MMMDCCCXXVIII");
		eq(RomanNumeral.toRoman(3829),"MMMDCCCXXIX");
		eq(RomanNumeral.toRoman(3830),"MMMDCCCXXX");
		eq(RomanNumeral.toRoman(3831),"MMMDCCCXXXI");
		eq(RomanNumeral.toRoman(3832),"MMMDCCCXXXII");
		eq(RomanNumeral.toRoman(3833),"MMMDCCCXXXIII");
		eq(RomanNumeral.toRoman(3834),"MMMDCCCXXXIV");
		eq(RomanNumeral.toRoman(3835),"MMMDCCCXXXV");
		eq(RomanNumeral.toRoman(3836),"MMMDCCCXXXVI");
		eq(RomanNumeral.toRoman(3837),"MMMDCCCXXXVII");
		eq(RomanNumeral.toRoman(3838),"MMMDCCCXXXVIII");
		eq(RomanNumeral.toRoman(3839),"MMMDCCCXXXIX");
		eq(RomanNumeral.toRoman(3840),"MMMDCCCXL");
		eq(RomanNumeral.toRoman(3841),"MMMDCCCXLI");
		eq(RomanNumeral.toRoman(3842),"MMMDCCCXLII");
		eq(RomanNumeral.toRoman(3843),"MMMDCCCXLIII");
		eq(RomanNumeral.toRoman(3844),"MMMDCCCXLIV");
		eq(RomanNumeral.toRoman(3845),"MMMDCCCXLV");
		eq(RomanNumeral.toRoman(3846),"MMMDCCCXLVI");
		eq(RomanNumeral.toRoman(3847),"MMMDCCCXLVII");
		eq(RomanNumeral.toRoman(3848),"MMMDCCCXLVIII");
		eq(RomanNumeral.toRoman(3849),"MMMDCCCXLIX");
		eq(RomanNumeral.toRoman(3850),"MMMDCCCL");
		eq(RomanNumeral.toRoman(3851),"MMMDCCCLI");
		eq(RomanNumeral.toRoman(3852),"MMMDCCCLII");
		eq(RomanNumeral.toRoman(3853),"MMMDCCCLIII");
		eq(RomanNumeral.toRoman(3854),"MMMDCCCLIV");
		eq(RomanNumeral.toRoman(3855),"MMMDCCCLV");
		eq(RomanNumeral.toRoman(3856),"MMMDCCCLVI");
		eq(RomanNumeral.toRoman(3857),"MMMDCCCLVII");
		eq(RomanNumeral.toRoman(3858),"MMMDCCCLVIII");
		eq(RomanNumeral.toRoman(3859),"MMMDCCCLIX");
		eq(RomanNumeral.toRoman(3860),"MMMDCCCLX");
		eq(RomanNumeral.toRoman(3861),"MMMDCCCLXI");
		eq(RomanNumeral.toRoman(3862),"MMMDCCCLXII");
		eq(RomanNumeral.toRoman(3863),"MMMDCCCLXIII");
		eq(RomanNumeral.toRoman(3864),"MMMDCCCLXIV");
		eq(RomanNumeral.toRoman(3865),"MMMDCCCLXV");
		eq(RomanNumeral.toRoman(3866),"MMMDCCCLXVI");
		eq(RomanNumeral.toRoman(3867),"MMMDCCCLXVII");
		eq(RomanNumeral.toRoman(3868),"MMMDCCCLXVIII");
		eq(RomanNumeral.toRoman(3869),"MMMDCCCLXIX");
		eq(RomanNumeral.toRoman(3870),"MMMDCCCLXX");
		eq(RomanNumeral.toRoman(3871),"MMMDCCCLXXI");
		eq(RomanNumeral.toRoman(3872),"MMMDCCCLXXII");
		eq(RomanNumeral.toRoman(3873),"MMMDCCCLXXIII");
		eq(RomanNumeral.toRoman(3874),"MMMDCCCLXXIV");
		eq(RomanNumeral.toRoman(3875),"MMMDCCCLXXV");
		eq(RomanNumeral.toRoman(3876),"MMMDCCCLXXVI");
		eq(RomanNumeral.toRoman(3877),"MMMDCCCLXXVII");
		eq(RomanNumeral.toRoman(3878),"MMMDCCCLXXVIII");
		eq(RomanNumeral.toRoman(3879),"MMMDCCCLXXIX");
		eq(RomanNumeral.toRoman(3880),"MMMDCCCLXXX");
		eq(RomanNumeral.toRoman(3881),"MMMDCCCLXXXI");
		eq(RomanNumeral.toRoman(3882),"MMMDCCCLXXXII");
		eq(RomanNumeral.toRoman(3883),"MMMDCCCLXXXIII");
		eq(RomanNumeral.toRoman(3884),"MMMDCCCLXXXIV");
		eq(RomanNumeral.toRoman(3885),"MMMDCCCLXXXV");
		eq(RomanNumeral.toRoman(3886),"MMMDCCCLXXXVI");
		eq(RomanNumeral.toRoman(3887),"MMMDCCCLXXXVII");
		eq(RomanNumeral.toRoman(3888),"MMMDCCCLXXXVIII");
		eq(RomanNumeral.toRoman(3889),"MMMDCCCLXXXIX");
		eq(RomanNumeral.toRoman(3890),"MMMDCCCXC");
		eq(RomanNumeral.toRoman(3891),"MMMDCCCXCI");
		eq(RomanNumeral.toRoman(3892),"MMMDCCCXCII");
		eq(RomanNumeral.toRoman(3893),"MMMDCCCXCIII");
		eq(RomanNumeral.toRoman(3894),"MMMDCCCXCIV");
		eq(RomanNumeral.toRoman(3895),"MMMDCCCXCV");
		eq(RomanNumeral.toRoman(3896),"MMMDCCCXCVI");
		eq(RomanNumeral.toRoman(3897),"MMMDCCCXCVII");
		eq(RomanNumeral.toRoman(3898),"MMMDCCCXCVIII");
		eq(RomanNumeral.toRoman(3899),"MMMDCCCXCIX");
		eq(RomanNumeral.toRoman(3900),"MMMCM");
		eq(RomanNumeral.toRoman(3901),"MMMCMI");
		eq(RomanNumeral.toRoman(3902),"MMMCMII");
		eq(RomanNumeral.toRoman(3903),"MMMCMIII");
		eq(RomanNumeral.toRoman(3904),"MMMCMIV");
		eq(RomanNumeral.toRoman(3905),"MMMCMV");
		eq(RomanNumeral.toRoman(3906),"MMMCMVI");
		eq(RomanNumeral.toRoman(3907),"MMMCMVII");
		eq(RomanNumeral.toRoman(3908),"MMMCMVIII");
		eq(RomanNumeral.toRoman(3909),"MMMCMIX");
		eq(RomanNumeral.toRoman(3910),"MMMCMX");
		eq(RomanNumeral.toRoman(3911),"MMMCMXI");
		eq(RomanNumeral.toRoman(3912),"MMMCMXII");
		eq(RomanNumeral.toRoman(3913),"MMMCMXIII");
		eq(RomanNumeral.toRoman(3914),"MMMCMXIV");
		eq(RomanNumeral.toRoman(3915),"MMMCMXV");
		eq(RomanNumeral.toRoman(3916),"MMMCMXVI");
		eq(RomanNumeral.toRoman(3917),"MMMCMXVII");
		eq(RomanNumeral.toRoman(3918),"MMMCMXVIII");
		eq(RomanNumeral.toRoman(3919),"MMMCMXIX");
		eq(RomanNumeral.toRoman(3920),"MMMCMXX");
		eq(RomanNumeral.toRoman(3921),"MMMCMXXI");
		eq(RomanNumeral.toRoman(3922),"MMMCMXXII");
		eq(RomanNumeral.toRoman(3923),"MMMCMXXIII");
		eq(RomanNumeral.toRoman(3924),"MMMCMXXIV");
		eq(RomanNumeral.toRoman(3925),"MMMCMXXV");
		eq(RomanNumeral.toRoman(3926),"MMMCMXXVI");
		eq(RomanNumeral.toRoman(3927),"MMMCMXXVII");
		eq(RomanNumeral.toRoman(3928),"MMMCMXXVIII");
		eq(RomanNumeral.toRoman(3929),"MMMCMXXIX");
		eq(RomanNumeral.toRoman(3930),"MMMCMXXX");
		eq(RomanNumeral.toRoman(3931),"MMMCMXXXI");
		eq(RomanNumeral.toRoman(3932),"MMMCMXXXII");
		eq(RomanNumeral.toRoman(3933),"MMMCMXXXIII");
		eq(RomanNumeral.toRoman(3934),"MMMCMXXXIV");
		eq(RomanNumeral.toRoman(3935),"MMMCMXXXV");
		eq(RomanNumeral.toRoman(3936),"MMMCMXXXVI");
		eq(RomanNumeral.toRoman(3937),"MMMCMXXXVII");
		eq(RomanNumeral.toRoman(3938),"MMMCMXXXVIII");
		eq(RomanNumeral.toRoman(3939),"MMMCMXXXIX");
		eq(RomanNumeral.toRoman(3940),"MMMCMXL");
		eq(RomanNumeral.toRoman(3941),"MMMCMXLI");
		eq(RomanNumeral.toRoman(3942),"MMMCMXLII");
		eq(RomanNumeral.toRoman(3943),"MMMCMXLIII");
		eq(RomanNumeral.toRoman(3944),"MMMCMXLIV");
		eq(RomanNumeral.toRoman(3945),"MMMCMXLV");
		eq(RomanNumeral.toRoman(3946),"MMMCMXLVI");
		eq(RomanNumeral.toRoman(3947),"MMMCMXLVII");
		eq(RomanNumeral.toRoman(3948),"MMMCMXLVIII");
		eq(RomanNumeral.toRoman(3949),"MMMCMXLIX");
		eq(RomanNumeral.toRoman(3950),"MMMCML");
		eq(RomanNumeral.toRoman(3951),"MMMCMLI");
		eq(RomanNumeral.toRoman(3952),"MMMCMLII");
		eq(RomanNumeral.toRoman(3953),"MMMCMLIII");
		eq(RomanNumeral.toRoman(3954),"MMMCMLIV");
		eq(RomanNumeral.toRoman(3955),"MMMCMLV");
		eq(RomanNumeral.toRoman(3956),"MMMCMLVI");
		eq(RomanNumeral.toRoman(3957),"MMMCMLVII");
		eq(RomanNumeral.toRoman(3958),"MMMCMLVIII");
		eq(RomanNumeral.toRoman(3959),"MMMCMLIX");
		eq(RomanNumeral.toRoman(3960),"MMMCMLX");
		eq(RomanNumeral.toRoman(3961),"MMMCMLXI");
		eq(RomanNumeral.toRoman(3962),"MMMCMLXII");
		eq(RomanNumeral.toRoman(3963),"MMMCMLXIII");
		eq(RomanNumeral.toRoman(3964),"MMMCMLXIV");
		eq(RomanNumeral.toRoman(3965),"MMMCMLXV");
		eq(RomanNumeral.toRoman(3966),"MMMCMLXVI");
		eq(RomanNumeral.toRoman(3967),"MMMCMLXVII");
		eq(RomanNumeral.toRoman(3968),"MMMCMLXVIII");
		eq(RomanNumeral.toRoman(3969),"MMMCMLXIX");
		eq(RomanNumeral.toRoman(3970),"MMMCMLXX");
		eq(RomanNumeral.toRoman(3971),"MMMCMLXXI");
		eq(RomanNumeral.toRoman(3972),"MMMCMLXXII");
		eq(RomanNumeral.toRoman(3973),"MMMCMLXXIII");
		eq(RomanNumeral.toRoman(3974),"MMMCMLXXIV");
		eq(RomanNumeral.toRoman(3975),"MMMCMLXXV");
		eq(RomanNumeral.toRoman(3976),"MMMCMLXXVI");
		eq(RomanNumeral.toRoman(3977),"MMMCMLXXVII");
		eq(RomanNumeral.toRoman(3978),"MMMCMLXXVIII");
		eq(RomanNumeral.toRoman(3979),"MMMCMLXXIX");
		eq(RomanNumeral.toRoman(3980),"MMMCMLXXX");
		eq(RomanNumeral.toRoman(3981),"MMMCMLXXXI");
		eq(RomanNumeral.toRoman(3982),"MMMCMLXXXII");
		eq(RomanNumeral.toRoman(3983),"MMMCMLXXXIII");
		eq(RomanNumeral.toRoman(3984),"MMMCMLXXXIV");
		eq(RomanNumeral.toRoman(3985),"MMMCMLXXXV");
		eq(RomanNumeral.toRoman(3986),"MMMCMLXXXVI");
		eq(RomanNumeral.toRoman(3987),"MMMCMLXXXVII");
		eq(RomanNumeral.toRoman(3988),"MMMCMLXXXVIII");
		eq(RomanNumeral.toRoman(3989),"MMMCMLXXXIX");
		eq(RomanNumeral.toRoman(3990),"MMMCMXC");
		eq(RomanNumeral.toRoman(3991),"MMMCMXCI");
		eq(RomanNumeral.toRoman(3992),"MMMCMXCII");
		eq(RomanNumeral.toRoman(3993),"MMMCMXCIII");
		eq(RomanNumeral.toRoman(3994),"MMMCMXCIV");
		eq(RomanNumeral.toRoman(3995),"MMMCMXCV");
		eq(RomanNumeral.toRoman(3996),"MMMCMXCVI");
		eq(RomanNumeral.toRoman(3997),"MMMCMXCVII");
		eq(RomanNumeral.toRoman(3998),"MMMCMXCVIII");
		eq(RomanNumeral.toRoman(3999),"MMMCMXCIX");
		nil(RomanNumeral.toRoman(4000));
	}

	public void testParse() {
		eq(RomanNumeral.parse(""), -1);
		eq(RomanNumeral.parse("I"),1);
		eq(RomanNumeral.parse("II"),2);
		eq(RomanNumeral.parse("III"),3);
		eq(RomanNumeral.parse("IV"),4);
		eq(RomanNumeral.parse("V"),5);
		eq(RomanNumeral.parse("VI"),6);
		eq(RomanNumeral.parse("VII"),7);
		eq(RomanNumeral.parse("VIII"),8);
		eq(RomanNumeral.parse("IX"),9);
		eq(RomanNumeral.parse("X"),10);
		eq(RomanNumeral.parse("XI"),11);
		eq(RomanNumeral.parse("XII"),12);
		eq(RomanNumeral.parse("XIII"),13);
		eq(RomanNumeral.parse("XIV"),14);
		eq(RomanNumeral.parse("XV"),15);
		eq(RomanNumeral.parse("XVI"),16);
		eq(RomanNumeral.parse("XVII"),17);
		eq(RomanNumeral.parse("XVIII"),18);
		eq(RomanNumeral.parse("XIX"),19);
		eq(RomanNumeral.parse("XX"),20);
		eq(RomanNumeral.parse("XXI"),21);
		eq(RomanNumeral.parse("XXII"),22);
		eq(RomanNumeral.parse("XXIII"),23);
		eq(RomanNumeral.parse("XXIV"),24);
		eq(RomanNumeral.parse("XXV"),25);
		eq(RomanNumeral.parse("XXVI"),26);
		eq(RomanNumeral.parse("XXVII"),27);
		eq(RomanNumeral.parse("XXVIII"),28);
		eq(RomanNumeral.parse("XXIX"),29);
		eq(RomanNumeral.parse("XXX"),30);
		eq(RomanNumeral.parse("XXXI"),31);
		eq(RomanNumeral.parse("XXXII"),32);
		eq(RomanNumeral.parse("XXXIII"),33);
		eq(RomanNumeral.parse("XXXIV"),34);
		eq(RomanNumeral.parse("XXXV"),35);
		eq(RomanNumeral.parse("XXXVI"),36);
		eq(RomanNumeral.parse("XXXVII"),37);
		eq(RomanNumeral.parse("XXXVIII"),38);
		eq(RomanNumeral.parse("XXXIX"),39);
		eq(RomanNumeral.parse("XL"),40);
		eq(RomanNumeral.parse("XLI"),41);
		eq(RomanNumeral.parse("XLII"),42);
		eq(RomanNumeral.parse("XLIII"),43);
		eq(RomanNumeral.parse("XLIV"),44);
		eq(RomanNumeral.parse("XLV"),45);
		eq(RomanNumeral.parse("XLVI"),46);
		eq(RomanNumeral.parse("XLVII"),47);
		eq(RomanNumeral.parse("XLVIII"),48);
		eq(RomanNumeral.parse("XLIX"),49);
		eq(RomanNumeral.parse("L"),50);
		eq(RomanNumeral.parse("LI"),51);
		eq(RomanNumeral.parse("LII"),52);
		eq(RomanNumeral.parse("LIII"),53);
		eq(RomanNumeral.parse("LIV"),54);
		eq(RomanNumeral.parse("LV"),55);
		eq(RomanNumeral.parse("LVI"),56);
		eq(RomanNumeral.parse("LVII"),57);
		eq(RomanNumeral.parse("LVIII"),58);
		eq(RomanNumeral.parse("LIX"),59);
		eq(RomanNumeral.parse("LX"),60);
		eq(RomanNumeral.parse("LXI"),61);
		eq(RomanNumeral.parse("LXII"),62);
		eq(RomanNumeral.parse("LXIII"),63);
		eq(RomanNumeral.parse("LXIV"),64);
		eq(RomanNumeral.parse("LXV"),65);
		eq(RomanNumeral.parse("LXVI"),66);
		eq(RomanNumeral.parse("LXVII"),67);
		eq(RomanNumeral.parse("LXVIII"),68);
		eq(RomanNumeral.parse("LXIX"),69);
		eq(RomanNumeral.parse("LXX"),70);
		eq(RomanNumeral.parse("LXXI"),71);
		eq(RomanNumeral.parse("LXXII"),72);
		eq(RomanNumeral.parse("LXXIII"),73);
		eq(RomanNumeral.parse("LXXIV"),74);
		eq(RomanNumeral.parse("LXXV"),75);
		eq(RomanNumeral.parse("LXXVI"),76);
		eq(RomanNumeral.parse("LXXVII"),77);
		eq(RomanNumeral.parse("LXXVIII"),78);
		eq(RomanNumeral.parse("LXXIX"),79);
		eq(RomanNumeral.parse("LXXX"),80);
		eq(RomanNumeral.parse("LXXXI"),81);
		eq(RomanNumeral.parse("LXXXII"),82);
		eq(RomanNumeral.parse("LXXXIII"),83);
		eq(RomanNumeral.parse("LXXXIV"),84);
		eq(RomanNumeral.parse("LXXXV"),85);
		eq(RomanNumeral.parse("LXXXVI"),86);
		eq(RomanNumeral.parse("LXXXVII"),87);
		eq(RomanNumeral.parse("LXXXVIII"),88);
		eq(RomanNumeral.parse("LXXXIX"),89);
		eq(RomanNumeral.parse("XC"),90);
		eq(RomanNumeral.parse("XCI"),91);
		eq(RomanNumeral.parse("XCII"),92);
		eq(RomanNumeral.parse("XCIII"),93);
		eq(RomanNumeral.parse("XCIV"),94);
		eq(RomanNumeral.parse("XCV"),95);
		eq(RomanNumeral.parse("XCVI"),96);
		eq(RomanNumeral.parse("XCVII"),97);
		eq(RomanNumeral.parse("XCVIII"),98);
		eq(RomanNumeral.parse("XCIX"),99);
		eq(RomanNumeral.parse("C"),100);
		eq(RomanNumeral.parse("CI"),101);
		eq(RomanNumeral.parse("CII"),102);
		eq(RomanNumeral.parse("CIII"),103);
		eq(RomanNumeral.parse("CIV"),104);
		eq(RomanNumeral.parse("CV"),105);
		eq(RomanNumeral.parse("CVI"),106);
		eq(RomanNumeral.parse("CVII"),107);
		eq(RomanNumeral.parse("CVIII"),108);
		eq(RomanNumeral.parse("CIX"),109);
		eq(RomanNumeral.parse("CX"),110);
		eq(RomanNumeral.parse("CXI"),111);
		eq(RomanNumeral.parse("CXII"),112);
		eq(RomanNumeral.parse("CXIII"),113);
		eq(RomanNumeral.parse("CXIV"),114);
		eq(RomanNumeral.parse("CXV"),115);
		eq(RomanNumeral.parse("CXVI"),116);
		eq(RomanNumeral.parse("CXVII"),117);
		eq(RomanNumeral.parse("CXVIII"),118);
		eq(RomanNumeral.parse("CXIX"),119);
		eq(RomanNumeral.parse("CXX"),120);
		eq(RomanNumeral.parse("CXXI"),121);
		eq(RomanNumeral.parse("CXXII"),122);
		eq(RomanNumeral.parse("CXXIII"),123);
		eq(RomanNumeral.parse("CXXIV"),124);
		eq(RomanNumeral.parse("CXXV"),125);
		eq(RomanNumeral.parse("CXXVI"),126);
		eq(RomanNumeral.parse("CXXVII"),127);
		eq(RomanNumeral.parse("CXXVIII"),128);
		eq(RomanNumeral.parse("CXXIX"),129);
		eq(RomanNumeral.parse("CXXX"),130);
		eq(RomanNumeral.parse("CXXXI"),131);
		eq(RomanNumeral.parse("CXXXII"),132);
		eq(RomanNumeral.parse("CXXXIII"),133);
		eq(RomanNumeral.parse("CXXXIV"),134);
		eq(RomanNumeral.parse("CXXXV"),135);
		eq(RomanNumeral.parse("CXXXVI"),136);
		eq(RomanNumeral.parse("CXXXVII"),137);
		eq(RomanNumeral.parse("CXXXVIII"),138);
		eq(RomanNumeral.parse("CXXXIX"),139);
		eq(RomanNumeral.parse("CXL"),140);
		eq(RomanNumeral.parse("CXLI"),141);
		eq(RomanNumeral.parse("CXLII"),142);
		eq(RomanNumeral.parse("CXLIII"),143);
		eq(RomanNumeral.parse("CXLIV"),144);
		eq(RomanNumeral.parse("CXLV"),145);
		eq(RomanNumeral.parse("CXLVI"),146);
		eq(RomanNumeral.parse("CXLVII"),147);
		eq(RomanNumeral.parse("CXLVIII"),148);
		eq(RomanNumeral.parse("CXLIX"),149);
		eq(RomanNumeral.parse("CL"),150);
		eq(RomanNumeral.parse("CLI"),151);
		eq(RomanNumeral.parse("CLII"),152);
		eq(RomanNumeral.parse("CLIII"),153);
		eq(RomanNumeral.parse("CLIV"),154);
		eq(RomanNumeral.parse("CLV"),155);
		eq(RomanNumeral.parse("CLVI"),156);
		eq(RomanNumeral.parse("CLVII"),157);
		eq(RomanNumeral.parse("CLVIII"),158);
		eq(RomanNumeral.parse("CLIX"),159);
		eq(RomanNumeral.parse("CLX"),160);
		eq(RomanNumeral.parse("CLXI"),161);
		eq(RomanNumeral.parse("CLXII"),162);
		eq(RomanNumeral.parse("CLXIII"),163);
		eq(RomanNumeral.parse("CLXIV"),164);
		eq(RomanNumeral.parse("CLXV"),165);
		eq(RomanNumeral.parse("CLXVI"),166);
		eq(RomanNumeral.parse("CLXVII"),167);
		eq(RomanNumeral.parse("CLXVIII"),168);
		eq(RomanNumeral.parse("CLXIX"),169);
		eq(RomanNumeral.parse("CLXX"),170);
		eq(RomanNumeral.parse("CLXXI"),171);
		eq(RomanNumeral.parse("CLXXII"),172);
		eq(RomanNumeral.parse("CLXXIII"),173);
		eq(RomanNumeral.parse("CLXXIV"),174);
		eq(RomanNumeral.parse("CLXXV"),175);
		eq(RomanNumeral.parse("CLXXVI"),176);
		eq(RomanNumeral.parse("CLXXVII"),177);
		eq(RomanNumeral.parse("CLXXVIII"),178);
		eq(RomanNumeral.parse("CLXXIX"),179);
		eq(RomanNumeral.parse("CLXXX"),180);
		eq(RomanNumeral.parse("CLXXXI"),181);
		eq(RomanNumeral.parse("CLXXXII"),182);
		eq(RomanNumeral.parse("CLXXXIII"),183);
		eq(RomanNumeral.parse("CLXXXIV"),184);
		eq(RomanNumeral.parse("CLXXXV"),185);
		eq(RomanNumeral.parse("CLXXXVI"),186);
		eq(RomanNumeral.parse("CLXXXVII"),187);
		eq(RomanNumeral.parse("CLXXXVIII"),188);
		eq(RomanNumeral.parse("CLXXXIX"),189);
		eq(RomanNumeral.parse("CXC"),190);
		eq(RomanNumeral.parse("CXCI"),191);
		eq(RomanNumeral.parse("CXCII"),192);
		eq(RomanNumeral.parse("CXCIII"),193);
		eq(RomanNumeral.parse("CXCIV"),194);
		eq(RomanNumeral.parse("CXCV"),195);
		eq(RomanNumeral.parse("CXCVI"),196);
		eq(RomanNumeral.parse("CXCVII"),197);
		eq(RomanNumeral.parse("CXCVIII"),198);
		eq(RomanNumeral.parse("CXCIX"),199);
		eq(RomanNumeral.parse("CC"),200);
		eq(RomanNumeral.parse("CCI"),201);
		eq(RomanNumeral.parse("CCII"),202);
		eq(RomanNumeral.parse("CCIII"),203);
		eq(RomanNumeral.parse("CCIV"),204);
		eq(RomanNumeral.parse("CCV"),205);
		eq(RomanNumeral.parse("CCVI"),206);
		eq(RomanNumeral.parse("CCVII"),207);
		eq(RomanNumeral.parse("CCVIII"),208);
		eq(RomanNumeral.parse("CCIX"),209);
		eq(RomanNumeral.parse("CCX"),210);
		eq(RomanNumeral.parse("CCXI"),211);
		eq(RomanNumeral.parse("CCXII"),212);
		eq(RomanNumeral.parse("CCXIII"),213);
		eq(RomanNumeral.parse("CCXIV"),214);
		eq(RomanNumeral.parse("CCXV"),215);
		eq(RomanNumeral.parse("CCXVI"),216);
		eq(RomanNumeral.parse("CCXVII"),217);
		eq(RomanNumeral.parse("CCXVIII"),218);
		eq(RomanNumeral.parse("CCXIX"),219);
		eq(RomanNumeral.parse("CCXX"),220);
		eq(RomanNumeral.parse("CCXXI"),221);
		eq(RomanNumeral.parse("CCXXII"),222);
		eq(RomanNumeral.parse("CCXXIII"),223);
		eq(RomanNumeral.parse("CCXXIV"),224);
		eq(RomanNumeral.parse("CCXXV"),225);
		eq(RomanNumeral.parse("CCXXVI"),226);
		eq(RomanNumeral.parse("CCXXVII"),227);
		eq(RomanNumeral.parse("CCXXVIII"),228);
		eq(RomanNumeral.parse("CCXXIX"),229);
		eq(RomanNumeral.parse("CCXXX"),230);
		eq(RomanNumeral.parse("CCXXXI"),231);
		eq(RomanNumeral.parse("CCXXXII"),232);
		eq(RomanNumeral.parse("CCXXXIII"),233);
		eq(RomanNumeral.parse("CCXXXIV"),234);
		eq(RomanNumeral.parse("CCXXXV"),235);
		eq(RomanNumeral.parse("CCXXXVI"),236);
		eq(RomanNumeral.parse("CCXXXVII"),237);
		eq(RomanNumeral.parse("CCXXXVIII"),238);
		eq(RomanNumeral.parse("CCXXXIX"),239);
		eq(RomanNumeral.parse("CCXL"),240);
		eq(RomanNumeral.parse("CCXLI"),241);
		eq(RomanNumeral.parse("CCXLII"),242);
		eq(RomanNumeral.parse("CCXLIII"),243);
		eq(RomanNumeral.parse("CCXLIV"),244);
		eq(RomanNumeral.parse("CCXLV"),245);
		eq(RomanNumeral.parse("CCXLVI"),246);
		eq(RomanNumeral.parse("CCXLVII"),247);
		eq(RomanNumeral.parse("CCXLVIII"),248);
		eq(RomanNumeral.parse("CCXLIX"),249);
		eq(RomanNumeral.parse("CCL"),250);
		eq(RomanNumeral.parse("CCLI"),251);
		eq(RomanNumeral.parse("CCLII"),252);
		eq(RomanNumeral.parse("CCLIII"),253);
		eq(RomanNumeral.parse("CCLIV"),254);
		eq(RomanNumeral.parse("CCLV"),255);
		eq(RomanNumeral.parse("CCLVI"),256);
		eq(RomanNumeral.parse("CCLVII"),257);
		eq(RomanNumeral.parse("CCLVIII"),258);
		eq(RomanNumeral.parse("CCLIX"),259);
		eq(RomanNumeral.parse("CCLX"),260);
		eq(RomanNumeral.parse("CCLXI"),261);
		eq(RomanNumeral.parse("CCLXII"),262);
		eq(RomanNumeral.parse("CCLXIII"),263);
		eq(RomanNumeral.parse("CCLXIV"),264);
		eq(RomanNumeral.parse("CCLXV"),265);
		eq(RomanNumeral.parse("CCLXVI"),266);
		eq(RomanNumeral.parse("CCLXVII"),267);
		eq(RomanNumeral.parse("CCLXVIII"),268);
		eq(RomanNumeral.parse("CCLXIX"),269);
		eq(RomanNumeral.parse("CCLXX"),270);
		eq(RomanNumeral.parse("CCLXXI"),271);
		eq(RomanNumeral.parse("CCLXXII"),272);
		eq(RomanNumeral.parse("CCLXXIII"),273);
		eq(RomanNumeral.parse("CCLXXIV"),274);
		eq(RomanNumeral.parse("CCLXXV"),275);
		eq(RomanNumeral.parse("CCLXXVI"),276);
		eq(RomanNumeral.parse("CCLXXVII"),277);
		eq(RomanNumeral.parse("CCLXXVIII"),278);
		eq(RomanNumeral.parse("CCLXXIX"),279);
		eq(RomanNumeral.parse("CCLXXX"),280);
		eq(RomanNumeral.parse("CCLXXXI"),281);
		eq(RomanNumeral.parse("CCLXXXII"),282);
		eq(RomanNumeral.parse("CCLXXXIII"),283);
		eq(RomanNumeral.parse("CCLXXXIV"),284);
		eq(RomanNumeral.parse("CCLXXXV"),285);
		eq(RomanNumeral.parse("CCLXXXVI"),286);
		eq(RomanNumeral.parse("CCLXXXVII"),287);
		eq(RomanNumeral.parse("CCLXXXVIII"),288);
		eq(RomanNumeral.parse("CCLXXXIX"),289);
		eq(RomanNumeral.parse("CCXC"),290);
		eq(RomanNumeral.parse("CCXCI"),291);
		eq(RomanNumeral.parse("CCXCII"),292);
		eq(RomanNumeral.parse("CCXCIII"),293);
		eq(RomanNumeral.parse("CCXCIV"),294);
		eq(RomanNumeral.parse("CCXCV"),295);
		eq(RomanNumeral.parse("CCXCVI"),296);
		eq(RomanNumeral.parse("CCXCVII"),297);
		eq(RomanNumeral.parse("CCXCVIII"),298);
		eq(RomanNumeral.parse("CCXCIX"),299);
		eq(RomanNumeral.parse("CCC"),300);
		eq(RomanNumeral.parse("CCCI"),301);
		eq(RomanNumeral.parse("CCCII"),302);
		eq(RomanNumeral.parse("CCCIII"),303);
		eq(RomanNumeral.parse("CCCIV"),304);
		eq(RomanNumeral.parse("CCCV"),305);
		eq(RomanNumeral.parse("CCCVI"),306);
		eq(RomanNumeral.parse("CCCVII"),307);
		eq(RomanNumeral.parse("CCCVIII"),308);
		eq(RomanNumeral.parse("CCCIX"),309);
		eq(RomanNumeral.parse("CCCX"),310);
		eq(RomanNumeral.parse("CCCXI"),311);
		eq(RomanNumeral.parse("CCCXII"),312);
		eq(RomanNumeral.parse("CCCXIII"),313);
		eq(RomanNumeral.parse("CCCXIV"),314);
		eq(RomanNumeral.parse("CCCXV"),315);
		eq(RomanNumeral.parse("CCCXVI"),316);
		eq(RomanNumeral.parse("CCCXVII"),317);
		eq(RomanNumeral.parse("CCCXVIII"),318);
		eq(RomanNumeral.parse("CCCXIX"),319);
		eq(RomanNumeral.parse("CCCXX"),320);
		eq(RomanNumeral.parse("CCCXXI"),321);
		eq(RomanNumeral.parse("CCCXXII"),322);
		eq(RomanNumeral.parse("CCCXXIII"),323);
		eq(RomanNumeral.parse("CCCXXIV"),324);
		eq(RomanNumeral.parse("CCCXXV"),325);
		eq(RomanNumeral.parse("CCCXXVI"),326);
		eq(RomanNumeral.parse("CCCXXVII"),327);
		eq(RomanNumeral.parse("CCCXXVIII"),328);
		eq(RomanNumeral.parse("CCCXXIX"),329);
		eq(RomanNumeral.parse("CCCXXX"),330);
		eq(RomanNumeral.parse("CCCXXXI"),331);
		eq(RomanNumeral.parse("CCCXXXII"),332);
		eq(RomanNumeral.parse("CCCXXXIII"),333);
		eq(RomanNumeral.parse("CCCXXXIV"),334);
		eq(RomanNumeral.parse("CCCXXXV"),335);
		eq(RomanNumeral.parse("CCCXXXVI"),336);
		eq(RomanNumeral.parse("CCCXXXVII"),337);
		eq(RomanNumeral.parse("CCCXXXVIII"),338);
		eq(RomanNumeral.parse("CCCXXXIX"),339);
		eq(RomanNumeral.parse("CCCXL"),340);
		eq(RomanNumeral.parse("CCCXLI"),341);
		eq(RomanNumeral.parse("CCCXLII"),342);
		eq(RomanNumeral.parse("CCCXLIII"),343);
		eq(RomanNumeral.parse("CCCXLIV"),344);
		eq(RomanNumeral.parse("CCCXLV"),345);
		eq(RomanNumeral.parse("CCCXLVI"),346);
		eq(RomanNumeral.parse("CCCXLVII"),347);
		eq(RomanNumeral.parse("CCCXLVIII"),348);
		eq(RomanNumeral.parse("CCCXLIX"),349);
		eq(RomanNumeral.parse("CCCL"),350);
		eq(RomanNumeral.parse("CCCLI"),351);
		eq(RomanNumeral.parse("CCCLII"),352);
		eq(RomanNumeral.parse("CCCLIII"),353);
		eq(RomanNumeral.parse("CCCLIV"),354);
		eq(RomanNumeral.parse("CCCLV"),355);
		eq(RomanNumeral.parse("CCCLVI"),356);
		eq(RomanNumeral.parse("CCCLVII"),357);
		eq(RomanNumeral.parse("CCCLVIII"),358);
		eq(RomanNumeral.parse("CCCLIX"),359);
		eq(RomanNumeral.parse("CCCLX"),360);
		eq(RomanNumeral.parse("CCCLXI"),361);
		eq(RomanNumeral.parse("CCCLXII"),362);
		eq(RomanNumeral.parse("CCCLXIII"),363);
		eq(RomanNumeral.parse("CCCLXIV"),364);
		eq(RomanNumeral.parse("CCCLXV"),365);
		eq(RomanNumeral.parse("CCCLXVI"),366);
		eq(RomanNumeral.parse("CCCLXVII"),367);
		eq(RomanNumeral.parse("CCCLXVIII"),368);
		eq(RomanNumeral.parse("CCCLXIX"),369);
		eq(RomanNumeral.parse("CCCLXX"),370);
		eq(RomanNumeral.parse("CCCLXXI"),371);
		eq(RomanNumeral.parse("CCCLXXII"),372);
		eq(RomanNumeral.parse("CCCLXXIII"),373);
		eq(RomanNumeral.parse("CCCLXXIV"),374);
		eq(RomanNumeral.parse("CCCLXXV"),375);
		eq(RomanNumeral.parse("CCCLXXVI"),376);
		eq(RomanNumeral.parse("CCCLXXVII"),377);
		eq(RomanNumeral.parse("CCCLXXVIII"),378);
		eq(RomanNumeral.parse("CCCLXXIX"),379);
		eq(RomanNumeral.parse("CCCLXXX"),380);
		eq(RomanNumeral.parse("CCCLXXXI"),381);
		eq(RomanNumeral.parse("CCCLXXXII"),382);
		eq(RomanNumeral.parse("CCCLXXXIII"),383);
		eq(RomanNumeral.parse("CCCLXXXIV"),384);
		eq(RomanNumeral.parse("CCCLXXXV"),385);
		eq(RomanNumeral.parse("CCCLXXXVI"),386);
		eq(RomanNumeral.parse("CCCLXXXVII"),387);
		eq(RomanNumeral.parse("CCCLXXXVIII"),388);
		eq(RomanNumeral.parse("CCCLXXXIX"),389);
		eq(RomanNumeral.parse("CCCXC"),390);
		eq(RomanNumeral.parse("CCCXCI"),391);
		eq(RomanNumeral.parse("CCCXCII"),392);
		eq(RomanNumeral.parse("CCCXCIII"),393);
		eq(RomanNumeral.parse("CCCXCIV"),394);
		eq(RomanNumeral.parse("CCCXCV"),395);
		eq(RomanNumeral.parse("CCCXCVI"),396);
		eq(RomanNumeral.parse("CCCXCVII"),397);
		eq(RomanNumeral.parse("CCCXCVIII"),398);
		eq(RomanNumeral.parse("CCCXCIX"),399);
		eq(RomanNumeral.parse("CD"),400);
		eq(RomanNumeral.parse("CDI"),401);
		eq(RomanNumeral.parse("CDII"),402);
		eq(RomanNumeral.parse("CDIII"),403);
		eq(RomanNumeral.parse("CDIV"),404);
		eq(RomanNumeral.parse("CDV"),405);
		eq(RomanNumeral.parse("CDVI"),406);
		eq(RomanNumeral.parse("CDVII"),407);
		eq(RomanNumeral.parse("CDVIII"),408);
		eq(RomanNumeral.parse("CDIX"),409);
		eq(RomanNumeral.parse("CDX"),410);
		eq(RomanNumeral.parse("CDXI"),411);
		eq(RomanNumeral.parse("CDXII"),412);
		eq(RomanNumeral.parse("CDXIII"),413);
		eq(RomanNumeral.parse("CDXIV"),414);
		eq(RomanNumeral.parse("CDXV"),415);
		eq(RomanNumeral.parse("CDXVI"),416);
		eq(RomanNumeral.parse("CDXVII"),417);
		eq(RomanNumeral.parse("CDXVIII"),418);
		eq(RomanNumeral.parse("CDXIX"),419);
		eq(RomanNumeral.parse("CDXX"),420);
		eq(RomanNumeral.parse("CDXXI"),421);
		eq(RomanNumeral.parse("CDXXII"),422);
		eq(RomanNumeral.parse("CDXXIII"),423);
		eq(RomanNumeral.parse("CDXXIV"),424);
		eq(RomanNumeral.parse("CDXXV"),425);
		eq(RomanNumeral.parse("CDXXVI"),426);
		eq(RomanNumeral.parse("CDXXVII"),427);
		eq(RomanNumeral.parse("CDXXVIII"),428);
		eq(RomanNumeral.parse("CDXXIX"),429);
		eq(RomanNumeral.parse("CDXXX"),430);
		eq(RomanNumeral.parse("CDXXXI"),431);
		eq(RomanNumeral.parse("CDXXXII"),432);
		eq(RomanNumeral.parse("CDXXXIII"),433);
		eq(RomanNumeral.parse("CDXXXIV"),434);
		eq(RomanNumeral.parse("CDXXXV"),435);
		eq(RomanNumeral.parse("CDXXXVI"),436);
		eq(RomanNumeral.parse("CDXXXVII"),437);
		eq(RomanNumeral.parse("CDXXXVIII"),438);
		eq(RomanNumeral.parse("CDXXXIX"),439);
		eq(RomanNumeral.parse("CDXL"),440);
		eq(RomanNumeral.parse("CDXLI"),441);
		eq(RomanNumeral.parse("CDXLII"),442);
		eq(RomanNumeral.parse("CDXLIII"),443);
		eq(RomanNumeral.parse("CDXLIV"),444);
		eq(RomanNumeral.parse("CDXLV"),445);
		eq(RomanNumeral.parse("CDXLVI"),446);
		eq(RomanNumeral.parse("CDXLVII"),447);
		eq(RomanNumeral.parse("CDXLVIII"),448);
		eq(RomanNumeral.parse("CDXLIX"),449);
		eq(RomanNumeral.parse("CDL"),450);
		eq(RomanNumeral.parse("CDLI"),451);
		eq(RomanNumeral.parse("CDLII"),452);
		eq(RomanNumeral.parse("CDLIII"),453);
		eq(RomanNumeral.parse("CDLIV"),454);
		eq(RomanNumeral.parse("CDLV"),455);
		eq(RomanNumeral.parse("CDLVI"),456);
		eq(RomanNumeral.parse("CDLVII"),457);
		eq(RomanNumeral.parse("CDLVIII"),458);
		eq(RomanNumeral.parse("CDLIX"),459);
		eq(RomanNumeral.parse("CDLX"),460);
		eq(RomanNumeral.parse("CDLXI"),461);
		eq(RomanNumeral.parse("CDLXII"),462);
		eq(RomanNumeral.parse("CDLXIII"),463);
		eq(RomanNumeral.parse("CDLXIV"),464);
		eq(RomanNumeral.parse("CDLXV"),465);
		eq(RomanNumeral.parse("CDLXVI"),466);
		eq(RomanNumeral.parse("CDLXVII"),467);
		eq(RomanNumeral.parse("CDLXVIII"),468);
		eq(RomanNumeral.parse("CDLXIX"),469);
		eq(RomanNumeral.parse("CDLXX"),470);
		eq(RomanNumeral.parse("CDLXXI"),471);
		eq(RomanNumeral.parse("CDLXXII"),472);
		eq(RomanNumeral.parse("CDLXXIII"),473);
		eq(RomanNumeral.parse("CDLXXIV"),474);
		eq(RomanNumeral.parse("CDLXXV"),475);
		eq(RomanNumeral.parse("CDLXXVI"),476);
		eq(RomanNumeral.parse("CDLXXVII"),477);
		eq(RomanNumeral.parse("CDLXXVIII"),478);
		eq(RomanNumeral.parse("CDLXXIX"),479);
		eq(RomanNumeral.parse("CDLXXX"),480);
		eq(RomanNumeral.parse("CDLXXXI"),481);
		eq(RomanNumeral.parse("CDLXXXII"),482);
		eq(RomanNumeral.parse("CDLXXXIII"),483);
		eq(RomanNumeral.parse("CDLXXXIV"),484);
		eq(RomanNumeral.parse("CDLXXXV"),485);
		eq(RomanNumeral.parse("CDLXXXVI"),486);
		eq(RomanNumeral.parse("CDLXXXVII"),487);
		eq(RomanNumeral.parse("CDLXXXVIII"),488);
		eq(RomanNumeral.parse("CDLXXXIX"),489);
		eq(RomanNumeral.parse("CDXC"),490);
		eq(RomanNumeral.parse("CDXCI"),491);
		eq(RomanNumeral.parse("CDXCII"),492);
		eq(RomanNumeral.parse("CDXCIII"),493);
		eq(RomanNumeral.parse("CDXCIV"),494);
		eq(RomanNumeral.parse("CDXCV"),495);
		eq(RomanNumeral.parse("CDXCVI"),496);
		eq(RomanNumeral.parse("CDXCVII"),497);
		eq(RomanNumeral.parse("CDXCVIII"),498);
		eq(RomanNumeral.parse("CDXCIX"),499);
		eq(RomanNumeral.parse("D"),500);
		eq(RomanNumeral.parse("DI"),501);
		eq(RomanNumeral.parse("DII"),502);
		eq(RomanNumeral.parse("DIII"),503);
		eq(RomanNumeral.parse("DIV"),504);
		eq(RomanNumeral.parse("DV"),505);
		eq(RomanNumeral.parse("DVI"),506);
		eq(RomanNumeral.parse("DVII"),507);
		eq(RomanNumeral.parse("DVIII"),508);
		eq(RomanNumeral.parse("DIX"),509);
		eq(RomanNumeral.parse("DX"),510);
		eq(RomanNumeral.parse("DXI"),511);
		eq(RomanNumeral.parse("DXII"),512);
		eq(RomanNumeral.parse("DXIII"),513);
		eq(RomanNumeral.parse("DXIV"),514);
		eq(RomanNumeral.parse("DXV"),515);
		eq(RomanNumeral.parse("DXVI"),516);
		eq(RomanNumeral.parse("DXVII"),517);
		eq(RomanNumeral.parse("DXVIII"),518);
		eq(RomanNumeral.parse("DXIX"),519);
		eq(RomanNumeral.parse("DXX"),520);
		eq(RomanNumeral.parse("DXXI"),521);
		eq(RomanNumeral.parse("DXXII"),522);
		eq(RomanNumeral.parse("DXXIII"),523);
		eq(RomanNumeral.parse("DXXIV"),524);
		eq(RomanNumeral.parse("DXXV"),525);
		eq(RomanNumeral.parse("DXXVI"),526);
		eq(RomanNumeral.parse("DXXVII"),527);
		eq(RomanNumeral.parse("DXXVIII"),528);
		eq(RomanNumeral.parse("DXXIX"),529);
		eq(RomanNumeral.parse("DXXX"),530);
		eq(RomanNumeral.parse("DXXXI"),531);
		eq(RomanNumeral.parse("DXXXII"),532);
		eq(RomanNumeral.parse("DXXXIII"),533);
		eq(RomanNumeral.parse("DXXXIV"),534);
		eq(RomanNumeral.parse("DXXXV"),535);
		eq(RomanNumeral.parse("DXXXVI"),536);
		eq(RomanNumeral.parse("DXXXVII"),537);
		eq(RomanNumeral.parse("DXXXVIII"),538);
		eq(RomanNumeral.parse("DXXXIX"),539);
		eq(RomanNumeral.parse("DXL"),540);
		eq(RomanNumeral.parse("DXLI"),541);
		eq(RomanNumeral.parse("DXLII"),542);
		eq(RomanNumeral.parse("DXLIII"),543);
		eq(RomanNumeral.parse("DXLIV"),544);
		eq(RomanNumeral.parse("DXLV"),545);
		eq(RomanNumeral.parse("DXLVI"),546);
		eq(RomanNumeral.parse("DXLVII"),547);
		eq(RomanNumeral.parse("DXLVIII"),548);
		eq(RomanNumeral.parse("DXLIX"),549);
		eq(RomanNumeral.parse("DL"),550);
		eq(RomanNumeral.parse("DLI"),551);
		eq(RomanNumeral.parse("DLII"),552);
		eq(RomanNumeral.parse("DLIII"),553);
		eq(RomanNumeral.parse("DLIV"),554);
		eq(RomanNumeral.parse("DLV"),555);
		eq(RomanNumeral.parse("DLVI"),556);
		eq(RomanNumeral.parse("DLVII"),557);
		eq(RomanNumeral.parse("DLVIII"),558);
		eq(RomanNumeral.parse("DLIX"),559);
		eq(RomanNumeral.parse("DLX"),560);
		eq(RomanNumeral.parse("DLXI"),561);
		eq(RomanNumeral.parse("DLXII"),562);
		eq(RomanNumeral.parse("DLXIII"),563);
		eq(RomanNumeral.parse("DLXIV"),564);
		eq(RomanNumeral.parse("DLXV"),565);
		eq(RomanNumeral.parse("DLXVI"),566);
		eq(RomanNumeral.parse("DLXVII"),567);
		eq(RomanNumeral.parse("DLXVIII"),568);
		eq(RomanNumeral.parse("DLXIX"),569);
		eq(RomanNumeral.parse("DLXX"),570);
		eq(RomanNumeral.parse("DLXXI"),571);
		eq(RomanNumeral.parse("DLXXII"),572);
		eq(RomanNumeral.parse("DLXXIII"),573);
		eq(RomanNumeral.parse("DLXXIV"),574);
		eq(RomanNumeral.parse("DLXXV"),575);
		eq(RomanNumeral.parse("DLXXVI"),576);
		eq(RomanNumeral.parse("DLXXVII"),577);
		eq(RomanNumeral.parse("DLXXVIII"),578);
		eq(RomanNumeral.parse("DLXXIX"),579);
		eq(RomanNumeral.parse("DLXXX"),580);
		eq(RomanNumeral.parse("DLXXXI"),581);
		eq(RomanNumeral.parse("DLXXXII"),582);
		eq(RomanNumeral.parse("DLXXXIII"),583);
		eq(RomanNumeral.parse("DLXXXIV"),584);
		eq(RomanNumeral.parse("DLXXXV"),585);
		eq(RomanNumeral.parse("DLXXXVI"),586);
		eq(RomanNumeral.parse("DLXXXVII"),587);
		eq(RomanNumeral.parse("DLXXXVIII"),588);
		eq(RomanNumeral.parse("DLXXXIX"),589);
		eq(RomanNumeral.parse("DXC"),590);
		eq(RomanNumeral.parse("DXCI"),591);
		eq(RomanNumeral.parse("DXCII"),592);
		eq(RomanNumeral.parse("DXCIII"),593);
		eq(RomanNumeral.parse("DXCIV"),594);
		eq(RomanNumeral.parse("DXCV"),595);
		eq(RomanNumeral.parse("DXCVI"),596);
		eq(RomanNumeral.parse("DXCVII"),597);
		eq(RomanNumeral.parse("DXCVIII"),598);
		eq(RomanNumeral.parse("DXCIX"),599);
		eq(RomanNumeral.parse("DC"),600);
		eq(RomanNumeral.parse("DCI"),601);
		eq(RomanNumeral.parse("DCII"),602);
		eq(RomanNumeral.parse("DCIII"),603);
		eq(RomanNumeral.parse("DCIV"),604);
		eq(RomanNumeral.parse("DCV"),605);
		eq(RomanNumeral.parse("DCVI"),606);
		eq(RomanNumeral.parse("DCVII"),607);
		eq(RomanNumeral.parse("DCVIII"),608);
		eq(RomanNumeral.parse("DCIX"),609);
		eq(RomanNumeral.parse("DCX"),610);
		eq(RomanNumeral.parse("DCXI"),611);
		eq(RomanNumeral.parse("DCXII"),612);
		eq(RomanNumeral.parse("DCXIII"),613);
		eq(RomanNumeral.parse("DCXIV"),614);
		eq(RomanNumeral.parse("DCXV"),615);
		eq(RomanNumeral.parse("DCXVI"),616);
		eq(RomanNumeral.parse("DCXVII"),617);
		eq(RomanNumeral.parse("DCXVIII"),618);
		eq(RomanNumeral.parse("DCXIX"),619);
		eq(RomanNumeral.parse("DCXX"),620);
		eq(RomanNumeral.parse("DCXXI"),621);
		eq(RomanNumeral.parse("DCXXII"),622);
		eq(RomanNumeral.parse("DCXXIII"),623);
		eq(RomanNumeral.parse("DCXXIV"),624);
		eq(RomanNumeral.parse("DCXXV"),625);
		eq(RomanNumeral.parse("DCXXVI"),626);
		eq(RomanNumeral.parse("DCXXVII"),627);
		eq(RomanNumeral.parse("DCXXVIII"),628);
		eq(RomanNumeral.parse("DCXXIX"),629);
		eq(RomanNumeral.parse("DCXXX"),630);
		eq(RomanNumeral.parse("DCXXXI"),631);
		eq(RomanNumeral.parse("DCXXXII"),632);
		eq(RomanNumeral.parse("DCXXXIII"),633);
		eq(RomanNumeral.parse("DCXXXIV"),634);
		eq(RomanNumeral.parse("DCXXXV"),635);
		eq(RomanNumeral.parse("DCXXXVI"),636);
		eq(RomanNumeral.parse("DCXXXVII"),637);
		eq(RomanNumeral.parse("DCXXXVIII"),638);
		eq(RomanNumeral.parse("DCXXXIX"),639);
		eq(RomanNumeral.parse("DCXL"),640);
		eq(RomanNumeral.parse("DCXLI"),641);
		eq(RomanNumeral.parse("DCXLII"),642);
		eq(RomanNumeral.parse("DCXLIII"),643);
		eq(RomanNumeral.parse("DCXLIV"),644);
		eq(RomanNumeral.parse("DCXLV"),645);
		eq(RomanNumeral.parse("DCXLVI"),646);
		eq(RomanNumeral.parse("DCXLVII"),647);
		eq(RomanNumeral.parse("DCXLVIII"),648);
		eq(RomanNumeral.parse("DCXLIX"),649);
		eq(RomanNumeral.parse("DCL"),650);
		eq(RomanNumeral.parse("DCLI"),651);
		eq(RomanNumeral.parse("DCLII"),652);
		eq(RomanNumeral.parse("DCLIII"),653);
		eq(RomanNumeral.parse("DCLIV"),654);
		eq(RomanNumeral.parse("DCLV"),655);
		eq(RomanNumeral.parse("DCLVI"),656);
		eq(RomanNumeral.parse("DCLVII"),657);
		eq(RomanNumeral.parse("DCLVIII"),658);
		eq(RomanNumeral.parse("DCLIX"),659);
		eq(RomanNumeral.parse("DCLX"),660);
		eq(RomanNumeral.parse("DCLXI"),661);
		eq(RomanNumeral.parse("DCLXII"),662);
		eq(RomanNumeral.parse("DCLXIII"),663);
		eq(RomanNumeral.parse("DCLXIV"),664);
		eq(RomanNumeral.parse("DCLXV"),665);
		eq(RomanNumeral.parse("DCLXVI"),666);
		eq(RomanNumeral.parse("DCLXVII"),667);
		eq(RomanNumeral.parse("DCLXVIII"),668);
		eq(RomanNumeral.parse("DCLXIX"),669);
		eq(RomanNumeral.parse("DCLXX"),670);
		eq(RomanNumeral.parse("DCLXXI"),671);
		eq(RomanNumeral.parse("DCLXXII"),672);
		eq(RomanNumeral.parse("DCLXXIII"),673);
		eq(RomanNumeral.parse("DCLXXIV"),674);
		eq(RomanNumeral.parse("DCLXXV"),675);
		eq(RomanNumeral.parse("DCLXXVI"),676);
		eq(RomanNumeral.parse("DCLXXVII"),677);
		eq(RomanNumeral.parse("DCLXXVIII"),678);
		eq(RomanNumeral.parse("DCLXXIX"),679);
		eq(RomanNumeral.parse("DCLXXX"),680);
		eq(RomanNumeral.parse("DCLXXXI"),681);
		eq(RomanNumeral.parse("DCLXXXII"),682);
		eq(RomanNumeral.parse("DCLXXXIII"),683);
		eq(RomanNumeral.parse("DCLXXXIV"),684);
		eq(RomanNumeral.parse("DCLXXXV"),685);
		eq(RomanNumeral.parse("DCLXXXVI"),686);
		eq(RomanNumeral.parse("DCLXXXVII"),687);
		eq(RomanNumeral.parse("DCLXXXVIII"),688);
		eq(RomanNumeral.parse("DCLXXXIX"),689);
		eq(RomanNumeral.parse("DCXC"),690);
		eq(RomanNumeral.parse("DCXCI"),691);
		eq(RomanNumeral.parse("DCXCII"),692);
		eq(RomanNumeral.parse("DCXCIII"),693);
		eq(RomanNumeral.parse("DCXCIV"),694);
		eq(RomanNumeral.parse("DCXCV"),695);
		eq(RomanNumeral.parse("DCXCVI"),696);
		eq(RomanNumeral.parse("DCXCVII"),697);
		eq(RomanNumeral.parse("DCXCVIII"),698);
		eq(RomanNumeral.parse("DCXCIX"),699);
		eq(RomanNumeral.parse("DCC"),700);
		eq(RomanNumeral.parse("DCCI"),701);
		eq(RomanNumeral.parse("DCCII"),702);
		eq(RomanNumeral.parse("DCCIII"),703);
		eq(RomanNumeral.parse("DCCIV"),704);
		eq(RomanNumeral.parse("DCCV"),705);
		eq(RomanNumeral.parse("DCCVI"),706);
		eq(RomanNumeral.parse("DCCVII"),707);
		eq(RomanNumeral.parse("DCCVIII"),708);
		eq(RomanNumeral.parse("DCCIX"),709);
		eq(RomanNumeral.parse("DCCX"),710);
		eq(RomanNumeral.parse("DCCXI"),711);
		eq(RomanNumeral.parse("DCCXII"),712);
		eq(RomanNumeral.parse("DCCXIII"),713);
		eq(RomanNumeral.parse("DCCXIV"),714);
		eq(RomanNumeral.parse("DCCXV"),715);
		eq(RomanNumeral.parse("DCCXVI"),716);
		eq(RomanNumeral.parse("DCCXVII"),717);
		eq(RomanNumeral.parse("DCCXVIII"),718);
		eq(RomanNumeral.parse("DCCXIX"),719);
		eq(RomanNumeral.parse("DCCXX"),720);
		eq(RomanNumeral.parse("DCCXXI"),721);
		eq(RomanNumeral.parse("DCCXXII"),722);
		eq(RomanNumeral.parse("DCCXXIII"),723);
		eq(RomanNumeral.parse("DCCXXIV"),724);
		eq(RomanNumeral.parse("DCCXXV"),725);
		eq(RomanNumeral.parse("DCCXXVI"),726);
		eq(RomanNumeral.parse("DCCXXVII"),727);
		eq(RomanNumeral.parse("DCCXXVIII"),728);
		eq(RomanNumeral.parse("DCCXXIX"),729);
		eq(RomanNumeral.parse("DCCXXX"),730);
		eq(RomanNumeral.parse("DCCXXXI"),731);
		eq(RomanNumeral.parse("DCCXXXII"),732);
		eq(RomanNumeral.parse("DCCXXXIII"),733);
		eq(RomanNumeral.parse("DCCXXXIV"),734);
		eq(RomanNumeral.parse("DCCXXXV"),735);
		eq(RomanNumeral.parse("DCCXXXVI"),736);
		eq(RomanNumeral.parse("DCCXXXVII"),737);
		eq(RomanNumeral.parse("DCCXXXVIII"),738);
		eq(RomanNumeral.parse("DCCXXXIX"),739);
		eq(RomanNumeral.parse("DCCXL"),740);
		eq(RomanNumeral.parse("DCCXLI"),741);
		eq(RomanNumeral.parse("DCCXLII"),742);
		eq(RomanNumeral.parse("DCCXLIII"),743);
		eq(RomanNumeral.parse("DCCXLIV"),744);
		eq(RomanNumeral.parse("DCCXLV"),745);
		eq(RomanNumeral.parse("DCCXLVI"),746);
		eq(RomanNumeral.parse("DCCXLVII"),747);
		eq(RomanNumeral.parse("DCCXLVIII"),748);
		eq(RomanNumeral.parse("DCCXLIX"),749);
		eq(RomanNumeral.parse("DCCL"),750);
		eq(RomanNumeral.parse("DCCLI"),751);
		eq(RomanNumeral.parse("DCCLII"),752);
		eq(RomanNumeral.parse("DCCLIII"),753);
		eq(RomanNumeral.parse("DCCLIV"),754);
		eq(RomanNumeral.parse("DCCLV"),755);
		eq(RomanNumeral.parse("DCCLVI"),756);
		eq(RomanNumeral.parse("DCCLVII"),757);
		eq(RomanNumeral.parse("DCCLVIII"),758);
		eq(RomanNumeral.parse("DCCLIX"),759);
		eq(RomanNumeral.parse("DCCLX"),760);
		eq(RomanNumeral.parse("DCCLXI"),761);
		eq(RomanNumeral.parse("DCCLXII"),762);
		eq(RomanNumeral.parse("DCCLXIII"),763);
		eq(RomanNumeral.parse("DCCLXIV"),764);
		eq(RomanNumeral.parse("DCCLXV"),765);
		eq(RomanNumeral.parse("DCCLXVI"),766);
		eq(RomanNumeral.parse("DCCLXVII"),767);
		eq(RomanNumeral.parse("DCCLXVIII"),768);
		eq(RomanNumeral.parse("DCCLXIX"),769);
		eq(RomanNumeral.parse("DCCLXX"),770);
		eq(RomanNumeral.parse("DCCLXXI"),771);
		eq(RomanNumeral.parse("DCCLXXII"),772);
		eq(RomanNumeral.parse("DCCLXXIII"),773);
		eq(RomanNumeral.parse("DCCLXXIV"),774);
		eq(RomanNumeral.parse("DCCLXXV"),775);
		eq(RomanNumeral.parse("DCCLXXVI"),776);
		eq(RomanNumeral.parse("DCCLXXVII"),777);
		eq(RomanNumeral.parse("DCCLXXVIII"),778);
		eq(RomanNumeral.parse("DCCLXXIX"),779);
		eq(RomanNumeral.parse("DCCLXXX"),780);
		eq(RomanNumeral.parse("DCCLXXXI"),781);
		eq(RomanNumeral.parse("DCCLXXXII"),782);
		eq(RomanNumeral.parse("DCCLXXXIII"),783);
		eq(RomanNumeral.parse("DCCLXXXIV"),784);
		eq(RomanNumeral.parse("DCCLXXXV"),785);
		eq(RomanNumeral.parse("DCCLXXXVI"),786);
		eq(RomanNumeral.parse("DCCLXXXVII"),787);
		eq(RomanNumeral.parse("DCCLXXXVIII"),788);
		eq(RomanNumeral.parse("DCCLXXXIX"),789);
		eq(RomanNumeral.parse("DCCXC"),790);
		eq(RomanNumeral.parse("DCCXCI"),791);
		eq(RomanNumeral.parse("DCCXCII"),792);
		eq(RomanNumeral.parse("DCCXCIII"),793);
		eq(RomanNumeral.parse("DCCXCIV"),794);
		eq(RomanNumeral.parse("DCCXCV"),795);
		eq(RomanNumeral.parse("DCCXCVI"),796);
		eq(RomanNumeral.parse("DCCXCVII"),797);
		eq(RomanNumeral.parse("DCCXCVIII"),798);
		eq(RomanNumeral.parse("DCCXCIX"),799);
		eq(RomanNumeral.parse("DCCC"),800);
		eq(RomanNumeral.parse("DCCCI"),801);
		eq(RomanNumeral.parse("DCCCII"),802);
		eq(RomanNumeral.parse("DCCCIII"),803);
		eq(RomanNumeral.parse("DCCCIV"),804);
		eq(RomanNumeral.parse("DCCCV"),805);
		eq(RomanNumeral.parse("DCCCVI"),806);
		eq(RomanNumeral.parse("DCCCVII"),807);
		eq(RomanNumeral.parse("DCCCVIII"),808);
		eq(RomanNumeral.parse("DCCCIX"),809);
		eq(RomanNumeral.parse("DCCCX"),810);
		eq(RomanNumeral.parse("DCCCXI"),811);
		eq(RomanNumeral.parse("DCCCXII"),812);
		eq(RomanNumeral.parse("DCCCXIII"),813);
		eq(RomanNumeral.parse("DCCCXIV"),814);
		eq(RomanNumeral.parse("DCCCXV"),815);
		eq(RomanNumeral.parse("DCCCXVI"),816);
		eq(RomanNumeral.parse("DCCCXVII"),817);
		eq(RomanNumeral.parse("DCCCXVIII"),818);
		eq(RomanNumeral.parse("DCCCXIX"),819);
		eq(RomanNumeral.parse("DCCCXX"),820);
		eq(RomanNumeral.parse("DCCCXXI"),821);
		eq(RomanNumeral.parse("DCCCXXII"),822);
		eq(RomanNumeral.parse("DCCCXXIII"),823);
		eq(RomanNumeral.parse("DCCCXXIV"),824);
		eq(RomanNumeral.parse("DCCCXXV"),825);
		eq(RomanNumeral.parse("DCCCXXVI"),826);
		eq(RomanNumeral.parse("DCCCXXVII"),827);
		eq(RomanNumeral.parse("DCCCXXVIII"),828);
		eq(RomanNumeral.parse("DCCCXXIX"),829);
		eq(RomanNumeral.parse("DCCCXXX"),830);
		eq(RomanNumeral.parse("DCCCXXXI"),831);
		eq(RomanNumeral.parse("DCCCXXXII"),832);
		eq(RomanNumeral.parse("DCCCXXXIII"),833);
		eq(RomanNumeral.parse("DCCCXXXIV"),834);
		eq(RomanNumeral.parse("DCCCXXXV"),835);
		eq(RomanNumeral.parse("DCCCXXXVI"),836);
		eq(RomanNumeral.parse("DCCCXXXVII"),837);
		eq(RomanNumeral.parse("DCCCXXXVIII"),838);
		eq(RomanNumeral.parse("DCCCXXXIX"),839);
		eq(RomanNumeral.parse("DCCCXL"),840);
		eq(RomanNumeral.parse("DCCCXLI"),841);
		eq(RomanNumeral.parse("DCCCXLII"),842);
		eq(RomanNumeral.parse("DCCCXLIII"),843);
		eq(RomanNumeral.parse("DCCCXLIV"),844);
		eq(RomanNumeral.parse("DCCCXLV"),845);
		eq(RomanNumeral.parse("DCCCXLVI"),846);
		eq(RomanNumeral.parse("DCCCXLVII"),847);
		eq(RomanNumeral.parse("DCCCXLVIII"),848);
		eq(RomanNumeral.parse("DCCCXLIX"),849);
		eq(RomanNumeral.parse("DCCCL"),850);
		eq(RomanNumeral.parse("DCCCLI"),851);
		eq(RomanNumeral.parse("DCCCLII"),852);
		eq(RomanNumeral.parse("DCCCLIII"),853);
		eq(RomanNumeral.parse("DCCCLIV"),854);
		eq(RomanNumeral.parse("DCCCLV"),855);
		eq(RomanNumeral.parse("DCCCLVI"),856);
		eq(RomanNumeral.parse("DCCCLVII"),857);
		eq(RomanNumeral.parse("DCCCLVIII"),858);
		eq(RomanNumeral.parse("DCCCLIX"),859);
		eq(RomanNumeral.parse("DCCCLX"),860);
		eq(RomanNumeral.parse("DCCCLXI"),861);
		eq(RomanNumeral.parse("DCCCLXII"),862);
		eq(RomanNumeral.parse("DCCCLXIII"),863);
		eq(RomanNumeral.parse("DCCCLXIV"),864);
		eq(RomanNumeral.parse("DCCCLXV"),865);
		eq(RomanNumeral.parse("DCCCLXVI"),866);
		eq(RomanNumeral.parse("DCCCLXVII"),867);
		eq(RomanNumeral.parse("DCCCLXVIII"),868);
		eq(RomanNumeral.parse("DCCCLXIX"),869);
		eq(RomanNumeral.parse("DCCCLXX"),870);
		eq(RomanNumeral.parse("DCCCLXXI"),871);
		eq(RomanNumeral.parse("DCCCLXXII"),872);
		eq(RomanNumeral.parse("DCCCLXXIII"),873);
		eq(RomanNumeral.parse("DCCCLXXIV"),874);
		eq(RomanNumeral.parse("DCCCLXXV"),875);
		eq(RomanNumeral.parse("DCCCLXXVI"),876);
		eq(RomanNumeral.parse("DCCCLXXVII"),877);
		eq(RomanNumeral.parse("DCCCLXXVIII"),878);
		eq(RomanNumeral.parse("DCCCLXXIX"),879);
		eq(RomanNumeral.parse("DCCCLXXX"),880);
		eq(RomanNumeral.parse("DCCCLXXXI"),881);
		eq(RomanNumeral.parse("DCCCLXXXII"),882);
		eq(RomanNumeral.parse("DCCCLXXXIII"),883);
		eq(RomanNumeral.parse("DCCCLXXXIV"),884);
		eq(RomanNumeral.parse("DCCCLXXXV"),885);
		eq(RomanNumeral.parse("DCCCLXXXVI"),886);
		eq(RomanNumeral.parse("DCCCLXXXVII"),887);
		eq(RomanNumeral.parse("DCCCLXXXVIII"),888);
		eq(RomanNumeral.parse("DCCCLXXXIX"),889);
		eq(RomanNumeral.parse("DCCCXC"),890);
		eq(RomanNumeral.parse("DCCCXCI"),891);
		eq(RomanNumeral.parse("DCCCXCII"),892);
		eq(RomanNumeral.parse("DCCCXCIII"),893);
		eq(RomanNumeral.parse("DCCCXCIV"),894);
		eq(RomanNumeral.parse("DCCCXCV"),895);
		eq(RomanNumeral.parse("DCCCXCVI"),896);
		eq(RomanNumeral.parse("DCCCXCVII"),897);
		eq(RomanNumeral.parse("DCCCXCVIII"),898);
		eq(RomanNumeral.parse("DCCCXCIX"),899);
		eq(RomanNumeral.parse("CM"),900);
		eq(RomanNumeral.parse("CMI"),901);
		eq(RomanNumeral.parse("CMII"),902);
		eq(RomanNumeral.parse("CMIII"),903);
		eq(RomanNumeral.parse("CMIV"),904);
		eq(RomanNumeral.parse("CMV"),905);
		eq(RomanNumeral.parse("CMVI"),906);
		eq(RomanNumeral.parse("CMVII"),907);
		eq(RomanNumeral.parse("CMVIII"),908);
		eq(RomanNumeral.parse("CMIX"),909);
		eq(RomanNumeral.parse("CMX"),910);
		eq(RomanNumeral.parse("CMXI"),911);
		eq(RomanNumeral.parse("CMXII"),912);
		eq(RomanNumeral.parse("CMXIII"),913);
		eq(RomanNumeral.parse("CMXIV"),914);
		eq(RomanNumeral.parse("CMXV"),915);
		eq(RomanNumeral.parse("CMXVI"),916);
		eq(RomanNumeral.parse("CMXVII"),917);
		eq(RomanNumeral.parse("CMXVIII"),918);
		eq(RomanNumeral.parse("CMXIX"),919);
		eq(RomanNumeral.parse("CMXX"),920);
		eq(RomanNumeral.parse("CMXXI"),921);
		eq(RomanNumeral.parse("CMXXII"),922);
		eq(RomanNumeral.parse("CMXXIII"),923);
		eq(RomanNumeral.parse("CMXXIV"),924);
		eq(RomanNumeral.parse("CMXXV"),925);
		eq(RomanNumeral.parse("CMXXVI"),926);
		eq(RomanNumeral.parse("CMXXVII"),927);
		eq(RomanNumeral.parse("CMXXVIII"),928);
		eq(RomanNumeral.parse("CMXXIX"),929);
		eq(RomanNumeral.parse("CMXXX"),930);
		eq(RomanNumeral.parse("CMXXXI"),931);
		eq(RomanNumeral.parse("CMXXXII"),932);
		eq(RomanNumeral.parse("CMXXXIII"),933);
		eq(RomanNumeral.parse("CMXXXIV"),934);
		eq(RomanNumeral.parse("CMXXXV"),935);
		eq(RomanNumeral.parse("CMXXXVI"),936);
		eq(RomanNumeral.parse("CMXXXVII"),937);
		eq(RomanNumeral.parse("CMXXXVIII"),938);
		eq(RomanNumeral.parse("CMXXXIX"),939);
		eq(RomanNumeral.parse("CMXL"),940);
		eq(RomanNumeral.parse("CMXLI"),941);
		eq(RomanNumeral.parse("CMXLII"),942);
		eq(RomanNumeral.parse("CMXLIII"),943);
		eq(RomanNumeral.parse("CMXLIV"),944);
		eq(RomanNumeral.parse("CMXLV"),945);
		eq(RomanNumeral.parse("CMXLVI"),946);
		eq(RomanNumeral.parse("CMXLVII"),947);
		eq(RomanNumeral.parse("CMXLVIII"),948);
		eq(RomanNumeral.parse("CMXLIX"),949);
		eq(RomanNumeral.parse("CML"),950);
		eq(RomanNumeral.parse("CMLI"),951);
		eq(RomanNumeral.parse("CMLII"),952);
		eq(RomanNumeral.parse("CMLIII"),953);
		eq(RomanNumeral.parse("CMLIV"),954);
		eq(RomanNumeral.parse("CMLV"),955);
		eq(RomanNumeral.parse("CMLVI"),956);
		eq(RomanNumeral.parse("CMLVII"),957);
		eq(RomanNumeral.parse("CMLVIII"),958);
		eq(RomanNumeral.parse("CMLIX"),959);
		eq(RomanNumeral.parse("CMLX"),960);
		eq(RomanNumeral.parse("CMLXI"),961);
		eq(RomanNumeral.parse("CMLXII"),962);
		eq(RomanNumeral.parse("CMLXIII"),963);
		eq(RomanNumeral.parse("CMLXIV"),964);
		eq(RomanNumeral.parse("CMLXV"),965);
		eq(RomanNumeral.parse("CMLXVI"),966);
		eq(RomanNumeral.parse("CMLXVII"),967);
		eq(RomanNumeral.parse("CMLXVIII"),968);
		eq(RomanNumeral.parse("CMLXIX"),969);
		eq(RomanNumeral.parse("CMLXX"),970);
		eq(RomanNumeral.parse("CMLXXI"),971);
		eq(RomanNumeral.parse("CMLXXII"),972);
		eq(RomanNumeral.parse("CMLXXIII"),973);
		eq(RomanNumeral.parse("CMLXXIV"),974);
		eq(RomanNumeral.parse("CMLXXV"),975);
		eq(RomanNumeral.parse("CMLXXVI"),976);
		eq(RomanNumeral.parse("CMLXXVII"),977);
		eq(RomanNumeral.parse("CMLXXVIII"),978);
		eq(RomanNumeral.parse("CMLXXIX"),979);
		eq(RomanNumeral.parse("CMLXXX"),980);
		eq(RomanNumeral.parse("CMLXXXI"),981);
		eq(RomanNumeral.parse("CMLXXXII"),982);
		eq(RomanNumeral.parse("CMLXXXIII"),983);
		eq(RomanNumeral.parse("CMLXXXIV"),984);
		eq(RomanNumeral.parse("CMLXXXV"),985);
		eq(RomanNumeral.parse("CMLXXXVI"),986);
		eq(RomanNumeral.parse("CMLXXXVII"),987);
		eq(RomanNumeral.parse("CMLXXXVIII"),988);
		eq(RomanNumeral.parse("CMLXXXIX"),989);
		eq(RomanNumeral.parse("CMXC"),990);
		eq(RomanNumeral.parse("CMXCI"),991);
		eq(RomanNumeral.parse("CMXCII"),992);
		eq(RomanNumeral.parse("CMXCIII"),993);
		eq(RomanNumeral.parse("CMXCIV"),994);
		eq(RomanNumeral.parse("CMXCV"),995);
		eq(RomanNumeral.parse("CMXCVI"),996);
		eq(RomanNumeral.parse("CMXCVII"),997);
		eq(RomanNumeral.parse("CMXCVIII"),998);
		eq(RomanNumeral.parse("CMXCIX"),999);
		eq(RomanNumeral.parse("M"),1000);
		eq(RomanNumeral.parse("MI"),1001);
		eq(RomanNumeral.parse("MII"),1002);
		eq(RomanNumeral.parse("MIII"),1003);
		eq(RomanNumeral.parse("MIV"),1004);
		eq(RomanNumeral.parse("MV"),1005);
		eq(RomanNumeral.parse("MVI"),1006);
		eq(RomanNumeral.parse("MVII"),1007);
		eq(RomanNumeral.parse("MVIII"),1008);
		eq(RomanNumeral.parse("MIX"),1009);
		eq(RomanNumeral.parse("MX"),1010);
		eq(RomanNumeral.parse("MXI"),1011);
		eq(RomanNumeral.parse("MXII"),1012);
		eq(RomanNumeral.parse("MXIII"),1013);
		eq(RomanNumeral.parse("MXIV"),1014);
		eq(RomanNumeral.parse("MXV"),1015);
		eq(RomanNumeral.parse("MXVI"),1016);
		eq(RomanNumeral.parse("MXVII"),1017);
		eq(RomanNumeral.parse("MXVIII"),1018);
		eq(RomanNumeral.parse("MXIX"),1019);
		eq(RomanNumeral.parse("MXX"),1020);
		eq(RomanNumeral.parse("MXXI"),1021);
		eq(RomanNumeral.parse("MXXII"),1022);
		eq(RomanNumeral.parse("MXXIII"),1023);
		eq(RomanNumeral.parse("MXXIV"),1024);
		eq(RomanNumeral.parse("MXXV"),1025);
		eq(RomanNumeral.parse("MXXVI"),1026);
		eq(RomanNumeral.parse("MXXVII"),1027);
		eq(RomanNumeral.parse("MXXVIII"),1028);
		eq(RomanNumeral.parse("MXXIX"),1029);
		eq(RomanNumeral.parse("MXXX"),1030);
		eq(RomanNumeral.parse("MXXXI"),1031);
		eq(RomanNumeral.parse("MXXXII"),1032);
		eq(RomanNumeral.parse("MXXXIII"),1033);
		eq(RomanNumeral.parse("MXXXIV"),1034);
		eq(RomanNumeral.parse("MXXXV"),1035);
		eq(RomanNumeral.parse("MXXXVI"),1036);
		eq(RomanNumeral.parse("MXXXVII"),1037);
		eq(RomanNumeral.parse("MXXXVIII"),1038);
		eq(RomanNumeral.parse("MXXXIX"),1039);
		eq(RomanNumeral.parse("MXL"),1040);
		eq(RomanNumeral.parse("MXLI"),1041);
		eq(RomanNumeral.parse("MXLII"),1042);
		eq(RomanNumeral.parse("MXLIII"),1043);
		eq(RomanNumeral.parse("MXLIV"),1044);
		eq(RomanNumeral.parse("MXLV"),1045);
		eq(RomanNumeral.parse("MXLVI"),1046);
		eq(RomanNumeral.parse("MXLVII"),1047);
		eq(RomanNumeral.parse("MXLVIII"),1048);
		eq(RomanNumeral.parse("MXLIX"),1049);
		eq(RomanNumeral.parse("ML"),1050);
		eq(RomanNumeral.parse("MLI"),1051);
		eq(RomanNumeral.parse("MLII"),1052);
		eq(RomanNumeral.parse("MLIII"),1053);
		eq(RomanNumeral.parse("MLIV"),1054);
		eq(RomanNumeral.parse("MLV"),1055);
		eq(RomanNumeral.parse("MLVI"),1056);
		eq(RomanNumeral.parse("MLVII"),1057);
		eq(RomanNumeral.parse("MLVIII"),1058);
		eq(RomanNumeral.parse("MLIX"),1059);
		eq(RomanNumeral.parse("MLX"),1060);
		eq(RomanNumeral.parse("MLXI"),1061);
		eq(RomanNumeral.parse("MLXII"),1062);
		eq(RomanNumeral.parse("MLXIII"),1063);
		eq(RomanNumeral.parse("MLXIV"),1064);
		eq(RomanNumeral.parse("MLXV"),1065);
		eq(RomanNumeral.parse("MLXVI"),1066);
		eq(RomanNumeral.parse("MLXVII"),1067);
		eq(RomanNumeral.parse("MLXVIII"),1068);
		eq(RomanNumeral.parse("MLXIX"),1069);
		eq(RomanNumeral.parse("MLXX"),1070);
		eq(RomanNumeral.parse("MLXXI"),1071);
		eq(RomanNumeral.parse("MLXXII"),1072);
		eq(RomanNumeral.parse("MLXXIII"),1073);
		eq(RomanNumeral.parse("MLXXIV"),1074);
		eq(RomanNumeral.parse("MLXXV"),1075);
		eq(RomanNumeral.parse("MLXXVI"),1076);
		eq(RomanNumeral.parse("MLXXVII"),1077);
		eq(RomanNumeral.parse("MLXXVIII"),1078);
		eq(RomanNumeral.parse("MLXXIX"),1079);
		eq(RomanNumeral.parse("MLXXX"),1080);
		eq(RomanNumeral.parse("MLXXXI"),1081);
		eq(RomanNumeral.parse("MLXXXII"),1082);
		eq(RomanNumeral.parse("MLXXXIII"),1083);
		eq(RomanNumeral.parse("MLXXXIV"),1084);
		eq(RomanNumeral.parse("MLXXXV"),1085);
		eq(RomanNumeral.parse("MLXXXVI"),1086);
		eq(RomanNumeral.parse("MLXXXVII"),1087);
		eq(RomanNumeral.parse("MLXXXVIII"),1088);
		eq(RomanNumeral.parse("MLXXXIX"),1089);
		eq(RomanNumeral.parse("MXC"),1090);
		eq(RomanNumeral.parse("MXCI"),1091);
		eq(RomanNumeral.parse("MXCII"),1092);
		eq(RomanNumeral.parse("MXCIII"),1093);
		eq(RomanNumeral.parse("MXCIV"),1094);
		eq(RomanNumeral.parse("MXCV"),1095);
		eq(RomanNumeral.parse("MXCVI"),1096);
		eq(RomanNumeral.parse("MXCVII"),1097);
		eq(RomanNumeral.parse("MXCVIII"),1098);
		eq(RomanNumeral.parse("MXCIX"),1099);
		eq(RomanNumeral.parse("MC"),1100);
		eq(RomanNumeral.parse("MCI"),1101);
		eq(RomanNumeral.parse("MCII"),1102);
		eq(RomanNumeral.parse("MCIII"),1103);
		eq(RomanNumeral.parse("MCIV"),1104);
		eq(RomanNumeral.parse("MCV"),1105);
		eq(RomanNumeral.parse("MCVI"),1106);
		eq(RomanNumeral.parse("MCVII"),1107);
		eq(RomanNumeral.parse("MCVIII"),1108);
		eq(RomanNumeral.parse("MCIX"),1109);
		eq(RomanNumeral.parse("MCX"),1110);
		eq(RomanNumeral.parse("MCXI"),1111);
		eq(RomanNumeral.parse("MCXII"),1112);
		eq(RomanNumeral.parse("MCXIII"),1113);
		eq(RomanNumeral.parse("MCXIV"),1114);
		eq(RomanNumeral.parse("MCXV"),1115);
		eq(RomanNumeral.parse("MCXVI"),1116);
		eq(RomanNumeral.parse("MCXVII"),1117);
		eq(RomanNumeral.parse("MCXVIII"),1118);
		eq(RomanNumeral.parse("MCXIX"),1119);
		eq(RomanNumeral.parse("MCXX"),1120);
		eq(RomanNumeral.parse("MCXXI"),1121);
		eq(RomanNumeral.parse("MCXXII"),1122);
		eq(RomanNumeral.parse("MCXXIII"),1123);
		eq(RomanNumeral.parse("MCXXIV"),1124);
		eq(RomanNumeral.parse("MCXXV"),1125);
		eq(RomanNumeral.parse("MCXXVI"),1126);
		eq(RomanNumeral.parse("MCXXVII"),1127);
		eq(RomanNumeral.parse("MCXXVIII"),1128);
		eq(RomanNumeral.parse("MCXXIX"),1129);
		eq(RomanNumeral.parse("MCXXX"),1130);
		eq(RomanNumeral.parse("MCXXXI"),1131);
		eq(RomanNumeral.parse("MCXXXII"),1132);
		eq(RomanNumeral.parse("MCXXXIII"),1133);
		eq(RomanNumeral.parse("MCXXXIV"),1134);
		eq(RomanNumeral.parse("MCXXXV"),1135);
		eq(RomanNumeral.parse("MCXXXVI"),1136);
		eq(RomanNumeral.parse("MCXXXVII"),1137);
		eq(RomanNumeral.parse("MCXXXVIII"),1138);
		eq(RomanNumeral.parse("MCXXXIX"),1139);
		eq(RomanNumeral.parse("MCXL"),1140);
		eq(RomanNumeral.parse("MCXLI"),1141);
		eq(RomanNumeral.parse("MCXLII"),1142);
		eq(RomanNumeral.parse("MCXLIII"),1143);
		eq(RomanNumeral.parse("MCXLIV"),1144);
		eq(RomanNumeral.parse("MCXLV"),1145);
		eq(RomanNumeral.parse("MCXLVI"),1146);
		eq(RomanNumeral.parse("MCXLVII"),1147);
		eq(RomanNumeral.parse("MCXLVIII"),1148);
		eq(RomanNumeral.parse("MCXLIX"),1149);
		eq(RomanNumeral.parse("MCL"),1150);
		eq(RomanNumeral.parse("MCLI"),1151);
		eq(RomanNumeral.parse("MCLII"),1152);
		eq(RomanNumeral.parse("MCLIII"),1153);
		eq(RomanNumeral.parse("MCLIV"),1154);
		eq(RomanNumeral.parse("MCLV"),1155);
		eq(RomanNumeral.parse("MCLVI"),1156);
		eq(RomanNumeral.parse("MCLVII"),1157);
		eq(RomanNumeral.parse("MCLVIII"),1158);
		eq(RomanNumeral.parse("MCLIX"),1159);
		eq(RomanNumeral.parse("MCLX"),1160);
		eq(RomanNumeral.parse("MCLXI"),1161);
		eq(RomanNumeral.parse("MCLXII"),1162);
		eq(RomanNumeral.parse("MCLXIII"),1163);
		eq(RomanNumeral.parse("MCLXIV"),1164);
		eq(RomanNumeral.parse("MCLXV"),1165);
		eq(RomanNumeral.parse("MCLXVI"),1166);
		eq(RomanNumeral.parse("MCLXVII"),1167);
		eq(RomanNumeral.parse("MCLXVIII"),1168);
		eq(RomanNumeral.parse("MCLXIX"),1169);
		eq(RomanNumeral.parse("MCLXX"),1170);
		eq(RomanNumeral.parse("MCLXXI"),1171);
		eq(RomanNumeral.parse("MCLXXII"),1172);
		eq(RomanNumeral.parse("MCLXXIII"),1173);
		eq(RomanNumeral.parse("MCLXXIV"),1174);
		eq(RomanNumeral.parse("MCLXXV"),1175);
		eq(RomanNumeral.parse("MCLXXVI"),1176);
		eq(RomanNumeral.parse("MCLXXVII"),1177);
		eq(RomanNumeral.parse("MCLXXVIII"),1178);
		eq(RomanNumeral.parse("MCLXXIX"),1179);
		eq(RomanNumeral.parse("MCLXXX"),1180);
		eq(RomanNumeral.parse("MCLXXXI"),1181);
		eq(RomanNumeral.parse("MCLXXXII"),1182);
		eq(RomanNumeral.parse("MCLXXXIII"),1183);
		eq(RomanNumeral.parse("MCLXXXIV"),1184);
		eq(RomanNumeral.parse("MCLXXXV"),1185);
		eq(RomanNumeral.parse("MCLXXXVI"),1186);
		eq(RomanNumeral.parse("MCLXXXVII"),1187);
		eq(RomanNumeral.parse("MCLXXXVIII"),1188);
		eq(RomanNumeral.parse("MCLXXXIX"),1189);
		eq(RomanNumeral.parse("MCXC"),1190);
		eq(RomanNumeral.parse("MCXCI"),1191);
		eq(RomanNumeral.parse("MCXCII"),1192);
		eq(RomanNumeral.parse("MCXCIII"),1193);
		eq(RomanNumeral.parse("MCXCIV"),1194);
		eq(RomanNumeral.parse("MCXCV"),1195);
		eq(RomanNumeral.parse("MCXCVI"),1196);
		eq(RomanNumeral.parse("MCXCVII"),1197);
		eq(RomanNumeral.parse("MCXCVIII"),1198);
		eq(RomanNumeral.parse("MCXCIX"),1199);
		eq(RomanNumeral.parse("MCC"),1200);
		eq(RomanNumeral.parse("MCCI"),1201);
		eq(RomanNumeral.parse("MCCII"),1202);
		eq(RomanNumeral.parse("MCCIII"),1203);
		eq(RomanNumeral.parse("MCCIV"),1204);
		eq(RomanNumeral.parse("MCCV"),1205);
		eq(RomanNumeral.parse("MCCVI"),1206);
		eq(RomanNumeral.parse("MCCVII"),1207);
		eq(RomanNumeral.parse("MCCVIII"),1208);
		eq(RomanNumeral.parse("MCCIX"),1209);
		eq(RomanNumeral.parse("MCCX"),1210);
		eq(RomanNumeral.parse("MCCXI"),1211);
		eq(RomanNumeral.parse("MCCXII"),1212);
		eq(RomanNumeral.parse("MCCXIII"),1213);
		eq(RomanNumeral.parse("MCCXIV"),1214);
		eq(RomanNumeral.parse("MCCXV"),1215);
		eq(RomanNumeral.parse("MCCXVI"),1216);
		eq(RomanNumeral.parse("MCCXVII"),1217);
		eq(RomanNumeral.parse("MCCXVIII"),1218);
		eq(RomanNumeral.parse("MCCXIX"),1219);
		eq(RomanNumeral.parse("MCCXX"),1220);
		eq(RomanNumeral.parse("MCCXXI"),1221);
		eq(RomanNumeral.parse("MCCXXII"),1222);
		eq(RomanNumeral.parse("MCCXXIII"),1223);
		eq(RomanNumeral.parse("MCCXXIV"),1224);
		eq(RomanNumeral.parse("MCCXXV"),1225);
		eq(RomanNumeral.parse("MCCXXVI"),1226);
		eq(RomanNumeral.parse("MCCXXVII"),1227);
		eq(RomanNumeral.parse("MCCXXVIII"),1228);
		eq(RomanNumeral.parse("MCCXXIX"),1229);
		eq(RomanNumeral.parse("MCCXXX"),1230);
		eq(RomanNumeral.parse("MCCXXXI"),1231);
		eq(RomanNumeral.parse("MCCXXXII"),1232);
		eq(RomanNumeral.parse("MCCXXXIII"),1233);
		eq(RomanNumeral.parse("MCCXXXIV"),1234);
		eq(RomanNumeral.parse("MCCXXXV"),1235);
		eq(RomanNumeral.parse("MCCXXXVI"),1236);
		eq(RomanNumeral.parse("MCCXXXVII"),1237);
		eq(RomanNumeral.parse("MCCXXXVIII"),1238);
		eq(RomanNumeral.parse("MCCXXXIX"),1239);
		eq(RomanNumeral.parse("MCCXL"),1240);
		eq(RomanNumeral.parse("MCCXLI"),1241);
		eq(RomanNumeral.parse("MCCXLII"),1242);
		eq(RomanNumeral.parse("MCCXLIII"),1243);
		eq(RomanNumeral.parse("MCCXLIV"),1244);
		eq(RomanNumeral.parse("MCCXLV"),1245);
		eq(RomanNumeral.parse("MCCXLVI"),1246);
		eq(RomanNumeral.parse("MCCXLVII"),1247);
		eq(RomanNumeral.parse("MCCXLVIII"),1248);
		eq(RomanNumeral.parse("MCCXLIX"),1249);
		eq(RomanNumeral.parse("MCCL"),1250);
		eq(RomanNumeral.parse("MCCLI"),1251);
		eq(RomanNumeral.parse("MCCLII"),1252);
		eq(RomanNumeral.parse("MCCLIII"),1253);
		eq(RomanNumeral.parse("MCCLIV"),1254);
		eq(RomanNumeral.parse("MCCLV"),1255);
		eq(RomanNumeral.parse("MCCLVI"),1256);
		eq(RomanNumeral.parse("MCCLVII"),1257);
		eq(RomanNumeral.parse("MCCLVIII"),1258);
		eq(RomanNumeral.parse("MCCLIX"),1259);
		eq(RomanNumeral.parse("MCCLX"),1260);
		eq(RomanNumeral.parse("MCCLXI"),1261);
		eq(RomanNumeral.parse("MCCLXII"),1262);
		eq(RomanNumeral.parse("MCCLXIII"),1263);
		eq(RomanNumeral.parse("MCCLXIV"),1264);
		eq(RomanNumeral.parse("MCCLXV"),1265);
		eq(RomanNumeral.parse("MCCLXVI"),1266);
		eq(RomanNumeral.parse("MCCLXVII"),1267);
		eq(RomanNumeral.parse("MCCLXVIII"),1268);
		eq(RomanNumeral.parse("MCCLXIX"),1269);
		eq(RomanNumeral.parse("MCCLXX"),1270);
		eq(RomanNumeral.parse("MCCLXXI"),1271);
		eq(RomanNumeral.parse("MCCLXXII"),1272);
		eq(RomanNumeral.parse("MCCLXXIII"),1273);
		eq(RomanNumeral.parse("MCCLXXIV"),1274);
		eq(RomanNumeral.parse("MCCLXXV"),1275);
		eq(RomanNumeral.parse("MCCLXXVI"),1276);
		eq(RomanNumeral.parse("MCCLXXVII"),1277);
		eq(RomanNumeral.parse("MCCLXXVIII"),1278);
		eq(RomanNumeral.parse("MCCLXXIX"),1279);
		eq(RomanNumeral.parse("MCCLXXX"),1280);
		eq(RomanNumeral.parse("MCCLXXXI"),1281);
		eq(RomanNumeral.parse("MCCLXXXII"),1282);
		eq(RomanNumeral.parse("MCCLXXXIII"),1283);
		eq(RomanNumeral.parse("MCCLXXXIV"),1284);
		eq(RomanNumeral.parse("MCCLXXXV"),1285);
		eq(RomanNumeral.parse("MCCLXXXVI"),1286);
		eq(RomanNumeral.parse("MCCLXXXVII"),1287);
		eq(RomanNumeral.parse("MCCLXXXVIII"),1288);
		eq(RomanNumeral.parse("MCCLXXXIX"),1289);
		eq(RomanNumeral.parse("MCCXC"),1290);
		eq(RomanNumeral.parse("MCCXCI"),1291);
		eq(RomanNumeral.parse("MCCXCII"),1292);
		eq(RomanNumeral.parse("MCCXCIII"),1293);
		eq(RomanNumeral.parse("MCCXCIV"),1294);
		eq(RomanNumeral.parse("MCCXCV"),1295);
		eq(RomanNumeral.parse("MCCXCVI"),1296);
		eq(RomanNumeral.parse("MCCXCVII"),1297);
		eq(RomanNumeral.parse("MCCXCVIII"),1298);
		eq(RomanNumeral.parse("MCCXCIX"),1299);
		eq(RomanNumeral.parse("MCCC"),1300);
		eq(RomanNumeral.parse("MCCCI"),1301);
		eq(RomanNumeral.parse("MCCCII"),1302);
		eq(RomanNumeral.parse("MCCCIII"),1303);
		eq(RomanNumeral.parse("MCCCIV"),1304);
		eq(RomanNumeral.parse("MCCCV"),1305);
		eq(RomanNumeral.parse("MCCCVI"),1306);
		eq(RomanNumeral.parse("MCCCVII"),1307);
		eq(RomanNumeral.parse("MCCCVIII"),1308);
		eq(RomanNumeral.parse("MCCCIX"),1309);
		eq(RomanNumeral.parse("MCCCX"),1310);
		eq(RomanNumeral.parse("MCCCXI"),1311);
		eq(RomanNumeral.parse("MCCCXII"),1312);
		eq(RomanNumeral.parse("MCCCXIII"),1313);
		eq(RomanNumeral.parse("MCCCXIV"),1314);
		eq(RomanNumeral.parse("MCCCXV"),1315);
		eq(RomanNumeral.parse("MCCCXVI"),1316);
		eq(RomanNumeral.parse("MCCCXVII"),1317);
		eq(RomanNumeral.parse("MCCCXVIII"),1318);
		eq(RomanNumeral.parse("MCCCXIX"),1319);
		eq(RomanNumeral.parse("MCCCXX"),1320);
		eq(RomanNumeral.parse("MCCCXXI"),1321);
		eq(RomanNumeral.parse("MCCCXXII"),1322);
		eq(RomanNumeral.parse("MCCCXXIII"),1323);
		eq(RomanNumeral.parse("MCCCXXIV"),1324);
		eq(RomanNumeral.parse("MCCCXXV"),1325);
		eq(RomanNumeral.parse("MCCCXXVI"),1326);
		eq(RomanNumeral.parse("MCCCXXVII"),1327);
		eq(RomanNumeral.parse("MCCCXXVIII"),1328);
		eq(RomanNumeral.parse("MCCCXXIX"),1329);
		eq(RomanNumeral.parse("MCCCXXX"),1330);
		eq(RomanNumeral.parse("MCCCXXXI"),1331);
		eq(RomanNumeral.parse("MCCCXXXII"),1332);
		eq(RomanNumeral.parse("MCCCXXXIII"),1333);
		eq(RomanNumeral.parse("MCCCXXXIV"),1334);
		eq(RomanNumeral.parse("MCCCXXXV"),1335);
		eq(RomanNumeral.parse("MCCCXXXVI"),1336);
		eq(RomanNumeral.parse("MCCCXXXVII"),1337);
		eq(RomanNumeral.parse("MCCCXXXVIII"),1338);
		eq(RomanNumeral.parse("MCCCXXXIX"),1339);
		eq(RomanNumeral.parse("MCCCXL"),1340);
		eq(RomanNumeral.parse("MCCCXLI"),1341);
		eq(RomanNumeral.parse("MCCCXLII"),1342);
		eq(RomanNumeral.parse("MCCCXLIII"),1343);
		eq(RomanNumeral.parse("MCCCXLIV"),1344);
		eq(RomanNumeral.parse("MCCCXLV"),1345);
		eq(RomanNumeral.parse("MCCCXLVI"),1346);
		eq(RomanNumeral.parse("MCCCXLVII"),1347);
		eq(RomanNumeral.parse("MCCCXLVIII"),1348);
		eq(RomanNumeral.parse("MCCCXLIX"),1349);
		eq(RomanNumeral.parse("MCCCL"),1350);
		eq(RomanNumeral.parse("MCCCLI"),1351);
		eq(RomanNumeral.parse("MCCCLII"),1352);
		eq(RomanNumeral.parse("MCCCLIII"),1353);
		eq(RomanNumeral.parse("MCCCLIV"),1354);
		eq(RomanNumeral.parse("MCCCLV"),1355);
		eq(RomanNumeral.parse("MCCCLVI"),1356);
		eq(RomanNumeral.parse("MCCCLVII"),1357);
		eq(RomanNumeral.parse("MCCCLVIII"),1358);
		eq(RomanNumeral.parse("MCCCLIX"),1359);
		eq(RomanNumeral.parse("MCCCLX"),1360);
		eq(RomanNumeral.parse("MCCCLXI"),1361);
		eq(RomanNumeral.parse("MCCCLXII"),1362);
		eq(RomanNumeral.parse("MCCCLXIII"),1363);
		eq(RomanNumeral.parse("MCCCLXIV"),1364);
		eq(RomanNumeral.parse("MCCCLXV"),1365);
		eq(RomanNumeral.parse("MCCCLXVI"),1366);
		eq(RomanNumeral.parse("MCCCLXVII"),1367);
		eq(RomanNumeral.parse("MCCCLXVIII"),1368);
		eq(RomanNumeral.parse("MCCCLXIX"),1369);
		eq(RomanNumeral.parse("MCCCLXX"),1370);
		eq(RomanNumeral.parse("MCCCLXXI"),1371);
		eq(RomanNumeral.parse("MCCCLXXII"),1372);
		eq(RomanNumeral.parse("MCCCLXXIII"),1373);
		eq(RomanNumeral.parse("MCCCLXXIV"),1374);
		eq(RomanNumeral.parse("MCCCLXXV"),1375);
		eq(RomanNumeral.parse("MCCCLXXVI"),1376);
		eq(RomanNumeral.parse("MCCCLXXVII"),1377);
		eq(RomanNumeral.parse("MCCCLXXVIII"),1378);
		eq(RomanNumeral.parse("MCCCLXXIX"),1379);
		eq(RomanNumeral.parse("MCCCLXXX"),1380);
		eq(RomanNumeral.parse("MCCCLXXXI"),1381);
		eq(RomanNumeral.parse("MCCCLXXXII"),1382);
		eq(RomanNumeral.parse("MCCCLXXXIII"),1383);
		eq(RomanNumeral.parse("MCCCLXXXIV"),1384);
		eq(RomanNumeral.parse("MCCCLXXXV"),1385);
		eq(RomanNumeral.parse("MCCCLXXXVI"),1386);
		eq(RomanNumeral.parse("MCCCLXXXVII"),1387);
		eq(RomanNumeral.parse("MCCCLXXXVIII"),1388);
		eq(RomanNumeral.parse("MCCCLXXXIX"),1389);
		eq(RomanNumeral.parse("MCCCXC"),1390);
		eq(RomanNumeral.parse("MCCCXCI"),1391);
		eq(RomanNumeral.parse("MCCCXCII"),1392);
		eq(RomanNumeral.parse("MCCCXCIII"),1393);
		eq(RomanNumeral.parse("MCCCXCIV"),1394);
		eq(RomanNumeral.parse("MCCCXCV"),1395);
		eq(RomanNumeral.parse("MCCCXCVI"),1396);
		eq(RomanNumeral.parse("MCCCXCVII"),1397);
		eq(RomanNumeral.parse("MCCCXCVIII"),1398);
		eq(RomanNumeral.parse("MCCCXCIX"),1399);
		eq(RomanNumeral.parse("MCD"),1400);
		eq(RomanNumeral.parse("MCDI"),1401);
		eq(RomanNumeral.parse("MCDII"),1402);
		eq(RomanNumeral.parse("MCDIII"),1403);
		eq(RomanNumeral.parse("MCDIV"),1404);
		eq(RomanNumeral.parse("MCDV"),1405);
		eq(RomanNumeral.parse("MCDVI"),1406);
		eq(RomanNumeral.parse("MCDVII"),1407);
		eq(RomanNumeral.parse("MCDVIII"),1408);
		eq(RomanNumeral.parse("MCDIX"),1409);
		eq(RomanNumeral.parse("MCDX"),1410);
		eq(RomanNumeral.parse("MCDXI"),1411);
		eq(RomanNumeral.parse("MCDXII"),1412);
		eq(RomanNumeral.parse("MCDXIII"),1413);
		eq(RomanNumeral.parse("MCDXIV"),1414);
		eq(RomanNumeral.parse("MCDXV"),1415);
		eq(RomanNumeral.parse("MCDXVI"),1416);
		eq(RomanNumeral.parse("MCDXVII"),1417);
		eq(RomanNumeral.parse("MCDXVIII"),1418);
		eq(RomanNumeral.parse("MCDXIX"),1419);
		eq(RomanNumeral.parse("MCDXX"),1420);
		eq(RomanNumeral.parse("MCDXXI"),1421);
		eq(RomanNumeral.parse("MCDXXII"),1422);
		eq(RomanNumeral.parse("MCDXXIII"),1423);
		eq(RomanNumeral.parse("MCDXXIV"),1424);
		eq(RomanNumeral.parse("MCDXXV"),1425);
		eq(RomanNumeral.parse("MCDXXVI"),1426);
		eq(RomanNumeral.parse("MCDXXVII"),1427);
		eq(RomanNumeral.parse("MCDXXVIII"),1428);
		eq(RomanNumeral.parse("MCDXXIX"),1429);
		eq(RomanNumeral.parse("MCDXXX"),1430);
		eq(RomanNumeral.parse("MCDXXXI"),1431);
		eq(RomanNumeral.parse("MCDXXXII"),1432);
		eq(RomanNumeral.parse("MCDXXXIII"),1433);
		eq(RomanNumeral.parse("MCDXXXIV"),1434);
		eq(RomanNumeral.parse("MCDXXXV"),1435);
		eq(RomanNumeral.parse("MCDXXXVI"),1436);
		eq(RomanNumeral.parse("MCDXXXVII"),1437);
		eq(RomanNumeral.parse("MCDXXXVIII"),1438);
		eq(RomanNumeral.parse("MCDXXXIX"),1439);
		eq(RomanNumeral.parse("MCDXL"),1440);
		eq(RomanNumeral.parse("MCDXLI"),1441);
		eq(RomanNumeral.parse("MCDXLII"),1442);
		eq(RomanNumeral.parse("MCDXLIII"),1443);
		eq(RomanNumeral.parse("MCDXLIV"),1444);
		eq(RomanNumeral.parse("MCDXLV"),1445);
		eq(RomanNumeral.parse("MCDXLVI"),1446);
		eq(RomanNumeral.parse("MCDXLVII"),1447);
		eq(RomanNumeral.parse("MCDXLVIII"),1448);
		eq(RomanNumeral.parse("MCDXLIX"),1449);
		eq(RomanNumeral.parse("MCDL"),1450);
		eq(RomanNumeral.parse("MCDLI"),1451);
		eq(RomanNumeral.parse("MCDLII"),1452);
		eq(RomanNumeral.parse("MCDLIII"),1453);
		eq(RomanNumeral.parse("MCDLIV"),1454);
		eq(RomanNumeral.parse("MCDLV"),1455);
		eq(RomanNumeral.parse("MCDLVI"),1456);
		eq(RomanNumeral.parse("MCDLVII"),1457);
		eq(RomanNumeral.parse("MCDLVIII"),1458);
		eq(RomanNumeral.parse("MCDLIX"),1459);
		eq(RomanNumeral.parse("MCDLX"),1460);
		eq(RomanNumeral.parse("MCDLXI"),1461);
		eq(RomanNumeral.parse("MCDLXII"),1462);
		eq(RomanNumeral.parse("MCDLXIII"),1463);
		eq(RomanNumeral.parse("MCDLXIV"),1464);
		eq(RomanNumeral.parse("MCDLXV"),1465);
		eq(RomanNumeral.parse("MCDLXVI"),1466);
		eq(RomanNumeral.parse("MCDLXVII"),1467);
		eq(RomanNumeral.parse("MCDLXVIII"),1468);
		eq(RomanNumeral.parse("MCDLXIX"),1469);
		eq(RomanNumeral.parse("MCDLXX"),1470);
		eq(RomanNumeral.parse("MCDLXXI"),1471);
		eq(RomanNumeral.parse("MCDLXXII"),1472);
		eq(RomanNumeral.parse("MCDLXXIII"),1473);
		eq(RomanNumeral.parse("MCDLXXIV"),1474);
		eq(RomanNumeral.parse("MCDLXXV"),1475);
		eq(RomanNumeral.parse("MCDLXXVI"),1476);
		eq(RomanNumeral.parse("MCDLXXVII"),1477);
		eq(RomanNumeral.parse("MCDLXXVIII"),1478);
		eq(RomanNumeral.parse("MCDLXXIX"),1479);
		eq(RomanNumeral.parse("MCDLXXX"),1480);
		eq(RomanNumeral.parse("MCDLXXXI"),1481);
		eq(RomanNumeral.parse("MCDLXXXII"),1482);
		eq(RomanNumeral.parse("MCDLXXXIII"),1483);
		eq(RomanNumeral.parse("MCDLXXXIV"),1484);
		eq(RomanNumeral.parse("MCDLXXXV"),1485);
		eq(RomanNumeral.parse("MCDLXXXVI"),1486);
		eq(RomanNumeral.parse("MCDLXXXVII"),1487);
		eq(RomanNumeral.parse("MCDLXXXVIII"),1488);
		eq(RomanNumeral.parse("MCDLXXXIX"),1489);
		eq(RomanNumeral.parse("MCDXC"),1490);
		eq(RomanNumeral.parse("MCDXCI"),1491);
		eq(RomanNumeral.parse("MCDXCII"),1492);
		eq(RomanNumeral.parse("MCDXCIII"),1493);
		eq(RomanNumeral.parse("MCDXCIV"),1494);
		eq(RomanNumeral.parse("MCDXCV"),1495);
		eq(RomanNumeral.parse("MCDXCVI"),1496);
		eq(RomanNumeral.parse("MCDXCVII"),1497);
		eq(RomanNumeral.parse("MCDXCVIII"),1498);
		eq(RomanNumeral.parse("MCDXCIX"),1499);
		eq(RomanNumeral.parse("MD"),1500);
		eq(RomanNumeral.parse("MDI"),1501);
		eq(RomanNumeral.parse("MDII"),1502);
		eq(RomanNumeral.parse("MDIII"),1503);
		eq(RomanNumeral.parse("MDIV"),1504);
		eq(RomanNumeral.parse("MDV"),1505);
		eq(RomanNumeral.parse("MDVI"),1506);
		eq(RomanNumeral.parse("MDVII"),1507);
		eq(RomanNumeral.parse("MDVIII"),1508);
		eq(RomanNumeral.parse("MDIX"),1509);
		eq(RomanNumeral.parse("MDX"),1510);
		eq(RomanNumeral.parse("MDXI"),1511);
		eq(RomanNumeral.parse("MDXII"),1512);
		eq(RomanNumeral.parse("MDXIII"),1513);
		eq(RomanNumeral.parse("MDXIV"),1514);
		eq(RomanNumeral.parse("MDXV"),1515);
		eq(RomanNumeral.parse("MDXVI"),1516);
		eq(RomanNumeral.parse("MDXVII"),1517);
		eq(RomanNumeral.parse("MDXVIII"),1518);
		eq(RomanNumeral.parse("MDXIX"),1519);
		eq(RomanNumeral.parse("MDXX"),1520);
		eq(RomanNumeral.parse("MDXXI"),1521);
		eq(RomanNumeral.parse("MDXXII"),1522);
		eq(RomanNumeral.parse("MDXXIII"),1523);
		eq(RomanNumeral.parse("MDXXIV"),1524);
		eq(RomanNumeral.parse("MDXXV"),1525);
		eq(RomanNumeral.parse("MDXXVI"),1526);
		eq(RomanNumeral.parse("MDXXVII"),1527);
		eq(RomanNumeral.parse("MDXXVIII"),1528);
		eq(RomanNumeral.parse("MDXXIX"),1529);
		eq(RomanNumeral.parse("MDXXX"),1530);
		eq(RomanNumeral.parse("MDXXXI"),1531);
		eq(RomanNumeral.parse("MDXXXII"),1532);
		eq(RomanNumeral.parse("MDXXXIII"),1533);
		eq(RomanNumeral.parse("MDXXXIV"),1534);
		eq(RomanNumeral.parse("MDXXXV"),1535);
		eq(RomanNumeral.parse("MDXXXVI"),1536);
		eq(RomanNumeral.parse("MDXXXVII"),1537);
		eq(RomanNumeral.parse("MDXXXVIII"),1538);
		eq(RomanNumeral.parse("MDXXXIX"),1539);
		eq(RomanNumeral.parse("MDXL"),1540);
		eq(RomanNumeral.parse("MDXLI"),1541);
		eq(RomanNumeral.parse("MDXLII"),1542);
		eq(RomanNumeral.parse("MDXLIII"),1543);
		eq(RomanNumeral.parse("MDXLIV"),1544);
		eq(RomanNumeral.parse("MDXLV"),1545);
		eq(RomanNumeral.parse("MDXLVI"),1546);
		eq(RomanNumeral.parse("MDXLVII"),1547);
		eq(RomanNumeral.parse("MDXLVIII"),1548);
		eq(RomanNumeral.parse("MDXLIX"),1549);
		eq(RomanNumeral.parse("MDL"),1550);
		eq(RomanNumeral.parse("MDLI"),1551);
		eq(RomanNumeral.parse("MDLII"),1552);
		eq(RomanNumeral.parse("MDLIII"),1553);
		eq(RomanNumeral.parse("MDLIV"),1554);
		eq(RomanNumeral.parse("MDLV"),1555);
		eq(RomanNumeral.parse("MDLVI"),1556);
		eq(RomanNumeral.parse("MDLVII"),1557);
		eq(RomanNumeral.parse("MDLVIII"),1558);
		eq(RomanNumeral.parse("MDLIX"),1559);
		eq(RomanNumeral.parse("MDLX"),1560);
		eq(RomanNumeral.parse("MDLXI"),1561);
		eq(RomanNumeral.parse("MDLXII"),1562);
		eq(RomanNumeral.parse("MDLXIII"),1563);
		eq(RomanNumeral.parse("MDLXIV"),1564);
		eq(RomanNumeral.parse("MDLXV"),1565);
		eq(RomanNumeral.parse("MDLXVI"),1566);
		eq(RomanNumeral.parse("MDLXVII"),1567);
		eq(RomanNumeral.parse("MDLXVIII"),1568);
		eq(RomanNumeral.parse("MDLXIX"),1569);
		eq(RomanNumeral.parse("MDLXX"),1570);
		eq(RomanNumeral.parse("MDLXXI"),1571);
		eq(RomanNumeral.parse("MDLXXII"),1572);
		eq(RomanNumeral.parse("MDLXXIII"),1573);
		eq(RomanNumeral.parse("MDLXXIV"),1574);
		eq(RomanNumeral.parse("MDLXXV"),1575);
		eq(RomanNumeral.parse("MDLXXVI"),1576);
		eq(RomanNumeral.parse("MDLXXVII"),1577);
		eq(RomanNumeral.parse("MDLXXVIII"),1578);
		eq(RomanNumeral.parse("MDLXXIX"),1579);
		eq(RomanNumeral.parse("MDLXXX"),1580);
		eq(RomanNumeral.parse("MDLXXXI"),1581);
		eq(RomanNumeral.parse("MDLXXXII"),1582);
		eq(RomanNumeral.parse("MDLXXXIII"),1583);
		eq(RomanNumeral.parse("MDLXXXIV"),1584);
		eq(RomanNumeral.parse("MDLXXXV"),1585);
		eq(RomanNumeral.parse("MDLXXXVI"),1586);
		eq(RomanNumeral.parse("MDLXXXVII"),1587);
		eq(RomanNumeral.parse("MDLXXXVIII"),1588);
		eq(RomanNumeral.parse("MDLXXXIX"),1589);
		eq(RomanNumeral.parse("MDXC"),1590);
		eq(RomanNumeral.parse("MDXCI"),1591);
		eq(RomanNumeral.parse("MDXCII"),1592);
		eq(RomanNumeral.parse("MDXCIII"),1593);
		eq(RomanNumeral.parse("MDXCIV"),1594);
		eq(RomanNumeral.parse("MDXCV"),1595);
		eq(RomanNumeral.parse("MDXCVI"),1596);
		eq(RomanNumeral.parse("MDXCVII"),1597);
		eq(RomanNumeral.parse("MDXCVIII"),1598);
		eq(RomanNumeral.parse("MDXCIX"),1599);
		eq(RomanNumeral.parse("MDC"),1600);
		eq(RomanNumeral.parse("MDCI"),1601);
		eq(RomanNumeral.parse("MDCII"),1602);
		eq(RomanNumeral.parse("MDCIII"),1603);
		eq(RomanNumeral.parse("MDCIV"),1604);
		eq(RomanNumeral.parse("MDCV"),1605);
		eq(RomanNumeral.parse("MDCVI"),1606);
		eq(RomanNumeral.parse("MDCVII"),1607);
		eq(RomanNumeral.parse("MDCVIII"),1608);
		eq(RomanNumeral.parse("MDCIX"),1609);
		eq(RomanNumeral.parse("MDCX"),1610);
		eq(RomanNumeral.parse("MDCXI"),1611);
		eq(RomanNumeral.parse("MDCXII"),1612);
		eq(RomanNumeral.parse("MDCXIII"),1613);
		eq(RomanNumeral.parse("MDCXIV"),1614);
		eq(RomanNumeral.parse("MDCXV"),1615);
		eq(RomanNumeral.parse("MDCXVI"),1616);
		eq(RomanNumeral.parse("MDCXVII"),1617);
		eq(RomanNumeral.parse("MDCXVIII"),1618);
		eq(RomanNumeral.parse("MDCXIX"),1619);
		eq(RomanNumeral.parse("MDCXX"),1620);
		eq(RomanNumeral.parse("MDCXXI"),1621);
		eq(RomanNumeral.parse("MDCXXII"),1622);
		eq(RomanNumeral.parse("MDCXXIII"),1623);
		eq(RomanNumeral.parse("MDCXXIV"),1624);
		eq(RomanNumeral.parse("MDCXXV"),1625);
		eq(RomanNumeral.parse("MDCXXVI"),1626);
		eq(RomanNumeral.parse("MDCXXVII"),1627);
		eq(RomanNumeral.parse("MDCXXVIII"),1628);
		eq(RomanNumeral.parse("MDCXXIX"),1629);
		eq(RomanNumeral.parse("MDCXXX"),1630);
		eq(RomanNumeral.parse("MDCXXXI"),1631);
		eq(RomanNumeral.parse("MDCXXXII"),1632);
		eq(RomanNumeral.parse("MDCXXXIII"),1633);
		eq(RomanNumeral.parse("MDCXXXIV"),1634);
		eq(RomanNumeral.parse("MDCXXXV"),1635);
		eq(RomanNumeral.parse("MDCXXXVI"),1636);
		eq(RomanNumeral.parse("MDCXXXVII"),1637);
		eq(RomanNumeral.parse("MDCXXXVIII"),1638);
		eq(RomanNumeral.parse("MDCXXXIX"),1639);
		eq(RomanNumeral.parse("MDCXL"),1640);
		eq(RomanNumeral.parse("MDCXLI"),1641);
		eq(RomanNumeral.parse("MDCXLII"),1642);
		eq(RomanNumeral.parse("MDCXLIII"),1643);
		eq(RomanNumeral.parse("MDCXLIV"),1644);
		eq(RomanNumeral.parse("MDCXLV"),1645);
		eq(RomanNumeral.parse("MDCXLVI"),1646);
		eq(RomanNumeral.parse("MDCXLVII"),1647);
		eq(RomanNumeral.parse("MDCXLVIII"),1648);
		eq(RomanNumeral.parse("MDCXLIX"),1649);
		eq(RomanNumeral.parse("MDCL"),1650);
		eq(RomanNumeral.parse("MDCLI"),1651);
		eq(RomanNumeral.parse("MDCLII"),1652);
		eq(RomanNumeral.parse("MDCLIII"),1653);
		eq(RomanNumeral.parse("MDCLIV"),1654);
		eq(RomanNumeral.parse("MDCLV"),1655);
		eq(RomanNumeral.parse("MDCLVI"),1656);
		eq(RomanNumeral.parse("MDCLVII"),1657);
		eq(RomanNumeral.parse("MDCLVIII"),1658);
		eq(RomanNumeral.parse("MDCLIX"),1659);
		eq(RomanNumeral.parse("MDCLX"),1660);
		eq(RomanNumeral.parse("MDCLXI"),1661);
		eq(RomanNumeral.parse("MDCLXII"),1662);
		eq(RomanNumeral.parse("MDCLXIII"),1663);
		eq(RomanNumeral.parse("MDCLXIV"),1664);
		eq(RomanNumeral.parse("MDCLXV"),1665);
		eq(RomanNumeral.parse("MDCLXVI"),1666);
		eq(RomanNumeral.parse("MDCLXVII"),1667);
		eq(RomanNumeral.parse("MDCLXVIII"),1668);
		eq(RomanNumeral.parse("MDCLXIX"),1669);
		eq(RomanNumeral.parse("MDCLXX"),1670);
		eq(RomanNumeral.parse("MDCLXXI"),1671);
		eq(RomanNumeral.parse("MDCLXXII"),1672);
		eq(RomanNumeral.parse("MDCLXXIII"),1673);
		eq(RomanNumeral.parse("MDCLXXIV"),1674);
		eq(RomanNumeral.parse("MDCLXXV"),1675);
		eq(RomanNumeral.parse("MDCLXXVI"),1676);
		eq(RomanNumeral.parse("MDCLXXVII"),1677);
		eq(RomanNumeral.parse("MDCLXXVIII"),1678);
		eq(RomanNumeral.parse("MDCLXXIX"),1679);
		eq(RomanNumeral.parse("MDCLXXX"),1680);
		eq(RomanNumeral.parse("MDCLXXXI"),1681);
		eq(RomanNumeral.parse("MDCLXXXII"),1682);
		eq(RomanNumeral.parse("MDCLXXXIII"),1683);
		eq(RomanNumeral.parse("MDCLXXXIV"),1684);
		eq(RomanNumeral.parse("MDCLXXXV"),1685);
		eq(RomanNumeral.parse("MDCLXXXVI"),1686);
		eq(RomanNumeral.parse("MDCLXXXVII"),1687);
		eq(RomanNumeral.parse("MDCLXXXVIII"),1688);
		eq(RomanNumeral.parse("MDCLXXXIX"),1689);
		eq(RomanNumeral.parse("MDCXC"),1690);
		eq(RomanNumeral.parse("MDCXCI"),1691);
		eq(RomanNumeral.parse("MDCXCII"),1692);
		eq(RomanNumeral.parse("MDCXCIII"),1693);
		eq(RomanNumeral.parse("MDCXCIV"),1694);
		eq(RomanNumeral.parse("MDCXCV"),1695);
		eq(RomanNumeral.parse("MDCXCVI"),1696);
		eq(RomanNumeral.parse("MDCXCVII"),1697);
		eq(RomanNumeral.parse("MDCXCVIII"),1698);
		eq(RomanNumeral.parse("MDCXCIX"),1699);
		eq(RomanNumeral.parse("MDCC"),1700);
		eq(RomanNumeral.parse("MDCCI"),1701);
		eq(RomanNumeral.parse("MDCCII"),1702);
		eq(RomanNumeral.parse("MDCCIII"),1703);
		eq(RomanNumeral.parse("MDCCIV"),1704);
		eq(RomanNumeral.parse("MDCCV"),1705);
		eq(RomanNumeral.parse("MDCCVI"),1706);
		eq(RomanNumeral.parse("MDCCVII"),1707);
		eq(RomanNumeral.parse("MDCCVIII"),1708);
		eq(RomanNumeral.parse("MDCCIX"),1709);
		eq(RomanNumeral.parse("MDCCX"),1710);
		eq(RomanNumeral.parse("MDCCXI"),1711);
		eq(RomanNumeral.parse("MDCCXII"),1712);
		eq(RomanNumeral.parse("MDCCXIII"),1713);
		eq(RomanNumeral.parse("MDCCXIV"),1714);
		eq(RomanNumeral.parse("MDCCXV"),1715);
		eq(RomanNumeral.parse("MDCCXVI"),1716);
		eq(RomanNumeral.parse("MDCCXVII"),1717);
		eq(RomanNumeral.parse("MDCCXVIII"),1718);
		eq(RomanNumeral.parse("MDCCXIX"),1719);
		eq(RomanNumeral.parse("MDCCXX"),1720);
		eq(RomanNumeral.parse("MDCCXXI"),1721);
		eq(RomanNumeral.parse("MDCCXXII"),1722);
		eq(RomanNumeral.parse("MDCCXXIII"),1723);
		eq(RomanNumeral.parse("MDCCXXIV"),1724);
		eq(RomanNumeral.parse("MDCCXXV"),1725);
		eq(RomanNumeral.parse("MDCCXXVI"),1726);
		eq(RomanNumeral.parse("MDCCXXVII"),1727);
		eq(RomanNumeral.parse("MDCCXXVIII"),1728);
		eq(RomanNumeral.parse("MDCCXXIX"),1729);
		eq(RomanNumeral.parse("MDCCXXX"),1730);
		eq(RomanNumeral.parse("MDCCXXXI"),1731);
		eq(RomanNumeral.parse("MDCCXXXII"),1732);
		eq(RomanNumeral.parse("MDCCXXXIII"),1733);
		eq(RomanNumeral.parse("MDCCXXXIV"),1734);
		eq(RomanNumeral.parse("MDCCXXXV"),1735);
		eq(RomanNumeral.parse("MDCCXXXVI"),1736);
		eq(RomanNumeral.parse("MDCCXXXVII"),1737);
		eq(RomanNumeral.parse("MDCCXXXVIII"),1738);
		eq(RomanNumeral.parse("MDCCXXXIX"),1739);
		eq(RomanNumeral.parse("MDCCXL"),1740);
		eq(RomanNumeral.parse("MDCCXLI"),1741);
		eq(RomanNumeral.parse("MDCCXLII"),1742);
		eq(RomanNumeral.parse("MDCCXLIII"),1743);
		eq(RomanNumeral.parse("MDCCXLIV"),1744);
		eq(RomanNumeral.parse("MDCCXLV"),1745);
		eq(RomanNumeral.parse("MDCCXLVI"),1746);
		eq(RomanNumeral.parse("MDCCXLVII"),1747);
		eq(RomanNumeral.parse("MDCCXLVIII"),1748);
		eq(RomanNumeral.parse("MDCCXLIX"),1749);
		eq(RomanNumeral.parse("MDCCL"),1750);
		eq(RomanNumeral.parse("MDCCLI"),1751);
		eq(RomanNumeral.parse("MDCCLII"),1752);
		eq(RomanNumeral.parse("MDCCLIII"),1753);
		eq(RomanNumeral.parse("MDCCLIV"),1754);
		eq(RomanNumeral.parse("MDCCLV"),1755);
		eq(RomanNumeral.parse("MDCCLVI"),1756);
		eq(RomanNumeral.parse("MDCCLVII"),1757);
		eq(RomanNumeral.parse("MDCCLVIII"),1758);
		eq(RomanNumeral.parse("MDCCLIX"),1759);
		eq(RomanNumeral.parse("MDCCLX"),1760);
		eq(RomanNumeral.parse("MDCCLXI"),1761);
		eq(RomanNumeral.parse("MDCCLXII"),1762);
		eq(RomanNumeral.parse("MDCCLXIII"),1763);
		eq(RomanNumeral.parse("MDCCLXIV"),1764);
		eq(RomanNumeral.parse("MDCCLXV"),1765);
		eq(RomanNumeral.parse("MDCCLXVI"),1766);
		eq(RomanNumeral.parse("MDCCLXVII"),1767);
		eq(RomanNumeral.parse("MDCCLXVIII"),1768);
		eq(RomanNumeral.parse("MDCCLXIX"),1769);
		eq(RomanNumeral.parse("MDCCLXX"),1770);
		eq(RomanNumeral.parse("MDCCLXXI"),1771);
		eq(RomanNumeral.parse("MDCCLXXII"),1772);
		eq(RomanNumeral.parse("MDCCLXXIII"),1773);
		eq(RomanNumeral.parse("MDCCLXXIV"),1774);
		eq(RomanNumeral.parse("MDCCLXXV"),1775);
		eq(RomanNumeral.parse("MDCCLXXVI"),1776);
		eq(RomanNumeral.parse("MDCCLXXVII"),1777);
		eq(RomanNumeral.parse("MDCCLXXVIII"),1778);
		eq(RomanNumeral.parse("MDCCLXXIX"),1779);
		eq(RomanNumeral.parse("MDCCLXXX"),1780);
		eq(RomanNumeral.parse("MDCCLXXXI"),1781);
		eq(RomanNumeral.parse("MDCCLXXXII"),1782);
		eq(RomanNumeral.parse("MDCCLXXXIII"),1783);
		eq(RomanNumeral.parse("MDCCLXXXIV"),1784);
		eq(RomanNumeral.parse("MDCCLXXXV"),1785);
		eq(RomanNumeral.parse("MDCCLXXXVI"),1786);
		eq(RomanNumeral.parse("MDCCLXXXVII"),1787);
		eq(RomanNumeral.parse("MDCCLXXXVIII"),1788);
		eq(RomanNumeral.parse("MDCCLXXXIX"),1789);
		eq(RomanNumeral.parse("MDCCXC"),1790);
		eq(RomanNumeral.parse("MDCCXCI"),1791);
		eq(RomanNumeral.parse("MDCCXCII"),1792);
		eq(RomanNumeral.parse("MDCCXCIII"),1793);
		eq(RomanNumeral.parse("MDCCXCIV"),1794);
		eq(RomanNumeral.parse("MDCCXCV"),1795);
		eq(RomanNumeral.parse("MDCCXCVI"),1796);
		eq(RomanNumeral.parse("MDCCXCVII"),1797);
		eq(RomanNumeral.parse("MDCCXCVIII"),1798);
		eq(RomanNumeral.parse("MDCCXCIX"),1799);
		eq(RomanNumeral.parse("MDCCC"),1800);
		eq(RomanNumeral.parse("MDCCCI"),1801);
		eq(RomanNumeral.parse("MDCCCII"),1802);
		eq(RomanNumeral.parse("MDCCCIII"),1803);
		eq(RomanNumeral.parse("MDCCCIV"),1804);
		eq(RomanNumeral.parse("MDCCCV"),1805);
		eq(RomanNumeral.parse("MDCCCVI"),1806);
		eq(RomanNumeral.parse("MDCCCVII"),1807);
		eq(RomanNumeral.parse("MDCCCVIII"),1808);
		eq(RomanNumeral.parse("MDCCCIX"),1809);
		eq(RomanNumeral.parse("MDCCCX"),1810);
		eq(RomanNumeral.parse("MDCCCXI"),1811);
		eq(RomanNumeral.parse("MDCCCXII"),1812);
		eq(RomanNumeral.parse("MDCCCXIII"),1813);
		eq(RomanNumeral.parse("MDCCCXIV"),1814);
		eq(RomanNumeral.parse("MDCCCXV"),1815);
		eq(RomanNumeral.parse("MDCCCXVI"),1816);
		eq(RomanNumeral.parse("MDCCCXVII"),1817);
		eq(RomanNumeral.parse("MDCCCXVIII"),1818);
		eq(RomanNumeral.parse("MDCCCXIX"),1819);
		eq(RomanNumeral.parse("MDCCCXX"),1820);
		eq(RomanNumeral.parse("MDCCCXXI"),1821);
		eq(RomanNumeral.parse("MDCCCXXII"),1822);
		eq(RomanNumeral.parse("MDCCCXXIII"),1823);
		eq(RomanNumeral.parse("MDCCCXXIV"),1824);
		eq(RomanNumeral.parse("MDCCCXXV"),1825);
		eq(RomanNumeral.parse("MDCCCXXVI"),1826);
		eq(RomanNumeral.parse("MDCCCXXVII"),1827);
		eq(RomanNumeral.parse("MDCCCXXVIII"),1828);
		eq(RomanNumeral.parse("MDCCCXXIX"),1829);
		eq(RomanNumeral.parse("MDCCCXXX"),1830);
		eq(RomanNumeral.parse("MDCCCXXXI"),1831);
		eq(RomanNumeral.parse("MDCCCXXXII"),1832);
		eq(RomanNumeral.parse("MDCCCXXXIII"),1833);
		eq(RomanNumeral.parse("MDCCCXXXIV"),1834);
		eq(RomanNumeral.parse("MDCCCXXXV"),1835);
		eq(RomanNumeral.parse("MDCCCXXXVI"),1836);
		eq(RomanNumeral.parse("MDCCCXXXVII"),1837);
		eq(RomanNumeral.parse("MDCCCXXXVIII"),1838);
		eq(RomanNumeral.parse("MDCCCXXXIX"),1839);
		eq(RomanNumeral.parse("MDCCCXL"),1840);
		eq(RomanNumeral.parse("MDCCCXLI"),1841);
		eq(RomanNumeral.parse("MDCCCXLII"),1842);
		eq(RomanNumeral.parse("MDCCCXLIII"),1843);
		eq(RomanNumeral.parse("MDCCCXLIV"),1844);
		eq(RomanNumeral.parse("MDCCCXLV"),1845);
		eq(RomanNumeral.parse("MDCCCXLVI"),1846);
		eq(RomanNumeral.parse("MDCCCXLVII"),1847);
		eq(RomanNumeral.parse("MDCCCXLVIII"),1848);
		eq(RomanNumeral.parse("MDCCCXLIX"),1849);
		eq(RomanNumeral.parse("MDCCCL"),1850);
		eq(RomanNumeral.parse("MDCCCLI"),1851);
		eq(RomanNumeral.parse("MDCCCLII"),1852);
		eq(RomanNumeral.parse("MDCCCLIII"),1853);
		eq(RomanNumeral.parse("MDCCCLIV"),1854);
		eq(RomanNumeral.parse("MDCCCLV"),1855);
		eq(RomanNumeral.parse("MDCCCLVI"),1856);
		eq(RomanNumeral.parse("MDCCCLVII"),1857);
		eq(RomanNumeral.parse("MDCCCLVIII"),1858);
		eq(RomanNumeral.parse("MDCCCLIX"),1859);
		eq(RomanNumeral.parse("MDCCCLX"),1860);
		eq(RomanNumeral.parse("MDCCCLXI"),1861);
		eq(RomanNumeral.parse("MDCCCLXII"),1862);
		eq(RomanNumeral.parse("MDCCCLXIII"),1863);
		eq(RomanNumeral.parse("MDCCCLXIV"),1864);
		eq(RomanNumeral.parse("MDCCCLXV"),1865);
		eq(RomanNumeral.parse("MDCCCLXVI"),1866);
		eq(RomanNumeral.parse("MDCCCLXVII"),1867);
		eq(RomanNumeral.parse("MDCCCLXVIII"),1868);
		eq(RomanNumeral.parse("MDCCCLXIX"),1869);
		eq(RomanNumeral.parse("MDCCCLXX"),1870);
		eq(RomanNumeral.parse("MDCCCLXXI"),1871);
		eq(RomanNumeral.parse("MDCCCLXXII"),1872);
		eq(RomanNumeral.parse("MDCCCLXXIII"),1873);
		eq(RomanNumeral.parse("MDCCCLXXIV"),1874);
		eq(RomanNumeral.parse("MDCCCLXXV"),1875);
		eq(RomanNumeral.parse("MDCCCLXXVI"),1876);
		eq(RomanNumeral.parse("MDCCCLXXVII"),1877);
		eq(RomanNumeral.parse("MDCCCLXXVIII"),1878);
		eq(RomanNumeral.parse("MDCCCLXXIX"),1879);
		eq(RomanNumeral.parse("MDCCCLXXX"),1880);
		eq(RomanNumeral.parse("MDCCCLXXXI"),1881);
		eq(RomanNumeral.parse("MDCCCLXXXII"),1882);
		eq(RomanNumeral.parse("MDCCCLXXXIII"),1883);
		eq(RomanNumeral.parse("MDCCCLXXXIV"),1884);
		eq(RomanNumeral.parse("MDCCCLXXXV"),1885);
		eq(RomanNumeral.parse("MDCCCLXXXVI"),1886);
		eq(RomanNumeral.parse("MDCCCLXXXVII"),1887);
		eq(RomanNumeral.parse("MDCCCLXXXVIII"),1888);
		eq(RomanNumeral.parse("MDCCCLXXXIX"),1889);
		eq(RomanNumeral.parse("MDCCCXC"),1890);
		eq(RomanNumeral.parse("MDCCCXCI"),1891);
		eq(RomanNumeral.parse("MDCCCXCII"),1892);
		eq(RomanNumeral.parse("MDCCCXCIII"),1893);
		eq(RomanNumeral.parse("MDCCCXCIV"),1894);
		eq(RomanNumeral.parse("MDCCCXCV"),1895);
		eq(RomanNumeral.parse("MDCCCXCVI"),1896);
		eq(RomanNumeral.parse("MDCCCXCVII"),1897);
		eq(RomanNumeral.parse("MDCCCXCVIII"),1898);
		eq(RomanNumeral.parse("MDCCCXCIX"),1899);
		eq(RomanNumeral.parse("MCM"),1900);
		eq(RomanNumeral.parse("MCMI"),1901);
		eq(RomanNumeral.parse("MCMII"),1902);
		eq(RomanNumeral.parse("MCMIII"),1903);
		eq(RomanNumeral.parse("MCMIV"),1904);
		eq(RomanNumeral.parse("MCMV"),1905);
		eq(RomanNumeral.parse("MCMVI"),1906);
		eq(RomanNumeral.parse("MCMVII"),1907);
		eq(RomanNumeral.parse("MCMVIII"),1908);
		eq(RomanNumeral.parse("MCMIX"),1909);
		eq(RomanNumeral.parse("MCMX"),1910);
		eq(RomanNumeral.parse("MCMXI"),1911);
		eq(RomanNumeral.parse("MCMXII"),1912);
		eq(RomanNumeral.parse("MCMXIII"),1913);
		eq(RomanNumeral.parse("MCMXIV"),1914);
		eq(RomanNumeral.parse("MCMXV"),1915);
		eq(RomanNumeral.parse("MCMXVI"),1916);
		eq(RomanNumeral.parse("MCMXVII"),1917);
		eq(RomanNumeral.parse("MCMXVIII"),1918);
		eq(RomanNumeral.parse("MCMXIX"),1919);
		eq(RomanNumeral.parse("MCMXX"),1920);
		eq(RomanNumeral.parse("MCMXXI"),1921);
		eq(RomanNumeral.parse("MCMXXII"),1922);
		eq(RomanNumeral.parse("MCMXXIII"),1923);
		eq(RomanNumeral.parse("MCMXXIV"),1924);
		eq(RomanNumeral.parse("MCMXXV"),1925);
		eq(RomanNumeral.parse("MCMXXVI"),1926);
		eq(RomanNumeral.parse("MCMXXVII"),1927);
		eq(RomanNumeral.parse("MCMXXVIII"),1928);
		eq(RomanNumeral.parse("MCMXXIX"),1929);
		eq(RomanNumeral.parse("MCMXXX"),1930);
		eq(RomanNumeral.parse("MCMXXXI"),1931);
		eq(RomanNumeral.parse("MCMXXXII"),1932);
		eq(RomanNumeral.parse("MCMXXXIII"),1933);
		eq(RomanNumeral.parse("MCMXXXIV"),1934);
		eq(RomanNumeral.parse("MCMXXXV"),1935);
		eq(RomanNumeral.parse("MCMXXXVI"),1936);
		eq(RomanNumeral.parse("MCMXXXVII"),1937);
		eq(RomanNumeral.parse("MCMXXXVIII"),1938);
		eq(RomanNumeral.parse("MCMXXXIX"),1939);
		eq(RomanNumeral.parse("MCMXL"),1940);
		eq(RomanNumeral.parse("MCMXLI"),1941);
		eq(RomanNumeral.parse("MCMXLII"),1942);
		eq(RomanNumeral.parse("MCMXLIII"),1943);
		eq(RomanNumeral.parse("MCMXLIV"),1944);
		eq(RomanNumeral.parse("MCMXLV"),1945);
		eq(RomanNumeral.parse("MCMXLVI"),1946);
		eq(RomanNumeral.parse("MCMXLVII"),1947);
		eq(RomanNumeral.parse("MCMXLVIII"),1948);
		eq(RomanNumeral.parse("MCMXLIX"),1949);
		eq(RomanNumeral.parse("MCML"),1950);
		eq(RomanNumeral.parse("MCMLI"),1951);
		eq(RomanNumeral.parse("MCMLII"),1952);
		eq(RomanNumeral.parse("MCMLIII"),1953);
		eq(RomanNumeral.parse("MCMLIV"),1954);
		eq(RomanNumeral.parse("MCMLV"),1955);
		eq(RomanNumeral.parse("MCMLVI"),1956);
		eq(RomanNumeral.parse("MCMLVII"),1957);
		eq(RomanNumeral.parse("MCMLVIII"),1958);
		eq(RomanNumeral.parse("MCMLIX"),1959);
		eq(RomanNumeral.parse("MCMLX"),1960);
		eq(RomanNumeral.parse("MCMLXI"),1961);
		eq(RomanNumeral.parse("MCMLXII"),1962);
		eq(RomanNumeral.parse("MCMLXIII"),1963);
		eq(RomanNumeral.parse("MCMLXIV"),1964);
		eq(RomanNumeral.parse("MCMLXV"),1965);
		eq(RomanNumeral.parse("MCMLXVI"),1966);
		eq(RomanNumeral.parse("MCMLXVII"),1967);
		eq(RomanNumeral.parse("MCMLXVIII"),1968);
		eq(RomanNumeral.parse("MCMLXIX"),1969);
		eq(RomanNumeral.parse("MCMLXX"),1970);
		eq(RomanNumeral.parse("MCMLXXI"),1971);
		eq(RomanNumeral.parse("MCMLXXII"),1972);
		eq(RomanNumeral.parse("MCMLXXIII"),1973);
		eq(RomanNumeral.parse("MCMLXXIV"),1974);
		eq(RomanNumeral.parse("MCMLXXV"),1975);
		eq(RomanNumeral.parse("MCMLXXVI"),1976);
		eq(RomanNumeral.parse("MCMLXXVII"),1977);
		eq(RomanNumeral.parse("MCMLXXVIII"),1978);
		eq(RomanNumeral.parse("MCMLXXIX"),1979);
		eq(RomanNumeral.parse("MCMLXXX"),1980);
		eq(RomanNumeral.parse("MCMLXXXI"),1981);
		eq(RomanNumeral.parse("MCMLXXXII"),1982);
		eq(RomanNumeral.parse("MCMLXXXIII"),1983);
		eq(RomanNumeral.parse("MCMLXXXIV"),1984);
		eq(RomanNumeral.parse("MCMLXXXV"),1985);
		eq(RomanNumeral.parse("MCMLXXXVI"),1986);
		eq(RomanNumeral.parse("MCMLXXXVII"),1987);
		eq(RomanNumeral.parse("MCMLXXXVIII"),1988);
		eq(RomanNumeral.parse("MCMLXXXIX"),1989);
		eq(RomanNumeral.parse("MCMXC"),1990);
		eq(RomanNumeral.parse("MCMXCI"),1991);
		eq(RomanNumeral.parse("MCMXCII"),1992);
		eq(RomanNumeral.parse("MCMXCIII"),1993);
		eq(RomanNumeral.parse("MCMXCIV"),1994);
		eq(RomanNumeral.parse("MCMXCV"),1995);
		eq(RomanNumeral.parse("MCMXCVI"),1996);
		eq(RomanNumeral.parse("MCMXCVII"),1997);
		eq(RomanNumeral.parse("MCMXCVIII"),1998);
		eq(RomanNumeral.parse("MCMXCIX"),1999);
		eq(RomanNumeral.parse("MM"),2000);
		eq(RomanNumeral.parse("MMI"),2001);
		eq(RomanNumeral.parse("MMII"),2002);
		eq(RomanNumeral.parse("MMIII"),2003);
		eq(RomanNumeral.parse("MMIV"),2004);
		eq(RomanNumeral.parse("MMV"),2005);
		eq(RomanNumeral.parse("MMVI"),2006);
		eq(RomanNumeral.parse("MMVII"),2007);
		eq(RomanNumeral.parse("MMVIII"),2008);
		eq(RomanNumeral.parse("MMIX"),2009);
		eq(RomanNumeral.parse("MMX"),2010);
		eq(RomanNumeral.parse("MMXI"),2011);
		eq(RomanNumeral.parse("MMXII"),2012);
		eq(RomanNumeral.parse("MMXIII"),2013);
		eq(RomanNumeral.parse("MMXIV"),2014);
		eq(RomanNumeral.parse("MMXV"),2015);
		eq(RomanNumeral.parse("MMXVI"),2016);
		eq(RomanNumeral.parse("MMXVII"),2017);
		eq(RomanNumeral.parse("MMXVIII"),2018);
		eq(RomanNumeral.parse("MMXIX"),2019);
		eq(RomanNumeral.parse("MMXX"),2020);
		eq(RomanNumeral.parse("MMXXI"),2021);
		eq(RomanNumeral.parse("MMXXII"),2022);
		eq(RomanNumeral.parse("MMXXIII"),2023);
		eq(RomanNumeral.parse("MMXXIV"),2024);
		eq(RomanNumeral.parse("MMXXV"),2025);
		eq(RomanNumeral.parse("MMXXVI"),2026);
		eq(RomanNumeral.parse("MMXXVII"),2027);
		eq(RomanNumeral.parse("MMXXVIII"),2028);
		eq(RomanNumeral.parse("MMXXIX"),2029);
		eq(RomanNumeral.parse("MMXXX"),2030);
		eq(RomanNumeral.parse("MMXXXI"),2031);
		eq(RomanNumeral.parse("MMXXXII"),2032);
		eq(RomanNumeral.parse("MMXXXIII"),2033);
		eq(RomanNumeral.parse("MMXXXIV"),2034);
		eq(RomanNumeral.parse("MMXXXV"),2035);
		eq(RomanNumeral.parse("MMXXXVI"),2036);
		eq(RomanNumeral.parse("MMXXXVII"),2037);
		eq(RomanNumeral.parse("MMXXXVIII"),2038);
		eq(RomanNumeral.parse("MMXXXIX"),2039);
		eq(RomanNumeral.parse("MMXL"),2040);
		eq(RomanNumeral.parse("MMXLI"),2041);
		eq(RomanNumeral.parse("MMXLII"),2042);
		eq(RomanNumeral.parse("MMXLIII"),2043);
		eq(RomanNumeral.parse("MMXLIV"),2044);
		eq(RomanNumeral.parse("MMXLV"),2045);
		eq(RomanNumeral.parse("MMXLVI"),2046);
		eq(RomanNumeral.parse("MMXLVII"),2047);
		eq(RomanNumeral.parse("MMXLVIII"),2048);
		eq(RomanNumeral.parse("MMXLIX"),2049);
		eq(RomanNumeral.parse("MML"),2050);
		eq(RomanNumeral.parse("MMLI"),2051);
		eq(RomanNumeral.parse("MMLII"),2052);
		eq(RomanNumeral.parse("MMLIII"),2053);
		eq(RomanNumeral.parse("MMLIV"),2054);
		eq(RomanNumeral.parse("MMLV"),2055);
		eq(RomanNumeral.parse("MMLVI"),2056);
		eq(RomanNumeral.parse("MMLVII"),2057);
		eq(RomanNumeral.parse("MMLVIII"),2058);
		eq(RomanNumeral.parse("MMLIX"),2059);
		eq(RomanNumeral.parse("MMLX"),2060);
		eq(RomanNumeral.parse("MMLXI"),2061);
		eq(RomanNumeral.parse("MMLXII"),2062);
		eq(RomanNumeral.parse("MMLXIII"),2063);
		eq(RomanNumeral.parse("MMLXIV"),2064);
		eq(RomanNumeral.parse("MMLXV"),2065);
		eq(RomanNumeral.parse("MMLXVI"),2066);
		eq(RomanNumeral.parse("MMLXVII"),2067);
		eq(RomanNumeral.parse("MMLXVIII"),2068);
		eq(RomanNumeral.parse("MMLXIX"),2069);
		eq(RomanNumeral.parse("MMLXX"),2070);
		eq(RomanNumeral.parse("MMLXXI"),2071);
		eq(RomanNumeral.parse("MMLXXII"),2072);
		eq(RomanNumeral.parse("MMLXXIII"),2073);
		eq(RomanNumeral.parse("MMLXXIV"),2074);
		eq(RomanNumeral.parse("MMLXXV"),2075);
		eq(RomanNumeral.parse("MMLXXVI"),2076);
		eq(RomanNumeral.parse("MMLXXVII"),2077);
		eq(RomanNumeral.parse("MMLXXVIII"),2078);
		eq(RomanNumeral.parse("MMLXXIX"),2079);
		eq(RomanNumeral.parse("MMLXXX"),2080);
		eq(RomanNumeral.parse("MMLXXXI"),2081);
		eq(RomanNumeral.parse("MMLXXXII"),2082);
		eq(RomanNumeral.parse("MMLXXXIII"),2083);
		eq(RomanNumeral.parse("MMLXXXIV"),2084);
		eq(RomanNumeral.parse("MMLXXXV"),2085);
		eq(RomanNumeral.parse("MMLXXXVI"),2086);
		eq(RomanNumeral.parse("MMLXXXVII"),2087);
		eq(RomanNumeral.parse("MMLXXXVIII"),2088);
		eq(RomanNumeral.parse("MMLXXXIX"),2089);
		eq(RomanNumeral.parse("MMXC"),2090);
		eq(RomanNumeral.parse("MMXCI"),2091);
		eq(RomanNumeral.parse("MMXCII"),2092);
		eq(RomanNumeral.parse("MMXCIII"),2093);
		eq(RomanNumeral.parse("MMXCIV"),2094);
		eq(RomanNumeral.parse("MMXCV"),2095);
		eq(RomanNumeral.parse("MMXCVI"),2096);
		eq(RomanNumeral.parse("MMXCVII"),2097);
		eq(RomanNumeral.parse("MMXCVIII"),2098);
		eq(RomanNumeral.parse("MMXCIX"),2099);
		eq(RomanNumeral.parse("MMC"),2100);
		eq(RomanNumeral.parse("MMCI"),2101);
		eq(RomanNumeral.parse("MMCII"),2102);
		eq(RomanNumeral.parse("MMCIII"),2103);
		eq(RomanNumeral.parse("MMCIV"),2104);
		eq(RomanNumeral.parse("MMCV"),2105);
		eq(RomanNumeral.parse("MMCVI"),2106);
		eq(RomanNumeral.parse("MMCVII"),2107);
		eq(RomanNumeral.parse("MMCVIII"),2108);
		eq(RomanNumeral.parse("MMCIX"),2109);
		eq(RomanNumeral.parse("MMCX"),2110);
		eq(RomanNumeral.parse("MMCXI"),2111);
		eq(RomanNumeral.parse("MMCXII"),2112);
		eq(RomanNumeral.parse("MMCXIII"),2113);
		eq(RomanNumeral.parse("MMCXIV"),2114);
		eq(RomanNumeral.parse("MMCXV"),2115);
		eq(RomanNumeral.parse("MMCXVI"),2116);
		eq(RomanNumeral.parse("MMCXVII"),2117);
		eq(RomanNumeral.parse("MMCXVIII"),2118);
		eq(RomanNumeral.parse("MMCXIX"),2119);
		eq(RomanNumeral.parse("MMCXX"),2120);
		eq(RomanNumeral.parse("MMCXXI"),2121);
		eq(RomanNumeral.parse("MMCXXII"),2122);
		eq(RomanNumeral.parse("MMCXXIII"),2123);
		eq(RomanNumeral.parse("MMCXXIV"),2124);
		eq(RomanNumeral.parse("MMCXXV"),2125);
		eq(RomanNumeral.parse("MMCXXVI"),2126);
		eq(RomanNumeral.parse("MMCXXVII"),2127);
		eq(RomanNumeral.parse("MMCXXVIII"),2128);
		eq(RomanNumeral.parse("MMCXXIX"),2129);
		eq(RomanNumeral.parse("MMCXXX"),2130);
		eq(RomanNumeral.parse("MMCXXXI"),2131);
		eq(RomanNumeral.parse("MMCXXXII"),2132);
		eq(RomanNumeral.parse("MMCXXXIII"),2133);
		eq(RomanNumeral.parse("MMCXXXIV"),2134);
		eq(RomanNumeral.parse("MMCXXXV"),2135);
		eq(RomanNumeral.parse("MMCXXXVI"),2136);
		eq(RomanNumeral.parse("MMCXXXVII"),2137);
		eq(RomanNumeral.parse("MMCXXXVIII"),2138);
		eq(RomanNumeral.parse("MMCXXXIX"),2139);
		eq(RomanNumeral.parse("MMCXL"),2140);
		eq(RomanNumeral.parse("MMCXLI"),2141);
		eq(RomanNumeral.parse("MMCXLII"),2142);
		eq(RomanNumeral.parse("MMCXLIII"),2143);
		eq(RomanNumeral.parse("MMCXLIV"),2144);
		eq(RomanNumeral.parse("MMCXLV"),2145);
		eq(RomanNumeral.parse("MMCXLVI"),2146);
		eq(RomanNumeral.parse("MMCXLVII"),2147);
		eq(RomanNumeral.parse("MMCXLVIII"),2148);
		eq(RomanNumeral.parse("MMCXLIX"),2149);
		eq(RomanNumeral.parse("MMCL"),2150);
		eq(RomanNumeral.parse("MMCLI"),2151);
		eq(RomanNumeral.parse("MMCLII"),2152);
		eq(RomanNumeral.parse("MMCLIII"),2153);
		eq(RomanNumeral.parse("MMCLIV"),2154);
		eq(RomanNumeral.parse("MMCLV"),2155);
		eq(RomanNumeral.parse("MMCLVI"),2156);
		eq(RomanNumeral.parse("MMCLVII"),2157);
		eq(RomanNumeral.parse("MMCLVIII"),2158);
		eq(RomanNumeral.parse("MMCLIX"),2159);
		eq(RomanNumeral.parse("MMCLX"),2160);
		eq(RomanNumeral.parse("MMCLXI"),2161);
		eq(RomanNumeral.parse("MMCLXII"),2162);
		eq(RomanNumeral.parse("MMCLXIII"),2163);
		eq(RomanNumeral.parse("MMCLXIV"),2164);
		eq(RomanNumeral.parse("MMCLXV"),2165);
		eq(RomanNumeral.parse("MMCLXVI"),2166);
		eq(RomanNumeral.parse("MMCLXVII"),2167);
		eq(RomanNumeral.parse("MMCLXVIII"),2168);
		eq(RomanNumeral.parse("MMCLXIX"),2169);
		eq(RomanNumeral.parse("MMCLXX"),2170);
		eq(RomanNumeral.parse("MMCLXXI"),2171);
		eq(RomanNumeral.parse("MMCLXXII"),2172);
		eq(RomanNumeral.parse("MMCLXXIII"),2173);
		eq(RomanNumeral.parse("MMCLXXIV"),2174);
		eq(RomanNumeral.parse("MMCLXXV"),2175);
		eq(RomanNumeral.parse("MMCLXXVI"),2176);
		eq(RomanNumeral.parse("MMCLXXVII"),2177);
		eq(RomanNumeral.parse("MMCLXXVIII"),2178);
		eq(RomanNumeral.parse("MMCLXXIX"),2179);
		eq(RomanNumeral.parse("MMCLXXX"),2180);
		eq(RomanNumeral.parse("MMCLXXXI"),2181);
		eq(RomanNumeral.parse("MMCLXXXII"),2182);
		eq(RomanNumeral.parse("MMCLXXXIII"),2183);
		eq(RomanNumeral.parse("MMCLXXXIV"),2184);
		eq(RomanNumeral.parse("MMCLXXXV"),2185);
		eq(RomanNumeral.parse("MMCLXXXVI"),2186);
		eq(RomanNumeral.parse("MMCLXXXVII"),2187);
		eq(RomanNumeral.parse("MMCLXXXVIII"),2188);
		eq(RomanNumeral.parse("MMCLXXXIX"),2189);
		eq(RomanNumeral.parse("MMCXC"),2190);
		eq(RomanNumeral.parse("MMCXCI"),2191);
		eq(RomanNumeral.parse("MMCXCII"),2192);
		eq(RomanNumeral.parse("MMCXCIII"),2193);
		eq(RomanNumeral.parse("MMCXCIV"),2194);
		eq(RomanNumeral.parse("MMCXCV"),2195);
		eq(RomanNumeral.parse("MMCXCVI"),2196);
		eq(RomanNumeral.parse("MMCXCVII"),2197);
		eq(RomanNumeral.parse("MMCXCVIII"),2198);
		eq(RomanNumeral.parse("MMCXCIX"),2199);
		eq(RomanNumeral.parse("MMCC"),2200);
		eq(RomanNumeral.parse("MMCCI"),2201);
		eq(RomanNumeral.parse("MMCCII"),2202);
		eq(RomanNumeral.parse("MMCCIII"),2203);
		eq(RomanNumeral.parse("MMCCIV"),2204);
		eq(RomanNumeral.parse("MMCCV"),2205);
		eq(RomanNumeral.parse("MMCCVI"),2206);
		eq(RomanNumeral.parse("MMCCVII"),2207);
		eq(RomanNumeral.parse("MMCCVIII"),2208);
		eq(RomanNumeral.parse("MMCCIX"),2209);
		eq(RomanNumeral.parse("MMCCX"),2210);
		eq(RomanNumeral.parse("MMCCXI"),2211);
		eq(RomanNumeral.parse("MMCCXII"),2212);
		eq(RomanNumeral.parse("MMCCXIII"),2213);
		eq(RomanNumeral.parse("MMCCXIV"),2214);
		eq(RomanNumeral.parse("MMCCXV"),2215);
		eq(RomanNumeral.parse("MMCCXVI"),2216);
		eq(RomanNumeral.parse("MMCCXVII"),2217);
		eq(RomanNumeral.parse("MMCCXVIII"),2218);
		eq(RomanNumeral.parse("MMCCXIX"),2219);
		eq(RomanNumeral.parse("MMCCXX"),2220);
		eq(RomanNumeral.parse("MMCCXXI"),2221);
		eq(RomanNumeral.parse("MMCCXXII"),2222);
		eq(RomanNumeral.parse("MMCCXXIII"),2223);
		eq(RomanNumeral.parse("MMCCXXIV"),2224);
		eq(RomanNumeral.parse("MMCCXXV"),2225);
		eq(RomanNumeral.parse("MMCCXXVI"),2226);
		eq(RomanNumeral.parse("MMCCXXVII"),2227);
		eq(RomanNumeral.parse("MMCCXXVIII"),2228);
		eq(RomanNumeral.parse("MMCCXXIX"),2229);
		eq(RomanNumeral.parse("MMCCXXX"),2230);
		eq(RomanNumeral.parse("MMCCXXXI"),2231);
		eq(RomanNumeral.parse("MMCCXXXII"),2232);
		eq(RomanNumeral.parse("MMCCXXXIII"),2233);
		eq(RomanNumeral.parse("MMCCXXXIV"),2234);
		eq(RomanNumeral.parse("MMCCXXXV"),2235);
		eq(RomanNumeral.parse("MMCCXXXVI"),2236);
		eq(RomanNumeral.parse("MMCCXXXVII"),2237);
		eq(RomanNumeral.parse("MMCCXXXVIII"),2238);
		eq(RomanNumeral.parse("MMCCXXXIX"),2239);
		eq(RomanNumeral.parse("MMCCXL"),2240);
		eq(RomanNumeral.parse("MMCCXLI"),2241);
		eq(RomanNumeral.parse("MMCCXLII"),2242);
		eq(RomanNumeral.parse("MMCCXLIII"),2243);
		eq(RomanNumeral.parse("MMCCXLIV"),2244);
		eq(RomanNumeral.parse("MMCCXLV"),2245);
		eq(RomanNumeral.parse("MMCCXLVI"),2246);
		eq(RomanNumeral.parse("MMCCXLVII"),2247);
		eq(RomanNumeral.parse("MMCCXLVIII"),2248);
		eq(RomanNumeral.parse("MMCCXLIX"),2249);
		eq(RomanNumeral.parse("MMCCL"),2250);
		eq(RomanNumeral.parse("MMCCLI"),2251);
		eq(RomanNumeral.parse("MMCCLII"),2252);
		eq(RomanNumeral.parse("MMCCLIII"),2253);
		eq(RomanNumeral.parse("MMCCLIV"),2254);
		eq(RomanNumeral.parse("MMCCLV"),2255);
		eq(RomanNumeral.parse("MMCCLVI"),2256);
		eq(RomanNumeral.parse("MMCCLVII"),2257);
		eq(RomanNumeral.parse("MMCCLVIII"),2258);
		eq(RomanNumeral.parse("MMCCLIX"),2259);
		eq(RomanNumeral.parse("MMCCLX"),2260);
		eq(RomanNumeral.parse("MMCCLXI"),2261);
		eq(RomanNumeral.parse("MMCCLXII"),2262);
		eq(RomanNumeral.parse("MMCCLXIII"),2263);
		eq(RomanNumeral.parse("MMCCLXIV"),2264);
		eq(RomanNumeral.parse("MMCCLXV"),2265);
		eq(RomanNumeral.parse("MMCCLXVI"),2266);
		eq(RomanNumeral.parse("MMCCLXVII"),2267);
		eq(RomanNumeral.parse("MMCCLXVIII"),2268);
		eq(RomanNumeral.parse("MMCCLXIX"),2269);
		eq(RomanNumeral.parse("MMCCLXX"),2270);
		eq(RomanNumeral.parse("MMCCLXXI"),2271);
		eq(RomanNumeral.parse("MMCCLXXII"),2272);
		eq(RomanNumeral.parse("MMCCLXXIII"),2273);
		eq(RomanNumeral.parse("MMCCLXXIV"),2274);
		eq(RomanNumeral.parse("MMCCLXXV"),2275);
		eq(RomanNumeral.parse("MMCCLXXVI"),2276);
		eq(RomanNumeral.parse("MMCCLXXVII"),2277);
		eq(RomanNumeral.parse("MMCCLXXVIII"),2278);
		eq(RomanNumeral.parse("MMCCLXXIX"),2279);
		eq(RomanNumeral.parse("MMCCLXXX"),2280);
		eq(RomanNumeral.parse("MMCCLXXXI"),2281);
		eq(RomanNumeral.parse("MMCCLXXXII"),2282);
		eq(RomanNumeral.parse("MMCCLXXXIII"),2283);
		eq(RomanNumeral.parse("MMCCLXXXIV"),2284);
		eq(RomanNumeral.parse("MMCCLXXXV"),2285);
		eq(RomanNumeral.parse("MMCCLXXXVI"),2286);
		eq(RomanNumeral.parse("MMCCLXXXVII"),2287);
		eq(RomanNumeral.parse("MMCCLXXXVIII"),2288);
		eq(RomanNumeral.parse("MMCCLXXXIX"),2289);
		eq(RomanNumeral.parse("MMCCXC"),2290);
		eq(RomanNumeral.parse("MMCCXCI"),2291);
		eq(RomanNumeral.parse("MMCCXCII"),2292);
		eq(RomanNumeral.parse("MMCCXCIII"),2293);
		eq(RomanNumeral.parse("MMCCXCIV"),2294);
		eq(RomanNumeral.parse("MMCCXCV"),2295);
		eq(RomanNumeral.parse("MMCCXCVI"),2296);
		eq(RomanNumeral.parse("MMCCXCVII"),2297);
		eq(RomanNumeral.parse("MMCCXCVIII"),2298);
		eq(RomanNumeral.parse("MMCCXCIX"),2299);
		eq(RomanNumeral.parse("MMCCC"),2300);
		eq(RomanNumeral.parse("MMCCCI"),2301);
		eq(RomanNumeral.parse("MMCCCII"),2302);
		eq(RomanNumeral.parse("MMCCCIII"),2303);
		eq(RomanNumeral.parse("MMCCCIV"),2304);
		eq(RomanNumeral.parse("MMCCCV"),2305);
		eq(RomanNumeral.parse("MMCCCVI"),2306);
		eq(RomanNumeral.parse("MMCCCVII"),2307);
		eq(RomanNumeral.parse("MMCCCVIII"),2308);
		eq(RomanNumeral.parse("MMCCCIX"),2309);
		eq(RomanNumeral.parse("MMCCCX"),2310);
		eq(RomanNumeral.parse("MMCCCXI"),2311);
		eq(RomanNumeral.parse("MMCCCXII"),2312);
		eq(RomanNumeral.parse("MMCCCXIII"),2313);
		eq(RomanNumeral.parse("MMCCCXIV"),2314);
		eq(RomanNumeral.parse("MMCCCXV"),2315);
		eq(RomanNumeral.parse("MMCCCXVI"),2316);
		eq(RomanNumeral.parse("MMCCCXVII"),2317);
		eq(RomanNumeral.parse("MMCCCXVIII"),2318);
		eq(RomanNumeral.parse("MMCCCXIX"),2319);
		eq(RomanNumeral.parse("MMCCCXX"),2320);
		eq(RomanNumeral.parse("MMCCCXXI"),2321);
		eq(RomanNumeral.parse("MMCCCXXII"),2322);
		eq(RomanNumeral.parse("MMCCCXXIII"),2323);
		eq(RomanNumeral.parse("MMCCCXXIV"),2324);
		eq(RomanNumeral.parse("MMCCCXXV"),2325);
		eq(RomanNumeral.parse("MMCCCXXVI"),2326);
		eq(RomanNumeral.parse("MMCCCXXVII"),2327);
		eq(RomanNumeral.parse("MMCCCXXVIII"),2328);
		eq(RomanNumeral.parse("MMCCCXXIX"),2329);
		eq(RomanNumeral.parse("MMCCCXXX"),2330);
		eq(RomanNumeral.parse("MMCCCXXXI"),2331);
		eq(RomanNumeral.parse("MMCCCXXXII"),2332);
		eq(RomanNumeral.parse("MMCCCXXXIII"),2333);
		eq(RomanNumeral.parse("MMCCCXXXIV"),2334);
		eq(RomanNumeral.parse("MMCCCXXXV"),2335);
		eq(RomanNumeral.parse("MMCCCXXXVI"),2336);
		eq(RomanNumeral.parse("MMCCCXXXVII"),2337);
		eq(RomanNumeral.parse("MMCCCXXXVIII"),2338);
		eq(RomanNumeral.parse("MMCCCXXXIX"),2339);
		eq(RomanNumeral.parse("MMCCCXL"),2340);
		eq(RomanNumeral.parse("MMCCCXLI"),2341);
		eq(RomanNumeral.parse("MMCCCXLII"),2342);
		eq(RomanNumeral.parse("MMCCCXLIII"),2343);
		eq(RomanNumeral.parse("MMCCCXLIV"),2344);
		eq(RomanNumeral.parse("MMCCCXLV"),2345);
		eq(RomanNumeral.parse("MMCCCXLVI"),2346);
		eq(RomanNumeral.parse("MMCCCXLVII"),2347);
		eq(RomanNumeral.parse("MMCCCXLVIII"),2348);
		eq(RomanNumeral.parse("MMCCCXLIX"),2349);
		eq(RomanNumeral.parse("MMCCCL"),2350);
		eq(RomanNumeral.parse("MMCCCLI"),2351);
		eq(RomanNumeral.parse("MMCCCLII"),2352);
		eq(RomanNumeral.parse("MMCCCLIII"),2353);
		eq(RomanNumeral.parse("MMCCCLIV"),2354);
		eq(RomanNumeral.parse("MMCCCLV"),2355);
		eq(RomanNumeral.parse("MMCCCLVI"),2356);
		eq(RomanNumeral.parse("MMCCCLVII"),2357);
		eq(RomanNumeral.parse("MMCCCLVIII"),2358);
		eq(RomanNumeral.parse("MMCCCLIX"),2359);
		eq(RomanNumeral.parse("MMCCCLX"),2360);
		eq(RomanNumeral.parse("MMCCCLXI"),2361);
		eq(RomanNumeral.parse("MMCCCLXII"),2362);
		eq(RomanNumeral.parse("MMCCCLXIII"),2363);
		eq(RomanNumeral.parse("MMCCCLXIV"),2364);
		eq(RomanNumeral.parse("MMCCCLXV"),2365);
		eq(RomanNumeral.parse("MMCCCLXVI"),2366);
		eq(RomanNumeral.parse("MMCCCLXVII"),2367);
		eq(RomanNumeral.parse("MMCCCLXVIII"),2368);
		eq(RomanNumeral.parse("MMCCCLXIX"),2369);
		eq(RomanNumeral.parse("MMCCCLXX"),2370);
		eq(RomanNumeral.parse("MMCCCLXXI"),2371);
		eq(RomanNumeral.parse("MMCCCLXXII"),2372);
		eq(RomanNumeral.parse("MMCCCLXXIII"),2373);
		eq(RomanNumeral.parse("MMCCCLXXIV"),2374);
		eq(RomanNumeral.parse("MMCCCLXXV"),2375);
		eq(RomanNumeral.parse("MMCCCLXXVI"),2376);
		eq(RomanNumeral.parse("MMCCCLXXVII"),2377);
		eq(RomanNumeral.parse("MMCCCLXXVIII"),2378);
		eq(RomanNumeral.parse("MMCCCLXXIX"),2379);
		eq(RomanNumeral.parse("MMCCCLXXX"),2380);
		eq(RomanNumeral.parse("MMCCCLXXXI"),2381);
		eq(RomanNumeral.parse("MMCCCLXXXII"),2382);
		eq(RomanNumeral.parse("MMCCCLXXXIII"),2383);
		eq(RomanNumeral.parse("MMCCCLXXXIV"),2384);
		eq(RomanNumeral.parse("MMCCCLXXXV"),2385);
		eq(RomanNumeral.parse("MMCCCLXXXVI"),2386);
		eq(RomanNumeral.parse("MMCCCLXXXVII"),2387);
		eq(RomanNumeral.parse("MMCCCLXXXVIII"),2388);
		eq(RomanNumeral.parse("MMCCCLXXXIX"),2389);
		eq(RomanNumeral.parse("MMCCCXC"),2390);
		eq(RomanNumeral.parse("MMCCCXCI"),2391);
		eq(RomanNumeral.parse("MMCCCXCII"),2392);
		eq(RomanNumeral.parse("MMCCCXCIII"),2393);
		eq(RomanNumeral.parse("MMCCCXCIV"),2394);
		eq(RomanNumeral.parse("MMCCCXCV"),2395);
		eq(RomanNumeral.parse("MMCCCXCVI"),2396);
		eq(RomanNumeral.parse("MMCCCXCVII"),2397);
		eq(RomanNumeral.parse("MMCCCXCVIII"),2398);
		eq(RomanNumeral.parse("MMCCCXCIX"),2399);
		eq(RomanNumeral.parse("MMCD"),2400);
		eq(RomanNumeral.parse("MMCDI"),2401);
		eq(RomanNumeral.parse("MMCDII"),2402);
		eq(RomanNumeral.parse("MMCDIII"),2403);
		eq(RomanNumeral.parse("MMCDIV"),2404);
		eq(RomanNumeral.parse("MMCDV"),2405);
		eq(RomanNumeral.parse("MMCDVI"),2406);
		eq(RomanNumeral.parse("MMCDVII"),2407);
		eq(RomanNumeral.parse("MMCDVIII"),2408);
		eq(RomanNumeral.parse("MMCDIX"),2409);
		eq(RomanNumeral.parse("MMCDX"),2410);
		eq(RomanNumeral.parse("MMCDXI"),2411);
		eq(RomanNumeral.parse("MMCDXII"),2412);
		eq(RomanNumeral.parse("MMCDXIII"),2413);
		eq(RomanNumeral.parse("MMCDXIV"),2414);
		eq(RomanNumeral.parse("MMCDXV"),2415);
		eq(RomanNumeral.parse("MMCDXVI"),2416);
		eq(RomanNumeral.parse("MMCDXVII"),2417);
		eq(RomanNumeral.parse("MMCDXVIII"),2418);
		eq(RomanNumeral.parse("MMCDXIX"),2419);
		eq(RomanNumeral.parse("MMCDXX"),2420);
		eq(RomanNumeral.parse("MMCDXXI"),2421);
		eq(RomanNumeral.parse("MMCDXXII"),2422);
		eq(RomanNumeral.parse("MMCDXXIII"),2423);
		eq(RomanNumeral.parse("MMCDXXIV"),2424);
		eq(RomanNumeral.parse("MMCDXXV"),2425);
		eq(RomanNumeral.parse("MMCDXXVI"),2426);
		eq(RomanNumeral.parse("MMCDXXVII"),2427);
		eq(RomanNumeral.parse("MMCDXXVIII"),2428);
		eq(RomanNumeral.parse("MMCDXXIX"),2429);
		eq(RomanNumeral.parse("MMCDXXX"),2430);
		eq(RomanNumeral.parse("MMCDXXXI"),2431);
		eq(RomanNumeral.parse("MMCDXXXII"),2432);
		eq(RomanNumeral.parse("MMCDXXXIII"),2433);
		eq(RomanNumeral.parse("MMCDXXXIV"),2434);
		eq(RomanNumeral.parse("MMCDXXXV"),2435);
		eq(RomanNumeral.parse("MMCDXXXVI"),2436);
		eq(RomanNumeral.parse("MMCDXXXVII"),2437);
		eq(RomanNumeral.parse("MMCDXXXVIII"),2438);
		eq(RomanNumeral.parse("MMCDXXXIX"),2439);
		eq(RomanNumeral.parse("MMCDXL"),2440);
		eq(RomanNumeral.parse("MMCDXLI"),2441);
		eq(RomanNumeral.parse("MMCDXLII"),2442);
		eq(RomanNumeral.parse("MMCDXLIII"),2443);
		eq(RomanNumeral.parse("MMCDXLIV"),2444);
		eq(RomanNumeral.parse("MMCDXLV"),2445);
		eq(RomanNumeral.parse("MMCDXLVI"),2446);
		eq(RomanNumeral.parse("MMCDXLVII"),2447);
		eq(RomanNumeral.parse("MMCDXLVIII"),2448);
		eq(RomanNumeral.parse("MMCDXLIX"),2449);
		eq(RomanNumeral.parse("MMCDL"),2450);
		eq(RomanNumeral.parse("MMCDLI"),2451);
		eq(RomanNumeral.parse("MMCDLII"),2452);
		eq(RomanNumeral.parse("MMCDLIII"),2453);
		eq(RomanNumeral.parse("MMCDLIV"),2454);
		eq(RomanNumeral.parse("MMCDLV"),2455);
		eq(RomanNumeral.parse("MMCDLVI"),2456);
		eq(RomanNumeral.parse("MMCDLVII"),2457);
		eq(RomanNumeral.parse("MMCDLVIII"),2458);
		eq(RomanNumeral.parse("MMCDLIX"),2459);
		eq(RomanNumeral.parse("MMCDLX"),2460);
		eq(RomanNumeral.parse("MMCDLXI"),2461);
		eq(RomanNumeral.parse("MMCDLXII"),2462);
		eq(RomanNumeral.parse("MMCDLXIII"),2463);
		eq(RomanNumeral.parse("MMCDLXIV"),2464);
		eq(RomanNumeral.parse("MMCDLXV"),2465);
		eq(RomanNumeral.parse("MMCDLXVI"),2466);
		eq(RomanNumeral.parse("MMCDLXVII"),2467);
		eq(RomanNumeral.parse("MMCDLXVIII"),2468);
		eq(RomanNumeral.parse("MMCDLXIX"),2469);
		eq(RomanNumeral.parse("MMCDLXX"),2470);
		eq(RomanNumeral.parse("MMCDLXXI"),2471);
		eq(RomanNumeral.parse("MMCDLXXII"),2472);
		eq(RomanNumeral.parse("MMCDLXXIII"),2473);
		eq(RomanNumeral.parse("MMCDLXXIV"),2474);
		eq(RomanNumeral.parse("MMCDLXXV"),2475);
		eq(RomanNumeral.parse("MMCDLXXVI"),2476);
		eq(RomanNumeral.parse("MMCDLXXVII"),2477);
		eq(RomanNumeral.parse("MMCDLXXVIII"),2478);
		eq(RomanNumeral.parse("MMCDLXXIX"),2479);
		eq(RomanNumeral.parse("MMCDLXXX"),2480);
		eq(RomanNumeral.parse("MMCDLXXXI"),2481);
		eq(RomanNumeral.parse("MMCDLXXXII"),2482);
		eq(RomanNumeral.parse("MMCDLXXXIII"),2483);
		eq(RomanNumeral.parse("MMCDLXXXIV"),2484);
		eq(RomanNumeral.parse("MMCDLXXXV"),2485);
		eq(RomanNumeral.parse("MMCDLXXXVI"),2486);
		eq(RomanNumeral.parse("MMCDLXXXVII"),2487);
		eq(RomanNumeral.parse("MMCDLXXXVIII"),2488);
		eq(RomanNumeral.parse("MMCDLXXXIX"),2489);
		eq(RomanNumeral.parse("MMCDXC"),2490);
		eq(RomanNumeral.parse("MMCDXCI"),2491);
		eq(RomanNumeral.parse("MMCDXCII"),2492);
		eq(RomanNumeral.parse("MMCDXCIII"),2493);
		eq(RomanNumeral.parse("MMCDXCIV"),2494);
		eq(RomanNumeral.parse("MMCDXCV"),2495);
		eq(RomanNumeral.parse("MMCDXCVI"),2496);
		eq(RomanNumeral.parse("MMCDXCVII"),2497);
		eq(RomanNumeral.parse("MMCDXCVIII"),2498);
		eq(RomanNumeral.parse("MMCDXCIX"),2499);
		eq(RomanNumeral.parse("MMD"),2500);
		eq(RomanNumeral.parse("MMDI"),2501);
		eq(RomanNumeral.parse("MMDII"),2502);
		eq(RomanNumeral.parse("MMDIII"),2503);
		eq(RomanNumeral.parse("MMDIV"),2504);
		eq(RomanNumeral.parse("MMDV"),2505);
		eq(RomanNumeral.parse("MMDVI"),2506);
		eq(RomanNumeral.parse("MMDVII"),2507);
		eq(RomanNumeral.parse("MMDVIII"),2508);
		eq(RomanNumeral.parse("MMDIX"),2509);
		eq(RomanNumeral.parse("MMDX"),2510);
		eq(RomanNumeral.parse("MMDXI"),2511);
		eq(RomanNumeral.parse("MMDXII"),2512);
		eq(RomanNumeral.parse("MMDXIII"),2513);
		eq(RomanNumeral.parse("MMDXIV"),2514);
		eq(RomanNumeral.parse("MMDXV"),2515);
		eq(RomanNumeral.parse("MMDXVI"),2516);
		eq(RomanNumeral.parse("MMDXVII"),2517);
		eq(RomanNumeral.parse("MMDXVIII"),2518);
		eq(RomanNumeral.parse("MMDXIX"),2519);
		eq(RomanNumeral.parse("MMDXX"),2520);
		eq(RomanNumeral.parse("MMDXXI"),2521);
		eq(RomanNumeral.parse("MMDXXII"),2522);
		eq(RomanNumeral.parse("MMDXXIII"),2523);
		eq(RomanNumeral.parse("MMDXXIV"),2524);
		eq(RomanNumeral.parse("MMDXXV"),2525);
		eq(RomanNumeral.parse("MMDXXVI"),2526);
		eq(RomanNumeral.parse("MMDXXVII"),2527);
		eq(RomanNumeral.parse("MMDXXVIII"),2528);
		eq(RomanNumeral.parse("MMDXXIX"),2529);
		eq(RomanNumeral.parse("MMDXXX"),2530);
		eq(RomanNumeral.parse("MMDXXXI"),2531);
		eq(RomanNumeral.parse("MMDXXXII"),2532);
		eq(RomanNumeral.parse("MMDXXXIII"),2533);
		eq(RomanNumeral.parse("MMDXXXIV"),2534);
		eq(RomanNumeral.parse("MMDXXXV"),2535);
		eq(RomanNumeral.parse("MMDXXXVI"),2536);
		eq(RomanNumeral.parse("MMDXXXVII"),2537);
		eq(RomanNumeral.parse("MMDXXXVIII"),2538);
		eq(RomanNumeral.parse("MMDXXXIX"),2539);
		eq(RomanNumeral.parse("MMDXL"),2540);
		eq(RomanNumeral.parse("MMDXLI"),2541);
		eq(RomanNumeral.parse("MMDXLII"),2542);
		eq(RomanNumeral.parse("MMDXLIII"),2543);
		eq(RomanNumeral.parse("MMDXLIV"),2544);
		eq(RomanNumeral.parse("MMDXLV"),2545);
		eq(RomanNumeral.parse("MMDXLVI"),2546);
		eq(RomanNumeral.parse("MMDXLVII"),2547);
		eq(RomanNumeral.parse("MMDXLVIII"),2548);
		eq(RomanNumeral.parse("MMDXLIX"),2549);
		eq(RomanNumeral.parse("MMDL"),2550);
		eq(RomanNumeral.parse("MMDLI"),2551);
		eq(RomanNumeral.parse("MMDLII"),2552);
		eq(RomanNumeral.parse("MMDLIII"),2553);
		eq(RomanNumeral.parse("MMDLIV"),2554);
		eq(RomanNumeral.parse("MMDLV"),2555);
		eq(RomanNumeral.parse("MMDLVI"),2556);
		eq(RomanNumeral.parse("MMDLVII"),2557);
		eq(RomanNumeral.parse("MMDLVIII"),2558);
		eq(RomanNumeral.parse("MMDLIX"),2559);
		eq(RomanNumeral.parse("MMDLX"),2560);
		eq(RomanNumeral.parse("MMDLXI"),2561);
		eq(RomanNumeral.parse("MMDLXII"),2562);
		eq(RomanNumeral.parse("MMDLXIII"),2563);
		eq(RomanNumeral.parse("MMDLXIV"),2564);
		eq(RomanNumeral.parse("MMDLXV"),2565);
		eq(RomanNumeral.parse("MMDLXVI"),2566);
		eq(RomanNumeral.parse("MMDLXVII"),2567);
		eq(RomanNumeral.parse("MMDLXVIII"),2568);
		eq(RomanNumeral.parse("MMDLXIX"),2569);
		eq(RomanNumeral.parse("MMDLXX"),2570);
		eq(RomanNumeral.parse("MMDLXXI"),2571);
		eq(RomanNumeral.parse("MMDLXXII"),2572);
		eq(RomanNumeral.parse("MMDLXXIII"),2573);
		eq(RomanNumeral.parse("MMDLXXIV"),2574);
		eq(RomanNumeral.parse("MMDLXXV"),2575);
		eq(RomanNumeral.parse("MMDLXXVI"),2576);
		eq(RomanNumeral.parse("MMDLXXVII"),2577);
		eq(RomanNumeral.parse("MMDLXXVIII"),2578);
		eq(RomanNumeral.parse("MMDLXXIX"),2579);
		eq(RomanNumeral.parse("MMDLXXX"),2580);
		eq(RomanNumeral.parse("MMDLXXXI"),2581);
		eq(RomanNumeral.parse("MMDLXXXII"),2582);
		eq(RomanNumeral.parse("MMDLXXXIII"),2583);
		eq(RomanNumeral.parse("MMDLXXXIV"),2584);
		eq(RomanNumeral.parse("MMDLXXXV"),2585);
		eq(RomanNumeral.parse("MMDLXXXVI"),2586);
		eq(RomanNumeral.parse("MMDLXXXVII"),2587);
		eq(RomanNumeral.parse("MMDLXXXVIII"),2588);
		eq(RomanNumeral.parse("MMDLXXXIX"),2589);
		eq(RomanNumeral.parse("MMDXC"),2590);
		eq(RomanNumeral.parse("MMDXCI"),2591);
		eq(RomanNumeral.parse("MMDXCII"),2592);
		eq(RomanNumeral.parse("MMDXCIII"),2593);
		eq(RomanNumeral.parse("MMDXCIV"),2594);
		eq(RomanNumeral.parse("MMDXCV"),2595);
		eq(RomanNumeral.parse("MMDXCVI"),2596);
		eq(RomanNumeral.parse("MMDXCVII"),2597);
		eq(RomanNumeral.parse("MMDXCVIII"),2598);
		eq(RomanNumeral.parse("MMDXCIX"),2599);
		eq(RomanNumeral.parse("MMDC"),2600);
		eq(RomanNumeral.parse("MMDCI"),2601);
		eq(RomanNumeral.parse("MMDCII"),2602);
		eq(RomanNumeral.parse("MMDCIII"),2603);
		eq(RomanNumeral.parse("MMDCIV"),2604);
		eq(RomanNumeral.parse("MMDCV"),2605);
		eq(RomanNumeral.parse("MMDCVI"),2606);
		eq(RomanNumeral.parse("MMDCVII"),2607);
		eq(RomanNumeral.parse("MMDCVIII"),2608);
		eq(RomanNumeral.parse("MMDCIX"),2609);
		eq(RomanNumeral.parse("MMDCX"),2610);
		eq(RomanNumeral.parse("MMDCXI"),2611);
		eq(RomanNumeral.parse("MMDCXII"),2612);
		eq(RomanNumeral.parse("MMDCXIII"),2613);
		eq(RomanNumeral.parse("MMDCXIV"),2614);
		eq(RomanNumeral.parse("MMDCXV"),2615);
		eq(RomanNumeral.parse("MMDCXVI"),2616);
		eq(RomanNumeral.parse("MMDCXVII"),2617);
		eq(RomanNumeral.parse("MMDCXVIII"),2618);
		eq(RomanNumeral.parse("MMDCXIX"),2619);
		eq(RomanNumeral.parse("MMDCXX"),2620);
		eq(RomanNumeral.parse("MMDCXXI"),2621);
		eq(RomanNumeral.parse("MMDCXXII"),2622);
		eq(RomanNumeral.parse("MMDCXXIII"),2623);
		eq(RomanNumeral.parse("MMDCXXIV"),2624);
		eq(RomanNumeral.parse("MMDCXXV"),2625);
		eq(RomanNumeral.parse("MMDCXXVI"),2626);
		eq(RomanNumeral.parse("MMDCXXVII"),2627);
		eq(RomanNumeral.parse("MMDCXXVIII"),2628);
		eq(RomanNumeral.parse("MMDCXXIX"),2629);
		eq(RomanNumeral.parse("MMDCXXX"),2630);
		eq(RomanNumeral.parse("MMDCXXXI"),2631);
		eq(RomanNumeral.parse("MMDCXXXII"),2632);
		eq(RomanNumeral.parse("MMDCXXXIII"),2633);
		eq(RomanNumeral.parse("MMDCXXXIV"),2634);
		eq(RomanNumeral.parse("MMDCXXXV"),2635);
		eq(RomanNumeral.parse("MMDCXXXVI"),2636);
		eq(RomanNumeral.parse("MMDCXXXVII"),2637);
		eq(RomanNumeral.parse("MMDCXXXVIII"),2638);
		eq(RomanNumeral.parse("MMDCXXXIX"),2639);
		eq(RomanNumeral.parse("MMDCXL"),2640);
		eq(RomanNumeral.parse("MMDCXLI"),2641);
		eq(RomanNumeral.parse("MMDCXLII"),2642);
		eq(RomanNumeral.parse("MMDCXLIII"),2643);
		eq(RomanNumeral.parse("MMDCXLIV"),2644);
		eq(RomanNumeral.parse("MMDCXLV"),2645);
		eq(RomanNumeral.parse("MMDCXLVI"),2646);
		eq(RomanNumeral.parse("MMDCXLVII"),2647);
		eq(RomanNumeral.parse("MMDCXLVIII"),2648);
		eq(RomanNumeral.parse("MMDCXLIX"),2649);
		eq(RomanNumeral.parse("MMDCL"),2650);
		eq(RomanNumeral.parse("MMDCLI"),2651);
		eq(RomanNumeral.parse("MMDCLII"),2652);
		eq(RomanNumeral.parse("MMDCLIII"),2653);
		eq(RomanNumeral.parse("MMDCLIV"),2654);
		eq(RomanNumeral.parse("MMDCLV"),2655);
		eq(RomanNumeral.parse("MMDCLVI"),2656);
		eq(RomanNumeral.parse("MMDCLVII"),2657);
		eq(RomanNumeral.parse("MMDCLVIII"),2658);
		eq(RomanNumeral.parse("MMDCLIX"),2659);
		eq(RomanNumeral.parse("MMDCLX"),2660);
		eq(RomanNumeral.parse("MMDCLXI"),2661);
		eq(RomanNumeral.parse("MMDCLXII"),2662);
		eq(RomanNumeral.parse("MMDCLXIII"),2663);
		eq(RomanNumeral.parse("MMDCLXIV"),2664);
		eq(RomanNumeral.parse("MMDCLXV"),2665);
		eq(RomanNumeral.parse("MMDCLXVI"),2666);
		eq(RomanNumeral.parse("MMDCLXVII"),2667);
		eq(RomanNumeral.parse("MMDCLXVIII"),2668);
		eq(RomanNumeral.parse("MMDCLXIX"),2669);
		eq(RomanNumeral.parse("MMDCLXX"),2670);
		eq(RomanNumeral.parse("MMDCLXXI"),2671);
		eq(RomanNumeral.parse("MMDCLXXII"),2672);
		eq(RomanNumeral.parse("MMDCLXXIII"),2673);
		eq(RomanNumeral.parse("MMDCLXXIV"),2674);
		eq(RomanNumeral.parse("MMDCLXXV"),2675);
		eq(RomanNumeral.parse("MMDCLXXVI"),2676);
		eq(RomanNumeral.parse("MMDCLXXVII"),2677);
		eq(RomanNumeral.parse("MMDCLXXVIII"),2678);
		eq(RomanNumeral.parse("MMDCLXXIX"),2679);
		eq(RomanNumeral.parse("MMDCLXXX"),2680);
		eq(RomanNumeral.parse("MMDCLXXXI"),2681);
		eq(RomanNumeral.parse("MMDCLXXXII"),2682);
		eq(RomanNumeral.parse("MMDCLXXXIII"),2683);
		eq(RomanNumeral.parse("MMDCLXXXIV"),2684);
		eq(RomanNumeral.parse("MMDCLXXXV"),2685);
		eq(RomanNumeral.parse("MMDCLXXXVI"),2686);
		eq(RomanNumeral.parse("MMDCLXXXVII"),2687);
		eq(RomanNumeral.parse("MMDCLXXXVIII"),2688);
		eq(RomanNumeral.parse("MMDCLXXXIX"),2689);
		eq(RomanNumeral.parse("MMDCXC"),2690);
		eq(RomanNumeral.parse("MMDCXCI"),2691);
		eq(RomanNumeral.parse("MMDCXCII"),2692);
		eq(RomanNumeral.parse("MMDCXCIII"),2693);
		eq(RomanNumeral.parse("MMDCXCIV"),2694);
		eq(RomanNumeral.parse("MMDCXCV"),2695);
		eq(RomanNumeral.parse("MMDCXCVI"),2696);
		eq(RomanNumeral.parse("MMDCXCVII"),2697);
		eq(RomanNumeral.parse("MMDCXCVIII"),2698);
		eq(RomanNumeral.parse("MMDCXCIX"),2699);
		eq(RomanNumeral.parse("MMDCC"),2700);
		eq(RomanNumeral.parse("MMDCCI"),2701);
		eq(RomanNumeral.parse("MMDCCII"),2702);
		eq(RomanNumeral.parse("MMDCCIII"),2703);
		eq(RomanNumeral.parse("MMDCCIV"),2704);
		eq(RomanNumeral.parse("MMDCCV"),2705);
		eq(RomanNumeral.parse("MMDCCVI"),2706);
		eq(RomanNumeral.parse("MMDCCVII"),2707);
		eq(RomanNumeral.parse("MMDCCVIII"),2708);
		eq(RomanNumeral.parse("MMDCCIX"),2709);
		eq(RomanNumeral.parse("MMDCCX"),2710);
		eq(RomanNumeral.parse("MMDCCXI"),2711);
		eq(RomanNumeral.parse("MMDCCXII"),2712);
		eq(RomanNumeral.parse("MMDCCXIII"),2713);
		eq(RomanNumeral.parse("MMDCCXIV"),2714);
		eq(RomanNumeral.parse("MMDCCXV"),2715);
		eq(RomanNumeral.parse("MMDCCXVI"),2716);
		eq(RomanNumeral.parse("MMDCCXVII"),2717);
		eq(RomanNumeral.parse("MMDCCXVIII"),2718);
		eq(RomanNumeral.parse("MMDCCXIX"),2719);
		eq(RomanNumeral.parse("MMDCCXX"),2720);
		eq(RomanNumeral.parse("MMDCCXXI"),2721);
		eq(RomanNumeral.parse("MMDCCXXII"),2722);
		eq(RomanNumeral.parse("MMDCCXXIII"),2723);
		eq(RomanNumeral.parse("MMDCCXXIV"),2724);
		eq(RomanNumeral.parse("MMDCCXXV"),2725);
		eq(RomanNumeral.parse("MMDCCXXVI"),2726);
		eq(RomanNumeral.parse("MMDCCXXVII"),2727);
		eq(RomanNumeral.parse("MMDCCXXVIII"),2728);
		eq(RomanNumeral.parse("MMDCCXXIX"),2729);
		eq(RomanNumeral.parse("MMDCCXXX"),2730);
		eq(RomanNumeral.parse("MMDCCXXXI"),2731);
		eq(RomanNumeral.parse("MMDCCXXXII"),2732);
		eq(RomanNumeral.parse("MMDCCXXXIII"),2733);
		eq(RomanNumeral.parse("MMDCCXXXIV"),2734);
		eq(RomanNumeral.parse("MMDCCXXXV"),2735);
		eq(RomanNumeral.parse("MMDCCXXXVI"),2736);
		eq(RomanNumeral.parse("MMDCCXXXVII"),2737);
		eq(RomanNumeral.parse("MMDCCXXXVIII"),2738);
		eq(RomanNumeral.parse("MMDCCXXXIX"),2739);
		eq(RomanNumeral.parse("MMDCCXL"),2740);
		eq(RomanNumeral.parse("MMDCCXLI"),2741);
		eq(RomanNumeral.parse("MMDCCXLII"),2742);
		eq(RomanNumeral.parse("MMDCCXLIII"),2743);
		eq(RomanNumeral.parse("MMDCCXLIV"),2744);
		eq(RomanNumeral.parse("MMDCCXLV"),2745);
		eq(RomanNumeral.parse("MMDCCXLVI"),2746);
		eq(RomanNumeral.parse("MMDCCXLVII"),2747);
		eq(RomanNumeral.parse("MMDCCXLVIII"),2748);
		eq(RomanNumeral.parse("MMDCCXLIX"),2749);
		eq(RomanNumeral.parse("MMDCCL"),2750);
		eq(RomanNumeral.parse("MMDCCLI"),2751);
		eq(RomanNumeral.parse("MMDCCLII"),2752);
		eq(RomanNumeral.parse("MMDCCLIII"),2753);
		eq(RomanNumeral.parse("MMDCCLIV"),2754);
		eq(RomanNumeral.parse("MMDCCLV"),2755);
		eq(RomanNumeral.parse("MMDCCLVI"),2756);
		eq(RomanNumeral.parse("MMDCCLVII"),2757);
		eq(RomanNumeral.parse("MMDCCLVIII"),2758);
		eq(RomanNumeral.parse("MMDCCLIX"),2759);
		eq(RomanNumeral.parse("MMDCCLX"),2760);
		eq(RomanNumeral.parse("MMDCCLXI"),2761);
		eq(RomanNumeral.parse("MMDCCLXII"),2762);
		eq(RomanNumeral.parse("MMDCCLXIII"),2763);
		eq(RomanNumeral.parse("MMDCCLXIV"),2764);
		eq(RomanNumeral.parse("MMDCCLXV"),2765);
		eq(RomanNumeral.parse("MMDCCLXVI"),2766);
		eq(RomanNumeral.parse("MMDCCLXVII"),2767);
		eq(RomanNumeral.parse("MMDCCLXVIII"),2768);
		eq(RomanNumeral.parse("MMDCCLXIX"),2769);
		eq(RomanNumeral.parse("MMDCCLXX"),2770);
		eq(RomanNumeral.parse("MMDCCLXXI"),2771);
		eq(RomanNumeral.parse("MMDCCLXXII"),2772);
		eq(RomanNumeral.parse("MMDCCLXXIII"),2773);
		eq(RomanNumeral.parse("MMDCCLXXIV"),2774);
		eq(RomanNumeral.parse("MMDCCLXXV"),2775);
		eq(RomanNumeral.parse("MMDCCLXXVI"),2776);
		eq(RomanNumeral.parse("MMDCCLXXVII"),2777);
		eq(RomanNumeral.parse("MMDCCLXXVIII"),2778);
		eq(RomanNumeral.parse("MMDCCLXXIX"),2779);
		eq(RomanNumeral.parse("MMDCCLXXX"),2780);
		eq(RomanNumeral.parse("MMDCCLXXXI"),2781);
		eq(RomanNumeral.parse("MMDCCLXXXII"),2782);
		eq(RomanNumeral.parse("MMDCCLXXXIII"),2783);
		eq(RomanNumeral.parse("MMDCCLXXXIV"),2784);
		eq(RomanNumeral.parse("MMDCCLXXXV"),2785);
		eq(RomanNumeral.parse("MMDCCLXXXVI"),2786);
		eq(RomanNumeral.parse("MMDCCLXXXVII"),2787);
		eq(RomanNumeral.parse("MMDCCLXXXVIII"),2788);
		eq(RomanNumeral.parse("MMDCCLXXXIX"),2789);
		eq(RomanNumeral.parse("MMDCCXC"),2790);
		eq(RomanNumeral.parse("MMDCCXCI"),2791);
		eq(RomanNumeral.parse("MMDCCXCII"),2792);
		eq(RomanNumeral.parse("MMDCCXCIII"),2793);
		eq(RomanNumeral.parse("MMDCCXCIV"),2794);
		eq(RomanNumeral.parse("MMDCCXCV"),2795);
		eq(RomanNumeral.parse("MMDCCXCVI"),2796);
		eq(RomanNumeral.parse("MMDCCXCVII"),2797);
		eq(RomanNumeral.parse("MMDCCXCVIII"),2798);
		eq(RomanNumeral.parse("MMDCCXCIX"),2799);
		eq(RomanNumeral.parse("MMDCCC"),2800);
		eq(RomanNumeral.parse("MMDCCCI"),2801);
		eq(RomanNumeral.parse("MMDCCCII"),2802);
		eq(RomanNumeral.parse("MMDCCCIII"),2803);
		eq(RomanNumeral.parse("MMDCCCIV"),2804);
		eq(RomanNumeral.parse("MMDCCCV"),2805);
		eq(RomanNumeral.parse("MMDCCCVI"),2806);
		eq(RomanNumeral.parse("MMDCCCVII"),2807);
		eq(RomanNumeral.parse("MMDCCCVIII"),2808);
		eq(RomanNumeral.parse("MMDCCCIX"),2809);
		eq(RomanNumeral.parse("MMDCCCX"),2810);
		eq(RomanNumeral.parse("MMDCCCXI"),2811);
		eq(RomanNumeral.parse("MMDCCCXII"),2812);
		eq(RomanNumeral.parse("MMDCCCXIII"),2813);
		eq(RomanNumeral.parse("MMDCCCXIV"),2814);
		eq(RomanNumeral.parse("MMDCCCXV"),2815);
		eq(RomanNumeral.parse("MMDCCCXVI"),2816);
		eq(RomanNumeral.parse("MMDCCCXVII"),2817);
		eq(RomanNumeral.parse("MMDCCCXVIII"),2818);
		eq(RomanNumeral.parse("MMDCCCXIX"),2819);
		eq(RomanNumeral.parse("MMDCCCXX"),2820);
		eq(RomanNumeral.parse("MMDCCCXXI"),2821);
		eq(RomanNumeral.parse("MMDCCCXXII"),2822);
		eq(RomanNumeral.parse("MMDCCCXXIII"),2823);
		eq(RomanNumeral.parse("MMDCCCXXIV"),2824);
		eq(RomanNumeral.parse("MMDCCCXXV"),2825);
		eq(RomanNumeral.parse("MMDCCCXXVI"),2826);
		eq(RomanNumeral.parse("MMDCCCXXVII"),2827);
		eq(RomanNumeral.parse("MMDCCCXXVIII"),2828);
		eq(RomanNumeral.parse("MMDCCCXXIX"),2829);
		eq(RomanNumeral.parse("MMDCCCXXX"),2830);
		eq(RomanNumeral.parse("MMDCCCXXXI"),2831);
		eq(RomanNumeral.parse("MMDCCCXXXII"),2832);
		eq(RomanNumeral.parse("MMDCCCXXXIII"),2833);
		eq(RomanNumeral.parse("MMDCCCXXXIV"),2834);
		eq(RomanNumeral.parse("MMDCCCXXXV"),2835);
		eq(RomanNumeral.parse("MMDCCCXXXVI"),2836);
		eq(RomanNumeral.parse("MMDCCCXXXVII"),2837);
		eq(RomanNumeral.parse("MMDCCCXXXVIII"),2838);
		eq(RomanNumeral.parse("MMDCCCXXXIX"),2839);
		eq(RomanNumeral.parse("MMDCCCXL"),2840);
		eq(RomanNumeral.parse("MMDCCCXLI"),2841);
		eq(RomanNumeral.parse("MMDCCCXLII"),2842);
		eq(RomanNumeral.parse("MMDCCCXLIII"),2843);
		eq(RomanNumeral.parse("MMDCCCXLIV"),2844);
		eq(RomanNumeral.parse("MMDCCCXLV"),2845);
		eq(RomanNumeral.parse("MMDCCCXLVI"),2846);
		eq(RomanNumeral.parse("MMDCCCXLVII"),2847);
		eq(RomanNumeral.parse("MMDCCCXLVIII"),2848);
		eq(RomanNumeral.parse("MMDCCCXLIX"),2849);
		eq(RomanNumeral.parse("MMDCCCL"),2850);
		eq(RomanNumeral.parse("MMDCCCLI"),2851);
		eq(RomanNumeral.parse("MMDCCCLII"),2852);
		eq(RomanNumeral.parse("MMDCCCLIII"),2853);
		eq(RomanNumeral.parse("MMDCCCLIV"),2854);
		eq(RomanNumeral.parse("MMDCCCLV"),2855);
		eq(RomanNumeral.parse("MMDCCCLVI"),2856);
		eq(RomanNumeral.parse("MMDCCCLVII"),2857);
		eq(RomanNumeral.parse("MMDCCCLVIII"),2858);
		eq(RomanNumeral.parse("MMDCCCLIX"),2859);
		eq(RomanNumeral.parse("MMDCCCLX"),2860);
		eq(RomanNumeral.parse("MMDCCCLXI"),2861);
		eq(RomanNumeral.parse("MMDCCCLXII"),2862);
		eq(RomanNumeral.parse("MMDCCCLXIII"),2863);
		eq(RomanNumeral.parse("MMDCCCLXIV"),2864);
		eq(RomanNumeral.parse("MMDCCCLXV"),2865);
		eq(RomanNumeral.parse("MMDCCCLXVI"),2866);
		eq(RomanNumeral.parse("MMDCCCLXVII"),2867);
		eq(RomanNumeral.parse("MMDCCCLXVIII"),2868);
		eq(RomanNumeral.parse("MMDCCCLXIX"),2869);
		eq(RomanNumeral.parse("MMDCCCLXX"),2870);
		eq(RomanNumeral.parse("MMDCCCLXXI"),2871);
		eq(RomanNumeral.parse("MMDCCCLXXII"),2872);
		eq(RomanNumeral.parse("MMDCCCLXXIII"),2873);
		eq(RomanNumeral.parse("MMDCCCLXXIV"),2874);
		eq(RomanNumeral.parse("MMDCCCLXXV"),2875);
		eq(RomanNumeral.parse("MMDCCCLXXVI"),2876);
		eq(RomanNumeral.parse("MMDCCCLXXVII"),2877);
		eq(RomanNumeral.parse("MMDCCCLXXVIII"),2878);
		eq(RomanNumeral.parse("MMDCCCLXXIX"),2879);
		eq(RomanNumeral.parse("MMDCCCLXXX"),2880);
		eq(RomanNumeral.parse("MMDCCCLXXXI"),2881);
		eq(RomanNumeral.parse("MMDCCCLXXXII"),2882);
		eq(RomanNumeral.parse("MMDCCCLXXXIII"),2883);
		eq(RomanNumeral.parse("MMDCCCLXXXIV"),2884);
		eq(RomanNumeral.parse("MMDCCCLXXXV"),2885);
		eq(RomanNumeral.parse("MMDCCCLXXXVI"),2886);
		eq(RomanNumeral.parse("MMDCCCLXXXVII"),2887);
		eq(RomanNumeral.parse("MMDCCCLXXXVIII"),2888);
		eq(RomanNumeral.parse("MMDCCCLXXXIX"),2889);
		eq(RomanNumeral.parse("MMDCCCXC"),2890);
		eq(RomanNumeral.parse("MMDCCCXCI"),2891);
		eq(RomanNumeral.parse("MMDCCCXCII"),2892);
		eq(RomanNumeral.parse("MMDCCCXCIII"),2893);
		eq(RomanNumeral.parse("MMDCCCXCIV"),2894);
		eq(RomanNumeral.parse("MMDCCCXCV"),2895);
		eq(RomanNumeral.parse("MMDCCCXCVI"),2896);
		eq(RomanNumeral.parse("MMDCCCXCVII"),2897);
		eq(RomanNumeral.parse("MMDCCCXCVIII"),2898);
		eq(RomanNumeral.parse("MMDCCCXCIX"),2899);
		eq(RomanNumeral.parse("MMCM"),2900);
		eq(RomanNumeral.parse("MMCMI"),2901);
		eq(RomanNumeral.parse("MMCMII"),2902);
		eq(RomanNumeral.parse("MMCMIII"),2903);
		eq(RomanNumeral.parse("MMCMIV"),2904);
		eq(RomanNumeral.parse("MMCMV"),2905);
		eq(RomanNumeral.parse("MMCMVI"),2906);
		eq(RomanNumeral.parse("MMCMVII"),2907);
		eq(RomanNumeral.parse("MMCMVIII"),2908);
		eq(RomanNumeral.parse("MMCMIX"),2909);
		eq(RomanNumeral.parse("MMCMX"),2910);
		eq(RomanNumeral.parse("MMCMXI"),2911);
		eq(RomanNumeral.parse("MMCMXII"),2912);
		eq(RomanNumeral.parse("MMCMXIII"),2913);
		eq(RomanNumeral.parse("MMCMXIV"),2914);
		eq(RomanNumeral.parse("MMCMXV"),2915);
		eq(RomanNumeral.parse("MMCMXVI"),2916);
		eq(RomanNumeral.parse("MMCMXVII"),2917);
		eq(RomanNumeral.parse("MMCMXVIII"),2918);
		eq(RomanNumeral.parse("MMCMXIX"),2919);
		eq(RomanNumeral.parse("MMCMXX"),2920);
		eq(RomanNumeral.parse("MMCMXXI"),2921);
		eq(RomanNumeral.parse("MMCMXXII"),2922);
		eq(RomanNumeral.parse("MMCMXXIII"),2923);
		eq(RomanNumeral.parse("MMCMXXIV"),2924);
		eq(RomanNumeral.parse("MMCMXXV"),2925);
		eq(RomanNumeral.parse("MMCMXXVI"),2926);
		eq(RomanNumeral.parse("MMCMXXVII"),2927);
		eq(RomanNumeral.parse("MMCMXXVIII"),2928);
		eq(RomanNumeral.parse("MMCMXXIX"),2929);
		eq(RomanNumeral.parse("MMCMXXX"),2930);
		eq(RomanNumeral.parse("MMCMXXXI"),2931);
		eq(RomanNumeral.parse("MMCMXXXII"),2932);
		eq(RomanNumeral.parse("MMCMXXXIII"),2933);
		eq(RomanNumeral.parse("MMCMXXXIV"),2934);
		eq(RomanNumeral.parse("MMCMXXXV"),2935);
		eq(RomanNumeral.parse("MMCMXXXVI"),2936);
		eq(RomanNumeral.parse("MMCMXXXVII"),2937);
		eq(RomanNumeral.parse("MMCMXXXVIII"),2938);
		eq(RomanNumeral.parse("MMCMXXXIX"),2939);
		eq(RomanNumeral.parse("MMCMXL"),2940);
		eq(RomanNumeral.parse("MMCMXLI"),2941);
		eq(RomanNumeral.parse("MMCMXLII"),2942);
		eq(RomanNumeral.parse("MMCMXLIII"),2943);
		eq(RomanNumeral.parse("MMCMXLIV"),2944);
		eq(RomanNumeral.parse("MMCMXLV"),2945);
		eq(RomanNumeral.parse("MMCMXLVI"),2946);
		eq(RomanNumeral.parse("MMCMXLVII"),2947);
		eq(RomanNumeral.parse("MMCMXLVIII"),2948);
		eq(RomanNumeral.parse("MMCMXLIX"),2949);
		eq(RomanNumeral.parse("MMCML"),2950);
		eq(RomanNumeral.parse("MMCMLI"),2951);
		eq(RomanNumeral.parse("MMCMLII"),2952);
		eq(RomanNumeral.parse("MMCMLIII"),2953);
		eq(RomanNumeral.parse("MMCMLIV"),2954);
		eq(RomanNumeral.parse("MMCMLV"),2955);
		eq(RomanNumeral.parse("MMCMLVI"),2956);
		eq(RomanNumeral.parse("MMCMLVII"),2957);
		eq(RomanNumeral.parse("MMCMLVIII"),2958);
		eq(RomanNumeral.parse("MMCMLIX"),2959);
		eq(RomanNumeral.parse("MMCMLX"),2960);
		eq(RomanNumeral.parse("MMCMLXI"),2961);
		eq(RomanNumeral.parse("MMCMLXII"),2962);
		eq(RomanNumeral.parse("MMCMLXIII"),2963);
		eq(RomanNumeral.parse("MMCMLXIV"),2964);
		eq(RomanNumeral.parse("MMCMLXV"),2965);
		eq(RomanNumeral.parse("MMCMLXVI"),2966);
		eq(RomanNumeral.parse("MMCMLXVII"),2967);
		eq(RomanNumeral.parse("MMCMLXVIII"),2968);
		eq(RomanNumeral.parse("MMCMLXIX"),2969);
		eq(RomanNumeral.parse("MMCMLXX"),2970);
		eq(RomanNumeral.parse("MMCMLXXI"),2971);
		eq(RomanNumeral.parse("MMCMLXXII"),2972);
		eq(RomanNumeral.parse("MMCMLXXIII"),2973);
		eq(RomanNumeral.parse("MMCMLXXIV"),2974);
		eq(RomanNumeral.parse("MMCMLXXV"),2975);
		eq(RomanNumeral.parse("MMCMLXXVI"),2976);
		eq(RomanNumeral.parse("MMCMLXXVII"),2977);
		eq(RomanNumeral.parse("MMCMLXXVIII"),2978);
		eq(RomanNumeral.parse("MMCMLXXIX"),2979);
		eq(RomanNumeral.parse("MMCMLXXX"),2980);
		eq(RomanNumeral.parse("MMCMLXXXI"),2981);
		eq(RomanNumeral.parse("MMCMLXXXII"),2982);
		eq(RomanNumeral.parse("MMCMLXXXIII"),2983);
		eq(RomanNumeral.parse("MMCMLXXXIV"),2984);
		eq(RomanNumeral.parse("MMCMLXXXV"),2985);
		eq(RomanNumeral.parse("MMCMLXXXVI"),2986);
		eq(RomanNumeral.parse("MMCMLXXXVII"),2987);
		eq(RomanNumeral.parse("MMCMLXXXVIII"),2988);
		eq(RomanNumeral.parse("MMCMLXXXIX"),2989);
		eq(RomanNumeral.parse("MMCMXC"),2990);
		eq(RomanNumeral.parse("MMCMXCI"),2991);
		eq(RomanNumeral.parse("MMCMXCII"),2992);
		eq(RomanNumeral.parse("MMCMXCIII"),2993);
		eq(RomanNumeral.parse("MMCMXCIV"),2994);
		eq(RomanNumeral.parse("MMCMXCV"),2995);
		eq(RomanNumeral.parse("MMCMXCVI"),2996);
		eq(RomanNumeral.parse("MMCMXCVII"),2997);
		eq(RomanNumeral.parse("MMCMXCVIII"),2998);
		eq(RomanNumeral.parse("MMCMXCIX"),2999);
		eq(RomanNumeral.parse("MMM"),3000);
		eq(RomanNumeral.parse("MMMI"),3001);
		eq(RomanNumeral.parse("MMMII"),3002);
		eq(RomanNumeral.parse("MMMIII"),3003);
		eq(RomanNumeral.parse("MMMIV"),3004);
		eq(RomanNumeral.parse("MMMV"),3005);
		eq(RomanNumeral.parse("MMMVI"),3006);
		eq(RomanNumeral.parse("MMMVII"),3007);
		eq(RomanNumeral.parse("MMMVIII"),3008);
		eq(RomanNumeral.parse("MMMIX"),3009);
		eq(RomanNumeral.parse("MMMX"),3010);
		eq(RomanNumeral.parse("MMMXI"),3011);
		eq(RomanNumeral.parse("MMMXII"),3012);
		eq(RomanNumeral.parse("MMMXIII"),3013);
		eq(RomanNumeral.parse("MMMXIV"),3014);
		eq(RomanNumeral.parse("MMMXV"),3015);
		eq(RomanNumeral.parse("MMMXVI"),3016);
		eq(RomanNumeral.parse("MMMXVII"),3017);
		eq(RomanNumeral.parse("MMMXVIII"),3018);
		eq(RomanNumeral.parse("MMMXIX"),3019);
		eq(RomanNumeral.parse("MMMXX"),3020);
		eq(RomanNumeral.parse("MMMXXI"),3021);
		eq(RomanNumeral.parse("MMMXXII"),3022);
		eq(RomanNumeral.parse("MMMXXIII"),3023);
		eq(RomanNumeral.parse("MMMXXIV"),3024);
		eq(RomanNumeral.parse("MMMXXV"),3025);
		eq(RomanNumeral.parse("MMMXXVI"),3026);
		eq(RomanNumeral.parse("MMMXXVII"),3027);
		eq(RomanNumeral.parse("MMMXXVIII"),3028);
		eq(RomanNumeral.parse("MMMXXIX"),3029);
		eq(RomanNumeral.parse("MMMXXX"),3030);
		eq(RomanNumeral.parse("MMMXXXI"),3031);
		eq(RomanNumeral.parse("MMMXXXII"),3032);
		eq(RomanNumeral.parse("MMMXXXIII"),3033);
		eq(RomanNumeral.parse("MMMXXXIV"),3034);
		eq(RomanNumeral.parse("MMMXXXV"),3035);
		eq(RomanNumeral.parse("MMMXXXVI"),3036);
		eq(RomanNumeral.parse("MMMXXXVII"),3037);
		eq(RomanNumeral.parse("MMMXXXVIII"),3038);
		eq(RomanNumeral.parse("MMMXXXIX"),3039);
		eq(RomanNumeral.parse("MMMXL"),3040);
		eq(RomanNumeral.parse("MMMXLI"),3041);
		eq(RomanNumeral.parse("MMMXLII"),3042);
		eq(RomanNumeral.parse("MMMXLIII"),3043);
		eq(RomanNumeral.parse("MMMXLIV"),3044);
		eq(RomanNumeral.parse("MMMXLV"),3045);
		eq(RomanNumeral.parse("MMMXLVI"),3046);
		eq(RomanNumeral.parse("MMMXLVII"),3047);
		eq(RomanNumeral.parse("MMMXLVIII"),3048);
		eq(RomanNumeral.parse("MMMXLIX"),3049);
		eq(RomanNumeral.parse("MMML"),3050);
		eq(RomanNumeral.parse("MMMLI"),3051);
		eq(RomanNumeral.parse("MMMLII"),3052);
		eq(RomanNumeral.parse("MMMLIII"),3053);
		eq(RomanNumeral.parse("MMMLIV"),3054);
		eq(RomanNumeral.parse("MMMLV"),3055);
		eq(RomanNumeral.parse("MMMLVI"),3056);
		eq(RomanNumeral.parse("MMMLVII"),3057);
		eq(RomanNumeral.parse("MMMLVIII"),3058);
		eq(RomanNumeral.parse("MMMLIX"),3059);
		eq(RomanNumeral.parse("MMMLX"),3060);
		eq(RomanNumeral.parse("MMMLXI"),3061);
		eq(RomanNumeral.parse("MMMLXII"),3062);
		eq(RomanNumeral.parse("MMMLXIII"),3063);
		eq(RomanNumeral.parse("MMMLXIV"),3064);
		eq(RomanNumeral.parse("MMMLXV"),3065);
		eq(RomanNumeral.parse("MMMLXVI"),3066);
		eq(RomanNumeral.parse("MMMLXVII"),3067);
		eq(RomanNumeral.parse("MMMLXVIII"),3068);
		eq(RomanNumeral.parse("MMMLXIX"),3069);
		eq(RomanNumeral.parse("MMMLXX"),3070);
		eq(RomanNumeral.parse("MMMLXXI"),3071);
		eq(RomanNumeral.parse("MMMLXXII"),3072);
		eq(RomanNumeral.parse("MMMLXXIII"),3073);
		eq(RomanNumeral.parse("MMMLXXIV"),3074);
		eq(RomanNumeral.parse("MMMLXXV"),3075);
		eq(RomanNumeral.parse("MMMLXXVI"),3076);
		eq(RomanNumeral.parse("MMMLXXVII"),3077);
		eq(RomanNumeral.parse("MMMLXXVIII"),3078);
		eq(RomanNumeral.parse("MMMLXXIX"),3079);
		eq(RomanNumeral.parse("MMMLXXX"),3080);
		eq(RomanNumeral.parse("MMMLXXXI"),3081);
		eq(RomanNumeral.parse("MMMLXXXII"),3082);
		eq(RomanNumeral.parse("MMMLXXXIII"),3083);
		eq(RomanNumeral.parse("MMMLXXXIV"),3084);
		eq(RomanNumeral.parse("MMMLXXXV"),3085);
		eq(RomanNumeral.parse("MMMLXXXVI"),3086);
		eq(RomanNumeral.parse("MMMLXXXVII"),3087);
		eq(RomanNumeral.parse("MMMLXXXVIII"),3088);
		eq(RomanNumeral.parse("MMMLXXXIX"),3089);
		eq(RomanNumeral.parse("MMMXC"),3090);
		eq(RomanNumeral.parse("MMMXCI"),3091);
		eq(RomanNumeral.parse("MMMXCII"),3092);
		eq(RomanNumeral.parse("MMMXCIII"),3093);
		eq(RomanNumeral.parse("MMMXCIV"),3094);
		eq(RomanNumeral.parse("MMMXCV"),3095);
		eq(RomanNumeral.parse("MMMXCVI"),3096);
		eq(RomanNumeral.parse("MMMXCVII"),3097);
		eq(RomanNumeral.parse("MMMXCVIII"),3098);
		eq(RomanNumeral.parse("MMMXCIX"),3099);
		eq(RomanNumeral.parse("MMMC"),3100);
		eq(RomanNumeral.parse("MMMCI"),3101);
		eq(RomanNumeral.parse("MMMCII"),3102);
		eq(RomanNumeral.parse("MMMCIII"),3103);
		eq(RomanNumeral.parse("MMMCIV"),3104);
		eq(RomanNumeral.parse("MMMCV"),3105);
		eq(RomanNumeral.parse("MMMCVI"),3106);
		eq(RomanNumeral.parse("MMMCVII"),3107);
		eq(RomanNumeral.parse("MMMCVIII"),3108);
		eq(RomanNumeral.parse("MMMCIX"),3109);
		eq(RomanNumeral.parse("MMMCX"),3110);
		eq(RomanNumeral.parse("MMMCXI"),3111);
		eq(RomanNumeral.parse("MMMCXII"),3112);
		eq(RomanNumeral.parse("MMMCXIII"),3113);
		eq(RomanNumeral.parse("MMMCXIV"),3114);
		eq(RomanNumeral.parse("MMMCXV"),3115);
		eq(RomanNumeral.parse("MMMCXVI"),3116);
		eq(RomanNumeral.parse("MMMCXVII"),3117);
		eq(RomanNumeral.parse("MMMCXVIII"),3118);
		eq(RomanNumeral.parse("MMMCXIX"),3119);
		eq(RomanNumeral.parse("MMMCXX"),3120);
		eq(RomanNumeral.parse("MMMCXXI"),3121);
		eq(RomanNumeral.parse("MMMCXXII"),3122);
		eq(RomanNumeral.parse("MMMCXXIII"),3123);
		eq(RomanNumeral.parse("MMMCXXIV"),3124);
		eq(RomanNumeral.parse("MMMCXXV"),3125);
		eq(RomanNumeral.parse("MMMCXXVI"),3126);
		eq(RomanNumeral.parse("MMMCXXVII"),3127);
		eq(RomanNumeral.parse("MMMCXXVIII"),3128);
		eq(RomanNumeral.parse("MMMCXXIX"),3129);
		eq(RomanNumeral.parse("MMMCXXX"),3130);
		eq(RomanNumeral.parse("MMMCXXXI"),3131);
		eq(RomanNumeral.parse("MMMCXXXII"),3132);
		eq(RomanNumeral.parse("MMMCXXXIII"),3133);
		eq(RomanNumeral.parse("MMMCXXXIV"),3134);
		eq(RomanNumeral.parse("MMMCXXXV"),3135);
		eq(RomanNumeral.parse("MMMCXXXVI"),3136);
		eq(RomanNumeral.parse("MMMCXXXVII"),3137);
		eq(RomanNumeral.parse("MMMCXXXVIII"),3138);
		eq(RomanNumeral.parse("MMMCXXXIX"),3139);
		eq(RomanNumeral.parse("MMMCXL"),3140);
		eq(RomanNumeral.parse("MMMCXLI"),3141);
		eq(RomanNumeral.parse("MMMCXLII"),3142);
		eq(RomanNumeral.parse("MMMCXLIII"),3143);
		eq(RomanNumeral.parse("MMMCXLIV"),3144);
		eq(RomanNumeral.parse("MMMCXLV"),3145);
		eq(RomanNumeral.parse("MMMCXLVI"),3146);
		eq(RomanNumeral.parse("MMMCXLVII"),3147);
		eq(RomanNumeral.parse("MMMCXLVIII"),3148);
		eq(RomanNumeral.parse("MMMCXLIX"),3149);
		eq(RomanNumeral.parse("MMMCL"),3150);
		eq(RomanNumeral.parse("MMMCLI"),3151);
		eq(RomanNumeral.parse("MMMCLII"),3152);
		eq(RomanNumeral.parse("MMMCLIII"),3153);
		eq(RomanNumeral.parse("MMMCLIV"),3154);
		eq(RomanNumeral.parse("MMMCLV"),3155);
		eq(RomanNumeral.parse("MMMCLVI"),3156);
		eq(RomanNumeral.parse("MMMCLVII"),3157);
		eq(RomanNumeral.parse("MMMCLVIII"),3158);
		eq(RomanNumeral.parse("MMMCLIX"),3159);
		eq(RomanNumeral.parse("MMMCLX"),3160);
		eq(RomanNumeral.parse("MMMCLXI"),3161);
		eq(RomanNumeral.parse("MMMCLXII"),3162);
		eq(RomanNumeral.parse("MMMCLXIII"),3163);
		eq(RomanNumeral.parse("MMMCLXIV"),3164);
		eq(RomanNumeral.parse("MMMCLXV"),3165);
		eq(RomanNumeral.parse("MMMCLXVI"),3166);
		eq(RomanNumeral.parse("MMMCLXVII"),3167);
		eq(RomanNumeral.parse("MMMCLXVIII"),3168);
		eq(RomanNumeral.parse("MMMCLXIX"),3169);
		eq(RomanNumeral.parse("MMMCLXX"),3170);
		eq(RomanNumeral.parse("MMMCLXXI"),3171);
		eq(RomanNumeral.parse("MMMCLXXII"),3172);
		eq(RomanNumeral.parse("MMMCLXXIII"),3173);
		eq(RomanNumeral.parse("MMMCLXXIV"),3174);
		eq(RomanNumeral.parse("MMMCLXXV"),3175);
		eq(RomanNumeral.parse("MMMCLXXVI"),3176);
		eq(RomanNumeral.parse("MMMCLXXVII"),3177);
		eq(RomanNumeral.parse("MMMCLXXVIII"),3178);
		eq(RomanNumeral.parse("MMMCLXXIX"),3179);
		eq(RomanNumeral.parse("MMMCLXXX"),3180);
		eq(RomanNumeral.parse("MMMCLXXXI"),3181);
		eq(RomanNumeral.parse("MMMCLXXXII"),3182);
		eq(RomanNumeral.parse("MMMCLXXXIII"),3183);
		eq(RomanNumeral.parse("MMMCLXXXIV"),3184);
		eq(RomanNumeral.parse("MMMCLXXXV"),3185);
		eq(RomanNumeral.parse("MMMCLXXXVI"),3186);
		eq(RomanNumeral.parse("MMMCLXXXVII"),3187);
		eq(RomanNumeral.parse("MMMCLXXXVIII"),3188);
		eq(RomanNumeral.parse("MMMCLXXXIX"),3189);
		eq(RomanNumeral.parse("MMMCXC"),3190);
		eq(RomanNumeral.parse("MMMCXCI"),3191);
		eq(RomanNumeral.parse("MMMCXCII"),3192);
		eq(RomanNumeral.parse("MMMCXCIII"),3193);
		eq(RomanNumeral.parse("MMMCXCIV"),3194);
		eq(RomanNumeral.parse("MMMCXCV"),3195);
		eq(RomanNumeral.parse("MMMCXCVI"),3196);
		eq(RomanNumeral.parse("MMMCXCVII"),3197);
		eq(RomanNumeral.parse("MMMCXCVIII"),3198);
		eq(RomanNumeral.parse("MMMCXCIX"),3199);
		eq(RomanNumeral.parse("MMMCC"),3200);
		eq(RomanNumeral.parse("MMMCCI"),3201);
		eq(RomanNumeral.parse("MMMCCII"),3202);
		eq(RomanNumeral.parse("MMMCCIII"),3203);
		eq(RomanNumeral.parse("MMMCCIV"),3204);
		eq(RomanNumeral.parse("MMMCCV"),3205);
		eq(RomanNumeral.parse("MMMCCVI"),3206);
		eq(RomanNumeral.parse("MMMCCVII"),3207);
		eq(RomanNumeral.parse("MMMCCVIII"),3208);
		eq(RomanNumeral.parse("MMMCCIX"),3209);
		eq(RomanNumeral.parse("MMMCCX"),3210);
		eq(RomanNumeral.parse("MMMCCXI"),3211);
		eq(RomanNumeral.parse("MMMCCXII"),3212);
		eq(RomanNumeral.parse("MMMCCXIII"),3213);
		eq(RomanNumeral.parse("MMMCCXIV"),3214);
		eq(RomanNumeral.parse("MMMCCXV"),3215);
		eq(RomanNumeral.parse("MMMCCXVI"),3216);
		eq(RomanNumeral.parse("MMMCCXVII"),3217);
		eq(RomanNumeral.parse("MMMCCXVIII"),3218);
		eq(RomanNumeral.parse("MMMCCXIX"),3219);
		eq(RomanNumeral.parse("MMMCCXX"),3220);
		eq(RomanNumeral.parse("MMMCCXXI"),3221);
		eq(RomanNumeral.parse("MMMCCXXII"),3222);
		eq(RomanNumeral.parse("MMMCCXXIII"),3223);
		eq(RomanNumeral.parse("MMMCCXXIV"),3224);
		eq(RomanNumeral.parse("MMMCCXXV"),3225);
		eq(RomanNumeral.parse("MMMCCXXVI"),3226);
		eq(RomanNumeral.parse("MMMCCXXVII"),3227);
		eq(RomanNumeral.parse("MMMCCXXVIII"),3228);
		eq(RomanNumeral.parse("MMMCCXXIX"),3229);
		eq(RomanNumeral.parse("MMMCCXXX"),3230);
		eq(RomanNumeral.parse("MMMCCXXXI"),3231);
		eq(RomanNumeral.parse("MMMCCXXXII"),3232);
		eq(RomanNumeral.parse("MMMCCXXXIII"),3233);
		eq(RomanNumeral.parse("MMMCCXXXIV"),3234);
		eq(RomanNumeral.parse("MMMCCXXXV"),3235);
		eq(RomanNumeral.parse("MMMCCXXXVI"),3236);
		eq(RomanNumeral.parse("MMMCCXXXVII"),3237);
		eq(RomanNumeral.parse("MMMCCXXXVIII"),3238);
		eq(RomanNumeral.parse("MMMCCXXXIX"),3239);
		eq(RomanNumeral.parse("MMMCCXL"),3240);
		eq(RomanNumeral.parse("MMMCCXLI"),3241);
		eq(RomanNumeral.parse("MMMCCXLII"),3242);
		eq(RomanNumeral.parse("MMMCCXLIII"),3243);
		eq(RomanNumeral.parse("MMMCCXLIV"),3244);
		eq(RomanNumeral.parse("MMMCCXLV"),3245);
		eq(RomanNumeral.parse("MMMCCXLVI"),3246);
		eq(RomanNumeral.parse("MMMCCXLVII"),3247);
		eq(RomanNumeral.parse("MMMCCXLVIII"),3248);
		eq(RomanNumeral.parse("MMMCCXLIX"),3249);
		eq(RomanNumeral.parse("MMMCCL"),3250);
		eq(RomanNumeral.parse("MMMCCLI"),3251);
		eq(RomanNumeral.parse("MMMCCLII"),3252);
		eq(RomanNumeral.parse("MMMCCLIII"),3253);
		eq(RomanNumeral.parse("MMMCCLIV"),3254);
		eq(RomanNumeral.parse("MMMCCLV"),3255);
		eq(RomanNumeral.parse("MMMCCLVI"),3256);
		eq(RomanNumeral.parse("MMMCCLVII"),3257);
		eq(RomanNumeral.parse("MMMCCLVIII"),3258);
		eq(RomanNumeral.parse("MMMCCLIX"),3259);
		eq(RomanNumeral.parse("MMMCCLX"),3260);
		eq(RomanNumeral.parse("MMMCCLXI"),3261);
		eq(RomanNumeral.parse("MMMCCLXII"),3262);
		eq(RomanNumeral.parse("MMMCCLXIII"),3263);
		eq(RomanNumeral.parse("MMMCCLXIV"),3264);
		eq(RomanNumeral.parse("MMMCCLXV"),3265);
		eq(RomanNumeral.parse("MMMCCLXVI"),3266);
		eq(RomanNumeral.parse("MMMCCLXVII"),3267);
		eq(RomanNumeral.parse("MMMCCLXVIII"),3268);
		eq(RomanNumeral.parse("MMMCCLXIX"),3269);
		eq(RomanNumeral.parse("MMMCCLXX"),3270);
		eq(RomanNumeral.parse("MMMCCLXXI"),3271);
		eq(RomanNumeral.parse("MMMCCLXXII"),3272);
		eq(RomanNumeral.parse("MMMCCLXXIII"),3273);
		eq(RomanNumeral.parse("MMMCCLXXIV"),3274);
		eq(RomanNumeral.parse("MMMCCLXXV"),3275);
		eq(RomanNumeral.parse("MMMCCLXXVI"),3276);
		eq(RomanNumeral.parse("MMMCCLXXVII"),3277);
		eq(RomanNumeral.parse("MMMCCLXXVIII"),3278);
		eq(RomanNumeral.parse("MMMCCLXXIX"),3279);
		eq(RomanNumeral.parse("MMMCCLXXX"),3280);
		eq(RomanNumeral.parse("MMMCCLXXXI"),3281);
		eq(RomanNumeral.parse("MMMCCLXXXII"),3282);
		eq(RomanNumeral.parse("MMMCCLXXXIII"),3283);
		eq(RomanNumeral.parse("MMMCCLXXXIV"),3284);
		eq(RomanNumeral.parse("MMMCCLXXXV"),3285);
		eq(RomanNumeral.parse("MMMCCLXXXVI"),3286);
		eq(RomanNumeral.parse("MMMCCLXXXVII"),3287);
		eq(RomanNumeral.parse("MMMCCLXXXVIII"),3288);
		eq(RomanNumeral.parse("MMMCCLXXXIX"),3289);
		eq(RomanNumeral.parse("MMMCCXC"),3290);
		eq(RomanNumeral.parse("MMMCCXCI"),3291);
		eq(RomanNumeral.parse("MMMCCXCII"),3292);
		eq(RomanNumeral.parse("MMMCCXCIII"),3293);
		eq(RomanNumeral.parse("MMMCCXCIV"),3294);
		eq(RomanNumeral.parse("MMMCCXCV"),3295);
		eq(RomanNumeral.parse("MMMCCXCVI"),3296);
		eq(RomanNumeral.parse("MMMCCXCVII"),3297);
		eq(RomanNumeral.parse("MMMCCXCVIII"),3298);
		eq(RomanNumeral.parse("MMMCCXCIX"),3299);
		eq(RomanNumeral.parse("MMMCCC"),3300);
		eq(RomanNumeral.parse("MMMCCCI"),3301);
		eq(RomanNumeral.parse("MMMCCCII"),3302);
		eq(RomanNumeral.parse("MMMCCCIII"),3303);
		eq(RomanNumeral.parse("MMMCCCIV"),3304);
		eq(RomanNumeral.parse("MMMCCCV"),3305);
		eq(RomanNumeral.parse("MMMCCCVI"),3306);
		eq(RomanNumeral.parse("MMMCCCVII"),3307);
		eq(RomanNumeral.parse("MMMCCCVIII"),3308);
		eq(RomanNumeral.parse("MMMCCCIX"),3309);
		eq(RomanNumeral.parse("MMMCCCX"),3310);
		eq(RomanNumeral.parse("MMMCCCXI"),3311);
		eq(RomanNumeral.parse("MMMCCCXII"),3312);
		eq(RomanNumeral.parse("MMMCCCXIII"),3313);
		eq(RomanNumeral.parse("MMMCCCXIV"),3314);
		eq(RomanNumeral.parse("MMMCCCXV"),3315);
		eq(RomanNumeral.parse("MMMCCCXVI"),3316);
		eq(RomanNumeral.parse("MMMCCCXVII"),3317);
		eq(RomanNumeral.parse("MMMCCCXVIII"),3318);
		eq(RomanNumeral.parse("MMMCCCXIX"),3319);
		eq(RomanNumeral.parse("MMMCCCXX"),3320);
		eq(RomanNumeral.parse("MMMCCCXXI"),3321);
		eq(RomanNumeral.parse("MMMCCCXXII"),3322);
		eq(RomanNumeral.parse("MMMCCCXXIII"),3323);
		eq(RomanNumeral.parse("MMMCCCXXIV"),3324);
		eq(RomanNumeral.parse("MMMCCCXXV"),3325);
		eq(RomanNumeral.parse("MMMCCCXXVI"),3326);
		eq(RomanNumeral.parse("MMMCCCXXVII"),3327);
		eq(RomanNumeral.parse("MMMCCCXXVIII"),3328);
		eq(RomanNumeral.parse("MMMCCCXXIX"),3329);
		eq(RomanNumeral.parse("MMMCCCXXX"),3330);
		eq(RomanNumeral.parse("MMMCCCXXXI"),3331);
		eq(RomanNumeral.parse("MMMCCCXXXII"),3332);
		eq(RomanNumeral.parse("MMMCCCXXXIII"),3333);
		eq(RomanNumeral.parse("MMMCCCXXXIV"),3334);
		eq(RomanNumeral.parse("MMMCCCXXXV"),3335);
		eq(RomanNumeral.parse("MMMCCCXXXVI"),3336);
		eq(RomanNumeral.parse("MMMCCCXXXVII"),3337);
		eq(RomanNumeral.parse("MMMCCCXXXVIII"),3338);
		eq(RomanNumeral.parse("MMMCCCXXXIX"),3339);
		eq(RomanNumeral.parse("MMMCCCXL"),3340);
		eq(RomanNumeral.parse("MMMCCCXLI"),3341);
		eq(RomanNumeral.parse("MMMCCCXLII"),3342);
		eq(RomanNumeral.parse("MMMCCCXLIII"),3343);
		eq(RomanNumeral.parse("MMMCCCXLIV"),3344);
		eq(RomanNumeral.parse("MMMCCCXLV"),3345);
		eq(RomanNumeral.parse("MMMCCCXLVI"),3346);
		eq(RomanNumeral.parse("MMMCCCXLVII"),3347);
		eq(RomanNumeral.parse("MMMCCCXLVIII"),3348);
		eq(RomanNumeral.parse("MMMCCCXLIX"),3349);
		eq(RomanNumeral.parse("MMMCCCL"),3350);
		eq(RomanNumeral.parse("MMMCCCLI"),3351);
		eq(RomanNumeral.parse("MMMCCCLII"),3352);
		eq(RomanNumeral.parse("MMMCCCLIII"),3353);
		eq(RomanNumeral.parse("MMMCCCLIV"),3354);
		eq(RomanNumeral.parse("MMMCCCLV"),3355);
		eq(RomanNumeral.parse("MMMCCCLVI"),3356);
		eq(RomanNumeral.parse("MMMCCCLVII"),3357);
		eq(RomanNumeral.parse("MMMCCCLVIII"),3358);
		eq(RomanNumeral.parse("MMMCCCLIX"),3359);
		eq(RomanNumeral.parse("MMMCCCLX"),3360);
		eq(RomanNumeral.parse("MMMCCCLXI"),3361);
		eq(RomanNumeral.parse("MMMCCCLXII"),3362);
		eq(RomanNumeral.parse("MMMCCCLXIII"),3363);
		eq(RomanNumeral.parse("MMMCCCLXIV"),3364);
		eq(RomanNumeral.parse("MMMCCCLXV"),3365);
		eq(RomanNumeral.parse("MMMCCCLXVI"),3366);
		eq(RomanNumeral.parse("MMMCCCLXVII"),3367);
		eq(RomanNumeral.parse("MMMCCCLXVIII"),3368);
		eq(RomanNumeral.parse("MMMCCCLXIX"),3369);
		eq(RomanNumeral.parse("MMMCCCLXX"),3370);
		eq(RomanNumeral.parse("MMMCCCLXXI"),3371);
		eq(RomanNumeral.parse("MMMCCCLXXII"),3372);
		eq(RomanNumeral.parse("MMMCCCLXXIII"),3373);
		eq(RomanNumeral.parse("MMMCCCLXXIV"),3374);
		eq(RomanNumeral.parse("MMMCCCLXXV"),3375);
		eq(RomanNumeral.parse("MMMCCCLXXVI"),3376);
		eq(RomanNumeral.parse("MMMCCCLXXVII"),3377);
		eq(RomanNumeral.parse("MMMCCCLXXVIII"),3378);
		eq(RomanNumeral.parse("MMMCCCLXXIX"),3379);
		eq(RomanNumeral.parse("MMMCCCLXXX"),3380);
		eq(RomanNumeral.parse("MMMCCCLXXXI"),3381);
		eq(RomanNumeral.parse("MMMCCCLXXXII"),3382);
		eq(RomanNumeral.parse("MMMCCCLXXXIII"),3383);
		eq(RomanNumeral.parse("MMMCCCLXXXIV"),3384);
		eq(RomanNumeral.parse("MMMCCCLXXXV"),3385);
		eq(RomanNumeral.parse("MMMCCCLXXXVI"),3386);
		eq(RomanNumeral.parse("MMMCCCLXXXVII"),3387);
		eq(RomanNumeral.parse("MMMCCCLXXXVIII"),3388);
		eq(RomanNumeral.parse("MMMCCCLXXXIX"),3389);
		eq(RomanNumeral.parse("MMMCCCXC"),3390);
		eq(RomanNumeral.parse("MMMCCCXCI"),3391);
		eq(RomanNumeral.parse("MMMCCCXCII"),3392);
		eq(RomanNumeral.parse("MMMCCCXCIII"),3393);
		eq(RomanNumeral.parse("MMMCCCXCIV"),3394);
		eq(RomanNumeral.parse("MMMCCCXCV"),3395);
		eq(RomanNumeral.parse("MMMCCCXCVI"),3396);
		eq(RomanNumeral.parse("MMMCCCXCVII"),3397);
		eq(RomanNumeral.parse("MMMCCCXCVIII"),3398);
		eq(RomanNumeral.parse("MMMCCCXCIX"),3399);
		eq(RomanNumeral.parse("MMMCD"),3400);
		eq(RomanNumeral.parse("MMMCDI"),3401);
		eq(RomanNumeral.parse("MMMCDII"),3402);
		eq(RomanNumeral.parse("MMMCDIII"),3403);
		eq(RomanNumeral.parse("MMMCDIV"),3404);
		eq(RomanNumeral.parse("MMMCDV"),3405);
		eq(RomanNumeral.parse("MMMCDVI"),3406);
		eq(RomanNumeral.parse("MMMCDVII"),3407);
		eq(RomanNumeral.parse("MMMCDVIII"),3408);
		eq(RomanNumeral.parse("MMMCDIX"),3409);
		eq(RomanNumeral.parse("MMMCDX"),3410);
		eq(RomanNumeral.parse("MMMCDXI"),3411);
		eq(RomanNumeral.parse("MMMCDXII"),3412);
		eq(RomanNumeral.parse("MMMCDXIII"),3413);
		eq(RomanNumeral.parse("MMMCDXIV"),3414);
		eq(RomanNumeral.parse("MMMCDXV"),3415);
		eq(RomanNumeral.parse("MMMCDXVI"),3416);
		eq(RomanNumeral.parse("MMMCDXVII"),3417);
		eq(RomanNumeral.parse("MMMCDXVIII"),3418);
		eq(RomanNumeral.parse("MMMCDXIX"),3419);
		eq(RomanNumeral.parse("MMMCDXX"),3420);
		eq(RomanNumeral.parse("MMMCDXXI"),3421);
		eq(RomanNumeral.parse("MMMCDXXII"),3422);
		eq(RomanNumeral.parse("MMMCDXXIII"),3423);
		eq(RomanNumeral.parse("MMMCDXXIV"),3424);
		eq(RomanNumeral.parse("MMMCDXXV"),3425);
		eq(RomanNumeral.parse("MMMCDXXVI"),3426);
		eq(RomanNumeral.parse("MMMCDXXVII"),3427);
		eq(RomanNumeral.parse("MMMCDXXVIII"),3428);
		eq(RomanNumeral.parse("MMMCDXXIX"),3429);
		eq(RomanNumeral.parse("MMMCDXXX"),3430);
		eq(RomanNumeral.parse("MMMCDXXXI"),3431);
		eq(RomanNumeral.parse("MMMCDXXXII"),3432);
		eq(RomanNumeral.parse("MMMCDXXXIII"),3433);
		eq(RomanNumeral.parse("MMMCDXXXIV"),3434);
		eq(RomanNumeral.parse("MMMCDXXXV"),3435);
		eq(RomanNumeral.parse("MMMCDXXXVI"),3436);
		eq(RomanNumeral.parse("MMMCDXXXVII"),3437);
		eq(RomanNumeral.parse("MMMCDXXXVIII"),3438);
		eq(RomanNumeral.parse("MMMCDXXXIX"),3439);
		eq(RomanNumeral.parse("MMMCDXL"),3440);
		eq(RomanNumeral.parse("MMMCDXLI"),3441);
		eq(RomanNumeral.parse("MMMCDXLII"),3442);
		eq(RomanNumeral.parse("MMMCDXLIII"),3443);
		eq(RomanNumeral.parse("MMMCDXLIV"),3444);
		eq(RomanNumeral.parse("MMMCDXLV"),3445);
		eq(RomanNumeral.parse("MMMCDXLVI"),3446);
		eq(RomanNumeral.parse("MMMCDXLVII"),3447);
		eq(RomanNumeral.parse("MMMCDXLVIII"),3448);
		eq(RomanNumeral.parse("MMMCDXLIX"),3449);
		eq(RomanNumeral.parse("MMMCDL"),3450);
		eq(RomanNumeral.parse("MMMCDLI"),3451);
		eq(RomanNumeral.parse("MMMCDLII"),3452);
		eq(RomanNumeral.parse("MMMCDLIII"),3453);
		eq(RomanNumeral.parse("MMMCDLIV"),3454);
		eq(RomanNumeral.parse("MMMCDLV"),3455);
		eq(RomanNumeral.parse("MMMCDLVI"),3456);
		eq(RomanNumeral.parse("MMMCDLVII"),3457);
		eq(RomanNumeral.parse("MMMCDLVIII"),3458);
		eq(RomanNumeral.parse("MMMCDLIX"),3459);
		eq(RomanNumeral.parse("MMMCDLX"),3460);
		eq(RomanNumeral.parse("MMMCDLXI"),3461);
		eq(RomanNumeral.parse("MMMCDLXII"),3462);
		eq(RomanNumeral.parse("MMMCDLXIII"),3463);
		eq(RomanNumeral.parse("MMMCDLXIV"),3464);
		eq(RomanNumeral.parse("MMMCDLXV"),3465);
		eq(RomanNumeral.parse("MMMCDLXVI"),3466);
		eq(RomanNumeral.parse("MMMCDLXVII"),3467);
		eq(RomanNumeral.parse("MMMCDLXVIII"),3468);
		eq(RomanNumeral.parse("MMMCDLXIX"),3469);
		eq(RomanNumeral.parse("MMMCDLXX"),3470);
		eq(RomanNumeral.parse("MMMCDLXXI"),3471);
		eq(RomanNumeral.parse("MMMCDLXXII"),3472);
		eq(RomanNumeral.parse("MMMCDLXXIII"),3473);
		eq(RomanNumeral.parse("MMMCDLXXIV"),3474);
		eq(RomanNumeral.parse("MMMCDLXXV"),3475);
		eq(RomanNumeral.parse("MMMCDLXXVI"),3476);
		eq(RomanNumeral.parse("MMMCDLXXVII"),3477);
		eq(RomanNumeral.parse("MMMCDLXXVIII"),3478);
		eq(RomanNumeral.parse("MMMCDLXXIX"),3479);
		eq(RomanNumeral.parse("MMMCDLXXX"),3480);
		eq(RomanNumeral.parse("MMMCDLXXXI"),3481);
		eq(RomanNumeral.parse("MMMCDLXXXII"),3482);
		eq(RomanNumeral.parse("MMMCDLXXXIII"),3483);
		eq(RomanNumeral.parse("MMMCDLXXXIV"),3484);
		eq(RomanNumeral.parse("MMMCDLXXXV"),3485);
		eq(RomanNumeral.parse("MMMCDLXXXVI"),3486);
		eq(RomanNumeral.parse("MMMCDLXXXVII"),3487);
		eq(RomanNumeral.parse("MMMCDLXXXVIII"),3488);
		eq(RomanNumeral.parse("MMMCDLXXXIX"),3489);
		eq(RomanNumeral.parse("MMMCDXC"),3490);
		eq(RomanNumeral.parse("MMMCDXCI"),3491);
		eq(RomanNumeral.parse("MMMCDXCII"),3492);
		eq(RomanNumeral.parse("MMMCDXCIII"),3493);
		eq(RomanNumeral.parse("MMMCDXCIV"),3494);
		eq(RomanNumeral.parse("MMMCDXCV"),3495);
		eq(RomanNumeral.parse("MMMCDXCVI"),3496);
		eq(RomanNumeral.parse("MMMCDXCVII"),3497);
		eq(RomanNumeral.parse("MMMCDXCVIII"),3498);
		eq(RomanNumeral.parse("MMMCDXCIX"),3499);
		eq(RomanNumeral.parse("MMMD"),3500);
		eq(RomanNumeral.parse("MMMDI"),3501);
		eq(RomanNumeral.parse("MMMDII"),3502);
		eq(RomanNumeral.parse("MMMDIII"),3503);
		eq(RomanNumeral.parse("MMMDIV"),3504);
		eq(RomanNumeral.parse("MMMDV"),3505);
		eq(RomanNumeral.parse("MMMDVI"),3506);
		eq(RomanNumeral.parse("MMMDVII"),3507);
		eq(RomanNumeral.parse("MMMDVIII"),3508);
		eq(RomanNumeral.parse("MMMDIX"),3509);
		eq(RomanNumeral.parse("MMMDX"),3510);
		eq(RomanNumeral.parse("MMMDXI"),3511);
		eq(RomanNumeral.parse("MMMDXII"),3512);
		eq(RomanNumeral.parse("MMMDXIII"),3513);
		eq(RomanNumeral.parse("MMMDXIV"),3514);
		eq(RomanNumeral.parse("MMMDXV"),3515);
		eq(RomanNumeral.parse("MMMDXVI"),3516);
		eq(RomanNumeral.parse("MMMDXVII"),3517);
		eq(RomanNumeral.parse("MMMDXVIII"),3518);
		eq(RomanNumeral.parse("MMMDXIX"),3519);
		eq(RomanNumeral.parse("MMMDXX"),3520);
		eq(RomanNumeral.parse("MMMDXXI"),3521);
		eq(RomanNumeral.parse("MMMDXXII"),3522);
		eq(RomanNumeral.parse("MMMDXXIII"),3523);
		eq(RomanNumeral.parse("MMMDXXIV"),3524);
		eq(RomanNumeral.parse("MMMDXXV"),3525);
		eq(RomanNumeral.parse("MMMDXXVI"),3526);
		eq(RomanNumeral.parse("MMMDXXVII"),3527);
		eq(RomanNumeral.parse("MMMDXXVIII"),3528);
		eq(RomanNumeral.parse("MMMDXXIX"),3529);
		eq(RomanNumeral.parse("MMMDXXX"),3530);
		eq(RomanNumeral.parse("MMMDXXXI"),3531);
		eq(RomanNumeral.parse("MMMDXXXII"),3532);
		eq(RomanNumeral.parse("MMMDXXXIII"),3533);
		eq(RomanNumeral.parse("MMMDXXXIV"),3534);
		eq(RomanNumeral.parse("MMMDXXXV"),3535);
		eq(RomanNumeral.parse("MMMDXXXVI"),3536);
		eq(RomanNumeral.parse("MMMDXXXVII"),3537);
		eq(RomanNumeral.parse("MMMDXXXVIII"),3538);
		eq(RomanNumeral.parse("MMMDXXXIX"),3539);
		eq(RomanNumeral.parse("MMMDXL"),3540);
		eq(RomanNumeral.parse("MMMDXLI"),3541);
		eq(RomanNumeral.parse("MMMDXLII"),3542);
		eq(RomanNumeral.parse("MMMDXLIII"),3543);
		eq(RomanNumeral.parse("MMMDXLIV"),3544);
		eq(RomanNumeral.parse("MMMDXLV"),3545);
		eq(RomanNumeral.parse("MMMDXLVI"),3546);
		eq(RomanNumeral.parse("MMMDXLVII"),3547);
		eq(RomanNumeral.parse("MMMDXLVIII"),3548);
		eq(RomanNumeral.parse("MMMDXLIX"),3549);
		eq(RomanNumeral.parse("MMMDL"),3550);
		eq(RomanNumeral.parse("MMMDLI"),3551);
		eq(RomanNumeral.parse("MMMDLII"),3552);
		eq(RomanNumeral.parse("MMMDLIII"),3553);
		eq(RomanNumeral.parse("MMMDLIV"),3554);
		eq(RomanNumeral.parse("MMMDLV"),3555);
		eq(RomanNumeral.parse("MMMDLVI"),3556);
		eq(RomanNumeral.parse("MMMDLVII"),3557);
		eq(RomanNumeral.parse("MMMDLVIII"),3558);
		eq(RomanNumeral.parse("MMMDLIX"),3559);
		eq(RomanNumeral.parse("MMMDLX"),3560);
		eq(RomanNumeral.parse("MMMDLXI"),3561);
		eq(RomanNumeral.parse("MMMDLXII"),3562);
		eq(RomanNumeral.parse("MMMDLXIII"),3563);
		eq(RomanNumeral.parse("MMMDLXIV"),3564);
		eq(RomanNumeral.parse("MMMDLXV"),3565);
		eq(RomanNumeral.parse("MMMDLXVI"),3566);
		eq(RomanNumeral.parse("MMMDLXVII"),3567);
		eq(RomanNumeral.parse("MMMDLXVIII"),3568);
		eq(RomanNumeral.parse("MMMDLXIX"),3569);
		eq(RomanNumeral.parse("MMMDLXX"),3570);
		eq(RomanNumeral.parse("MMMDLXXI"),3571);
		eq(RomanNumeral.parse("MMMDLXXII"),3572);
		eq(RomanNumeral.parse("MMMDLXXIII"),3573);
		eq(RomanNumeral.parse("MMMDLXXIV"),3574);
		eq(RomanNumeral.parse("MMMDLXXV"),3575);
		eq(RomanNumeral.parse("MMMDLXXVI"),3576);
		eq(RomanNumeral.parse("MMMDLXXVII"),3577);
		eq(RomanNumeral.parse("MMMDLXXVIII"),3578);
		eq(RomanNumeral.parse("MMMDLXXIX"),3579);
		eq(RomanNumeral.parse("MMMDLXXX"),3580);
		eq(RomanNumeral.parse("MMMDLXXXI"),3581);
		eq(RomanNumeral.parse("MMMDLXXXII"),3582);
		eq(RomanNumeral.parse("MMMDLXXXIII"),3583);
		eq(RomanNumeral.parse("MMMDLXXXIV"),3584);
		eq(RomanNumeral.parse("MMMDLXXXV"),3585);
		eq(RomanNumeral.parse("MMMDLXXXVI"),3586);
		eq(RomanNumeral.parse("MMMDLXXXVII"),3587);
		eq(RomanNumeral.parse("MMMDLXXXVIII"),3588);
		eq(RomanNumeral.parse("MMMDLXXXIX"),3589);
		eq(RomanNumeral.parse("MMMDXC"),3590);
		eq(RomanNumeral.parse("MMMDXCI"),3591);
		eq(RomanNumeral.parse("MMMDXCII"),3592);
		eq(RomanNumeral.parse("MMMDXCIII"),3593);
		eq(RomanNumeral.parse("MMMDXCIV"),3594);
		eq(RomanNumeral.parse("MMMDXCV"),3595);
		eq(RomanNumeral.parse("MMMDXCVI"),3596);
		eq(RomanNumeral.parse("MMMDXCVII"),3597);
		eq(RomanNumeral.parse("MMMDXCVIII"),3598);
		eq(RomanNumeral.parse("MMMDXCIX"),3599);
		eq(RomanNumeral.parse("MMMDC"),3600);
		eq(RomanNumeral.parse("MMMDCI"),3601);
		eq(RomanNumeral.parse("MMMDCII"),3602);
		eq(RomanNumeral.parse("MMMDCIII"),3603);
		eq(RomanNumeral.parse("MMMDCIV"),3604);
		eq(RomanNumeral.parse("MMMDCV"),3605);
		eq(RomanNumeral.parse("MMMDCVI"),3606);
		eq(RomanNumeral.parse("MMMDCVII"),3607);
		eq(RomanNumeral.parse("MMMDCVIII"),3608);
		eq(RomanNumeral.parse("MMMDCIX"),3609);
		eq(RomanNumeral.parse("MMMDCX"),3610);
		eq(RomanNumeral.parse("MMMDCXI"),3611);
		eq(RomanNumeral.parse("MMMDCXII"),3612);
		eq(RomanNumeral.parse("MMMDCXIII"),3613);
		eq(RomanNumeral.parse("MMMDCXIV"),3614);
		eq(RomanNumeral.parse("MMMDCXV"),3615);
		eq(RomanNumeral.parse("MMMDCXVI"),3616);
		eq(RomanNumeral.parse("MMMDCXVII"),3617);
		eq(RomanNumeral.parse("MMMDCXVIII"),3618);
		eq(RomanNumeral.parse("MMMDCXIX"),3619);
		eq(RomanNumeral.parse("MMMDCXX"),3620);
		eq(RomanNumeral.parse("MMMDCXXI"),3621);
		eq(RomanNumeral.parse("MMMDCXXII"),3622);
		eq(RomanNumeral.parse("MMMDCXXIII"),3623);
		eq(RomanNumeral.parse("MMMDCXXIV"),3624);
		eq(RomanNumeral.parse("MMMDCXXV"),3625);
		eq(RomanNumeral.parse("MMMDCXXVI"),3626);
		eq(RomanNumeral.parse("MMMDCXXVII"),3627);
		eq(RomanNumeral.parse("MMMDCXXVIII"),3628);
		eq(RomanNumeral.parse("MMMDCXXIX"),3629);
		eq(RomanNumeral.parse("MMMDCXXX"),3630);
		eq(RomanNumeral.parse("MMMDCXXXI"),3631);
		eq(RomanNumeral.parse("MMMDCXXXII"),3632);
		eq(RomanNumeral.parse("MMMDCXXXIII"),3633);
		eq(RomanNumeral.parse("MMMDCXXXIV"),3634);
		eq(RomanNumeral.parse("MMMDCXXXV"),3635);
		eq(RomanNumeral.parse("MMMDCXXXVI"),3636);
		eq(RomanNumeral.parse("MMMDCXXXVII"),3637);
		eq(RomanNumeral.parse("MMMDCXXXVIII"),3638);
		eq(RomanNumeral.parse("MMMDCXXXIX"),3639);
		eq(RomanNumeral.parse("MMMDCXL"),3640);
		eq(RomanNumeral.parse("MMMDCXLI"),3641);
		eq(RomanNumeral.parse("MMMDCXLII"),3642);
		eq(RomanNumeral.parse("MMMDCXLIII"),3643);
		eq(RomanNumeral.parse("MMMDCXLIV"),3644);
		eq(RomanNumeral.parse("MMMDCXLV"),3645);
		eq(RomanNumeral.parse("MMMDCXLVI"),3646);
		eq(RomanNumeral.parse("MMMDCXLVII"),3647);
		eq(RomanNumeral.parse("MMMDCXLVIII"),3648);
		eq(RomanNumeral.parse("MMMDCXLIX"),3649);
		eq(RomanNumeral.parse("MMMDCL"),3650);
		eq(RomanNumeral.parse("MMMDCLI"),3651);
		eq(RomanNumeral.parse("MMMDCLII"),3652);
		eq(RomanNumeral.parse("MMMDCLIII"),3653);
		eq(RomanNumeral.parse("MMMDCLIV"),3654);
		eq(RomanNumeral.parse("MMMDCLV"),3655);
		eq(RomanNumeral.parse("MMMDCLVI"),3656);
		eq(RomanNumeral.parse("MMMDCLVII"),3657);
		eq(RomanNumeral.parse("MMMDCLVIII"),3658);
		eq(RomanNumeral.parse("MMMDCLIX"),3659);
		eq(RomanNumeral.parse("MMMDCLX"),3660);
		eq(RomanNumeral.parse("MMMDCLXI"),3661);
		eq(RomanNumeral.parse("MMMDCLXII"),3662);
		eq(RomanNumeral.parse("MMMDCLXIII"),3663);
		eq(RomanNumeral.parse("MMMDCLXIV"),3664);
		eq(RomanNumeral.parse("MMMDCLXV"),3665);
		eq(RomanNumeral.parse("MMMDCLXVI"),3666);
		eq(RomanNumeral.parse("MMMDCLXVII"),3667);
		eq(RomanNumeral.parse("MMMDCLXVIII"),3668);
		eq(RomanNumeral.parse("MMMDCLXIX"),3669);
		eq(RomanNumeral.parse("MMMDCLXX"),3670);
		eq(RomanNumeral.parse("MMMDCLXXI"),3671);
		eq(RomanNumeral.parse("MMMDCLXXII"),3672);
		eq(RomanNumeral.parse("MMMDCLXXIII"),3673);
		eq(RomanNumeral.parse("MMMDCLXXIV"),3674);
		eq(RomanNumeral.parse("MMMDCLXXV"),3675);
		eq(RomanNumeral.parse("MMMDCLXXVI"),3676);
		eq(RomanNumeral.parse("MMMDCLXXVII"),3677);
		eq(RomanNumeral.parse("MMMDCLXXVIII"),3678);
		eq(RomanNumeral.parse("MMMDCLXXIX"),3679);
		eq(RomanNumeral.parse("MMMDCLXXX"),3680);
		eq(RomanNumeral.parse("MMMDCLXXXI"),3681);
		eq(RomanNumeral.parse("MMMDCLXXXII"),3682);
		eq(RomanNumeral.parse("MMMDCLXXXIII"),3683);
		eq(RomanNumeral.parse("MMMDCLXXXIV"),3684);
		eq(RomanNumeral.parse("MMMDCLXXXV"),3685);
		eq(RomanNumeral.parse("MMMDCLXXXVI"),3686);
		eq(RomanNumeral.parse("MMMDCLXXXVII"),3687);
		eq(RomanNumeral.parse("MMMDCLXXXVIII"),3688);
		eq(RomanNumeral.parse("MMMDCLXXXIX"),3689);
		eq(RomanNumeral.parse("MMMDCXC"),3690);
		eq(RomanNumeral.parse("MMMDCXCI"),3691);
		eq(RomanNumeral.parse("MMMDCXCII"),3692);
		eq(RomanNumeral.parse("MMMDCXCIII"),3693);
		eq(RomanNumeral.parse("MMMDCXCIV"),3694);
		eq(RomanNumeral.parse("MMMDCXCV"),3695);
		eq(RomanNumeral.parse("MMMDCXCVI"),3696);
		eq(RomanNumeral.parse("MMMDCXCVII"),3697);
		eq(RomanNumeral.parse("MMMDCXCVIII"),3698);
		eq(RomanNumeral.parse("MMMDCXCIX"),3699);
		eq(RomanNumeral.parse("MMMDCC"),3700);
		eq(RomanNumeral.parse("MMMDCCI"),3701);
		eq(RomanNumeral.parse("MMMDCCII"),3702);
		eq(RomanNumeral.parse("MMMDCCIII"),3703);
		eq(RomanNumeral.parse("MMMDCCIV"),3704);
		eq(RomanNumeral.parse("MMMDCCV"),3705);
		eq(RomanNumeral.parse("MMMDCCVI"),3706);
		eq(RomanNumeral.parse("MMMDCCVII"),3707);
		eq(RomanNumeral.parse("MMMDCCVIII"),3708);
		eq(RomanNumeral.parse("MMMDCCIX"),3709);
		eq(RomanNumeral.parse("MMMDCCX"),3710);
		eq(RomanNumeral.parse("MMMDCCXI"),3711);
		eq(RomanNumeral.parse("MMMDCCXII"),3712);
		eq(RomanNumeral.parse("MMMDCCXIII"),3713);
		eq(RomanNumeral.parse("MMMDCCXIV"),3714);
		eq(RomanNumeral.parse("MMMDCCXV"),3715);
		eq(RomanNumeral.parse("MMMDCCXVI"),3716);
		eq(RomanNumeral.parse("MMMDCCXVII"),3717);
		eq(RomanNumeral.parse("MMMDCCXVIII"),3718);
		eq(RomanNumeral.parse("MMMDCCXIX"),3719);
		eq(RomanNumeral.parse("MMMDCCXX"),3720);
		eq(RomanNumeral.parse("MMMDCCXXI"),3721);
		eq(RomanNumeral.parse("MMMDCCXXII"),3722);
		eq(RomanNumeral.parse("MMMDCCXXIII"),3723);
		eq(RomanNumeral.parse("MMMDCCXXIV"),3724);
		eq(RomanNumeral.parse("MMMDCCXXV"),3725);
		eq(RomanNumeral.parse("MMMDCCXXVI"),3726);
		eq(RomanNumeral.parse("MMMDCCXXVII"),3727);
		eq(RomanNumeral.parse("MMMDCCXXVIII"),3728);
		eq(RomanNumeral.parse("MMMDCCXXIX"),3729);
		eq(RomanNumeral.parse("MMMDCCXXX"),3730);
		eq(RomanNumeral.parse("MMMDCCXXXI"),3731);
		eq(RomanNumeral.parse("MMMDCCXXXII"),3732);
		eq(RomanNumeral.parse("MMMDCCXXXIII"),3733);
		eq(RomanNumeral.parse("MMMDCCXXXIV"),3734);
		eq(RomanNumeral.parse("MMMDCCXXXV"),3735);
		eq(RomanNumeral.parse("MMMDCCXXXVI"),3736);
		eq(RomanNumeral.parse("MMMDCCXXXVII"),3737);
		eq(RomanNumeral.parse("MMMDCCXXXVIII"),3738);
		eq(RomanNumeral.parse("MMMDCCXXXIX"),3739);
		eq(RomanNumeral.parse("MMMDCCXL"),3740);
		eq(RomanNumeral.parse("MMMDCCXLI"),3741);
		eq(RomanNumeral.parse("MMMDCCXLII"),3742);
		eq(RomanNumeral.parse("MMMDCCXLIII"),3743);
		eq(RomanNumeral.parse("MMMDCCXLIV"),3744);
		eq(RomanNumeral.parse("MMMDCCXLV"),3745);
		eq(RomanNumeral.parse("MMMDCCXLVI"),3746);
		eq(RomanNumeral.parse("MMMDCCXLVII"),3747);
		eq(RomanNumeral.parse("MMMDCCXLVIII"),3748);
		eq(RomanNumeral.parse("MMMDCCXLIX"),3749);
		eq(RomanNumeral.parse("MMMDCCL"),3750);
		eq(RomanNumeral.parse("MMMDCCLI"),3751);
		eq(RomanNumeral.parse("MMMDCCLII"),3752);
		eq(RomanNumeral.parse("MMMDCCLIII"),3753);
		eq(RomanNumeral.parse("MMMDCCLIV"),3754);
		eq(RomanNumeral.parse("MMMDCCLV"),3755);
		eq(RomanNumeral.parse("MMMDCCLVI"),3756);
		eq(RomanNumeral.parse("MMMDCCLVII"),3757);
		eq(RomanNumeral.parse("MMMDCCLVIII"),3758);
		eq(RomanNumeral.parse("MMMDCCLIX"),3759);
		eq(RomanNumeral.parse("MMMDCCLX"),3760);
		eq(RomanNumeral.parse("MMMDCCLXI"),3761);
		eq(RomanNumeral.parse("MMMDCCLXII"),3762);
		eq(RomanNumeral.parse("MMMDCCLXIII"),3763);
		eq(RomanNumeral.parse("MMMDCCLXIV"),3764);
		eq(RomanNumeral.parse("MMMDCCLXV"),3765);
		eq(RomanNumeral.parse("MMMDCCLXVI"),3766);
		eq(RomanNumeral.parse("MMMDCCLXVII"),3767);
		eq(RomanNumeral.parse("MMMDCCLXVIII"),3768);
		eq(RomanNumeral.parse("MMMDCCLXIX"),3769);
		eq(RomanNumeral.parse("MMMDCCLXX"),3770);
		eq(RomanNumeral.parse("MMMDCCLXXI"),3771);
		eq(RomanNumeral.parse("MMMDCCLXXII"),3772);
		eq(RomanNumeral.parse("MMMDCCLXXIII"),3773);
		eq(RomanNumeral.parse("MMMDCCLXXIV"),3774);
		eq(RomanNumeral.parse("MMMDCCLXXV"),3775);
		eq(RomanNumeral.parse("MMMDCCLXXVI"),3776);
		eq(RomanNumeral.parse("MMMDCCLXXVII"),3777);
		eq(RomanNumeral.parse("MMMDCCLXXVIII"),3778);
		eq(RomanNumeral.parse("MMMDCCLXXIX"),3779);
		eq(RomanNumeral.parse("MMMDCCLXXX"),3780);
		eq(RomanNumeral.parse("MMMDCCLXXXI"),3781);
		eq(RomanNumeral.parse("MMMDCCLXXXII"),3782);
		eq(RomanNumeral.parse("MMMDCCLXXXIII"),3783);
		eq(RomanNumeral.parse("MMMDCCLXXXIV"),3784);
		eq(RomanNumeral.parse("MMMDCCLXXXV"),3785);
		eq(RomanNumeral.parse("MMMDCCLXXXVI"),3786);
		eq(RomanNumeral.parse("MMMDCCLXXXVII"),3787);
		eq(RomanNumeral.parse("MMMDCCLXXXVIII"),3788);
		eq(RomanNumeral.parse("MMMDCCLXXXIX"),3789);
		eq(RomanNumeral.parse("MMMDCCXC"),3790);
		eq(RomanNumeral.parse("MMMDCCXCI"),3791);
		eq(RomanNumeral.parse("MMMDCCXCII"),3792);
		eq(RomanNumeral.parse("MMMDCCXCIII"),3793);
		eq(RomanNumeral.parse("MMMDCCXCIV"),3794);
		eq(RomanNumeral.parse("MMMDCCXCV"),3795);
		eq(RomanNumeral.parse("MMMDCCXCVI"),3796);
		eq(RomanNumeral.parse("MMMDCCXCVII"),3797);
		eq(RomanNumeral.parse("MMMDCCXCVIII"),3798);
		eq(RomanNumeral.parse("MMMDCCXCIX"),3799);
		eq(RomanNumeral.parse("MMMDCCC"),3800);
		eq(RomanNumeral.parse("MMMDCCCI"),3801);
		eq(RomanNumeral.parse("MMMDCCCII"),3802);
		eq(RomanNumeral.parse("MMMDCCCIII"),3803);
		eq(RomanNumeral.parse("MMMDCCCIV"),3804);
		eq(RomanNumeral.parse("MMMDCCCV"),3805);
		eq(RomanNumeral.parse("MMMDCCCVI"),3806);
		eq(RomanNumeral.parse("MMMDCCCVII"),3807);
		eq(RomanNumeral.parse("MMMDCCCVIII"),3808);
		eq(RomanNumeral.parse("MMMDCCCIX"),3809);
		eq(RomanNumeral.parse("MMMDCCCX"),3810);
		eq(RomanNumeral.parse("MMMDCCCXI"),3811);
		eq(RomanNumeral.parse("MMMDCCCXII"),3812);
		eq(RomanNumeral.parse("MMMDCCCXIII"),3813);
		eq(RomanNumeral.parse("MMMDCCCXIV"),3814);
		eq(RomanNumeral.parse("MMMDCCCXV"),3815);
		eq(RomanNumeral.parse("MMMDCCCXVI"),3816);
		eq(RomanNumeral.parse("MMMDCCCXVII"),3817);
		eq(RomanNumeral.parse("MMMDCCCXVIII"),3818);
		eq(RomanNumeral.parse("MMMDCCCXIX"),3819);
		eq(RomanNumeral.parse("MMMDCCCXX"),3820);
		eq(RomanNumeral.parse("MMMDCCCXXI"),3821);
		eq(RomanNumeral.parse("MMMDCCCXXII"),3822);
		eq(RomanNumeral.parse("MMMDCCCXXIII"),3823);
		eq(RomanNumeral.parse("MMMDCCCXXIV"),3824);
		eq(RomanNumeral.parse("MMMDCCCXXV"),3825);
		eq(RomanNumeral.parse("MMMDCCCXXVI"),3826);
		eq(RomanNumeral.parse("MMMDCCCXXVII"),3827);
		eq(RomanNumeral.parse("MMMDCCCXXVIII"),3828);
		eq(RomanNumeral.parse("MMMDCCCXXIX"),3829);
		eq(RomanNumeral.parse("MMMDCCCXXX"),3830);
		eq(RomanNumeral.parse("MMMDCCCXXXI"),3831);
		eq(RomanNumeral.parse("MMMDCCCXXXII"),3832);
		eq(RomanNumeral.parse("MMMDCCCXXXIII"),3833);
		eq(RomanNumeral.parse("MMMDCCCXXXIV"),3834);
		eq(RomanNumeral.parse("MMMDCCCXXXV"),3835);
		eq(RomanNumeral.parse("MMMDCCCXXXVI"),3836);
		eq(RomanNumeral.parse("MMMDCCCXXXVII"),3837);
		eq(RomanNumeral.parse("MMMDCCCXXXVIII"),3838);
		eq(RomanNumeral.parse("MMMDCCCXXXIX"),3839);
		eq(RomanNumeral.parse("MMMDCCCXL"),3840);
		eq(RomanNumeral.parse("MMMDCCCXLI"),3841);
		eq(RomanNumeral.parse("MMMDCCCXLII"),3842);
		eq(RomanNumeral.parse("MMMDCCCXLIII"),3843);
		eq(RomanNumeral.parse("MMMDCCCXLIV"),3844);
		eq(RomanNumeral.parse("MMMDCCCXLV"),3845);
		eq(RomanNumeral.parse("MMMDCCCXLVI"),3846);
		eq(RomanNumeral.parse("MMMDCCCXLVII"),3847);
		eq(RomanNumeral.parse("MMMDCCCXLVIII"),3848);
		eq(RomanNumeral.parse("MMMDCCCXLIX"),3849);
		eq(RomanNumeral.parse("MMMDCCCL"),3850);
		eq(RomanNumeral.parse("MMMDCCCLI"),3851);
		eq(RomanNumeral.parse("MMMDCCCLII"),3852);
		eq(RomanNumeral.parse("MMMDCCCLIII"),3853);
		eq(RomanNumeral.parse("MMMDCCCLIV"),3854);
		eq(RomanNumeral.parse("MMMDCCCLV"),3855);
		eq(RomanNumeral.parse("MMMDCCCLVI"),3856);
		eq(RomanNumeral.parse("MMMDCCCLVII"),3857);
		eq(RomanNumeral.parse("MMMDCCCLVIII"),3858);
		eq(RomanNumeral.parse("MMMDCCCLIX"),3859);
		eq(RomanNumeral.parse("MMMDCCCLX"),3860);
		eq(RomanNumeral.parse("MMMDCCCLXI"),3861);
		eq(RomanNumeral.parse("MMMDCCCLXII"),3862);
		eq(RomanNumeral.parse("MMMDCCCLXIII"),3863);
		eq(RomanNumeral.parse("MMMDCCCLXIV"),3864);
		eq(RomanNumeral.parse("MMMDCCCLXV"),3865);
		eq(RomanNumeral.parse("MMMDCCCLXVI"),3866);
		eq(RomanNumeral.parse("MMMDCCCLXVII"),3867);
		eq(RomanNumeral.parse("MMMDCCCLXVIII"),3868);
		eq(RomanNumeral.parse("MMMDCCCLXIX"),3869);
		eq(RomanNumeral.parse("MMMDCCCLXX"),3870);
		eq(RomanNumeral.parse("MMMDCCCLXXI"),3871);
		eq(RomanNumeral.parse("MMMDCCCLXXII"),3872);
		eq(RomanNumeral.parse("MMMDCCCLXXIII"),3873);
		eq(RomanNumeral.parse("MMMDCCCLXXIV"),3874);
		eq(RomanNumeral.parse("MMMDCCCLXXV"),3875);
		eq(RomanNumeral.parse("MMMDCCCLXXVI"),3876);
		eq(RomanNumeral.parse("MMMDCCCLXXVII"),3877);
		eq(RomanNumeral.parse("MMMDCCCLXXVIII"),3878);
		eq(RomanNumeral.parse("MMMDCCCLXXIX"),3879);
		eq(RomanNumeral.parse("MMMDCCCLXXX"),3880);
		eq(RomanNumeral.parse("MMMDCCCLXXXI"),3881);
		eq(RomanNumeral.parse("MMMDCCCLXXXII"),3882);
		eq(RomanNumeral.parse("MMMDCCCLXXXIII"),3883);
		eq(RomanNumeral.parse("MMMDCCCLXXXIV"),3884);
		eq(RomanNumeral.parse("MMMDCCCLXXXV"),3885);
		eq(RomanNumeral.parse("MMMDCCCLXXXVI"),3886);
		eq(RomanNumeral.parse("MMMDCCCLXXXVII"),3887);
		eq(RomanNumeral.parse("MMMDCCCLXXXVIII"),3888);
		eq(RomanNumeral.parse("MMMDCCCLXXXIX"),3889);
		eq(RomanNumeral.parse("MMMDCCCXC"),3890);
		eq(RomanNumeral.parse("MMMDCCCXCI"),3891);
		eq(RomanNumeral.parse("MMMDCCCXCII"),3892);
		eq(RomanNumeral.parse("MMMDCCCXCIII"),3893);
		eq(RomanNumeral.parse("MMMDCCCXCIV"),3894);
		eq(RomanNumeral.parse("MMMDCCCXCV"),3895);
		eq(RomanNumeral.parse("MMMDCCCXCVI"),3896);
		eq(RomanNumeral.parse("MMMDCCCXCVII"),3897);
		eq(RomanNumeral.parse("MMMDCCCXCVIII"),3898);
		eq(RomanNumeral.parse("MMMDCCCXCIX"),3899);
		eq(RomanNumeral.parse("MMMCM"),3900);
		eq(RomanNumeral.parse("MMMCMI"),3901);
		eq(RomanNumeral.parse("MMMCMII"),3902);
		eq(RomanNumeral.parse("MMMCMIII"),3903);
		eq(RomanNumeral.parse("MMMCMIV"),3904);
		eq(RomanNumeral.parse("MMMCMV"),3905);
		eq(RomanNumeral.parse("MMMCMVI"),3906);
		eq(RomanNumeral.parse("MMMCMVII"),3907);
		eq(RomanNumeral.parse("MMMCMVIII"),3908);
		eq(RomanNumeral.parse("MMMCMIX"),3909);
		eq(RomanNumeral.parse("MMMCMX"),3910);
		eq(RomanNumeral.parse("MMMCMXI"),3911);
		eq(RomanNumeral.parse("MMMCMXII"),3912);
		eq(RomanNumeral.parse("MMMCMXIII"),3913);
		eq(RomanNumeral.parse("MMMCMXIV"),3914);
		eq(RomanNumeral.parse("MMMCMXV"),3915);
		eq(RomanNumeral.parse("MMMCMXVI"),3916);
		eq(RomanNumeral.parse("MMMCMXVII"),3917);
		eq(RomanNumeral.parse("MMMCMXVIII"),3918);
		eq(RomanNumeral.parse("MMMCMXIX"),3919);
		eq(RomanNumeral.parse("MMMCMXX"),3920);
		eq(RomanNumeral.parse("MMMCMXXI"),3921);
		eq(RomanNumeral.parse("MMMCMXXII"),3922);
		eq(RomanNumeral.parse("MMMCMXXIII"),3923);
		eq(RomanNumeral.parse("MMMCMXXIV"),3924);
		eq(RomanNumeral.parse("MMMCMXXV"),3925);
		eq(RomanNumeral.parse("MMMCMXXVI"),3926);
		eq(RomanNumeral.parse("MMMCMXXVII"),3927);
		eq(RomanNumeral.parse("MMMCMXXVIII"),3928);
		eq(RomanNumeral.parse("MMMCMXXIX"),3929);
		eq(RomanNumeral.parse("MMMCMXXX"),3930);
		eq(RomanNumeral.parse("MMMCMXXXI"),3931);
		eq(RomanNumeral.parse("MMMCMXXXII"),3932);
		eq(RomanNumeral.parse("MMMCMXXXIII"),3933);
		eq(RomanNumeral.parse("MMMCMXXXIV"),3934);
		eq(RomanNumeral.parse("MMMCMXXXV"),3935);
		eq(RomanNumeral.parse("MMMCMXXXVI"),3936);
		eq(RomanNumeral.parse("MMMCMXXXVII"),3937);
		eq(RomanNumeral.parse("MMMCMXXXVIII"),3938);
		eq(RomanNumeral.parse("MMMCMXXXIX"),3939);
		eq(RomanNumeral.parse("MMMCMXL"),3940);
		eq(RomanNumeral.parse("MMMCMXLI"),3941);
		eq(RomanNumeral.parse("MMMCMXLII"),3942);
		eq(RomanNumeral.parse("MMMCMXLIII"),3943);
		eq(RomanNumeral.parse("MMMCMXLIV"),3944);
		eq(RomanNumeral.parse("MMMCMXLV"),3945);
		eq(RomanNumeral.parse("MMMCMXLVI"),3946);
		eq(RomanNumeral.parse("MMMCMXLVII"),3947);
		eq(RomanNumeral.parse("MMMCMXLVIII"),3948);
		eq(RomanNumeral.parse("MMMCMXLIX"),3949);
		eq(RomanNumeral.parse("MMMCML"),3950);
		eq(RomanNumeral.parse("MMMCMLI"),3951);
		eq(RomanNumeral.parse("MMMCMLII"),3952);
		eq(RomanNumeral.parse("MMMCMLIII"),3953);
		eq(RomanNumeral.parse("MMMCMLIV"),3954);
		eq(RomanNumeral.parse("MMMCMLV"),3955);
		eq(RomanNumeral.parse("MMMCMLVI"),3956);
		eq(RomanNumeral.parse("MMMCMLVII"),3957);
		eq(RomanNumeral.parse("MMMCMLVIII"),3958);
		eq(RomanNumeral.parse("MMMCMLIX"),3959);
		eq(RomanNumeral.parse("MMMCMLX"),3960);
		eq(RomanNumeral.parse("MMMCMLXI"),3961);
		eq(RomanNumeral.parse("MMMCMLXII"),3962);
		eq(RomanNumeral.parse("MMMCMLXIII"),3963);
		eq(RomanNumeral.parse("MMMCMLXIV"),3964);
		eq(RomanNumeral.parse("MMMCMLXV"),3965);
		eq(RomanNumeral.parse("MMMCMLXVI"),3966);
		eq(RomanNumeral.parse("MMMCMLXVII"),3967);
		eq(RomanNumeral.parse("MMMCMLXVIII"),3968);
		eq(RomanNumeral.parse("MMMCMLXIX"),3969);
		eq(RomanNumeral.parse("MMMCMLXX"),3970);
		eq(RomanNumeral.parse("MMMCMLXXI"),3971);
		eq(RomanNumeral.parse("MMMCMLXXII"),3972);
		eq(RomanNumeral.parse("MMMCMLXXIII"),3973);
		eq(RomanNumeral.parse("MMMCMLXXIV"),3974);
		eq(RomanNumeral.parse("MMMCMLXXV"),3975);
		eq(RomanNumeral.parse("MMMCMLXXVI"),3976);
		eq(RomanNumeral.parse("MMMCMLXXVII"),3977);
		eq(RomanNumeral.parse("MMMCMLXXVIII"),3978);
		eq(RomanNumeral.parse("MMMCMLXXIX"),3979);
		eq(RomanNumeral.parse("MMMCMLXXX"),3980);
		eq(RomanNumeral.parse("MMMCMLXXXI"),3981);
		eq(RomanNumeral.parse("MMMCMLXXXII"),3982);
		eq(RomanNumeral.parse("MMMCMLXXXIII"),3983);
		eq(RomanNumeral.parse("MMMCMLXXXIV"),3984);
		eq(RomanNumeral.parse("MMMCMLXXXV"),3985);
		eq(RomanNumeral.parse("MMMCMLXXXVI"),3986);
		eq(RomanNumeral.parse("MMMCMLXXXVII"),3987);
		eq(RomanNumeral.parse("MMMCMLXXXVIII"),3988);
		eq(RomanNumeral.parse("MMMCMLXXXIX"),3989);
		eq(RomanNumeral.parse("MMMCMXC"),3990);
		eq(RomanNumeral.parse("MMMCMXCI"),3991);
		eq(RomanNumeral.parse("MMMCMXCII"),3992);
		eq(RomanNumeral.parse("MMMCMXCIII"),3993);
		eq(RomanNumeral.parse("MMMCMXCIV"),3994);
		eq(RomanNumeral.parse("MMMCMXCV"),3995);
		eq(RomanNumeral.parse("MMMCMXCVI"),3996);
		eq(RomanNumeral.parse("MMMCMXCVII"),3997);
		eq(RomanNumeral.parse("MMMCMXCVIII"),3998);
		eq(RomanNumeral.parse("MMMCMXCIX"),3999);
		eq(RomanNumeral.parse("MMMM"), -1);
		eq(RomanNumeral.parse("IM"), -1);
	}

	static void rep(long l, String s) {
		eq(RomanNumeral.toBigRoman(l), s.replace('c', '\u2183'));
	}

	public void testToBigRoman() {
		rep(10000, "CCIcc");
		rep(11000, "CCIccCIc");
		rep(13000, "CCIccCIcCIcCIc");
		rep(15000, "CCIcccc");
		rep(17000, "CCIccccCIcCIc");
		rep(57000, "IcccIccCIcCIc");
		rep(10500, "CCIccIc");
		rep(11500, "CCIccCIcc");
		rep(   72, "LXXII");
		rep(11572, "CCIccCIccLXXII");
		rep(  876, "IcCCCLXXVI");
	}

	static void pas(long l, String s) {
		eq(RomanNumeral.parseBigRoman(
				s.replace('c', '\u2183')).intValue(), l);
	}

	public void testParseBigRoman() {
		pas(10000, "CCIcc");
		pas(11000, "CCIccCIc");
		pas(13000, "CCIccCIcCIcCIc");
		pas(14000, "CCIccCIcCIcCIcCIc");
		pas(15000, "CCIcccc");
//		pas(15000, "CCIccIcc");
		pas(17000, "CCIccccCIcCIc");
		pas(19000, "CCIccccCIcCIcCIcCIc");
		pas(57000, "IcccIccCIcCIc");
		pas(10500, "CCIccIc");
		pas(11500, "CCIccCIcc");
		pas(   72, "LXXII");
		pas(11572, "CCIccCIccLXXII");
		pas(    1, "I");
		pas(    2, "II");
		pas(    3, "III");
		pas(    4, "IV");
		pas(    9, "IX");
		pas(   90, "XC");
		pas(  400, "CCCC");
		pas(  500, "Ic");
		pas( 1000, "\u2180");
		pas( 5000, "\u2181");
		pas(10000, "\u2182");
		pas(765000, "IccccCCCIcccCCCIccccccCCIcccc");
		pas(765876, "IccccCCCIcccCCCIccccccCCIccccIcCCCLXXVI");
	}

	static void per(String s) {
		try {
			RomanNumeral.parseBigRoman(s.replace('c', '\u2183'));
			fail();
		} catch(RuntimeException e) {}
	}

	public void testParseBigRomanErr() {
		per("CCCIcc");
		per("CCCIccccccc");
		per("CCIccCCCIccc");
		per("IcccCCCIccc");
		per("IcccIccc");
		per("IccIccc");
		per("CIcCIcCIcCIcCIc");
		per("CCIccCCIccCCIccCCIccCIcCIcCIcCIcCIc");
		per("LCCIcc");
		per("");
	}

}
